/* PackageKitBackend.c generated by valac 0.56.13, the Vala compiler
 * generated from PackageKitBackend.vala, do not modify */

/*-
 * Copyright 2019-2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: David Hewitt <davidmhewitt@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <appstream.h>
#include <stdlib.h>
#include <string.h>
#include <packagekit-glib2/packagekit.h>
#include <float.h>
#include <math.h>
#include <polkit/polkit.h>
#include <glib/gi18n-lib.h>
#include <unistd.h>
#include <glib/gstdio.h>

#define APP_CENTER_CORE_PACKAGE_KIT_BACKEND_FAKE_PACKAGE_ID "%s;fake.version;amd64;installed:xenial-main"
#define APP_CENTER_CORE_PACKAGE_KIT_BACKEND_PACKAGEKIT_ACTIVITY_TIMEOUT_MS 2000
#define APP_CENTER_CORE_PACKAGE_LOCAL_ID_SUFFIX ".appcenter-local"
#define APP_CENTER_CORE_PACKAGE_APPCENTER_PACKAGE_ORIGIN "appcenter"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PACKAGE_KIT_BACKEND_ERROR (package_kit_backend_error_get_type ())

#define APP_CENTER_CORE_TYPE_BACKEND (app_center_core_backend_get_type ())
#define APP_CENTER_CORE_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_BACKEND, AppCenterCoreBackend))
#define APP_CENTER_CORE_IS_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_BACKEND))
#define APP_CENTER_CORE_BACKEND_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), APP_CENTER_CORE_TYPE_BACKEND, AppCenterCoreBackendIface))

typedef struct _AppCenterCoreBackend AppCenterCoreBackend;
typedef struct _AppCenterCoreBackendIface AppCenterCoreBackendIface;

#define APP_CENTER_CORE_TYPE_PACKAGE_DETAILS (app_center_core_package_details_get_type ())
#define APP_CENTER_CORE_PACKAGE_DETAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_PACKAGE_DETAILS, AppCenterCorePackageDetails))
#define APP_CENTER_CORE_PACKAGE_DETAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_PACKAGE_DETAILS, AppCenterCorePackageDetailsClass))
#define APP_CENTER_CORE_IS_PACKAGE_DETAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_PACKAGE_DETAILS))
#define APP_CENTER_CORE_IS_PACKAGE_DETAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_PACKAGE_DETAILS))
#define APP_CENTER_CORE_PACKAGE_DETAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_PACKAGE_DETAILS, AppCenterCorePackageDetailsClass))

typedef struct _AppCenterCorePackageDetails AppCenterCorePackageDetails;
typedef struct _AppCenterCorePackageDetailsClass AppCenterCorePackageDetailsClass;

#define APP_CENTER_CORE_TYPE_PACKAGE (app_center_core_package_get_type ())
#define APP_CENTER_CORE_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_PACKAGE, AppCenterCorePackage))
#define APP_CENTER_CORE_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_PACKAGE, AppCenterCorePackageClass))
#define APP_CENTER_CORE_IS_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_PACKAGE))
#define APP_CENTER_CORE_IS_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_PACKAGE))
#define APP_CENTER_CORE_PACKAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_PACKAGE, AppCenterCorePackageClass))

typedef struct _AppCenterCorePackage AppCenterCorePackage;
typedef struct _AppCenterCorePackageClass AppCenterCorePackageClass;

#define APP_CENTER_CORE_TYPE_CHANGE_INFORMATION (app_center_core_change_information_get_type ())
#define APP_CENTER_CORE_CHANGE_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_CHANGE_INFORMATION, AppCenterCoreChangeInformation))
#define APP_CENTER_CORE_CHANGE_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_CHANGE_INFORMATION, AppCenterCoreChangeInformationClass))
#define APP_CENTER_CORE_IS_CHANGE_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_CHANGE_INFORMATION))
#define APP_CENTER_CORE_IS_CHANGE_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_CHANGE_INFORMATION))
#define APP_CENTER_CORE_CHANGE_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_CHANGE_INFORMATION, AppCenterCoreChangeInformationClass))

typedef struct _AppCenterCoreChangeInformation AppCenterCoreChangeInformation;
typedef struct _AppCenterCoreChangeInformationClass AppCenterCoreChangeInformationClass;
typedef enum  {
	APP_CENTER_CORE_JOB_TYPE_GET_DETAILS_FOR_PACKAGE_IDS,
	APP_CENTER_CORE_JOB_TYPE_GET_INSTALLED_PACKAGES,
	APP_CENTER_CORE_JOB_TYPE_GET_DOWNLOAD_SIZE,
	APP_CENTER_CORE_JOB_TYPE_REFRESH_CACHE,
	APP_CENTER_CORE_JOB_TYPE_GET_UPDATES,
	APP_CENTER_CORE_JOB_TYPE_INSTALL_PACKAGE,
	APP_CENTER_CORE_JOB_TYPE_UPDATE_PACKAGE,
	APP_CENTER_CORE_JOB_TYPE_REMOVE_PACKAGE,
	APP_CENTER_CORE_JOB_TYPE_IS_PACKAGE_INSTALLED,
	APP_CENTER_CORE_JOB_TYPE_GET_PACKAGE_DETAILS,
	APP_CENTER_CORE_JOB_TYPE_GET_PACKAGE_DEPENDENCIES,
	APP_CENTER_CORE_JOB_TYPE_GET_PREPARED_PACKAGES,
	APP_CENTER_CORE_JOB_TYPE_REPAIR
} AppCenterCoreJobType;

#define APP_CENTER_CORE_JOB_TYPE_TYPE (app_center_core_job_type_get_type ())

#define APP_CENTER_CORE_TYPE_PACKAGE_KIT_BACKEND (app_center_core_package_kit_backend_get_type ())
#define APP_CENTER_CORE_PACKAGE_KIT_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_PACKAGE_KIT_BACKEND, AppCenterCorePackageKitBackend))
#define APP_CENTER_CORE_PACKAGE_KIT_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_PACKAGE_KIT_BACKEND, AppCenterCorePackageKitBackendClass))
#define APP_CENTER_CORE_IS_PACKAGE_KIT_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_PACKAGE_KIT_BACKEND))
#define APP_CENTER_CORE_IS_PACKAGE_KIT_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_PACKAGE_KIT_BACKEND))
#define APP_CENTER_CORE_PACKAGE_KIT_BACKEND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_PACKAGE_KIT_BACKEND, AppCenterCorePackageKitBackendClass))

typedef struct _AppCenterCorePackageKitBackend AppCenterCorePackageKitBackend;
typedef struct _AppCenterCorePackageKitBackendClass AppCenterCorePackageKitBackendClass;
typedef struct _AppCenterCorePackageKitBackendPrivate AppCenterCorePackageKitBackendPrivate;

#define APP_CENTER_CORE_TYPE_JOB (app_center_core_job_get_type ())
#define APP_CENTER_CORE_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_JOB, AppCenterCoreJob))
#define APP_CENTER_CORE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_JOB, AppCenterCoreJobClass))
#define APP_CENTER_CORE_IS_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_JOB))
#define APP_CENTER_CORE_IS_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_JOB))
#define APP_CENTER_CORE_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_JOB, AppCenterCoreJobClass))

typedef struct _AppCenterCoreJob AppCenterCoreJob;
typedef struct _AppCenterCoreJobClass AppCenterCoreJobClass;
enum  {
	APP_CENTER_CORE_PACKAGE_KIT_BACKEND_0_PROPERTY,
	APP_CENTER_CORE_PACKAGE_KIT_BACKEND_FAKE_PACKAGES_PROPERTY,
	APP_CENTER_CORE_PACKAGE_KIT_BACKEND_JOB_TYPE_PROPERTY,
	APP_CENTER_CORE_PACKAGE_KIT_BACKEND_WORKING_PROPERTY,
	APP_CENTER_CORE_PACKAGE_KIT_BACKEND_NUM_PROPERTIES
};
static GParamSpec* app_center_core_package_kit_backend_properties[APP_CENTER_CORE_PACKAGE_KIT_BACKEND_NUM_PROPERTIES];

#define APP_CENTER_CORE_TYPE_TASK (app_center_core_task_get_type ())
#define APP_CENTER_CORE_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_TASK, AppCenterCoreTask))
#define APP_CENTER_CORE_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_TASK, AppCenterCoreTaskClass))
#define APP_CENTER_CORE_IS_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_TASK))
#define APP_CENTER_CORE_IS_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_TASK))
#define APP_CENTER_CORE_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_TASK, AppCenterCoreTaskClass))

typedef struct _AppCenterCoreTask AppCenterCoreTask;
typedef struct _AppCenterCoreTaskClass AppCenterCoreTaskClass;
#define _g_async_queue_unref0(var) ((var == NULL) ? NULL : (var = (g_async_queue_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define APP_CENTER_CORE_TYPE_UPDATE_MANAGER (app_center_core_update_manager_get_type ())
#define APP_CENTER_CORE_UPDATE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_UPDATE_MANAGER, AppCenterCoreUpdateManager))
#define APP_CENTER_CORE_UPDATE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_UPDATE_MANAGER, AppCenterCoreUpdateManagerClass))
#define APP_CENTER_CORE_IS_UPDATE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_UPDATE_MANAGER))
#define APP_CENTER_CORE_IS_UPDATE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_UPDATE_MANAGER))
#define APP_CENTER_CORE_UPDATE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_UPDATE_MANAGER, AppCenterCoreUpdateManagerClass))

typedef struct _AppCenterCoreUpdateManager AppCenterCoreUpdateManager;
typedef struct _AppCenterCoreUpdateManagerClass AppCenterCoreUpdateManagerClass;
typedef enum  {
	APP_CENTER_CORE_PACKAGE_STATE_NOT_INSTALLED,
	APP_CENTER_CORE_PACKAGE_STATE_INSTALLED,
	APP_CENTER_CORE_PACKAGE_STATE_INSTALLING,
	APP_CENTER_CORE_PACKAGE_STATE_UPDATE_AVAILABLE,
	APP_CENTER_CORE_PACKAGE_STATE_UPDATING,
	APP_CENTER_CORE_PACKAGE_STATE_REMOVING
} AppCenterCorePackageState;

#define APP_CENTER_CORE_PACKAGE_TYPE_STATE (app_center_core_package_state_get_type ())

#define APP_CENTER_CORE_TYPE_CLIENT (app_center_core_client_get_type ())
#define APP_CENTER_CORE_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_CLIENT, AppCenterCoreClient))
#define APP_CENTER_CORE_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_CLIENT, AppCenterCoreClientClass))
#define APP_CENTER_CORE_IS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_CLIENT))
#define APP_CENTER_CORE_IS_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_CLIENT))
#define APP_CENTER_CORE_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_CLIENT, AppCenterCoreClientClass))

typedef struct _AppCenterCoreClient AppCenterCoreClient;
typedef struct _AppCenterCoreClientClass AppCenterCoreClientClass;
typedef struct _AppCenterCorePackageKitBackendTriggerUpdateCheckData AppCenterCorePackageKitBackendTriggerUpdateCheckData;

#define APP_CENTER_CORE_TYPE_COMPONENT_VALIDATOR (app_center_core_component_validator_get_type ())
#define APP_CENTER_CORE_COMPONENT_VALIDATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_COMPONENT_VALIDATOR, AppCenterCoreComponentValidator))
#define APP_CENTER_CORE_COMPONENT_VALIDATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_COMPONENT_VALIDATOR, AppCenterCoreComponentValidatorClass))
#define APP_CENTER_CORE_IS_COMPONENT_VALIDATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_COMPONENT_VALIDATOR))
#define APP_CENTER_CORE_IS_COMPONENT_VALIDATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_COMPONENT_VALIDATOR))
#define APP_CENTER_CORE_COMPONENT_VALIDATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_COMPONENT_VALIDATOR, AppCenterCoreComponentValidatorClass))

typedef struct _AppCenterCoreComponentValidator AppCenterCoreComponentValidator;
typedef struct _AppCenterCoreComponentValidatorClass AppCenterCoreComponentValidatorClass;
typedef struct _Block53Data Block53Data;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _AppCenterCorePackageKitBackendGetPreparedApplicationsData AppCenterCorePackageKitBackendGetPreparedApplicationsData;
typedef struct _AppCenterCorePackageKitBackendGetInstalledApplicationsData AppCenterCorePackageKitBackendGetInstalledApplicationsData;
typedef struct _Block54Data Block54Data;
typedef struct _Block55Data Block55Data;
typedef struct _Block56Data Block56Data;
#define _app_center_core_job_args_unref0(var) ((var == NULL) ? NULL : (var = (app_center_core_job_args_unref (var), NULL)))

#define APP_CENTER_CORE_TYPE_JOB_ARGS (app_center_core_job_args_get_type ())
#define APP_CENTER_CORE_JOB_ARGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_JOB_ARGS, AppCenterCoreJobArgs))
#define APP_CENTER_CORE_JOB_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_JOB_ARGS, AppCenterCoreJobArgsClass))
#define APP_CENTER_CORE_IS_JOB_ARGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_JOB_ARGS))
#define APP_CENTER_CORE_IS_JOB_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_JOB_ARGS))
#define APP_CENTER_CORE_JOB_ARGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_JOB_ARGS, AppCenterCoreJobArgsClass))

typedef struct _AppCenterCoreJobArgs AppCenterCoreJobArgs;
typedef struct _AppCenterCoreJobArgsClass AppCenterCoreJobArgsClass;
typedef struct _Block57Data Block57Data;
typedef struct _AppCenterCorePackageKitBackendLaunchJobData AppCenterCorePackageKitBackendLaunchJobData;
typedef struct _Block58Data Block58Data;

#define APP_CENTER_CORE_TYPE_GET_PREPARED_PACKAGES_ARGS (app_center_core_get_prepared_packages_args_get_type ())
#define APP_CENTER_CORE_GET_PREPARED_PACKAGES_ARGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_GET_PREPARED_PACKAGES_ARGS, AppCenterCoreGetPreparedPackagesArgs))
#define APP_CENTER_CORE_GET_PREPARED_PACKAGES_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_GET_PREPARED_PACKAGES_ARGS, AppCenterCoreGetPreparedPackagesArgsClass))
#define APP_CENTER_CORE_IS_GET_PREPARED_PACKAGES_ARGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_GET_PREPARED_PACKAGES_ARGS))
#define APP_CENTER_CORE_IS_GET_PREPARED_PACKAGES_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_GET_PREPARED_PACKAGES_ARGS))
#define APP_CENTER_CORE_GET_PREPARED_PACKAGES_ARGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_GET_PREPARED_PACKAGES_ARGS, AppCenterCoreGetPreparedPackagesArgsClass))

typedef struct _AppCenterCoreGetPreparedPackagesArgs AppCenterCoreGetPreparedPackagesArgs;
typedef struct _AppCenterCoreGetPreparedPackagesArgsClass AppCenterCoreGetPreparedPackagesArgsClass;
typedef struct _AppCenterCoreJobArgsPrivate AppCenterCoreJobArgsPrivate;
typedef struct _AppCenterCoreGetPreparedPackagesArgsPrivate AppCenterCoreGetPreparedPackagesArgsPrivate;
typedef struct _AppCenterCoreJobPrivate AppCenterCoreJobPrivate;
typedef struct _AppCenterCorePackageKitBackendGetPreparedPackagesData AppCenterCorePackageKitBackendGetPreparedPackagesData;

#define APP_CENTER_CORE_TYPE_GET_INSTALLED_PACKAGES_ARGS (app_center_core_get_installed_packages_args_get_type ())
#define APP_CENTER_CORE_GET_INSTALLED_PACKAGES_ARGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_GET_INSTALLED_PACKAGES_ARGS, AppCenterCoreGetInstalledPackagesArgs))
#define APP_CENTER_CORE_GET_INSTALLED_PACKAGES_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_GET_INSTALLED_PACKAGES_ARGS, AppCenterCoreGetInstalledPackagesArgsClass))
#define APP_CENTER_CORE_IS_GET_INSTALLED_PACKAGES_ARGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_GET_INSTALLED_PACKAGES_ARGS))
#define APP_CENTER_CORE_IS_GET_INSTALLED_PACKAGES_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_GET_INSTALLED_PACKAGES_ARGS))
#define APP_CENTER_CORE_GET_INSTALLED_PACKAGES_ARGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_GET_INSTALLED_PACKAGES_ARGS, AppCenterCoreGetInstalledPackagesArgsClass))

typedef struct _AppCenterCoreGetInstalledPackagesArgs AppCenterCoreGetInstalledPackagesArgs;
typedef struct _AppCenterCoreGetInstalledPackagesArgsClass AppCenterCoreGetInstalledPackagesArgsClass;
typedef struct _AppCenterCoreGetInstalledPackagesArgsPrivate AppCenterCoreGetInstalledPackagesArgsPrivate;
typedef struct _AppCenterCorePackageKitBackendGetInstalledPackagesData AppCenterCorePackageKitBackendGetInstalledPackagesData;
typedef struct _Block59Data Block59Data;

#define APP_CENTER_CORE_TYPE_GET_DOWNLOAD_SIZE_ARGS (app_center_core_get_download_size_args_get_type ())
#define APP_CENTER_CORE_GET_DOWNLOAD_SIZE_ARGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_GET_DOWNLOAD_SIZE_ARGS, AppCenterCoreGetDownloadSizeArgs))
#define APP_CENTER_CORE_GET_DOWNLOAD_SIZE_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_GET_DOWNLOAD_SIZE_ARGS, AppCenterCoreGetDownloadSizeArgsClass))
#define APP_CENTER_CORE_IS_GET_DOWNLOAD_SIZE_ARGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_GET_DOWNLOAD_SIZE_ARGS))
#define APP_CENTER_CORE_IS_GET_DOWNLOAD_SIZE_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_GET_DOWNLOAD_SIZE_ARGS))
#define APP_CENTER_CORE_GET_DOWNLOAD_SIZE_ARGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_GET_DOWNLOAD_SIZE_ARGS, AppCenterCoreGetDownloadSizeArgsClass))

typedef struct _AppCenterCoreGetDownloadSizeArgs AppCenterCoreGetDownloadSizeArgs;
typedef struct _AppCenterCoreGetDownloadSizeArgsClass AppCenterCoreGetDownloadSizeArgsClass;
typedef struct _AppCenterCoreGetDownloadSizeArgsPrivate AppCenterCoreGetDownloadSizeArgsPrivate;
typedef struct _AppCenterCorePackageKitBackendGetDownloadSizeData AppCenterCorePackageKitBackendGetDownloadSizeData;
typedef struct _Block60Data Block60Data;

#define APP_CENTER_CORE_TYPE_INSTALL_PACKAGE_ARGS (app_center_core_install_package_args_get_type ())
#define APP_CENTER_CORE_INSTALL_PACKAGE_ARGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_INSTALL_PACKAGE_ARGS, AppCenterCoreInstallPackageArgs))
#define APP_CENTER_CORE_INSTALL_PACKAGE_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_INSTALL_PACKAGE_ARGS, AppCenterCoreInstallPackageArgsClass))
#define APP_CENTER_CORE_IS_INSTALL_PACKAGE_ARGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_INSTALL_PACKAGE_ARGS))
#define APP_CENTER_CORE_IS_INSTALL_PACKAGE_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_INSTALL_PACKAGE_ARGS))
#define APP_CENTER_CORE_INSTALL_PACKAGE_ARGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_INSTALL_PACKAGE_ARGS, AppCenterCoreInstallPackageArgsClass))

typedef struct _AppCenterCoreInstallPackageArgs AppCenterCoreInstallPackageArgs;
typedef struct _AppCenterCoreInstallPackageArgsClass AppCenterCoreInstallPackageArgsClass;
typedef struct _AppCenterCoreInstallPackageArgsPrivate AppCenterCoreInstallPackageArgsPrivate;
typedef enum  {
	APP_CENTER_CORE_CHANGE_INFORMATION_STATUS_UNKNOWN,
	APP_CENTER_CORE_CHANGE_INFORMATION_STATUS_CANCELLED,
	APP_CENTER_CORE_CHANGE_INFORMATION_STATUS_WAITING,
	APP_CENTER_CORE_CHANGE_INFORMATION_STATUS_RUNNING,
	APP_CENTER_CORE_CHANGE_INFORMATION_STATUS_FINISHED
} AppCenterCoreChangeInformationStatus;

#define APP_CENTER_CORE_CHANGE_INFORMATION_TYPE_STATUS (app_center_core_change_information_status_get_type ())
typedef struct _AppCenterCorePackageKitBackendInstallPackageData AppCenterCorePackageKitBackendInstallPackageData;
typedef struct _Block61Data Block61Data;

#define APP_CENTER_CORE_TYPE_UPDATE_PACKAGE_ARGS (app_center_core_update_package_args_get_type ())
#define APP_CENTER_CORE_UPDATE_PACKAGE_ARGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_UPDATE_PACKAGE_ARGS, AppCenterCoreUpdatePackageArgs))
#define APP_CENTER_CORE_UPDATE_PACKAGE_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_UPDATE_PACKAGE_ARGS, AppCenterCoreUpdatePackageArgsClass))
#define APP_CENTER_CORE_IS_UPDATE_PACKAGE_ARGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_UPDATE_PACKAGE_ARGS))
#define APP_CENTER_CORE_IS_UPDATE_PACKAGE_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_UPDATE_PACKAGE_ARGS))
#define APP_CENTER_CORE_UPDATE_PACKAGE_ARGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_UPDATE_PACKAGE_ARGS, AppCenterCoreUpdatePackageArgsClass))

typedef struct _AppCenterCoreUpdatePackageArgs AppCenterCoreUpdatePackageArgs;
typedef struct _AppCenterCoreUpdatePackageArgsClass AppCenterCoreUpdatePackageArgsClass;
typedef struct _AppCenterCoreUpdatePackageArgsPrivate AppCenterCoreUpdatePackageArgsPrivate;
typedef struct _AppCenterCorePackageKitBackendUpdatePackageData AppCenterCorePackageKitBackendUpdatePackageData;
typedef struct _Block62Data Block62Data;

#define APP_CENTER_CORE_TYPE_REMOVE_PACKAGE_ARGS (app_center_core_remove_package_args_get_type ())
#define APP_CENTER_CORE_REMOVE_PACKAGE_ARGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_REMOVE_PACKAGE_ARGS, AppCenterCoreRemovePackageArgs))
#define APP_CENTER_CORE_REMOVE_PACKAGE_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_REMOVE_PACKAGE_ARGS, AppCenterCoreRemovePackageArgsClass))
#define APP_CENTER_CORE_IS_REMOVE_PACKAGE_ARGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_REMOVE_PACKAGE_ARGS))
#define APP_CENTER_CORE_IS_REMOVE_PACKAGE_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_REMOVE_PACKAGE_ARGS))
#define APP_CENTER_CORE_REMOVE_PACKAGE_ARGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_REMOVE_PACKAGE_ARGS, AppCenterCoreRemovePackageArgsClass))

typedef struct _AppCenterCoreRemovePackageArgs AppCenterCoreRemovePackageArgs;
typedef struct _AppCenterCoreRemovePackageArgsClass AppCenterCoreRemovePackageArgsClass;
typedef struct _AppCenterCoreRemovePackageArgsPrivate AppCenterCoreRemovePackageArgsPrivate;
typedef struct _AppCenterCorePackageKitBackendRemovePackageData AppCenterCorePackageKitBackendRemovePackageData;
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
typedef struct _Block63Data Block63Data;

#define APP_CENTER_CORE_TYPE_GET_UPDATES_ARGS (app_center_core_get_updates_args_get_type ())
#define APP_CENTER_CORE_GET_UPDATES_ARGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_GET_UPDATES_ARGS, AppCenterCoreGetUpdatesArgs))
#define APP_CENTER_CORE_GET_UPDATES_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_GET_UPDATES_ARGS, AppCenterCoreGetUpdatesArgsClass))
#define APP_CENTER_CORE_IS_GET_UPDATES_ARGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_GET_UPDATES_ARGS))
#define APP_CENTER_CORE_IS_GET_UPDATES_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_GET_UPDATES_ARGS))
#define APP_CENTER_CORE_GET_UPDATES_ARGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_GET_UPDATES_ARGS, AppCenterCoreGetUpdatesArgsClass))

typedef struct _AppCenterCoreGetUpdatesArgs AppCenterCoreGetUpdatesArgs;
typedef struct _AppCenterCoreGetUpdatesArgsClass AppCenterCoreGetUpdatesArgsClass;
typedef struct _AppCenterCoreGetUpdatesArgsPrivate AppCenterCoreGetUpdatesArgsPrivate;
typedef struct _AppCenterCorePackageKitBackendGetUpdatesData AppCenterCorePackageKitBackendGetUpdatesData;

#define APP_CENTER_CORE_TYPE_REFRESH_CACHE_ARGS (app_center_core_refresh_cache_args_get_type ())
#define APP_CENTER_CORE_REFRESH_CACHE_ARGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_REFRESH_CACHE_ARGS, AppCenterCoreRefreshCacheArgs))
#define APP_CENTER_CORE_REFRESH_CACHE_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_REFRESH_CACHE_ARGS, AppCenterCoreRefreshCacheArgsClass))
#define APP_CENTER_CORE_IS_REFRESH_CACHE_ARGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_REFRESH_CACHE_ARGS))
#define APP_CENTER_CORE_IS_REFRESH_CACHE_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_REFRESH_CACHE_ARGS))
#define APP_CENTER_CORE_REFRESH_CACHE_ARGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_REFRESH_CACHE_ARGS, AppCenterCoreRefreshCacheArgsClass))

typedef struct _AppCenterCoreRefreshCacheArgs AppCenterCoreRefreshCacheArgs;
typedef struct _AppCenterCoreRefreshCacheArgsClass AppCenterCoreRefreshCacheArgsClass;
typedef struct _AppCenterCoreRefreshCacheArgsPrivate AppCenterCoreRefreshCacheArgsPrivate;

#define APP_CENTER_CORE_TYPE_BACKEND_AGGREGATOR (app_center_core_backend_aggregator_get_type ())
#define APP_CENTER_CORE_BACKEND_AGGREGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_BACKEND_AGGREGATOR, AppCenterCoreBackendAggregator))
#define APP_CENTER_CORE_BACKEND_AGGREGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_BACKEND_AGGREGATOR, AppCenterCoreBackendAggregatorClass))
#define APP_CENTER_CORE_IS_BACKEND_AGGREGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_BACKEND_AGGREGATOR))
#define APP_CENTER_CORE_IS_BACKEND_AGGREGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_BACKEND_AGGREGATOR))
#define APP_CENTER_CORE_BACKEND_AGGREGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_BACKEND_AGGREGATOR, AppCenterCoreBackendAggregatorClass))

typedef struct _AppCenterCoreBackendAggregator AppCenterCoreBackendAggregator;
typedef struct _AppCenterCoreBackendAggregatorClass AppCenterCoreBackendAggregatorClass;
typedef struct _AppCenterCorePackageKitBackendRefreshCacheData AppCenterCorePackageKitBackendRefreshCacheData;

#define APP_CENTER_CORE_TYPE_ISPACKAGE_INSTALLED_ARGS (app_center_core_ispackage_installed_args_get_type ())
#define APP_CENTER_CORE_ISPACKAGE_INSTALLED_ARGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_ISPACKAGE_INSTALLED_ARGS, AppCenterCoreIsPackageInstalledArgs))
#define APP_CENTER_CORE_ISPACKAGE_INSTALLED_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_ISPACKAGE_INSTALLED_ARGS, AppCenterCoreIsPackageInstalledArgsClass))
#define APP_CENTER_CORE_IS_ISPACKAGE_INSTALLED_ARGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_ISPACKAGE_INSTALLED_ARGS))
#define APP_CENTER_CORE_IS_ISPACKAGE_INSTALLED_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_ISPACKAGE_INSTALLED_ARGS))
#define APP_CENTER_CORE_ISPACKAGE_INSTALLED_ARGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_ISPACKAGE_INSTALLED_ARGS, AppCenterCoreIsPackageInstalledArgsClass))

typedef struct _AppCenterCoreIsPackageInstalledArgs AppCenterCoreIsPackageInstalledArgs;
typedef struct _AppCenterCoreIsPackageInstalledArgsClass AppCenterCoreIsPackageInstalledArgsClass;
typedef struct _AppCenterCoreIsPackageInstalledArgsPrivate AppCenterCoreIsPackageInstalledArgsPrivate;
typedef struct _AppCenterCorePackageKitBackendIsPackageInstalledData AppCenterCorePackageKitBackendIsPackageInstalledData;
typedef struct _Block64Data Block64Data;
typedef struct _AppCenterCorePackageKitBackendUpdateMultiplePackageStateData AppCenterCorePackageKitBackendUpdateMultiplePackageStateData;

#define APP_CENTER_CORE_TYPE_GET_PACKAGE_DETAILS_ARGS (app_center_core_get_package_details_args_get_type ())
#define APP_CENTER_CORE_GET_PACKAGE_DETAILS_ARGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_GET_PACKAGE_DETAILS_ARGS, AppCenterCoreGetPackageDetailsArgs))
#define APP_CENTER_CORE_GET_PACKAGE_DETAILS_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_GET_PACKAGE_DETAILS_ARGS, AppCenterCoreGetPackageDetailsArgsClass))
#define APP_CENTER_CORE_IS_GET_PACKAGE_DETAILS_ARGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_GET_PACKAGE_DETAILS_ARGS))
#define APP_CENTER_CORE_IS_GET_PACKAGE_DETAILS_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_GET_PACKAGE_DETAILS_ARGS))
#define APP_CENTER_CORE_GET_PACKAGE_DETAILS_ARGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_GET_PACKAGE_DETAILS_ARGS, AppCenterCoreGetPackageDetailsArgsClass))

typedef struct _AppCenterCoreGetPackageDetailsArgs AppCenterCoreGetPackageDetailsArgs;
typedef struct _AppCenterCoreGetPackageDetailsArgsClass AppCenterCoreGetPackageDetailsArgsClass;
typedef struct _AppCenterCoreGetPackageDetailsArgsPrivate AppCenterCoreGetPackageDetailsArgsPrivate;
typedef struct _AppCenterCorePackageKitBackendGetPackageDetailsData AppCenterCorePackageKitBackendGetPackageDetailsData;
typedef struct _Block65Data Block65Data;

#define APP_CENTER_CORE_TYPE_GET_PACKAGE_DEPENDENCIES_ARGS (app_center_core_get_package_dependencies_args_get_type ())
#define APP_CENTER_CORE_GET_PACKAGE_DEPENDENCIES_ARGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_GET_PACKAGE_DEPENDENCIES_ARGS, AppCenterCoreGetPackageDependenciesArgs))
#define APP_CENTER_CORE_GET_PACKAGE_DEPENDENCIES_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_GET_PACKAGE_DEPENDENCIES_ARGS, AppCenterCoreGetPackageDependenciesArgsClass))
#define APP_CENTER_CORE_IS_GET_PACKAGE_DEPENDENCIES_ARGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_GET_PACKAGE_DEPENDENCIES_ARGS))
#define APP_CENTER_CORE_IS_GET_PACKAGE_DEPENDENCIES_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_GET_PACKAGE_DEPENDENCIES_ARGS))
#define APP_CENTER_CORE_GET_PACKAGE_DEPENDENCIES_ARGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_GET_PACKAGE_DEPENDENCIES_ARGS, AppCenterCoreGetPackageDependenciesArgsClass))

typedef struct _AppCenterCoreGetPackageDependenciesArgs AppCenterCoreGetPackageDependenciesArgs;
typedef struct _AppCenterCoreGetPackageDependenciesArgsClass AppCenterCoreGetPackageDependenciesArgsClass;
typedef struct _AppCenterCoreGetPackageDependenciesArgsPrivate AppCenterCoreGetPackageDependenciesArgsPrivate;
typedef struct _AppCenterCorePackageKitBackendGetPackageDependenciesData AppCenterCorePackageKitBackendGetPackageDependenciesData;
typedef struct _AppCenterCorePackageKitBackendRepairData AppCenterCorePackageKitBackendRepairData;
typedef struct _Block66Data Block66Data;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))

typedef enum  {
	PACKAGE_KIT_BACKEND_ERROR_PACKAGE_NOT_FOUND
} PackageKitBackendError;
#define PACKAGE_KIT_BACKEND_ERROR package_kit_backend_error_quark ()

struct _AppCenterCoreBackendIface {
	GTypeInterface parent_iface;
	void (*get_prepared_applications) (AppCenterCoreBackend* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeCollection* (*get_prepared_applications_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_);
	void (*get_installed_applications) (AppCenterCoreBackend* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeCollection* (*get_installed_applications_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_);
	GeeCollection* (*get_applications_for_category) (AppCenterCoreBackend* self, AsCategory* category);
	GeeCollection* (*search_applications) (AppCenterCoreBackend* self, const gchar* query, AsCategory* category);
	GeeCollection* (*search_applications_mime) (AppCenterCoreBackend* self, const gchar* query);
	AppCenterCorePackage* (*get_package_for_component_id) (AppCenterCoreBackend* self, const gchar* id);
	GeeCollection* (*get_packages_for_component_id) (AppCenterCoreBackend* self, const gchar* id);
	AppCenterCorePackage* (*get_package_for_desktop_id) (AppCenterCoreBackend* self, const gchar* id);
	GeeCollection* (*get_packages_by_author) (AppCenterCoreBackend* self, const gchar* author, gint max);
	void (*refresh_cache) (AppCenterCoreBackend* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*refresh_cache_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	void (*get_download_size) (AppCenterCoreBackend* self, AppCenterCorePackage* package, GCancellable* cancellable, gboolean is_update, GAsyncReadyCallback _callback_, gpointer _user_data_);
	guint64 (*get_download_size_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	void (*is_package_installed) (AppCenterCoreBackend* self, AppCenterCorePackage* package, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*is_package_installed_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	void (*get_package_details) (AppCenterCoreBackend* self, AppCenterCorePackage* package, GAsyncReadyCallback _callback_, gpointer _user_data_);
	AppCenterCorePackageDetails* (*get_package_details_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	void (*install_package) (AppCenterCoreBackend* self, AppCenterCorePackage* package, AppCenterCoreChangeInformation* change_info, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*install_package_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	void (*update_package) (AppCenterCoreBackend* self, AppCenterCorePackage* package, AppCenterCoreChangeInformation* change_info, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*update_package_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	void (*remove_package) (AppCenterCoreBackend* self, AppCenterCorePackage* package, AppCenterCoreChangeInformation* change_info, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*remove_package_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	void (*repair) (AppCenterCoreBackend* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*repair_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	AppCenterCoreJobType (*get_job_type) (AppCenterCoreBackend* self);
	void (*set_job_type) (AppCenterCoreBackend* self, AppCenterCoreJobType value);
	gboolean (*get_working) (AppCenterCoreBackend* self);
	void (*set_working) (AppCenterCoreBackend* self, gboolean value);
};

struct _AppCenterCorePackageKitBackend {
	GObject parent_instance;
	AppCenterCorePackageKitBackendPrivate * priv;
};

struct _AppCenterCorePackageKitBackendClass {
	GObjectClass parent_class;
};

struct _AppCenterCorePackageKitBackendPrivate {
	GAsyncQueue* jobs;
	GThread* worker_thread;
	GDateTime* last_action;
	GeeHashMap* package_list;
	AsPool* appstream_pool;
	gchar** _fake_packages;
	gint _fake_packages_length1;
	gint __fake_packages_size_;
	gboolean thread_should_run;
	AppCenterCoreJobType _job_type;
	gboolean _working;
	gboolean can_cancel;
	gint current_progress;
	gint last_progress;
	PkStatusEnum current_status;
	PkStatusEnum status;
	gdouble progress_denom;
	gdouble progress;
};

struct _AppCenterCorePackageKitBackendTriggerUpdateCheckData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	GError* e;
	GError* _tmp0_;
	const gchar* _tmp1_;
	AppCenterCoreClient* _tmp2_;
	GError* _inner_error0_;
};

struct _Block53Data {
	int _ref_count_;
	AppCenterCorePackageKitBackend* self;
	GeeHashMap* new_package_list;
	AppCenterCoreComponentValidator* comp_validator;
};

struct _AppCenterCorePackageKitBackendGetPreparedApplicationsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	GCancellable* cancellable;
	GeeCollection* result;
	GeeTreeSet* packages;
	GeeTreeSet* _tmp0_;
	PkResults* pk_prepared;
	PkResults* _tmp1_;
	GPtrArray* package_array;
	PkResults* _tmp2_;
	GPtrArray* _tmp3_;
	GPtrArray* _tmp4_;
	GPtrArray* pk_package_collection;
	guint pk_package_index;
	PkPackage* pk_package;
	GeeTreeSet* _tmp5_;
	PkPackage* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	PkPackage* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	PkPackage* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	PkPackage* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	AppCenterCorePackageDetails* _tmp18_;
	AppCenterCorePackageDetails* _tmp19_;
	GPtrArray* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
};

struct _AppCenterCorePackageKitBackendGetInstalledApplicationsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	GCancellable* cancellable;
	GeeCollection* result;
	GeeTreeSet* packages;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* installed;
	GeeTreeSet* _tmp1_;
	GeeIterator* _pk_package_it;
	GeeTreeSet* _tmp2_;
	GeeIterator* _tmp3_;
	GeeIterator* _tmp4_;
	PkPackage* pk_package;
	GeeIterator* _tmp5_;
	gpointer _tmp6_;
	AppCenterCorePackage* package;
	PkPackage* _tmp7_;
	AppCenterCorePackage* _tmp8_;
	AppCenterCorePackage* _tmp9_;
	GeeTreeSet* _tmp10_;
	AppCenterCorePackage* _tmp11_;
};

struct _Block54Data {
	int _ref_count_;
	AppCenterCorePackageKitBackend* self;
	GeeTreeSet* apps;
};

struct _Block55Data {
	int _ref_count_;
	AppCenterCorePackageKitBackend* self;
	GeeTreeSet* apps;
};

struct _Block56Data {
	int _ref_count_;
	Block55Data * _data55_;
	GeeCollection* cat_packages;
};

struct _Block57Data {
	int _ref_count_;
	AppCenterCorePackageKitBackend* self;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	gpointer _async_data_;
};

struct _AppCenterCorePackageKitBackendLaunchJobData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	AppCenterCoreJobType type;
	AppCenterCoreJobArgs* args;
	AppCenterCoreJob* result;
	Block57Data* _data57_;
	AppCenterCoreJob* job;
	AppCenterCoreJob* _tmp0_;
	GAsyncQueue* _tmp1_;
	AppCenterCoreJob* _tmp2_;
};

struct _Block58Data {
	int _ref_count_;
	AppCenterCorePackageKitBackend* self;
	PkResults* results;
	gchar** package_ids;
	gint package_ids_length1;
	gint _package_ids_size_;
	GeeArrayList* downloaded_updates;
};

struct _AppCenterCoreJobArgs {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AppCenterCoreJobArgsPrivate * priv;
};

struct _AppCenterCoreJobArgsClass {
	GTypeClass parent_class;
	void (*finalize) (AppCenterCoreJobArgs *self);
};

struct _AppCenterCoreGetPreparedPackagesArgs {
	AppCenterCoreJobArgs parent_instance;
	AppCenterCoreGetPreparedPackagesArgsPrivate * priv;
	GCancellable* cancellable;
};

struct _AppCenterCoreGetPreparedPackagesArgsClass {
	AppCenterCoreJobArgsClass parent_class;
};

struct _AppCenterCoreJob {
	GObject parent_instance;
	AppCenterCoreJobPrivate * priv;
	GValue result;
};

struct _AppCenterCoreJobClass {
	GObjectClass parent_class;
};

struct _AppCenterCorePackageKitBackendGetPreparedPackagesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	GCancellable* cancellable;
	PkResults* result;
	AppCenterCoreGetPreparedPackagesArgs* job_args;
	AppCenterCoreGetPreparedPackagesArgs* _tmp0_;
	GCancellable* _tmp1_;
	AppCenterCoreJob* job;
	AppCenterCoreJob* _tmp2_;
	GObject* _tmp3_;
	PkResults* _tmp4_;
};

struct _AppCenterCoreGetInstalledPackagesArgs {
	AppCenterCoreJobArgs parent_instance;
	AppCenterCoreGetInstalledPackagesArgsPrivate * priv;
	GCancellable* cancellable;
};

struct _AppCenterCoreGetInstalledPackagesArgsClass {
	AppCenterCoreJobArgsClass parent_class;
};

struct _AppCenterCorePackageKitBackendGetInstalledPackagesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	GCancellable* cancellable;
	GeeTreeSet* result;
	AppCenterCoreGetInstalledPackagesArgs* job_args;
	AppCenterCoreGetInstalledPackagesArgs* _tmp0_;
	GCancellable* _tmp1_;
	AppCenterCoreJob* job;
	AppCenterCoreJob* _tmp2_;
	GObject* _tmp3_;
	GeeTreeSet* _tmp4_;
};

struct _Block59Data {
	int _ref_count_;
	AppCenterCorePackageKitBackend* self;
	guint64 size;
	gchar** package_array;
	gint package_array_length1;
	gint _package_array_size_;
};

struct _AppCenterCoreGetDownloadSizeArgs {
	AppCenterCoreJobArgs parent_instance;
	AppCenterCoreGetDownloadSizeArgsPrivate * priv;
	AppCenterCorePackage* package;
	GCancellable* cancellable;
};

struct _AppCenterCoreGetDownloadSizeArgsClass {
	AppCenterCoreJobArgsClass parent_class;
};

struct _AppCenterCorePackageKitBackendGetDownloadSizeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	AppCenterCorePackage* package;
	GCancellable* cancellable;
	gboolean is_update;
	guint64 result;
	AppCenterCoreGetDownloadSizeArgs* job_args;
	AppCenterCoreGetDownloadSizeArgs* _tmp0_;
	AppCenterCoreGetDownloadSizeArgs* _tmp1_;
	AppCenterCorePackage* _tmp2_;
	AppCenterCoreGetDownloadSizeArgs* _tmp3_;
	GCancellable* _tmp4_;
	AppCenterCoreJob* job;
	AppCenterCoreGetDownloadSizeArgs* _tmp5_;
	AppCenterCoreJob* _tmp6_;
	AppCenterCoreJob* _tmp7_;
	GError* _tmp8_;
	GError* _tmp9_;
	AppCenterCoreJob* _tmp10_;
	GError* _tmp11_;
	GError* _tmp12_;
	GError* _tmp13_;
	AppCenterCoreJob* _tmp14_;
	GError* _inner_error0_;
};

struct _Block60Data {
	int _ref_count_;
	AppCenterCorePackageKitBackend* self;
	AppCenterCoreChangeInformation* change_info;
	gchar** packages_ids;
	gint packages_ids_length1;
	gint _packages_ids_size_;
};

struct _AppCenterCoreInstallPackageArgs {
	AppCenterCoreJobArgs parent_instance;
	AppCenterCoreInstallPackageArgsPrivate * priv;
	AppCenterCorePackage* package;
	AppCenterCoreChangeInformation* change_info;
	GCancellable* cancellable;
};

struct _AppCenterCoreInstallPackageArgsClass {
	AppCenterCoreJobArgsClass parent_class;
};

struct _AppCenterCorePackageKitBackendInstallPackageData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	AppCenterCorePackage* package;
	AppCenterCoreChangeInformation* change_info;
	GCancellable* cancellable;
	gboolean result;
	AppCenterCoreInstallPackageArgs* job_args;
	AppCenterCoreInstallPackageArgs* _tmp0_;
	AppCenterCoreInstallPackageArgs* _tmp1_;
	AppCenterCorePackage* _tmp2_;
	AppCenterCoreInstallPackageArgs* _tmp3_;
	AppCenterCoreChangeInformation* _tmp4_;
	AppCenterCoreInstallPackageArgs* _tmp5_;
	GCancellable* _tmp6_;
	AppCenterCoreJob* job;
	AppCenterCoreInstallPackageArgs* _tmp7_;
	AppCenterCoreJob* _tmp8_;
	AppCenterCoreJob* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	AppCenterCoreJob* _tmp12_;
	GError* _tmp13_;
	GError* _tmp14_;
	GError* _tmp15_;
	AppCenterCoreJob* _tmp16_;
	GError* _inner_error0_;
};

struct _Block61Data {
	int _ref_count_;
	AppCenterCorePackageKitBackend* self;
	AppCenterCoreChangeInformation* change_info;
};

struct _AppCenterCoreUpdatePackageArgs {
	AppCenterCoreJobArgs parent_instance;
	AppCenterCoreUpdatePackageArgsPrivate * priv;
	AppCenterCorePackage* package;
	AppCenterCoreChangeInformation* change_info;
	GCancellable* cancellable;
};

struct _AppCenterCoreUpdatePackageArgsClass {
	AppCenterCoreJobArgsClass parent_class;
};

struct _AppCenterCorePackageKitBackendUpdatePackageData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	AppCenterCorePackage* package;
	AppCenterCoreChangeInformation* change_info;
	GCancellable* cancellable;
	gboolean result;
	AppCenterCoreUpdatePackageArgs* job_args;
	AppCenterCoreUpdatePackageArgs* _tmp0_;
	AppCenterCoreUpdatePackageArgs* _tmp1_;
	AppCenterCorePackage* _tmp2_;
	AppCenterCoreUpdatePackageArgs* _tmp3_;
	AppCenterCoreChangeInformation* _tmp4_;
	AppCenterCoreUpdatePackageArgs* _tmp5_;
	GCancellable* _tmp6_;
	PolkitPermission* _tmp7_;
	PolkitPermission* _tmp8_;
	PolkitUnixProcess* _tmp9_;
	PolkitUnixProcess* _tmp10_;
	PolkitPermission* _tmp11_;
	PolkitPermission* _tmp12_;
	PolkitPermission* _tmp13_;
	GError* e;
	GError* _tmp14_;
	const gchar* _tmp15_;
	AppCenterCoreJob* job;
	AppCenterCoreUpdatePackageArgs* _tmp16_;
	AppCenterCoreJob* _tmp17_;
	AppCenterCoreJob* _tmp18_;
	GError* _tmp19_;
	GError* _tmp20_;
	AppCenterCoreJob* _tmp21_;
	GError* _tmp22_;
	GError* _tmp23_;
	GError* _tmp24_;
	AppCenterCoreJob* _tmp25_;
	GError* _inner_error0_;
};

struct _Block62Data {
	int _ref_count_;
	AppCenterCorePackageKitBackend* self;
	AppCenterCoreChangeInformation* change_info;
	gchar** packages_ids;
	gint packages_ids_length1;
	gint _packages_ids_size_;
};

struct _AppCenterCoreRemovePackageArgs {
	AppCenterCoreJobArgs parent_instance;
	AppCenterCoreRemovePackageArgsPrivate * priv;
	AppCenterCorePackage* package;
	AppCenterCoreChangeInformation* change_info;
	GCancellable* cancellable;
};

struct _AppCenterCoreRemovePackageArgsClass {
	AppCenterCoreJobArgsClass parent_class;
};

struct _AppCenterCorePackageKitBackendRemovePackageData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	AppCenterCorePackage* package;
	AppCenterCoreChangeInformation* change_info;
	GCancellable* cancellable;
	gboolean result;
	AppCenterCoreRemovePackageArgs* job_args;
	AppCenterCoreRemovePackageArgs* _tmp0_;
	AppCenterCoreRemovePackageArgs* _tmp1_;
	AppCenterCorePackage* _tmp2_;
	AppCenterCoreRemovePackageArgs* _tmp3_;
	AppCenterCoreChangeInformation* _tmp4_;
	AppCenterCoreRemovePackageArgs* _tmp5_;
	GCancellable* _tmp6_;
	AppCenterCoreJob* job;
	AppCenterCoreRemovePackageArgs* _tmp7_;
	AppCenterCoreJob* _tmp8_;
	AppCenterCoreJob* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	AppCenterCoreJob* _tmp12_;
	GError* _tmp13_;
	GError* _tmp14_;
	GError* _tmp15_;
	AppCenterCoreJob* _tmp16_;
	GError* _inner_error0_;
};

struct _Block63Data {
	int _ref_count_;
	AppCenterCorePackageKitBackend* self;
	PkResults* results;
	gchar** package_ids;
	gint package_ids_length1;
	gint _package_ids_size_;
	GeeArrayList* downloaded_updates;
};

struct _AppCenterCoreGetUpdatesArgs {
	AppCenterCoreJobArgs parent_instance;
	AppCenterCoreGetUpdatesArgsPrivate * priv;
	GCancellable* cancellable;
};

struct _AppCenterCoreGetUpdatesArgsClass {
	AppCenterCoreJobArgsClass parent_class;
};

struct _AppCenterCorePackageKitBackendGetUpdatesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	GCancellable* cancellable;
	PkResults* result;
	AppCenterCoreGetUpdatesArgs* job_args;
	AppCenterCoreGetUpdatesArgs* _tmp0_;
	AppCenterCoreGetUpdatesArgs* _tmp1_;
	GCancellable* _tmp2_;
	AppCenterCoreJob* job;
	AppCenterCoreGetUpdatesArgs* _tmp3_;
	AppCenterCoreJob* _tmp4_;
	AppCenterCoreJob* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	AppCenterCoreJob* _tmp8_;
	GError* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	AppCenterCoreJob* _tmp12_;
	GObject* _tmp13_;
	PkResults* _tmp14_;
	GError* _inner_error0_;
};

struct _AppCenterCoreRefreshCacheArgs {
	AppCenterCoreJobArgs parent_instance;
	AppCenterCoreRefreshCacheArgsPrivate * priv;
	GCancellable* cancellable;
};

struct _AppCenterCoreRefreshCacheArgsClass {
	AppCenterCoreJobArgsClass parent_class;
};

struct _AppCenterCorePackageKitBackendRefreshCacheData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	GCancellable* cancellable;
	gboolean result;
	AppCenterCoreRefreshCacheArgs* job_args;
	AppCenterCoreRefreshCacheArgs* _tmp0_;
	AppCenterCoreRefreshCacheArgs* _tmp1_;
	GCancellable* _tmp2_;
	AppCenterCoreJob* job;
	AppCenterCoreRefreshCacheArgs* _tmp3_;
	AppCenterCoreJob* _tmp4_;
	AppCenterCoreJob* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	AppCenterCoreJob* _tmp8_;
	GError* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	AppCenterCoreJob* _tmp12_;
	GError* _inner_error0_;
};

struct _AppCenterCoreIsPackageInstalledArgs {
	AppCenterCoreJobArgs parent_instance;
	AppCenterCoreIsPackageInstalledArgsPrivate * priv;
	AppCenterCorePackage* package;
};

struct _AppCenterCoreIsPackageInstalledArgsClass {
	AppCenterCoreJobArgsClass parent_class;
};

struct _AppCenterCorePackageKitBackendIsPackageInstalledData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	AppCenterCorePackage* package;
	gboolean result;
	AppCenterCoreIsPackageInstalledArgs* job_args;
	AppCenterCoreIsPackageInstalledArgs* _tmp0_;
	AppCenterCoreIsPackageInstalledArgs* _tmp1_;
	AppCenterCorePackage* _tmp2_;
	AppCenterCoreJob* job;
	AppCenterCoreIsPackageInstalledArgs* _tmp3_;
	AppCenterCoreJob* _tmp4_;
	AppCenterCoreJob* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	AppCenterCoreJob* _tmp8_;
	GError* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	AppCenterCoreJob* _tmp12_;
	GError* _inner_error0_;
};

struct _Block64Data {
	int _ref_count_;
	AppCenterCorePackageKitBackend* self;
	PkPackage* pk_package;
};

struct _AppCenterCorePackageKitBackendUpdateMultiplePackageStateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	GeeCollection* packages;
	gchar** query;
	gchar** _tmp0_;
	gint query_length1;
	gint _query_size_;
	GeeIterator* _app_it;
	GeeIterator* _tmp1_;
	GeeIterator* _tmp2_;
	AppCenterCorePackage* app;
	GeeIterator* _tmp3_;
	gpointer _tmp4_;
	AppCenterCorePackage* _tmp5_;
	AppCenterCoreBackend* _tmp6_;
	AppCenterCoreBackend* _tmp7_;
	AppCenterCorePackage* _tmp8_;
	AsComponent* _tmp9_;
	AsComponent* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	PkBitfield filter;
	PkResults* results;
	AppCenterCoreTask* _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	PkResults* _tmp18_;
	GPtrArray* array;
	PkResults* _tmp19_;
	GPtrArray* _tmp20_;
	GPtrArray* _tmp21_;
	GError* e;
	GError* _tmp22_;
	GError* _tmp23_;
	GError* _inner_error0_;
};

struct _AppCenterCoreGetPackageDetailsArgs {
	AppCenterCoreJobArgs parent_instance;
	AppCenterCoreGetPackageDetailsArgsPrivate * priv;
	AppCenterCorePackage* package;
};

struct _AppCenterCoreGetPackageDetailsArgsClass {
	AppCenterCoreJobArgsClass parent_class;
};

struct _AppCenterCorePackageKitBackendGetPackageDetailsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	AppCenterCorePackage* package;
	AppCenterCorePackageDetails* result;
	AppCenterCoreGetPackageDetailsArgs* job_args;
	AppCenterCoreGetPackageDetailsArgs* _tmp0_;
	AppCenterCoreGetPackageDetailsArgs* _tmp1_;
	AppCenterCorePackage* _tmp2_;
	AppCenterCoreJob* job;
	AppCenterCoreGetPackageDetailsArgs* _tmp3_;
	AppCenterCoreJob* _tmp4_;
	AppCenterCoreJob* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	AppCenterCoreJob* _tmp8_;
	GError* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	AppCenterCoreJob* _tmp12_;
	GObject* _tmp13_;
	AppCenterCorePackageDetails* _tmp14_;
	GError* _inner_error0_;
};

struct _Block65Data {
	int _ref_count_;
	AppCenterCorePackageKitBackend* self;
	gchar** package_array;
	gint package_array_length1;
	gint _package_array_size_;
};

struct _AppCenterCoreGetPackageDependenciesArgs {
	AppCenterCoreJobArgs parent_instance;
	AppCenterCoreGetPackageDependenciesArgsPrivate * priv;
	AppCenterCorePackage* package;
	GCancellable* cancellable;
};

struct _AppCenterCoreGetPackageDependenciesArgsClass {
	AppCenterCoreJobArgsClass parent_class;
};

struct _AppCenterCorePackageKitBackendGetPackageDependenciesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	AppCenterCorePackage* package;
	GCancellable* cancellable;
	GeeArrayList* result;
	AppCenterCoreGetPackageDependenciesArgs* job_args;
	AppCenterCorePackage* _tmp0_;
	GCancellable* _tmp1_;
	AppCenterCoreGetPackageDependenciesArgs* _tmp2_;
	AppCenterCoreJob* job;
	AppCenterCoreGetPackageDependenciesArgs* _tmp3_;
	AppCenterCoreJob* _tmp4_;
	AppCenterCoreJob* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	AppCenterCoreJob* _tmp8_;
	GError* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	AppCenterCoreJob* _tmp12_;
	GObject* _tmp13_;
	GeeArrayList* _tmp14_;
	GError* _inner_error0_;
};

struct _AppCenterCorePackageKitBackendRepairData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AppCenterCorePackageKitBackend* self;
	GCancellable* cancellable;
	gboolean result;
};

struct _Block66Data {
	int _ref_count_;
	GMainLoop* loop;
};

static gint AppCenterCorePackageKitBackend_private_offset;
static gpointer app_center_core_package_kit_backend_parent_class = NULL;
static AppCenterCoreTask* app_center_core_package_kit_backend_client;
static AppCenterCoreTask* app_center_core_package_kit_backend_client = NULL;
static PolkitPermission* app_center_core_package_kit_backend_update_permission;
static PolkitPermission* app_center_core_package_kit_backend_update_permission = NULL;
static PkControl* app_center_core_package_kit_backend__control;
static PkControl* app_center_core_package_kit_backend__control = NULL;
static GOnce app_center_core_package_kit_backend_instance;
static GOnce app_center_core_package_kit_backend_instance = G_ONCE_INIT;
static AppCenterCoreBackendIface * app_center_core_package_kit_backend_app_center_core_backend_parent_iface = NULL;

VALA_EXTERN GQuark package_kit_backend_error_quark (void);
VALA_EXTERN GType package_kit_backend_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType app_center_core_package_details_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCorePackageDetails, g_object_unref)
VALA_EXTERN GType app_center_core_package_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCorePackage, g_object_unref)
VALA_EXTERN GType app_center_core_change_information_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreChangeInformation, g_object_unref)
VALA_EXTERN GType app_center_core_job_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType app_center_core_backend_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreBackend, g_object_unref)
VALA_EXTERN GType app_center_core_package_kit_backend_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCorePackageKitBackend, g_object_unref)
VALA_EXTERN GType app_center_core_job_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreJob, g_object_unref)
VALA_EXTERN GType app_center_core_task_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreTask, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static gboolean app_center_core_package_kit_backend_worker_func (AppCenterCorePackageKitBackend* self);
VALA_EXTERN void app_center_core_backend_set_working (AppCenterCoreBackend* self,
                                          gboolean value);
VALA_EXTERN AppCenterCoreJobType app_center_core_job_get_operation (AppCenterCoreJob* self);
VALA_EXTERN void app_center_core_backend_set_job_type (AppCenterCoreBackend* self,
                                           AppCenterCoreJobType value);
static void app_center_core_package_kit_backend_get_prepared_packages_internal (AppCenterCorePackageKitBackend* self,
                                                                         AppCenterCoreJob* job);
static void app_center_core_package_kit_backend_get_installed_packages_internal (AppCenterCorePackageKitBackend* self,
                                                                          AppCenterCoreJob* job);
static void app_center_core_package_kit_backend_get_download_size_internal (AppCenterCorePackageKitBackend* self,
                                                                     AppCenterCoreJob* job);
static void app_center_core_package_kit_backend_refresh_cache_internal (AppCenterCorePackageKitBackend* self,
                                                                 AppCenterCoreJob* job);
static void app_center_core_package_kit_backend_get_updates_internal (AppCenterCorePackageKitBackend* self,
                                                               AppCenterCoreJob* job);
static void app_center_core_package_kit_backend_install_package_internal (AppCenterCorePackageKitBackend* self,
                                                                   AppCenterCoreJob* job);
static void app_center_core_package_kit_backend_update_package_internal (AppCenterCorePackageKitBackend* self,
                                                                  AppCenterCoreJob* job);
static void app_center_core_package_kit_backend_remove_package_internal (AppCenterCorePackageKitBackend* self,
                                                                  AppCenterCoreJob* job);
static void app_center_core_package_kit_backend_is_package_installed_internal (AppCenterCorePackageKitBackend* self,
                                                                        AppCenterCoreJob* job);
static void app_center_core_package_kit_backend_get_package_details_internal (AppCenterCorePackageKitBackend* self,
                                                                       AppCenterCoreJob* job);
static void app_center_core_package_kit_backend_get_package_dependencies_internal (AppCenterCorePackageKitBackend* self,
                                                                            AppCenterCoreJob* job);
static AppCenterCorePackageKitBackend* app_center_core_package_kit_backend_new (void);
static AppCenterCorePackageKitBackend* app_center_core_package_kit_backend_construct (GType object_type);
static gpointer _app_center_core_package_kit_backend_worker_func_gthread_func (gpointer self);
static void app_center_core_package_kit_backend_reload_appstream_pool (AppCenterCorePackageKitBackend* self);
static PkControl* app_center_core_package_kit_backend_get_control (void);
static void app_center_core_package_kit_backend_updates_changed_callback (AppCenterCorePackageKitBackend* self);
static void _app_center_core_package_kit_backend_updates_changed_callback_pk_control_updates_changed (PkControl* _sender,
                                                                                               gpointer self);
VALA_EXTERN gboolean app_center_core_backend_get_working (AppCenterCoreBackend* self);
VALA_EXTERN GType app_center_core_update_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreUpdateManager, g_object_unref)
VALA_EXTERN AppCenterCoreUpdateManager* app_center_core_update_manager_get_default (void);
VALA_EXTERN void app_center_core_update_manager_update_restart_state (AppCenterCoreUpdateManager* self);
VALA_EXTERN GType app_center_core_package_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN AppCenterCorePackageState app_center_core_package_get_state (AppCenterCorePackage* self);
VALA_EXTERN gboolean app_center_core_package_get_installed (AppCenterCorePackage* self);
VALA_EXTERN void app_center_core_package_clear_installed (AppCenterCorePackage* self);
static void app_center_core_package_kit_backend_trigger_update_check (AppCenterCorePackageKitBackend* self,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_);
static void app_center_core_package_kit_backend_trigger_update_check_finish (AppCenterCorePackageKitBackend* self,
                                                                      GAsyncResult* _res_);
static void app_center_core_package_kit_backend_trigger_update_check_data_free (gpointer _data);
static gboolean app_center_core_package_kit_backend_trigger_update_check_co (AppCenterCorePackageKitBackendTriggerUpdateCheckData* _data_);
VALA_EXTERN void app_center_core_backend_refresh_cache (AppCenterCoreBackend* self,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN gboolean app_center_core_backend_refresh_cache_finish (AppCenterCoreBackend* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
static void app_center_core_package_kit_backend_trigger_update_check_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_);
VALA_EXTERN GType app_center_core_client_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreClient, g_object_unref)
VALA_EXTERN AppCenterCoreClient* app_center_core_client_get_default (void);
VALA_EXTERN void app_center_core_client_refresh_updates (AppCenterCoreClient* self,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN void app_center_core_client_refresh_updates_finish (AppCenterCoreClient* self,
                                                    GAsyncResult* _res_);
VALA_EXTERN GType app_center_core_component_validator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreComponentValidator, g_object_unref)
static Block53Data* block53_data_ref (Block53Data* _data53_);
static void block53_data_unref (void * _userdata_);
VALA_EXTERN AppCenterCoreComponentValidator* app_center_core_component_validator_get_default (void);
static void ___lambda18_ (Block53Data* _data53_,
                   AsComponent* comp);
VALA_EXTERN gboolean app_center_core_component_validator_validate (AppCenterCoreComponentValidator* self,
                                                       AsComponent* component);
VALA_EXTERN void app_center_core_package_replace_component (AppCenterCorePackage* self,
                                                AsComponent* component);
VALA_EXTERN AppCenterCorePackage* app_center_core_package_new (AppCenterCoreBackend* backend,
                                                   AsComponent* component);
VALA_EXTERN AppCenterCorePackage* app_center_core_package_construct (GType object_type,
                                                         AppCenterCoreBackend* backend,
                                                         AsComponent* component);
static void ____lambda18__gfunc (gconstpointer data,
                          gpointer self);
VALA_EXTERN AppCenterCorePackage* app_center_core_package_kit_backend_lookup_package_by_id (AppCenterCorePackageKitBackend* self,
                                                                                const gchar* id);
VALA_EXTERN AppCenterCorePackage* app_center_core_package_kit_backend_add_local_component_file (AppCenterCorePackageKitBackend* self,
                                                                                    GFile* file,
                                                                                    GError** error);
static void app_center_core_package_kit_backend_real_get_prepared_applications_data_free (gpointer _data);
static void app_center_core_package_kit_backend_real_get_prepared_applications (AppCenterCoreBackend* base,
                                                                         GCancellable* cancellable,
                                                                         GAsyncReadyCallback _callback_,
                                                                         gpointer _user_data_);
static gboolean app_center_core_package_kit_backend_real_get_prepared_applications_co (AppCenterCorePackageKitBackendGetPreparedApplicationsData* _data_);
VALA_EXTERN void app_center_core_package_kit_backend_get_prepared_packages (AppCenterCorePackageKitBackend* self,
                                                                GCancellable* cancellable,
                                                                GAsyncReadyCallback _callback_,
                                                                gpointer _user_data_);
VALA_EXTERN PkResults* app_center_core_package_kit_backend_get_prepared_packages_finish (AppCenterCorePackageKitBackend* self,
                                                                             GAsyncResult* _res_);
static void app_center_core_package_kit_backend_get_prepared_applications_ready (GObject* source_object,
                                                                          GAsyncResult* _res_,
                                                                          gpointer _user_data_);
VALA_EXTERN AppCenterCorePackageDetails* app_center_core_package_details_new (void);
VALA_EXTERN AppCenterCorePackageDetails* app_center_core_package_details_construct (GType object_type);
VALA_EXTERN void app_center_core_package_details_set_name (AppCenterCorePackageDetails* self,
                                               const gchar* value);
VALA_EXTERN void app_center_core_package_details_set_description (AppCenterCorePackageDetails* self,
                                                      const gchar* value);
VALA_EXTERN void app_center_core_package_details_set_summary (AppCenterCorePackageDetails* self,
                                                  const gchar* value);
VALA_EXTERN void app_center_core_package_details_set_version (AppCenterCorePackageDetails* self,
                                                  const gchar* value);
static void app_center_core_package_kit_backend_real_get_installed_applications_data_free (gpointer _data);
static void app_center_core_package_kit_backend_real_get_installed_applications (AppCenterCoreBackend* base,
                                                                          GCancellable* cancellable,
                                                                          GAsyncReadyCallback _callback_,
                                                                          gpointer _user_data_);
static gboolean app_center_core_package_kit_backend_real_get_installed_applications_co (AppCenterCorePackageKitBackendGetInstalledApplicationsData* _data_);
VALA_EXTERN void app_center_core_package_kit_backend_get_installed_packages (AppCenterCorePackageKitBackend* self,
                                                                 GCancellable* cancellable,
                                                                 GAsyncReadyCallback _callback_,
                                                                 gpointer _user_data_);
VALA_EXTERN GeeTreeSet* app_center_core_package_kit_backend_get_installed_packages_finish (AppCenterCorePackageKitBackend* self,
                                                                               GAsyncResult* _res_);
static void app_center_core_package_kit_backend_get_installed_applications_ready (GObject* source_object,
                                                                           GAsyncResult* _res_,
                                                                           gpointer _user_data_);
static AppCenterCorePackage* app_center_core_package_kit_backend_populate_basic_package_details (AppCenterCorePackageKitBackend* self,
                                                                                          PkPackage* pk_package);
static AppCenterCorePackage* app_center_core_package_kit_backend_real_get_package_for_component_id (AppCenterCoreBackend* base,
                                                                                             const gchar* id);
VALA_EXTERN AsComponent* app_center_core_package_get_component (AppCenterCorePackage* self);
VALA_EXTERN GeeHashMap* app_center_core_package_kit_backend_get_packages_for_component_ids (AppCenterCorePackageKitBackend* self,
                                                                                gchar** ids,
                                                                                gint ids_length1);
VALA_EXTERN AppCenterCorePackage* app_center_core_backend_get_package_for_component_id (AppCenterCoreBackend* self,
                                                                            const gchar* id);
static GeeCollection* app_center_core_package_kit_backend_real_get_packages_for_component_id (AppCenterCoreBackend* base,
                                                                                       const gchar* id);
static AppCenterCorePackage* app_center_core_package_kit_backend_real_get_package_for_desktop_id (AppCenterCoreBackend* base,
                                                                                           const gchar* desktop_id);
static GeeCollection* app_center_core_package_kit_backend_real_get_packages_by_author (AppCenterCoreBackend* base,
                                                                                const gchar* author,
                                                                                gint max);
static GeeCollection* app_center_core_package_kit_backend_real_get_applications_for_category (AppCenterCoreBackend* base,
                                                                                       AsCategory* category);
static Block54Data* block54_data_ref (Block54Data* _data54_);
static void block54_data_unref (void * _userdata_);
static void __lambda81_ (Block54Data* _data54_,
                  AsComponent* comp);
static void ___lambda81__gfunc (gconstpointer data,
                         gpointer self);
static GeeCollection* app_center_core_package_kit_backend_real_search_applications (AppCenterCoreBackend* base,
                                                                             const gchar* query,
                                                                             AsCategory* category);
static Block55Data* block55_data_ref (Block55Data* _data55_);
static void block55_data_unref (void * _userdata_);
static void ___lambda82_ (Block55Data* _data55_,
                   AsComponent* comp);
static void ____lambda82__gfunc (gconstpointer data,
                          gpointer self);
static Block56Data* block56_data_ref (Block56Data* _data56_);
static void block56_data_unref (void * _userdata_);
VALA_EXTERN GeeCollection* app_center_core_backend_get_applications_for_category (AppCenterCoreBackend* self,
                                                                      AsCategory* category);
static void ___lambda83_ (Block56Data* _data56_,
                   AsComponent* comp);
static void ____lambda83__gfunc (gconstpointer data,
                          gpointer self);
static GeeCollection* app_center_core_package_kit_backend_real_search_applications_mime (AppCenterCoreBackend* base,
                                                                                  const gchar* query);
static void app_center_core_package_kit_backend_launch_job_data_free (gpointer _data);
VALA_EXTERN gpointer app_center_core_job_args_ref (gpointer instance);
VALA_EXTERN void app_center_core_job_args_unref (gpointer instance);
VALA_EXTERN GParamSpec* app_center_core_param_spec_job_args (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags);
VALA_EXTERN void app_center_core_value_set_job_args (GValue* value,
                                         gpointer v_object);
VALA_EXTERN void app_center_core_value_take_job_args (GValue* value,
                                          gpointer v_object);
VALA_EXTERN gpointer app_center_core_value_get_job_args (const GValue* value);
VALA_EXTERN GType app_center_core_job_args_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreJobArgs, app_center_core_job_args_unref)
static void app_center_core_package_kit_backend_launch_job (AppCenterCorePackageKitBackend* self,
                                                     AppCenterCoreJobType type,
                                                     AppCenterCoreJobArgs* args,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static AppCenterCoreJob* app_center_core_package_kit_backend_launch_job_finish (AppCenterCorePackageKitBackend* self,
                                                                         GAsyncResult* _res_);
static gboolean app_center_core_package_kit_backend_launch_job_co (AppCenterCorePackageKitBackendLaunchJobData* _data_);
static Block57Data* block57_data_ref (Block57Data* _data57_);
static void block57_data_unref (void * _userdata_);
VALA_EXTERN AppCenterCoreJob* app_center_core_job_new (AppCenterCoreJobType type);
VALA_EXTERN AppCenterCoreJob* app_center_core_job_construct (GType object_type,
                                                 AppCenterCoreJobType type);
VALA_EXTERN void app_center_core_job_set_args (AppCenterCoreJob* self,
                                   AppCenterCoreJobArgs* value);
static gboolean _app_center_core_package_kit_backend_launch_job_co_gsource_func (gpointer self);
static void __lambda45_ (Block57Data* _data57_);
static void ___lambda45__app_center_core_job_results_ready (AppCenterCoreJob* _sender,
                                                     gpointer self);
static Block58Data* block58_data_ref (Block58Data* _data58_);
static void block58_data_unref (void * _userdata_);
VALA_EXTERN GType app_center_core_get_prepared_packages_args_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreGetPreparedPackagesArgs, app_center_core_job_args_unref)
VALA_EXTERN AppCenterCoreJobArgs* app_center_core_job_get_args (AppCenterCoreJob* self);
static void ___lambda4_ (AppCenterCorePackageKitBackend* self,
                  PkProgress* t,
                  PkProgressType p);
static void ____lambda4__pk_progress_callback (PkProgress* progress,
                                        PkProgressType type,
                                        gpointer self);
VALA_EXTERN void app_center_core_job_set_error (AppCenterCoreJob* self,
                                    GError* value);
static GeeArrayList* app_center_core_package_kit_backend_get_downloaded_updates (AppCenterCorePackageKitBackend* self);
static void __lambda5_ (Block58Data* _data58_,
                 PkPackage* pk_package);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void ___lambda5__gfunc (gconstpointer data,
                        gpointer self);
static void _vala_array_add7 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void ___lambda6_ (AppCenterCorePackageKitBackend* self,
                  PkProgress* p,
                  PkProgressType t);
static void ____lambda6__pk_progress_callback (PkProgress* progress,
                                        PkProgressType type,
                                        gpointer self);
static void __lambda7_ (Block58Data* _data58_,
                 PkDetails* details);
static void ___lambda7__gfunc (gconstpointer data,
                        gpointer self);
static void app_center_core_package_kit_backend_get_prepared_packages_data_free (gpointer _data);
static gboolean app_center_core_package_kit_backend_get_prepared_packages_co (AppCenterCorePackageKitBackendGetPreparedPackagesData* _data_);
VALA_EXTERN AppCenterCoreGetPreparedPackagesArgs* app_center_core_get_prepared_packages_args_new (void);
VALA_EXTERN AppCenterCoreGetPreparedPackagesArgs* app_center_core_get_prepared_packages_args_construct (GType object_type);
static void app_center_core_package_kit_backend_get_prepared_packages_ready (GObject* source_object,
                                                                      GAsyncResult* _res_,
                                                                      gpointer _user_data_);
VALA_EXTERN GType app_center_core_get_installed_packages_args_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreGetInstalledPackagesArgs, app_center_core_job_args_unref)
static void ___lambda8_ (AppCenterCorePackageKitBackend* self,
                  PkProgress* prog,
                  PkProgressType type);
static void ____lambda8__pk_progress_callback (PkProgress* progress,
                                        PkProgressType type,
                                        gpointer self);
static void app_center_core_package_kit_backend_get_installed_packages_data_free (gpointer _data);
static gboolean app_center_core_package_kit_backend_get_installed_packages_co (AppCenterCorePackageKitBackendGetInstalledPackagesData* _data_);
VALA_EXTERN AppCenterCoreGetInstalledPackagesArgs* app_center_core_get_installed_packages_args_new (void);
VALA_EXTERN AppCenterCoreGetInstalledPackagesArgs* app_center_core_get_installed_packages_args_construct (GType object_type);
static void app_center_core_package_kit_backend_get_installed_packages_ready (GObject* source_object,
                                                                       GAsyncResult* _res_,
                                                                       gpointer _user_data_);
static Block59Data* block59_data_ref (Block59Data* _data59_);
static void block59_data_unref (void * _userdata_);
VALA_EXTERN GType app_center_core_get_download_size_args_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreGetDownloadSizeArgs, app_center_core_job_args_unref)
static PkPackage* app_center_core_package_kit_backend_get_package_internal (AppCenterCorePackageKitBackend* self,
                                                                     AppCenterCorePackage* package,
                                                                     GError** error);
static void ___lambda12_ (AppCenterCorePackageKitBackend* self,
                   PkProgress* p,
                   PkProgressType t);
static void ____lambda12__pk_progress_callback (PkProgress* progress,
                                         PkProgressType type,
                                         gpointer self);
static void ___lambda13_ (Block59Data* _data59_,
                   PkPackage* dep_package);
static void _vala_array_add8 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void ____lambda13__gfunc (gconstpointer data,
                          gpointer self);
static void _vala_array_add9 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void ____lambda14_ (AppCenterCorePackageKitBackend* self,
                    PkProgress* p,
                    PkProgressType t);
static void _____lambda14__pk_progress_callback (PkProgress* progress,
                                          PkProgressType type,
                                          gpointer self);
static void ___lambda15_ (Block59Data* _data59_,
                   PkDetails* detail);
static void ____lambda15__gfunc (gconstpointer data,
                          gpointer self);
static void app_center_core_package_kit_backend_real_get_download_size_data_free (gpointer _data);
static void app_center_core_package_kit_backend_real_get_download_size (AppCenterCoreBackend* base,
                                                                 AppCenterCorePackage* package,
                                                                 GCancellable* cancellable,
                                                                 gboolean is_update,
                                                                 GAsyncReadyCallback _callback_,
                                                                 gpointer _user_data_);
static gboolean app_center_core_package_kit_backend_real_get_download_size_co (AppCenterCorePackageKitBackendGetDownloadSizeData* _data_);
VALA_EXTERN AppCenterCoreGetDownloadSizeArgs* app_center_core_get_download_size_args_new (void);
VALA_EXTERN AppCenterCoreGetDownloadSizeArgs* app_center_core_get_download_size_args_construct (GType object_type);
static void app_center_core_package_kit_backend_get_download_size_ready (GObject* source_object,
                                                                  GAsyncResult* _res_,
                                                                  gpointer _user_data_);
VALA_EXTERN GError* app_center_core_job_get_error (AppCenterCoreJob* self);
static Block60Data* block60_data_ref (Block60Data* _data60_);
static void block60_data_unref (void * _userdata_);
VALA_EXTERN GType app_center_core_install_package_args_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreInstallPackageArgs, app_center_core_job_args_unref)
static void app_center_core_package_kit_backend_reset_progress (AppCenterCorePackageKitBackend* self);
static gchar** _vala_array_dup6 (gchar** self,
                          gssize length);
static void _vala_array_add10 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void ___lambda71_ (AppCenterCorePackageKitBackend* self);
static void ____lambda71__pk_progress_callback (PkProgress* progress,
                                         PkProgressType type,
                                         gpointer self);
static void ____lambda72_ (AppCenterCorePackageKitBackend* self);
static void _____lambda72__pk_progress_callback (PkProgress* progress,
                                          PkProgressType type,
                                          gpointer self);
static void ___lambda73_ (Block60Data* _data60_,
                   PkPackage* package);
static void _vala_array_add11 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void ____lambda73__gfunc (gconstpointer data,
                          gpointer self);
static void _vala_array_add12 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void ___lambda74_ (Block60Data* _data60_,
                   PkProgress* progress,
                   PkProgressType status);
static void app_center_core_package_kit_backend_update_progress_status (AppCenterCorePackageKitBackend* self,
                                                                 PkProgress* progress,
                                                                 PkProgressType type);
VALA_EXTERN GType app_center_core_change_information_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void app_center_core_change_information_callback (AppCenterCoreChangeInformation* self,
                                                  gboolean can_cancel,
                                                  const gchar* status_description,
                                                  gdouble progress,
                                                  AppCenterCoreChangeInformationStatus status);
VALA_EXTERN const gchar* utils_pk_status_to_string (PkStatusEnum status);
static AppCenterCoreChangeInformationStatus app_center_core_package_kit_backend_pk_status_to_appcenter_status (PkStatusEnum status);
static void ____lambda74__pk_progress_callback (PkProgress* progress,
                                         PkProgressType type,
                                         gpointer self);
static void app_center_core_package_kit_backend_real_install_package_data_free (gpointer _data);
static void app_center_core_package_kit_backend_real_install_package (AppCenterCoreBackend* base,
                                                               AppCenterCorePackage* package,
                                                               AppCenterCoreChangeInformation* change_info,
                                                               GCancellable* cancellable,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_);
static gboolean app_center_core_package_kit_backend_real_install_package_co (AppCenterCorePackageKitBackendInstallPackageData* _data_);
VALA_EXTERN AppCenterCoreInstallPackageArgs* app_center_core_install_package_args_new (void);
VALA_EXTERN AppCenterCoreInstallPackageArgs* app_center_core_install_package_args_construct (GType object_type);
static void app_center_core_package_kit_backend_install_package_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
static Block61Data* block61_data_ref (Block61Data* _data61_);
static void block61_data_unref (void * _userdata_);
VALA_EXTERN GType app_center_core_update_package_args_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreUpdatePackageArgs, app_center_core_job_args_unref)
VALA_EXTERN AppCenterCoreChangeInformation* app_center_core_package_get_change_information (AppCenterCorePackage* self);
VALA_EXTERN GeeMultiMap* app_center_core_change_information_get_updatable_packages (AppCenterCoreChangeInformation* self);
static void _vala_array_add13 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void ___lambda75_ (Block61Data* _data61_,
                   PkProgress* progress,
                   PkProgressType status);
static void ____lambda75__pk_progress_callback (PkProgress* progress,
                                         PkProgressType type,
                                         gpointer self);
static void app_center_core_package_kit_backend_real_update_package_data_free (gpointer _data);
static void app_center_core_package_kit_backend_real_update_package (AppCenterCoreBackend* base,
                                                              AppCenterCorePackage* package,
                                                              AppCenterCoreChangeInformation* change_info,
                                                              GCancellable* cancellable,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
static gboolean app_center_core_package_kit_backend_real_update_package_co (AppCenterCorePackageKitBackendUpdatePackageData* _data_);
VALA_EXTERN AppCenterCoreUpdatePackageArgs* app_center_core_update_package_args_new (void);
VALA_EXTERN AppCenterCoreUpdatePackageArgs* app_center_core_update_package_args_construct (GType object_type);
static void app_center_core_package_kit_backend_update_package_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_);
static Block62Data* block62_data_ref (Block62Data* _data62_);
static void block62_data_unref (void * _userdata_);
VALA_EXTERN GType app_center_core_remove_package_args_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreRemovePackageArgs, app_center_core_job_args_unref)
static gchar** _vala_array_dup7 (gchar** self,
                          gssize length);
static void _vala_array_add14 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void ___lambda76_ (AppCenterCorePackageKitBackend* self);
static void ____lambda76__pk_progress_callback (PkProgress* progress,
                                         PkProgressType type,
                                         gpointer self);
static void ___lambda77_ (Block62Data* _data62_,
                   PkPackage* package);
static void _vala_array_add15 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void ____lambda77__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda78_ (Block62Data* _data62_,
                   PkProgress* progress,
                   PkProgressType status);
static void ____lambda78__pk_progress_callback (PkProgress* progress,
                                         PkProgressType type,
                                         gpointer self);
static void app_center_core_package_kit_backend_real_remove_package_data_free (gpointer _data);
static void app_center_core_package_kit_backend_real_remove_package (AppCenterCoreBackend* base,
                                                              AppCenterCorePackage* package,
                                                              AppCenterCoreChangeInformation* change_info,
                                                              GCancellable* cancellable,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
static gboolean app_center_core_package_kit_backend_real_remove_package_co (AppCenterCorePackageKitBackendRemovePackageData* _data_);
VALA_EXTERN AppCenterCoreRemovePackageArgs* app_center_core_remove_package_args_new (void);
VALA_EXTERN AppCenterCoreRemovePackageArgs* app_center_core_remove_package_args_construct (GType object_type);
static void app_center_core_package_kit_backend_remove_package_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_);
static gchar** _vala_array_dup8 (gchar** self,
                          gssize length);
VALA_EXTERN gboolean app_center_core_package_kit_backend_is_restart_required (AppCenterCorePackageKitBackend* self);
static Block63Data* block63_data_ref (Block63Data* _data63_);
static void block63_data_unref (void * _userdata_);
VALA_EXTERN GType app_center_core_get_updates_args_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreGetUpdatesArgs, app_center_core_job_args_unref)
static void ___lambda67_ (AppCenterCorePackageKitBackend* self,
                   PkProgress* t,
                   PkProgressType p);
static void ____lambda67__pk_progress_callback (PkProgress* progress,
                                         PkProgressType type,
                                         gpointer self);
VALA_EXTERN gchar** app_center_core_package_kit_backend_get_fake_packages (AppCenterCorePackageKitBackend* self,
                                                               gint* result_length1);
VALA_EXTERN void app_center_core_package_kit_backend_set_fake_packages (AppCenterCorePackageKitBackend* self,
                                                            gchar** value,
                                                            gint value_length1);
static void __lambda68_ (Block63Data* _data63_,
                  PkPackage* pk_package);
static void _vala_array_add16 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void ___lambda68__gfunc (gconstpointer data,
                         gpointer self);
static void _vala_array_add17 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void ___lambda69_ (AppCenterCorePackageKitBackend* self,
                   PkProgress* p,
                   PkProgressType t);
static void ____lambda69__pk_progress_callback (PkProgress* progress,
                                         PkProgressType type,
                                         gpointer self);
static void __lambda70_ (Block63Data* _data63_,
                  PkDetails* details);
static void ___lambda70__gfunc (gconstpointer data,
                         gpointer self);
static void app_center_core_package_kit_backend_get_updates_data_free (gpointer _data);
VALA_EXTERN void app_center_core_package_kit_backend_get_updates (AppCenterCorePackageKitBackend* self,
                                                      GCancellable* cancellable,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
VALA_EXTERN PkResults* app_center_core_package_kit_backend_get_updates_finish (AppCenterCorePackageKitBackend* self,
                                                                   GAsyncResult* _res_,
                                                                   GError** error);
static gboolean app_center_core_package_kit_backend_get_updates_co (AppCenterCorePackageKitBackendGetUpdatesData* _data_);
VALA_EXTERN AppCenterCoreGetUpdatesArgs* app_center_core_get_updates_args_new (void);
VALA_EXTERN AppCenterCoreGetUpdatesArgs* app_center_core_get_updates_args_construct (GType object_type);
static void app_center_core_package_kit_backend_get_updates_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_);
VALA_EXTERN GType app_center_core_refresh_cache_args_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreRefreshCacheArgs, app_center_core_job_args_unref)
static void ___lambda16_ (AppCenterCorePackageKitBackend* self,
                   PkProgress* t,
                   PkProgressType p);
static void ____lambda16__pk_progress_callback (PkProgress* progress,
                                         PkProgressType type,
                                         gpointer self);
VALA_EXTERN GType app_center_core_backend_aggregator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreBackendAggregator, g_object_unref)
VALA_EXTERN AppCenterCoreBackendAggregator* app_center_core_backend_aggregator_get_default (void);
static void app_center_core_package_kit_backend_real_refresh_cache_data_free (gpointer _data);
static void app_center_core_package_kit_backend_real_refresh_cache (AppCenterCoreBackend* base,
                                                             GCancellable* cancellable,
                                                             GAsyncReadyCallback _callback_,
                                                             gpointer _user_data_);
static gboolean app_center_core_package_kit_backend_real_refresh_cache_co (AppCenterCorePackageKitBackendRefreshCacheData* _data_);
VALA_EXTERN AppCenterCoreRefreshCacheArgs* app_center_core_refresh_cache_args_new (void);
VALA_EXTERN AppCenterCoreRefreshCacheArgs* app_center_core_refresh_cache_args_construct (GType object_type);
static void app_center_core_package_kit_backend_refresh_cache_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_);
VALA_EXTERN GType app_center_core_ispackage_installed_args_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreIsPackageInstalledArgs, app_center_core_job_args_unref)
static void app_center_core_package_kit_backend_real_is_package_installed_data_free (gpointer _data);
static void app_center_core_package_kit_backend_real_is_package_installed (AppCenterCoreBackend* base,
                                                                    AppCenterCorePackage* package,
                                                                    GAsyncReadyCallback _callback_,
                                                                    gpointer _user_data_);
static gboolean app_center_core_package_kit_backend_real_is_package_installed_co (AppCenterCorePackageKitBackendIsPackageInstalledData* _data_);
VALA_EXTERN AppCenterCoreIsPackageInstalledArgs* app_center_core_ispackage_installed_args_new (void);
VALA_EXTERN AppCenterCoreIsPackageInstalledArgs* app_center_core_ispackage_installed_args_construct (GType object_type);
static void app_center_core_package_kit_backend_is_package_installed_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_);
static Block64Data* block64_data_ref (Block64Data* _data64_);
static void block64_data_unref (void * _userdata_);
static void ___lambda9_ (AppCenterCorePackageKitBackend* self);
static void ____lambda9__pk_progress_callback (PkProgress* progress,
                                        PkProgressType type,
                                        gpointer self);
static void ____lambda10_ (AppCenterCorePackageKitBackend* self,
                    PkProgress* t,
                    PkProgressType p);
static void _____lambda10__pk_progress_callback (PkProgress* progress,
                                          PkProgressType type,
                                          gpointer self);
static void ____lambda11_ (Block64Data* _data64_,
                    PkDetails* details);
static void _____lambda11__gfunc (gconstpointer data,
                           gpointer self);
static void app_center_core_package_kit_backend_update_multiple_package_state_data_free (gpointer _data);
VALA_EXTERN void app_center_core_package_kit_backend_update_multiple_package_state (AppCenterCorePackageKitBackend* self,
                                                                        GeeCollection* packages,
                                                                        GAsyncReadyCallback _callback_,
                                                                        gpointer _user_data_);
VALA_EXTERN void app_center_core_package_kit_backend_update_multiple_package_state_finish (AppCenterCorePackageKitBackend* self,
                                                                               GAsyncResult* _res_,
                                                                               GError** error);
static gboolean app_center_core_package_kit_backend_update_multiple_package_state_co (AppCenterCorePackageKitBackendUpdateMultiplePackageStateData* _data_);
VALA_EXTERN AppCenterCoreBackend* app_center_core_package_get_backend (AppCenterCorePackage* self);
static void _vala_array_add18 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add19 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void ___lambda84_ (AppCenterCorePackageKitBackend* self);
static void ____lambda84__pk_progress_callback (PkProgress* progress,
                                         PkProgressType type,
                                         gpointer self);
static void app_center_core_package_kit_backend_update_multiple_package_state_ready (GObject* source_object,
                                                                              GAsyncResult* _res_,
                                                                              gpointer _user_data_);
static void ___lambda85_ (AppCenterCorePackageKitBackend* self,
                   PkPackage* pk_package);
static void ____lambda85__gfunc (gconstpointer data,
                          gpointer self);
VALA_EXTERN void app_center_core_package_set_latest_version (AppCenterCorePackage* self,
                                                 const gchar* value);
VALA_EXTERN void app_center_core_package_set_name (AppCenterCorePackage* self,
                                       const gchar* new_name);
VALA_EXTERN void app_center_core_package_set_summary (AppCenterCorePackage* self,
                                          const gchar* new_summary);
VALA_EXTERN void app_center_core_package_mark_installed (AppCenterCorePackage* self);
VALA_EXTERN GType app_center_core_get_package_details_args_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreGetPackageDetailsArgs, app_center_core_job_args_unref)
static void app_center_core_package_kit_backend_real_get_package_details_data_free (gpointer _data);
static void app_center_core_package_kit_backend_real_get_package_details (AppCenterCoreBackend* base,
                                                                   AppCenterCorePackage* package,
                                                                   GAsyncReadyCallback _callback_,
                                                                   gpointer _user_data_);
static gboolean app_center_core_package_kit_backend_real_get_package_details_co (AppCenterCorePackageKitBackendGetPackageDetailsData* _data_);
VALA_EXTERN AppCenterCoreGetPackageDetailsArgs* app_center_core_get_package_details_args_new (void);
VALA_EXTERN AppCenterCoreGetPackageDetailsArgs* app_center_core_get_package_details_args_construct (GType object_type);
static void app_center_core_package_kit_backend_get_package_details_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_);
static Block65Data* block65_data_ref (Block65Data* _data65_);
static void block65_data_unref (void * _userdata_);
VALA_EXTERN GType app_center_core_get_package_dependencies_args_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreGetPackageDependenciesArgs, app_center_core_job_args_unref)
static void ___lambda79_ (AppCenterCorePackageKitBackend* self,
                   PkProgress* p,
                   PkProgressType t);
static void ____lambda79__pk_progress_callback (PkProgress* progress,
                                         PkProgressType type,
                                         gpointer self);
static void ___lambda80_ (Block65Data* _data65_,
                   PkPackage* dep_package);
static void _vala_array_add20 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void ____lambda80__gfunc (gconstpointer data,
                          gpointer self);
static gchar** _vala_array_dup9 (gchar** self,
                          gssize length);
static void app_center_core_package_kit_backend_get_package_dependencies_data_free (gpointer _data);
VALA_EXTERN void app_center_core_package_kit_backend_get_package_dependencies (AppCenterCorePackageKitBackend* self,
                                                                   AppCenterCorePackage* package,
                                                                   GCancellable* cancellable,
                                                                   GAsyncReadyCallback _callback_,
                                                                   gpointer _user_data_);
VALA_EXTERN GeeArrayList* app_center_core_package_kit_backend_get_package_dependencies_finish (AppCenterCorePackageKitBackend* self,
                                                                                   GAsyncResult* _res_,
                                                                                   GError** error);
static gboolean app_center_core_package_kit_backend_get_package_dependencies_co (AppCenterCorePackageKitBackendGetPackageDependenciesData* _data_);
VALA_EXTERN AppCenterCoreGetPackageDependenciesArgs* app_center_core_get_package_dependencies_args_new (void);
VALA_EXTERN AppCenterCoreGetPackageDependenciesArgs* app_center_core_get_package_dependencies_args_construct (GType object_type);
static void app_center_core_package_kit_backend_get_package_dependencies_ready (GObject* source_object,
                                                                         GAsyncResult* _res_,
                                                                         gpointer _user_data_);
static void app_center_core_package_kit_backend_real_repair_data_free (gpointer _data);
static void app_center_core_package_kit_backend_real_repair (AppCenterCoreBackend* base,
                                                      GCancellable* cancellable,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static gboolean app_center_core_package_kit_backend_real_repair_co (AppCenterCorePackageKitBackendRepairData* _data_);
VALA_EXTERN AppCenterCorePackageKitBackend* app_center_core_package_kit_backend_get_default (void);
static AppCenterCorePackageKitBackend* __lambda44_ (void);
static gpointer ___lambda44__gthread_func (gpointer self);
static gchar** _vala_array_dup10 (gchar** self,
                           gssize length);
VALA_EXTERN gboolean app_center_core_package_kit_backend_get_supports_parallel_package_queries (void);
static Block66Data* block66_data_ref (Block66Data* _data66_);
static void block66_data_unref (void * _userdata_);
static void _app_center_core_package_kit_backend___lambda86_ (Block66Data* _data66_,
                                                       GObject* obj,
                                                       GAsyncResult* res);
static void __app_center_core_package_kit_backend___lambda86__gasync_ready_callback (GObject* source_object,
                                                                              GAsyncResult* res,
                                                                              gpointer self);
VALA_EXTERN AppCenterCoreTask* app_center_core_task_new (void);
VALA_EXTERN AppCenterCoreTask* app_center_core_task_construct (GType object_type);
VALA_EXTERN void app_center_core_backend_get_prepared_applications (AppCenterCoreBackend* self,
                                                        GCancellable* cancellable,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
VALA_EXTERN GeeCollection* app_center_core_backend_get_prepared_applications_finish (AppCenterCoreBackend* self,
                                                                         GAsyncResult* _res_);
VALA_EXTERN void app_center_core_backend_get_installed_applications (AppCenterCoreBackend* self,
                                                         GCancellable* cancellable,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_);
VALA_EXTERN GeeCollection* app_center_core_backend_get_installed_applications_finish (AppCenterCoreBackend* self,
                                                                          GAsyncResult* _res_);
VALA_EXTERN GeeCollection* app_center_core_backend_get_packages_for_component_id (AppCenterCoreBackend* self,
                                                                      const gchar* id);
VALA_EXTERN AppCenterCorePackage* app_center_core_backend_get_package_for_desktop_id (AppCenterCoreBackend* self,
                                                                          const gchar* id);
VALA_EXTERN GeeCollection* app_center_core_backend_get_packages_by_author (AppCenterCoreBackend* self,
                                                               const gchar* author,
                                                               gint max);
VALA_EXTERN GeeCollection* app_center_core_backend_search_applications (AppCenterCoreBackend* self,
                                                            const gchar* query,
                                                            AsCategory* category);
VALA_EXTERN GeeCollection* app_center_core_backend_search_applications_mime (AppCenterCoreBackend* self,
                                                                 const gchar* query);
VALA_EXTERN void app_center_core_backend_get_download_size (AppCenterCoreBackend* self,
                                                AppCenterCorePackage* package,
                                                GCancellable* cancellable,
                                                gboolean is_update,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN guint64 app_center_core_backend_get_download_size_finish (AppCenterCoreBackend* self,
                                                          GAsyncResult* _res_,
                                                          GError** error);
VALA_EXTERN void app_center_core_backend_install_package (AppCenterCoreBackend* self,
                                              AppCenterCorePackage* package,
                                              AppCenterCoreChangeInformation* change_info,
                                              GCancellable* cancellable,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
VALA_EXTERN gboolean app_center_core_backend_install_package_finish (AppCenterCoreBackend* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
VALA_EXTERN void app_center_core_backend_update_package (AppCenterCoreBackend* self,
                                             AppCenterCorePackage* package,
                                             AppCenterCoreChangeInformation* change_info,
                                             GCancellable* cancellable,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN gboolean app_center_core_backend_update_package_finish (AppCenterCoreBackend* self,
                                                        GAsyncResult* _res_,
                                                        GError** error);
VALA_EXTERN void app_center_core_backend_remove_package (AppCenterCoreBackend* self,
                                             AppCenterCorePackage* package,
                                             AppCenterCoreChangeInformation* change_info,
                                             GCancellable* cancellable,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN gboolean app_center_core_backend_remove_package_finish (AppCenterCoreBackend* self,
                                                        GAsyncResult* _res_,
                                                        GError** error);
VALA_EXTERN void app_center_core_backend_is_package_installed (AppCenterCoreBackend* self,
                                                   AppCenterCorePackage* package,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
VALA_EXTERN gboolean app_center_core_backend_is_package_installed_finish (AppCenterCoreBackend* self,
                                                              GAsyncResult* _res_,
                                                              GError** error);
VALA_EXTERN void app_center_core_backend_get_package_details (AppCenterCoreBackend* self,
                                                  AppCenterCorePackage* package,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
VALA_EXTERN AppCenterCorePackageDetails* app_center_core_backend_get_package_details_finish (AppCenterCoreBackend* self,
                                                                                 GAsyncResult* _res_,
                                                                                 GError** error);
VALA_EXTERN void app_center_core_backend_repair (AppCenterCoreBackend* self,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
VALA_EXTERN gboolean app_center_core_backend_repair_finish (AppCenterCoreBackend* self,
                                                GAsyncResult* _res_,
                                                GError** error);
VALA_EXTERN AppCenterCoreJobType app_center_core_backend_get_job_type (AppCenterCoreBackend* self);
static void app_center_core_package_kit_backend_finalize (GObject * obj);
static GType app_center_core_package_kit_backend_get_type_once (void);
static void _vala_app_center_core_package_kit_backend_get_property (GObject * object,
                                                             guint property_id,
                                                             GValue * value,
                                                             GParamSpec * pspec);
static void _vala_app_center_core_package_kit_backend_set_property (GObject * object,
                                                             guint property_id,
                                                             const GValue * value,
                                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GQuark
package_kit_backend_error_quark (void)
{
	return g_quark_from_static_string ("package-kit-backend-error-quark");
}

static GType
package_kit_backend_error_get_type_once (void)
{
	static const GEnumValue values[] = {{PACKAGE_KIT_BACKEND_ERROR_PACKAGE_NOT_FOUND, "PACKAGE_KIT_BACKEND_ERROR_PACKAGE_NOT_FOUND", "package-not-found"}, {0, NULL, NULL}};
	GType package_kit_backend_error_type_id;
	package_kit_backend_error_type_id = g_enum_register_static ("PackageKitBackendError", values);
	return package_kit_backend_error_type_id;
}

GType
package_kit_backend_error_get_type (void)
{
	static volatile gsize package_kit_backend_error_type_id__once = 0;
	if (g_once_init_enter (&package_kit_backend_error_type_id__once)) {
		GType package_kit_backend_error_type_id;
		package_kit_backend_error_type_id = package_kit_backend_error_get_type_once ();
		g_once_init_leave (&package_kit_backend_error_type_id__once, package_kit_backend_error_type_id);
	}
	return package_kit_backend_error_type_id__once;
}

static inline gpointer
app_center_core_package_kit_backend_get_instance_private (AppCenterCorePackageKitBackend* self)
{
	return G_STRUCT_MEMBER_P (self, AppCenterCorePackageKitBackend_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 26 "../src/Core/PackageKitBackend.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1984 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_worker_func (AppCenterCorePackageKitBackend* self)
{
	gboolean result;
#line 86 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 87 "../src/Core/PackageKitBackend.vala"
	while (TRUE) {
#line 1995 "PackageKitBackend.c"
		GDateTime* _tmp0_;
		AppCenterCoreJob* job = NULL;
		GAsyncQueue* _tmp1_;
		gpointer _tmp2_;
		AppCenterCoreJob* _tmp3_;
		AppCenterCoreJobType _tmp4_;
		AppCenterCoreJobType _tmp5_;
		AppCenterCoreJob* _tmp6_;
		AppCenterCoreJobType _tmp7_;
		AppCenterCoreJobType _tmp8_;
#line 87 "../src/Core/PackageKitBackend.vala"
		if (!self->priv->thread_should_run) {
#line 87 "../src/Core/PackageKitBackend.vala"
			break;
#line 2010 "PackageKitBackend.c"
		}
#line 88 "../src/Core/PackageKitBackend.vala"
		_tmp0_ = g_date_time_new_now_local ();
#line 88 "../src/Core/PackageKitBackend.vala"
		_g_date_time_unref0 (self->priv->last_action);
#line 88 "../src/Core/PackageKitBackend.vala"
		self->priv->last_action = _tmp0_;
#line 89 "../src/Core/PackageKitBackend.vala"
		app_center_core_backend_set_working ((AppCenterCoreBackend*) self, FALSE);
#line 90 "../src/Core/PackageKitBackend.vala"
		_tmp1_ = self->priv->jobs;
#line 90 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = g_async_queue_pop (_tmp1_);
#line 90 "../src/Core/PackageKitBackend.vala"
		job = (AppCenterCoreJob*) _tmp2_;
#line 91 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = job;
#line 91 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = app_center_core_job_get_operation (_tmp3_);
#line 91 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = _tmp4_;
#line 91 "../src/Core/PackageKitBackend.vala"
		app_center_core_backend_set_job_type ((AppCenterCoreBackend*) self, _tmp5_);
#line 92 "../src/Core/PackageKitBackend.vala"
		app_center_core_backend_set_working ((AppCenterCoreBackend*) self, TRUE);
#line 93 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = job;
#line 93 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = app_center_core_job_get_operation (_tmp6_);
#line 93 "../src/Core/PackageKitBackend.vala"
		_tmp8_ = _tmp7_;
#line 93 "../src/Core/PackageKitBackend.vala"
		switch (_tmp8_) {
#line 93 "../src/Core/PackageKitBackend.vala"
			case APP_CENTER_CORE_JOB_TYPE_GET_PREPARED_PACKAGES:
#line 2046 "PackageKitBackend.c"
			{
				AppCenterCoreJob* _tmp9_;
#line 95 "../src/Core/PackageKitBackend.vala"
				_tmp9_ = job;
#line 95 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_kit_backend_get_prepared_packages_internal (self, _tmp9_);
#line 96 "../src/Core/PackageKitBackend.vala"
				break;
#line 2055 "PackageKitBackend.c"
			}
#line 93 "../src/Core/PackageKitBackend.vala"
			case APP_CENTER_CORE_JOB_TYPE_GET_INSTALLED_PACKAGES:
#line 2059 "PackageKitBackend.c"
			{
				AppCenterCoreJob* _tmp10_;
#line 98 "../src/Core/PackageKitBackend.vala"
				_tmp10_ = job;
#line 98 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_kit_backend_get_installed_packages_internal (self, _tmp10_);
#line 99 "../src/Core/PackageKitBackend.vala"
				break;
#line 2068 "PackageKitBackend.c"
			}
#line 93 "../src/Core/PackageKitBackend.vala"
			case APP_CENTER_CORE_JOB_TYPE_GET_DOWNLOAD_SIZE:
#line 2072 "PackageKitBackend.c"
			{
				AppCenterCoreJob* _tmp11_;
#line 101 "../src/Core/PackageKitBackend.vala"
				_tmp11_ = job;
#line 101 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_kit_backend_get_download_size_internal (self, _tmp11_);
#line 102 "../src/Core/PackageKitBackend.vala"
				break;
#line 2081 "PackageKitBackend.c"
			}
#line 93 "../src/Core/PackageKitBackend.vala"
			case APP_CENTER_CORE_JOB_TYPE_REFRESH_CACHE:
#line 2085 "PackageKitBackend.c"
			{
				AppCenterCoreJob* _tmp12_;
#line 104 "../src/Core/PackageKitBackend.vala"
				_tmp12_ = job;
#line 104 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_kit_backend_refresh_cache_internal (self, _tmp12_);
#line 105 "../src/Core/PackageKitBackend.vala"
				break;
#line 2094 "PackageKitBackend.c"
			}
#line 93 "../src/Core/PackageKitBackend.vala"
			case APP_CENTER_CORE_JOB_TYPE_GET_UPDATES:
#line 2098 "PackageKitBackend.c"
			{
				AppCenterCoreJob* _tmp13_;
#line 107 "../src/Core/PackageKitBackend.vala"
				_tmp13_ = job;
#line 107 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_kit_backend_get_updates_internal (self, _tmp13_);
#line 108 "../src/Core/PackageKitBackend.vala"
				break;
#line 2107 "PackageKitBackend.c"
			}
#line 93 "../src/Core/PackageKitBackend.vala"
			case APP_CENTER_CORE_JOB_TYPE_INSTALL_PACKAGE:
#line 2111 "PackageKitBackend.c"
			{
				AppCenterCoreJob* _tmp14_;
#line 110 "../src/Core/PackageKitBackend.vala"
				_tmp14_ = job;
#line 110 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_kit_backend_install_package_internal (self, _tmp14_);
#line 111 "../src/Core/PackageKitBackend.vala"
				break;
#line 2120 "PackageKitBackend.c"
			}
#line 93 "../src/Core/PackageKitBackend.vala"
			case APP_CENTER_CORE_JOB_TYPE_UPDATE_PACKAGE:
#line 2124 "PackageKitBackend.c"
			{
				AppCenterCoreJob* _tmp15_;
#line 113 "../src/Core/PackageKitBackend.vala"
				_tmp15_ = job;
#line 113 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_kit_backend_update_package_internal (self, _tmp15_);
#line 114 "../src/Core/PackageKitBackend.vala"
				break;
#line 2133 "PackageKitBackend.c"
			}
#line 93 "../src/Core/PackageKitBackend.vala"
			case APP_CENTER_CORE_JOB_TYPE_REMOVE_PACKAGE:
#line 2137 "PackageKitBackend.c"
			{
				AppCenterCoreJob* _tmp16_;
#line 116 "../src/Core/PackageKitBackend.vala"
				_tmp16_ = job;
#line 116 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_kit_backend_remove_package_internal (self, _tmp16_);
#line 117 "../src/Core/PackageKitBackend.vala"
				break;
#line 2146 "PackageKitBackend.c"
			}
#line 93 "../src/Core/PackageKitBackend.vala"
			case APP_CENTER_CORE_JOB_TYPE_IS_PACKAGE_INSTALLED:
#line 2150 "PackageKitBackend.c"
			{
				AppCenterCoreJob* _tmp17_;
#line 119 "../src/Core/PackageKitBackend.vala"
				_tmp17_ = job;
#line 119 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_kit_backend_is_package_installed_internal (self, _tmp17_);
#line 120 "../src/Core/PackageKitBackend.vala"
				break;
#line 2159 "PackageKitBackend.c"
			}
#line 93 "../src/Core/PackageKitBackend.vala"
			case APP_CENTER_CORE_JOB_TYPE_GET_PACKAGE_DETAILS:
#line 2163 "PackageKitBackend.c"
			{
				AppCenterCoreJob* _tmp18_;
#line 122 "../src/Core/PackageKitBackend.vala"
				_tmp18_ = job;
#line 122 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_kit_backend_get_package_details_internal (self, _tmp18_);
#line 123 "../src/Core/PackageKitBackend.vala"
				break;
#line 2172 "PackageKitBackend.c"
			}
#line 93 "../src/Core/PackageKitBackend.vala"
			case APP_CENTER_CORE_JOB_TYPE_GET_PACKAGE_DEPENDENCIES:
#line 2176 "PackageKitBackend.c"
			{
				AppCenterCoreJob* _tmp19_;
#line 125 "../src/Core/PackageKitBackend.vala"
				_tmp19_ = job;
#line 125 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_kit_backend_get_package_dependencies_internal (self, _tmp19_);
#line 126 "../src/Core/PackageKitBackend.vala"
				break;
#line 2185 "PackageKitBackend.c"
			}
			default:
			{
#line 128 "../src/Core/PackageKitBackend.vala"
				g_assert_not_reached ();
#line 2191 "PackageKitBackend.c"
			}
		}
#line 87 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (job);
#line 2196 "PackageKitBackend.c"
	}
#line 132 "../src/Core/PackageKitBackend.vala"
	result = TRUE;
#line 132 "../src/Core/PackageKitBackend.vala"
	return result;
#line 2202 "PackageKitBackend.c"
}

static gpointer
_app_center_core_package_kit_backend_worker_func_gthread_func (gpointer self)
{
	gpointer result;
	result = (gpointer) ((gintptr) app_center_core_package_kit_backend_worker_func ((AppCenterCorePackageKitBackend*) self));
#line 160 "../src/Core/PackageKitBackend.vala"
	g_object_unref (self);
#line 160 "../src/Core/PackageKitBackend.vala"
	return result;
#line 2214 "PackageKitBackend.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 200 "../src/Core/PackageKitBackend.vala"
	return self ? g_object_ref (self) : NULL;
#line 2222 "PackageKitBackend.c"
}

static void
_app_center_core_package_kit_backend_updates_changed_callback_pk_control_updates_changed (PkControl* _sender,
                                                                                          gpointer self)
{
#line 231 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_updates_changed_callback ((AppCenterCorePackageKitBackend*) self);
#line 2231 "PackageKitBackend.c"
}

static AppCenterCorePackageKitBackend*
app_center_core_package_kit_backend_construct (GType object_type)
{
	AppCenterCorePackageKitBackend * self = NULL;
	GThread* _tmp0_;
	GeeHashMap* _tmp1_;
	AsPool* _tmp2_;
	AsPool* _tmp3_;
	AsPool* _tmp4_;
	GProxyResolver* proxy_resolver = NULL;
	GProxyResolver* _tmp5_;
	GProxyResolver* _tmp6_;
	gchar* http_proxy = NULL;
	gchar* ftp_proxy = NULL;
	PkControl* _tmp29_;
	PkControl* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 159 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) g_object_new (object_type, NULL);
#line 160 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = g_thread_new ("packagekit-worker", _app_center_core_package_kit_backend_worker_func_gthread_func, g_object_ref (self));
#line 160 "../src/Core/PackageKitBackend.vala"
	_g_thread_unref0 (self->priv->worker_thread);
#line 160 "../src/Core/PackageKitBackend.vala"
	self->priv->worker_thread = _tmp0_;
#line 162 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, APP_CENTER_CORE_TYPE_PACKAGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 162 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (self->priv->package_list);
#line 162 "../src/Core/PackageKitBackend.vala"
	self->priv->package_list = _tmp1_;
#line 163 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = as_pool_new ();
#line 163 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (self->priv->appstream_pool);
#line 163 "../src/Core/PackageKitBackend.vala"
	self->priv->appstream_pool = _tmp2_;
#line 189 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = self->priv->appstream_pool;
#line 189 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = self->priv->appstream_pool;
#line 189 "../src/Core/PackageKitBackend.vala"
	as_pool_set_flags (_tmp3_, as_pool_get_flags (_tmp4_) | (AS_POOL_FLAG_RESOLVE_ADDONS & (~AS_POOL_FLAG_LOAD_OS_DESKTOP_FILES)));
#line 198 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_reload_appstream_pool (self);
#line 200 "../src/Core/PackageKitBackend.vala"
	_tmp5_ = g_proxy_resolver_get_default ();
#line 200 "../src/Core/PackageKitBackend.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 200 "../src/Core/PackageKitBackend.vala"
	proxy_resolver = _tmp6_;
#line 201 "../src/Core/PackageKitBackend.vala"
	http_proxy = NULL;
#line 202 "../src/Core/PackageKitBackend.vala"
	ftp_proxy = NULL;
#line 2289 "PackageKitBackend.c"
	{
		gchar** possible_proxies = NULL;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint possible_proxies_length1;
		gint _possible_proxies_size_;
		gboolean _tmp9_ = FALSE;
#line 208 "../src/Core/PackageKitBackend.vala"
		_tmp8_ = _tmp7_ = g_proxy_resolver_lookup (proxy_resolver, "http://ppa.launchpad.net", NULL, &_inner_error0_);
#line 208 "../src/Core/PackageKitBackend.vala"
		possible_proxies = _tmp8_;
#line 208 "../src/Core/PackageKitBackend.vala"
		possible_proxies_length1 = _vala_array_length (_tmp7_);
#line 208 "../src/Core/PackageKitBackend.vala"
		_possible_proxies_size_ = possible_proxies_length1;
#line 208 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2307 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 209 "../src/Core/PackageKitBackend.vala"
		if (possible_proxies_length1 > 0) {
#line 2312 "PackageKitBackend.c"
			const gchar* _tmp10_;
#line 209 "../src/Core/PackageKitBackend.vala"
			_tmp10_ = possible_proxies[0];
#line 209 "../src/Core/PackageKitBackend.vala"
			_tmp9_ = g_strcmp0 (_tmp10_, "direct://") != 0;
#line 2318 "PackageKitBackend.c"
		} else {
#line 209 "../src/Core/PackageKitBackend.vala"
			_tmp9_ = FALSE;
#line 2322 "PackageKitBackend.c"
		}
#line 209 "../src/Core/PackageKitBackend.vala"
		if (_tmp9_) {
#line 2326 "PackageKitBackend.c"
			const gchar* _tmp11_;
			gchar* _tmp12_;
#line 210 "../src/Core/PackageKitBackend.vala"
			_tmp11_ = possible_proxies[0];
#line 210 "../src/Core/PackageKitBackend.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 210 "../src/Core/PackageKitBackend.vala"
			_g_free0 (http_proxy);
#line 210 "../src/Core/PackageKitBackend.vala"
			http_proxy = _tmp12_;
#line 2337 "PackageKitBackend.c"
		}
#line 204 "../src/Core/PackageKitBackend.vala"
		possible_proxies = (_vala_array_free (possible_proxies, possible_proxies_length1, (GDestroyNotify) g_free), NULL);
#line 2341 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 204 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 204 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 213 "../src/Core/PackageKitBackend.vala"
		_tmp13_ = e;
#line 213 "../src/Core/PackageKitBackend.vala"
		_tmp14_ = _tmp13_->message;
#line 213 "../src/Core/PackageKitBackend.vala"
		g_warning ("PackageKitBackend.vala:213: Unable to lookup http proxy to use for Pac" \
"kageKit: %s", _tmp14_);
#line 204 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 2361 "PackageKitBackend.c"
	}
	__finally0:
#line 204 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 204 "../src/Core/PackageKitBackend.vala"
		_g_free0 (ftp_proxy);
#line 204 "../src/Core/PackageKitBackend.vala"
		_g_free0 (http_proxy);
#line 204 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (proxy_resolver);
#line 204 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 204 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 204 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 2378 "PackageKitBackend.c"
	}
	{
		gchar** possible_proxies = NULL;
		gchar** _tmp15_;
		gchar** _tmp16_;
		gint possible_proxies_length1;
		gint _possible_proxies_size_;
		gboolean _tmp17_ = FALSE;
#line 217 "../src/Core/PackageKitBackend.vala"
		_tmp16_ = _tmp15_ = g_proxy_resolver_lookup (proxy_resolver, "ftp://ppa.launchpad.net", NULL, &_inner_error0_);
#line 217 "../src/Core/PackageKitBackend.vala"
		possible_proxies = _tmp16_;
#line 217 "../src/Core/PackageKitBackend.vala"
		possible_proxies_length1 = _vala_array_length (_tmp15_);
#line 217 "../src/Core/PackageKitBackend.vala"
		_possible_proxies_size_ = possible_proxies_length1;
#line 217 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2397 "PackageKitBackend.c"
			goto __catch1_g_error;
		}
#line 218 "../src/Core/PackageKitBackend.vala"
		if (possible_proxies_length1 > 0) {
#line 2402 "PackageKitBackend.c"
			const gchar* _tmp18_;
#line 218 "../src/Core/PackageKitBackend.vala"
			_tmp18_ = possible_proxies[0];
#line 218 "../src/Core/PackageKitBackend.vala"
			_tmp17_ = g_strcmp0 (_tmp18_, "direct://") != 0;
#line 2408 "PackageKitBackend.c"
		} else {
#line 218 "../src/Core/PackageKitBackend.vala"
			_tmp17_ = FALSE;
#line 2412 "PackageKitBackend.c"
		}
#line 218 "../src/Core/PackageKitBackend.vala"
		if (_tmp17_) {
#line 2416 "PackageKitBackend.c"
			const gchar* _tmp19_;
			gchar* _tmp20_;
#line 219 "../src/Core/PackageKitBackend.vala"
			_tmp19_ = possible_proxies[0];
#line 219 "../src/Core/PackageKitBackend.vala"
			_tmp20_ = g_strdup (_tmp19_);
#line 219 "../src/Core/PackageKitBackend.vala"
			_g_free0 (ftp_proxy);
#line 219 "../src/Core/PackageKitBackend.vala"
			ftp_proxy = _tmp20_;
#line 2427 "PackageKitBackend.c"
		}
#line 216 "../src/Core/PackageKitBackend.vala"
		possible_proxies = (_vala_array_free (possible_proxies, possible_proxies_length1, (GDestroyNotify) g_free), NULL);
#line 2431 "PackageKitBackend.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
#line 216 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 216 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 222 "../src/Core/PackageKitBackend.vala"
		_tmp21_ = e;
#line 222 "../src/Core/PackageKitBackend.vala"
		_tmp22_ = _tmp21_->message;
#line 222 "../src/Core/PackageKitBackend.vala"
		g_warning ("PackageKitBackend.vala:222: Unable to lookup ftp proxy to use for Pack" \
"ageKit: %s", _tmp22_);
#line 216 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 2451 "PackageKitBackend.c"
	}
	__finally1:
#line 216 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 216 "../src/Core/PackageKitBackend.vala"
		_g_free0 (ftp_proxy);
#line 216 "../src/Core/PackageKitBackend.vala"
		_g_free0 (http_proxy);
#line 216 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (proxy_resolver);
#line 216 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 216 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 216 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 2468 "PackageKitBackend.c"
	}
	{
		PkControl* _tmp23_;
		PkControl* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
#line 226 "../src/Core/PackageKitBackend.vala"
		_tmp23_ = app_center_core_package_kit_backend_get_control ();
#line 226 "../src/Core/PackageKitBackend.vala"
		_tmp24_ = _tmp23_;
#line 226 "../src/Core/PackageKitBackend.vala"
		_tmp25_ = http_proxy;
#line 226 "../src/Core/PackageKitBackend.vala"
		_tmp26_ = ftp_proxy;
#line 226 "../src/Core/PackageKitBackend.vala"
		pk_control_set_proxy (_tmp24_, _tmp25_, _tmp26_, NULL, &_inner_error0_);
#line 226 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2487 "PackageKitBackend.c"
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
#line 225 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 225 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 228 "../src/Core/PackageKitBackend.vala"
		_tmp27_ = e;
#line 228 "../src/Core/PackageKitBackend.vala"
		_tmp28_ = _tmp27_->message;
#line 228 "../src/Core/PackageKitBackend.vala"
		g_warning ("PackageKitBackend.vala:228: Unable to set proxy for PackageKit to use:" \
" %s", _tmp28_);
#line 225 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 2509 "PackageKitBackend.c"
	}
	__finally2:
#line 225 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 225 "../src/Core/PackageKitBackend.vala"
		_g_free0 (ftp_proxy);
#line 225 "../src/Core/PackageKitBackend.vala"
		_g_free0 (http_proxy);
#line 225 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (proxy_resolver);
#line 225 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 225 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 225 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 2526 "PackageKitBackend.c"
	}
#line 231 "../src/Core/PackageKitBackend.vala"
	_tmp29_ = app_center_core_package_kit_backend_get_control ();
#line 231 "../src/Core/PackageKitBackend.vala"
	_tmp30_ = _tmp29_;
#line 231 "../src/Core/PackageKitBackend.vala"
	g_signal_connect_object (_tmp30_, "updates-changed", (GCallback) _app_center_core_package_kit_backend_updates_changed_callback_pk_control_updates_changed, self, 0);
#line 159 "../src/Core/PackageKitBackend.vala"
	_g_free0 (ftp_proxy);
#line 159 "../src/Core/PackageKitBackend.vala"
	_g_free0 (http_proxy);
#line 159 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (proxy_resolver);
#line 159 "../src/Core/PackageKitBackend.vala"
	return self;
#line 2542 "PackageKitBackend.c"
}

static AppCenterCorePackageKitBackend*
app_center_core_package_kit_backend_new (void)
{
#line 159 "../src/Core/PackageKitBackend.vala"
	return app_center_core_package_kit_backend_construct (APP_CENTER_CORE_TYPE_PACKAGE_KIT_BACKEND);
#line 2550 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_updates_changed_callback (AppCenterCorePackageKitBackend* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 234 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 235 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_backend_get_working ((AppCenterCoreBackend*) self);
#line 235 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 235 "../src/Core/PackageKitBackend.vala"
	if (!_tmp1_) {
#line 2566 "PackageKitBackend.c"
		AppCenterCoreUpdateManager* _tmp2_;
		GTimeSpan time_since_last_action = 0LL;
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		GTimeSpan _tmp6_;
#line 236 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = app_center_core_update_manager_get_default ();
#line 236 "../src/Core/PackageKitBackend.vala"
		app_center_core_update_manager_update_restart_state (_tmp2_);
#line 238 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = g_date_time_new_now_local ();
#line 238 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = _tmp3_;
#line 238 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = self->priv->last_action;
#line 238 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = g_date_time_difference (_tmp4_, _tmp5_) / G_TIME_SPAN_MILLISECOND;
#line 238 "../src/Core/PackageKitBackend.vala"
		_g_date_time_unref0 (_tmp4_);
#line 238 "../src/Core/PackageKitBackend.vala"
		time_since_last_action = _tmp6_;
#line 239 "../src/Core/PackageKitBackend.vala"
		if (time_since_last_action >= ((GTimeSpan) APP_CENTER_CORE_PACKAGE_KIT_BACKEND_PACKAGEKIT_ACTIVITY_TIMEOUT_MS)) {
#line 240 "../src/Core/PackageKitBackend.vala"
			g_info ("PackageKitBackend.vala:240: packages possibly changed by external prog" \
"ram, refreshing cache");
#line 2593 "PackageKitBackend.c"
			{
				GeeIterator* _package_it = NULL;
				GeeHashMap* _tmp7_;
				GeeCollection* _tmp8_;
				GeeCollection* _tmp9_;
				GeeCollection* _tmp10_;
				GeeIterator* _tmp11_;
				GeeIterator* _tmp12_;
#line 244 "../src/Core/PackageKitBackend.vala"
				_tmp7_ = self->priv->package_list;
#line 244 "../src/Core/PackageKitBackend.vala"
				_tmp8_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp7_);
#line 244 "../src/Core/PackageKitBackend.vala"
				_tmp9_ = _tmp8_;
#line 244 "../src/Core/PackageKitBackend.vala"
				_tmp10_ = _tmp9_;
#line 244 "../src/Core/PackageKitBackend.vala"
				_tmp11_ = gee_iterable_iterator ((GeeIterable*) _tmp10_);
#line 244 "../src/Core/PackageKitBackend.vala"
				_tmp12_ = _tmp11_;
#line 244 "../src/Core/PackageKitBackend.vala"
				_g_object_unref0 (_tmp10_);
#line 244 "../src/Core/PackageKitBackend.vala"
				_package_it = _tmp12_;
#line 244 "../src/Core/PackageKitBackend.vala"
				while (TRUE) {
#line 2620 "PackageKitBackend.c"
					GeeIterator* _tmp13_;
					AppCenterCorePackage* package = NULL;
					GeeIterator* _tmp14_;
					gpointer _tmp15_;
					gboolean _tmp16_ = FALSE;
					AppCenterCorePackage* _tmp17_;
					AppCenterCorePackageState _tmp18_;
					AppCenterCorePackageState _tmp19_;
#line 244 "../src/Core/PackageKitBackend.vala"
					_tmp13_ = _package_it;
#line 244 "../src/Core/PackageKitBackend.vala"
					if (!gee_iterator_next (_tmp13_)) {
#line 244 "../src/Core/PackageKitBackend.vala"
						break;
#line 2635 "PackageKitBackend.c"
					}
#line 244 "../src/Core/PackageKitBackend.vala"
					_tmp14_ = _package_it;
#line 244 "../src/Core/PackageKitBackend.vala"
					_tmp15_ = gee_iterator_get (_tmp14_);
#line 244 "../src/Core/PackageKitBackend.vala"
					package = (AppCenterCorePackage*) _tmp15_;
#line 245 "../src/Core/PackageKitBackend.vala"
					_tmp17_ = package;
#line 245 "../src/Core/PackageKitBackend.vala"
					_tmp18_ = app_center_core_package_get_state (_tmp17_);
#line 245 "../src/Core/PackageKitBackend.vala"
					_tmp19_ = _tmp18_;
#line 245 "../src/Core/PackageKitBackend.vala"
					if (_tmp19_ != APP_CENTER_CORE_PACKAGE_STATE_NOT_INSTALLED) {
#line 245 "../src/Core/PackageKitBackend.vala"
						_tmp16_ = TRUE;
#line 2653 "PackageKitBackend.c"
					} else {
						AppCenterCorePackage* _tmp20_;
						gboolean _tmp21_;
						gboolean _tmp22_;
#line 245 "../src/Core/PackageKitBackend.vala"
						_tmp20_ = package;
#line 245 "../src/Core/PackageKitBackend.vala"
						_tmp21_ = app_center_core_package_get_installed (_tmp20_);
#line 245 "../src/Core/PackageKitBackend.vala"
						_tmp22_ = _tmp21_;
#line 245 "../src/Core/PackageKitBackend.vala"
						_tmp16_ = _tmp22_;
#line 2666 "PackageKitBackend.c"
					}
#line 245 "../src/Core/PackageKitBackend.vala"
					if (_tmp16_) {
#line 2670 "PackageKitBackend.c"
						AppCenterCorePackage* _tmp23_;
#line 246 "../src/Core/PackageKitBackend.vala"
						_tmp23_ = package;
#line 246 "../src/Core/PackageKitBackend.vala"
						app_center_core_package_clear_installed (_tmp23_);
#line 2676 "PackageKitBackend.c"
					}
#line 244 "../src/Core/PackageKitBackend.vala"
					_g_object_unref0 (package);
#line 2680 "PackageKitBackend.c"
				}
#line 244 "../src/Core/PackageKitBackend.vala"
				_g_object_unref0 (_package_it);
#line 2684 "PackageKitBackend.c"
			}
#line 250 "../src/Core/PackageKitBackend.vala"
			app_center_core_package_kit_backend_trigger_update_check (self, NULL, NULL);
#line 2688 "PackageKitBackend.c"
		}
	}
}

static void
app_center_core_package_kit_backend_trigger_update_check_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendTriggerUpdateCheckData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendTriggerUpdateCheckData, _data_);
#line 2702 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_trigger_update_check (AppCenterCorePackageKitBackend* self,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_)
{
	AppCenterCorePackageKitBackendTriggerUpdateCheckData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendTriggerUpdateCheckData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_trigger_update_check_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_trigger_update_check_co (_data_);
#line 2726 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_trigger_update_check_finish (AppCenterCorePackageKitBackend* self,
                                                                 GAsyncResult* _res_)
{
	AppCenterCorePackageKitBackendTriggerUpdateCheckData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2736 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_trigger_update_check_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_)
{
	AppCenterCorePackageKitBackendTriggerUpdateCheckData* _data_;
#line 257 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 257 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 257 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 257 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_trigger_update_check_co (_data_);
#line 2753 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_trigger_update_check_co (AppCenterCorePackageKitBackendTriggerUpdateCheckData* _data_)
{
#line 255 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 255 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 2763 "PackageKitBackend.c"
		goto _state_0;
#line 255 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 2767 "PackageKitBackend.c"
		goto _state_1;
#line 255 "../src/Core/PackageKitBackend.vala"
		case 2:
#line 2771 "PackageKitBackend.c"
		goto _state_2;
		default:
#line 255 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 2776 "PackageKitBackend.c"
	}
	_state_0:
	{
#line 257 "../src/Core/PackageKitBackend.vala"
		_data_->_state_ = 1;
#line 257 "../src/Core/PackageKitBackend.vala"
		app_center_core_backend_refresh_cache ((AppCenterCoreBackend*) _data_->self, NULL, app_center_core_package_kit_backend_trigger_update_check_ready, _data_);
#line 257 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 2786 "PackageKitBackend.c"
		_state_1:
#line 257 "../src/Core/PackageKitBackend.vala"
		app_center_core_backend_refresh_cache_finish ((AppCenterCoreBackend*) _data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 257 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2792 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 256 "../src/Core/PackageKitBackend.vala"
		_data_->e = _data_->_inner_error0_;
#line 256 "../src/Core/PackageKitBackend.vala"
		_data_->_inner_error0_ = NULL;
#line 259 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp0_ = _data_->e;
#line 259 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp1_ = _data_->_tmp0_->message;
#line 259 "../src/Core/PackageKitBackend.vala"
		g_warning ("PackageKitBackend.vala:259: Unable to refresh cache after external cha" \
"nge: %s", _data_->_tmp1_);
#line 256 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (_data_->e);
#line 2811 "PackageKitBackend.c"
	}
	__finally0:
#line 256 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 256 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 256 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 256 "../src/Core/PackageKitBackend.vala"
		g_object_unref (_data_->_async_result);
#line 256 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 2824 "PackageKitBackend.c"
	}
#line 262 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = app_center_core_client_get_default ();
#line 262 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 2;
#line 262 "../src/Core/PackageKitBackend.vala"
	app_center_core_client_refresh_updates (_data_->_tmp2_, app_center_core_package_kit_backend_trigger_update_check_ready, _data_);
#line 262 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 2834 "PackageKitBackend.c"
	_state_2:
#line 262 "../src/Core/PackageKitBackend.vala"
	app_center_core_client_refresh_updates_finish (_data_->_tmp2_, _data_->_res_);
#line 255 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 255 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 255 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 255 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2846 "PackageKitBackend.c"
		}
	}
#line 255 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 255 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 2853 "PackageKitBackend.c"
}

static Block53Data*
block53_data_ref (Block53Data* _data53_)
{
#line 271 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data53_->_ref_count_);
#line 271 "../src/Core/PackageKitBackend.vala"
	return _data53_;
#line 2863 "PackageKitBackend.c"
}

static void
block53_data_unref (void * _userdata_)
{
	Block53Data* _data53_;
	_data53_ = (Block53Data*) _userdata_;
#line 271 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data53_->_ref_count_)) {
#line 2873 "PackageKitBackend.c"
		AppCenterCorePackageKitBackend* self;
#line 271 "../src/Core/PackageKitBackend.vala"
		self = _data53_->self;
#line 271 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data53_->comp_validator);
#line 271 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data53_->new_package_list);
#line 271 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (self);
#line 271 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block53Data, _data53_);
#line 2885 "PackageKitBackend.c"
	}
}

static void
___lambda18_ (Block53Data* _data53_,
              AsComponent* comp)
{
	AppCenterCorePackageKitBackend* self;
	gchar** _tmp0_;
	gchar** _tmp1_;
#line 278 "../src/Core/PackageKitBackend.vala"
	self = _data53_->self;
#line 278 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (comp != NULL);
#line 279 "../src/Core/PackageKitBackend.vala"
	if (!app_center_core_component_validator_validate (_data53_->comp_validator, comp)) {
#line 280 "../src/Core/PackageKitBackend.vala"
		return;
#line 2904 "PackageKitBackend.c"
	}
#line 283 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_ = as_component_get_pkgnames (comp);
#line 2908 "PackageKitBackend.c"
	{
		gchar** pkg_name_collection = NULL;
		gint pkg_name_collection_length1 = 0;
		gint _pkg_name_collection_size_ = 0;
		gint pkg_name_it = 0;
#line 283 "../src/Core/PackageKitBackend.vala"
		pkg_name_collection = _tmp1_;
#line 283 "../src/Core/PackageKitBackend.vala"
		pkg_name_collection_length1 = _vala_array_length (_tmp0_);
#line 283 "../src/Core/PackageKitBackend.vala"
		for (pkg_name_it = 0; pkg_name_it < pkg_name_collection_length1; pkg_name_it = pkg_name_it + 1) {
#line 2920 "PackageKitBackend.c"
			const gchar* pkg_name = NULL;
#line 283 "../src/Core/PackageKitBackend.vala"
			pkg_name = pkg_name_collection[pkg_name_it];
#line 2924 "PackageKitBackend.c"
			{
				AppCenterCorePackage* package = NULL;
				GeeHashMap* _tmp2_;
				const gchar* _tmp3_;
				gpointer _tmp4_;
				AppCenterCorePackage* _tmp5_;
				const gchar* _tmp8_;
				AppCenterCorePackage* _tmp9_;
#line 284 "../src/Core/PackageKitBackend.vala"
				_tmp2_ = self->priv->package_list;
#line 284 "../src/Core/PackageKitBackend.vala"
				_tmp3_ = pkg_name;
#line 284 "../src/Core/PackageKitBackend.vala"
				_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, _tmp3_);
#line 284 "../src/Core/PackageKitBackend.vala"
				package = (AppCenterCorePackage*) _tmp4_;
#line 285 "../src/Core/PackageKitBackend.vala"
				_tmp5_ = package;
#line 285 "../src/Core/PackageKitBackend.vala"
				if (_tmp5_ != NULL) {
#line 2945 "PackageKitBackend.c"
					AppCenterCorePackage* _tmp6_;
#line 286 "../src/Core/PackageKitBackend.vala"
					_tmp6_ = package;
#line 286 "../src/Core/PackageKitBackend.vala"
					app_center_core_package_replace_component (_tmp6_, comp);
#line 2951 "PackageKitBackend.c"
				} else {
					AppCenterCorePackage* _tmp7_;
#line 288 "../src/Core/PackageKitBackend.vala"
					_tmp7_ = app_center_core_package_new ((AppCenterCoreBackend*) self, comp);
#line 288 "../src/Core/PackageKitBackend.vala"
					_g_object_unref0 (package);
#line 288 "../src/Core/PackageKitBackend.vala"
					package = _tmp7_;
#line 2960 "PackageKitBackend.c"
				}
#line 291 "../src/Core/PackageKitBackend.vala"
				_tmp8_ = pkg_name;
#line 291 "../src/Core/PackageKitBackend.vala"
				_tmp9_ = package;
#line 291 "../src/Core/PackageKitBackend.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _data53_->new_package_list, _tmp8_, _tmp9_);
#line 283 "../src/Core/PackageKitBackend.vala"
				_g_object_unref0 (package);
#line 2970 "PackageKitBackend.c"
			}
		}
	}
}

static void
____lambda18__gfunc (gconstpointer data,
                     gpointer self)
{
#line 278 "../src/Core/PackageKitBackend.vala"
	___lambda18_ (self, (AsComponent*) data);
#line 2982 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_reload_appstream_pool (AppCenterCorePackageKitBackend* self)
{
	GError* _inner_error0_ = NULL;
#line 270 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 2991 "PackageKitBackend.c"
	{
		AsPool* _tmp0_;
#line 272 "../src/Core/PackageKitBackend.vala"
		_tmp0_ = self->priv->appstream_pool;
#line 272 "../src/Core/PackageKitBackend.vala"
		as_pool_load (_tmp0_, NULL, &_inner_error0_);
#line 272 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3000 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 271 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 271 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 274 "../src/Core/PackageKitBackend.vala"
		_tmp1_ = e;
#line 274 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = _tmp1_->message;
#line 274 "../src/Core/PackageKitBackend.vala"
		g_critical ("PackageKitBackend.vala:274: %s", _tmp2_);
#line 271 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 3022 "PackageKitBackend.c"
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		Block53Data* _data53_;
		GeeHashMap* _tmp3_;
		AppCenterCoreComponentValidator* _tmp4_;
		AppCenterCoreComponentValidator* _tmp5_;
		AsPool* _tmp6_;
		GPtrArray* _tmp7_;
		GPtrArray* _tmp8_;
		GeeHashMap* _tmp9_;
#line 271 "../src/Core/PackageKitBackend.vala"
		_data53_ = g_slice_new0 (Block53Data);
#line 271 "../src/Core/PackageKitBackend.vala"
		_data53_->_ref_count_ = 1;
#line 271 "../src/Core/PackageKitBackend.vala"
		_data53_->self = g_object_ref (self);
#line 276 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, APP_CENTER_CORE_TYPE_PACKAGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 276 "../src/Core/PackageKitBackend.vala"
		_data53_->new_package_list = _tmp3_;
#line 277 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = app_center_core_component_validator_get_default ();
#line 277 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 277 "../src/Core/PackageKitBackend.vala"
		_data53_->comp_validator = _tmp5_;
#line 278 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = self->priv->appstream_pool;
#line 278 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = as_pool_get_components_gir (_tmp6_);
#line 278 "../src/Core/PackageKitBackend.vala"
		_tmp8_ = _tmp7_;
#line 278 "../src/Core/PackageKitBackend.vala"
		g_ptr_array_foreach (_tmp8_, ____lambda18__gfunc, _data53_);
#line 278 "../src/Core/PackageKitBackend.vala"
		_g_ptr_array_unref0 (_tmp8_);
#line 295 "../src/Core/PackageKitBackend.vala"
		_tmp9_ = _g_object_ref0 (_data53_->new_package_list);
#line 295 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (self->priv->package_list);
#line 295 "../src/Core/PackageKitBackend.vala"
		self->priv->package_list = _tmp9_;
#line 271 "../src/Core/PackageKitBackend.vala"
		block53_data_unref (_data53_);
#line 271 "../src/Core/PackageKitBackend.vala"
		_data53_ = NULL;
#line 3071 "PackageKitBackend.c"
	}
#line 271 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 271 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 271 "../src/Core/PackageKitBackend.vala"
		return;
#line 3081 "PackageKitBackend.c"
	}
}

AppCenterCorePackage*
app_center_core_package_kit_backend_lookup_package_by_id (AppCenterCorePackageKitBackend* self,
                                                          const gchar* id)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	AppCenterCorePackage* result;
#line 299 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 299 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 300 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = self->priv->package_list;
#line 300 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, id);
#line 300 "../src/Core/PackageKitBackend.vala"
	result = (AppCenterCorePackage*) _tmp1_;
#line 300 "../src/Core/PackageKitBackend.vala"
	return result;
#line 3104 "PackageKitBackend.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 308 "../src/Core/PackageKitBackend.vala"
	return self ? g_error_copy (self) : NULL;
#line 3112 "PackageKitBackend.c"
}

AppCenterCorePackage*
app_center_core_package_kit_backend_add_local_component_file (AppCenterCorePackageKitBackend* self,
                                                              GFile* file,
                                                              GError** error)
{
	AsMetadata* metadata = NULL;
	AsMetadata* _tmp0_;
	AsComponent* component = NULL;
	AsComponent* _tmp3_;
	AsComponent* _tmp4_;
	GError* _inner_error0_ = NULL;
	AppCenterCorePackage* result;
#line 303 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 303 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 304 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = as_metadata_new ();
#line 304 "../src/Core/PackageKitBackend.vala"
	metadata = _tmp0_;
#line 3135 "PackageKitBackend.c"
	{
#line 306 "../src/Core/PackageKitBackend.vala"
		as_metadata_parse_file (metadata, file, AS_FORMAT_KIND_XML, &_inner_error0_);
#line 306 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3141 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		GError* _tmp2_;
#line 305 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 305 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 308 "../src/Core/PackageKitBackend.vala"
		_tmp1_ = e;
#line 308 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = _g_error_copy0 (_tmp1_);
#line 308 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = _tmp2_;
#line 308 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 3163 "PackageKitBackend.c"
		goto __finally0;
	}
	__finally0:
#line 305 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 305 "../src/Core/PackageKitBackend.vala"
		g_propagate_error (error, _inner_error0_);
#line 305 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (metadata);
#line 305 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 3175 "PackageKitBackend.c"
	}
#line 311 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = as_metadata_get_component (metadata);
#line 311 "../src/Core/PackageKitBackend.vala"
	component = _tmp3_;
#line 312 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = component;
#line 312 "../src/Core/PackageKitBackend.vala"
	if (_tmp4_ != NULL) {
#line 3185 "PackageKitBackend.c"
		gchar* name = NULL;
		AsComponent* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* id = NULL;
		AsComponent* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		AsComponent* _tmp11_;
		const gchar* _tmp12_;
		AsComponent* _tmp13_;
		const gchar* _tmp14_;
		AsComponent* _tmp15_;
		GPtrArray* components = NULL;
		GPtrArray* _tmp16_;
		GPtrArray* _tmp17_;
		AsComponent* _tmp18_;
		AsComponent* _tmp19_;
		AsPool* _tmp20_;
		GPtrArray* _tmp21_;
		AppCenterCorePackage* package = NULL;
		AsComponent* _tmp22_;
		AppCenterCorePackage* _tmp23_;
		GeeHashMap* _tmp24_;
		const gchar* _tmp25_;
		AppCenterCorePackage* _tmp26_;
#line 313 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = component;
#line 313 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = as_component_get_name (_tmp5_);
#line 313 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = g_strdup_printf (_ ("%s (local)"), _tmp6_);
#line 313 "../src/Core/PackageKitBackend.vala"
		name = _tmp7_;
#line 314 "../src/Core/PackageKitBackend.vala"
		_tmp8_ = component;
#line 314 "../src/Core/PackageKitBackend.vala"
		_tmp9_ = as_component_get_id (_tmp8_);
#line 314 "../src/Core/PackageKitBackend.vala"
		_tmp10_ = g_strdup_printf ("%s%s", _tmp9_, APP_CENTER_CORE_PACKAGE_LOCAL_ID_SUFFIX);
#line 314 "../src/Core/PackageKitBackend.vala"
		id = _tmp10_;
#line 316 "../src/Core/PackageKitBackend.vala"
		_tmp11_ = component;
#line 316 "../src/Core/PackageKitBackend.vala"
		_tmp12_ = name;
#line 316 "../src/Core/PackageKitBackend.vala"
		as_component_set_name (_tmp11_, _tmp12_, NULL);
#line 317 "../src/Core/PackageKitBackend.vala"
		_tmp13_ = component;
#line 317 "../src/Core/PackageKitBackend.vala"
		_tmp14_ = id;
#line 317 "../src/Core/PackageKitBackend.vala"
		as_component_set_id (_tmp13_, _tmp14_);
#line 318 "../src/Core/PackageKitBackend.vala"
		_tmp15_ = component;
#line 318 "../src/Core/PackageKitBackend.vala"
		as_component_set_origin (_tmp15_, APP_CENTER_CORE_PACKAGE_APPCENTER_PACKAGE_ORIGIN);
#line 321 "../src/Core/PackageKitBackend.vala"
		_tmp16_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 321 "../src/Core/PackageKitBackend.vala"
		components = _tmp16_;
#line 322 "../src/Core/PackageKitBackend.vala"
		_tmp17_ = components;
#line 322 "../src/Core/PackageKitBackend.vala"
		_tmp18_ = component;
#line 322 "../src/Core/PackageKitBackend.vala"
		_tmp19_ = _g_object_ref0 (_tmp18_);
#line 322 "../src/Core/PackageKitBackend.vala"
		g_ptr_array_add (_tmp17_, _tmp19_);
#line 324 "../src/Core/PackageKitBackend.vala"
		_tmp20_ = self->priv->appstream_pool;
#line 324 "../src/Core/PackageKitBackend.vala"
		_tmp21_ = components;
#line 324 "../src/Core/PackageKitBackend.vala"
		as_pool_add_components (_tmp20_, _tmp21_, &_inner_error0_);
#line 324 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 324 "../src/Core/PackageKitBackend.vala"
			g_propagate_error (error, _inner_error0_);
#line 324 "../src/Core/PackageKitBackend.vala"
			_g_ptr_array_unref0 (components);
#line 324 "../src/Core/PackageKitBackend.vala"
			_g_free0 (id);
#line 324 "../src/Core/PackageKitBackend.vala"
			_g_free0 (name);
#line 324 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (metadata);
#line 324 "../src/Core/PackageKitBackend.vala"
			return NULL;
#line 3276 "PackageKitBackend.c"
		}
#line 329 "../src/Core/PackageKitBackend.vala"
		_tmp22_ = component;
#line 329 "../src/Core/PackageKitBackend.vala"
		_tmp23_ = app_center_core_package_new ((AppCenterCoreBackend*) self, _tmp22_);
#line 329 "../src/Core/PackageKitBackend.vala"
		package = _tmp23_;
#line 330 "../src/Core/PackageKitBackend.vala"
		_tmp24_ = self->priv->package_list;
#line 330 "../src/Core/PackageKitBackend.vala"
		_tmp25_ = id;
#line 330 "../src/Core/PackageKitBackend.vala"
		_tmp26_ = package;
#line 330 "../src/Core/PackageKitBackend.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp24_, _tmp25_, _tmp26_);
#line 332 "../src/Core/PackageKitBackend.vala"
		result = package;
#line 332 "../src/Core/PackageKitBackend.vala"
		_g_ptr_array_unref0 (components);
#line 332 "../src/Core/PackageKitBackend.vala"
		_g_free0 (id);
#line 332 "../src/Core/PackageKitBackend.vala"
		_g_free0 (name);
#line 332 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (metadata);
#line 332 "../src/Core/PackageKitBackend.vala"
		return result;
#line 3304 "PackageKitBackend.c"
	}
#line 335 "../src/Core/PackageKitBackend.vala"
	result = NULL;
#line 335 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (metadata);
#line 335 "../src/Core/PackageKitBackend.vala"
	return result;
#line 3312 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_get_prepared_applications_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendGetPreparedApplicationsData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendGetPreparedApplicationsData, _data_);
#line 3328 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_get_prepared_applications (AppCenterCoreBackend* base,
                                                                    GCancellable* cancellable,
                                                                    GAsyncReadyCallback _callback_,
                                                                    gpointer _user_data_)
{
	AppCenterCorePackageKitBackend * self;
	AppCenterCorePackageKitBackendGetPreparedApplicationsData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendGetPreparedApplicationsData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_real_get_prepared_applications_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_get_prepared_applications_co (_data_);
#line 3361 "PackageKitBackend.c"
}

static GeeCollection*
app_center_core_package_kit_backend_get_prepared_applications_finish (AppCenterCoreBackend* base,
                                                                      GAsyncResult* _res_)
{
	GeeCollection* result;
	AppCenterCorePackageKitBackendGetPreparedApplicationsData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 24 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 3376 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->result = NULL;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 3384 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_prepared_applications_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_)
{
	AppCenterCorePackageKitBackendGetPreparedApplicationsData* _data_;
#line 341 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 341 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 341 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 341 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_get_prepared_applications_co (_data_);
#line 3401 "PackageKitBackend.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5893 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5894 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5894 "glib-2.0.vapi"
	return result;
#line 3414 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_real_get_prepared_applications_co (AppCenterCorePackageKitBackendGetPreparedApplicationsData* _data_)
{
#line 338 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 338 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 3424 "PackageKitBackend.c"
		goto _state_0;
#line 338 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 3428 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 338 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 3433 "PackageKitBackend.c"
	}
	_state_0:
#line 339 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = gee_tree_set_new (APP_CENTER_CORE_TYPE_PACKAGE_DETAILS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 339 "../src/Core/PackageKitBackend.vala"
	_data_->packages = _data_->_tmp0_;
#line 341 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 1;
#line 341 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_get_prepared_packages (_data_->self, NULL, app_center_core_package_kit_backend_get_prepared_applications_ready, _data_);
#line 341 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 3446 "PackageKitBackend.c"
	_state_1:
#line 341 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = app_center_core_package_kit_backend_get_prepared_packages_finish (_data_->self, _data_->_res_);
#line 341 "../src/Core/PackageKitBackend.vala"
	_data_->pk_prepared = _data_->_tmp1_;
#line 342 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = _data_->pk_prepared;
#line 342 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_ = pk_results_get_package_array (_data_->_tmp2_);
#line 342 "../src/Core/PackageKitBackend.vala"
	_data_->package_array = _data_->_tmp3_;
#line 343 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp4_ = _data_->package_array;
#line 3460 "PackageKitBackend.c"
	{
#line 343 "../src/Core/PackageKitBackend.vala"
		_data_->pk_package_collection = _data_->_tmp4_;
#line 343 "../src/Core/PackageKitBackend.vala"
		for (_data_->pk_package_index = 0; _data_->pk_package_index < _data_->pk_package_collection->len; _data_->pk_package_index = _data_->pk_package_index + 1) {
#line 343 "../src/Core/PackageKitBackend.vala"
			_data_->pk_package = g_ptr_array_index (_data_->pk_package_collection, _data_->pk_package_index);
#line 3468 "PackageKitBackend.c"
			{
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp5_ = _data_->packages;
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp6_ = _data_->pk_package;
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp7_ = pk_package_get_name (_data_->_tmp6_);
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp8_ = g_strdup (_data_->_tmp7_);
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp9_ = _data_->pk_package;
#line 344 "../src/Core/PackageKitBackend.vala"
				g_object_get (_data_->_tmp9_, "description", &_data_->_tmp10_, NULL);
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp11_ = _data_->_tmp10_;
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp12_ = _data_->pk_package;
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp13_ = pk_package_get_summary (_data_->_tmp12_);
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp14_ = g_strdup (_data_->_tmp13_);
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp15_ = _data_->pk_package;
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp16_ = pk_package_get_version (_data_->_tmp15_);
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp17_ = g_strdup (_data_->_tmp16_);
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp18_ = NULL;
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp18_ = app_center_core_package_details_new ();
#line 344 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_details_set_name (_data_->_tmp18_, _data_->_tmp8_);
#line 344 "../src/Core/PackageKitBackend.vala"
				_g_free0 (_data_->_tmp8_);
#line 344 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_details_set_description (_data_->_tmp18_, _data_->_tmp11_);
#line 344 "../src/Core/PackageKitBackend.vala"
				_g_free0 (_data_->_tmp11_);
#line 344 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_details_set_summary (_data_->_tmp18_, _data_->_tmp14_);
#line 344 "../src/Core/PackageKitBackend.vala"
				_g_free0 (_data_->_tmp14_);
#line 344 "../src/Core/PackageKitBackend.vala"
				app_center_core_package_details_set_version (_data_->_tmp18_, _data_->_tmp17_);
#line 344 "../src/Core/PackageKitBackend.vala"
				_g_free0 (_data_->_tmp17_);
#line 344 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp19_ = _data_->_tmp18_;
#line 344 "../src/Core/PackageKitBackend.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp5_, _data_->_tmp19_);
#line 344 "../src/Core/PackageKitBackend.vala"
				_g_object_unref0 (_data_->_tmp19_);
#line 3522 "PackageKitBackend.c"
			}
		}
	}
#line 352 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp20_ = _data_->package_array;
#line 352 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp21_ = vala_g_ptr_array_get_length (_data_->_tmp20_);
#line 352 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 352 "../src/Core/PackageKitBackend.vala"
	if (_data_->_tmp22_ > 0) {
#line 353 "../src/Core/PackageKitBackend.vala"
		app_center_core_package_kit_backend_updates_changed_callback (_data_->self);
#line 3536 "PackageKitBackend.c"
	}
#line 356 "../src/Core/PackageKitBackend.vala"
	_data_->result = (GeeCollection*) _data_->packages;
#line 356 "../src/Core/PackageKitBackend.vala"
	_g_ptr_array_unref0 (_data_->package_array);
#line 356 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->pk_prepared);
#line 356 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 356 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 356 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 356 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3552 "PackageKitBackend.c"
		}
	}
#line 356 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 356 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 3559 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_get_installed_applications_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendGetInstalledApplicationsData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendGetInstalledApplicationsData, _data_);
#line 3575 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_get_installed_applications (AppCenterCoreBackend* base,
                                                                     GCancellable* cancellable,
                                                                     GAsyncReadyCallback _callback_,
                                                                     gpointer _user_data_)
{
	AppCenterCorePackageKitBackend * self;
	AppCenterCorePackageKitBackendGetInstalledApplicationsData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendGetInstalledApplicationsData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_real_get_installed_applications_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_get_installed_applications_co (_data_);
#line 3608 "PackageKitBackend.c"
}

static GeeCollection*
app_center_core_package_kit_backend_get_installed_applications_finish (AppCenterCoreBackend* base,
                                                                       GAsyncResult* _res_)
{
	GeeCollection* result;
	AppCenterCorePackageKitBackendGetInstalledApplicationsData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 24 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 3623 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->result = NULL;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 3631 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_installed_applications_ready (GObject* source_object,
                                                                      GAsyncResult* _res_,
                                                                      gpointer _user_data_)
{
	AppCenterCorePackageKitBackendGetInstalledApplicationsData* _data_;
#line 361 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 361 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 361 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 361 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_get_installed_applications_co (_data_);
#line 3648 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_real_get_installed_applications_co (AppCenterCorePackageKitBackendGetInstalledApplicationsData* _data_)
{
#line 359 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 359 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 3658 "PackageKitBackend.c"
		goto _state_0;
#line 359 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 3662 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 359 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 3667 "PackageKitBackend.c"
	}
	_state_0:
#line 360 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = gee_tree_set_new (APP_CENTER_CORE_TYPE_PACKAGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 360 "../src/Core/PackageKitBackend.vala"
	_data_->packages = _data_->_tmp0_;
#line 361 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 1;
#line 361 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_get_installed_packages (_data_->self, _data_->cancellable, app_center_core_package_kit_backend_get_installed_applications_ready, _data_);
#line 361 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 3680 "PackageKitBackend.c"
	_state_1:
#line 361 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = app_center_core_package_kit_backend_get_installed_packages_finish (_data_->self, _data_->_res_);
#line 361 "../src/Core/PackageKitBackend.vala"
	_data_->installed = _data_->_tmp1_;
#line 3686 "PackageKitBackend.c"
	{
#line 362 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp2_ = _data_->installed;
#line 362 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp3_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _data_->_tmp2_);
#line 362 "../src/Core/PackageKitBackend.vala"
		_data_->_pk_package_it = _data_->_tmp3_;
#line 362 "../src/Core/PackageKitBackend.vala"
		while (TRUE) {
#line 362 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp4_ = _data_->_pk_package_it;
#line 362 "../src/Core/PackageKitBackend.vala"
			if (!gee_iterator_next (_data_->_tmp4_)) {
#line 362 "../src/Core/PackageKitBackend.vala"
				break;
#line 3702 "PackageKitBackend.c"
			}
#line 362 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp5_ = _data_->_pk_package_it;
#line 362 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp6_ = gee_iterator_get (_data_->_tmp5_);
#line 362 "../src/Core/PackageKitBackend.vala"
			_data_->pk_package = (PkPackage*) _data_->_tmp6_;
#line 363 "../src/Core/PackageKitBackend.vala"
			if (g_cancellable_is_cancelled (_data_->cancellable)) {
#line 364 "../src/Core/PackageKitBackend.vala"
				_g_object_unref0 (_data_->pk_package);
#line 364 "../src/Core/PackageKitBackend.vala"
				break;
#line 3716 "PackageKitBackend.c"
			}
#line 367 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp7_ = _data_->pk_package;
#line 367 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp8_ = app_center_core_package_kit_backend_populate_basic_package_details (_data_->self, _data_->_tmp7_);
#line 367 "../src/Core/PackageKitBackend.vala"
			_data_->package = _data_->_tmp8_;
#line 368 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp9_ = _data_->package;
#line 368 "../src/Core/PackageKitBackend.vala"
			if (_data_->_tmp9_ != NULL) {
#line 369 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp10_ = _data_->packages;
#line 369 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp11_ = _data_->package;
#line 369 "../src/Core/PackageKitBackend.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp10_, _data_->_tmp11_);
#line 3734 "PackageKitBackend.c"
			}
#line 362 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (_data_->package);
#line 362 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (_data_->pk_package);
#line 3740 "PackageKitBackend.c"
		}
#line 362 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data_->_pk_package_it);
#line 3744 "PackageKitBackend.c"
	}
#line 373 "../src/Core/PackageKitBackend.vala"
	_data_->result = (GeeCollection*) _data_->packages;
#line 373 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->installed);
#line 373 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 373 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 373 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 373 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3758 "PackageKitBackend.c"
		}
	}
#line 373 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 373 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 3765 "PackageKitBackend.c"
}

static AppCenterCorePackage*
app_center_core_package_kit_backend_real_get_package_for_component_id (AppCenterCoreBackend* base,
                                                                       const gchar* id)
{
	AppCenterCorePackageKitBackend * self;
	AppCenterCorePackage* result;
#line 376 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 376 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 3778 "PackageKitBackend.c"
	{
		GeeIterator* _package_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 377 "../src/Core/PackageKitBackend.vala"
		_tmp0_ = self->priv->package_list;
#line 377 "../src/Core/PackageKitBackend.vala"
		_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 377 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = _tmp1_;
#line 377 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = _tmp2_;
#line 377 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 377 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = _tmp4_;
#line 377 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp3_);
#line 377 "../src/Core/PackageKitBackend.vala"
		_package_it = _tmp5_;
#line 377 "../src/Core/PackageKitBackend.vala"
		while (TRUE) {
#line 3805 "PackageKitBackend.c"
			GeeIterator* _tmp6_;
			AppCenterCorePackage* package = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			AppCenterCorePackage* _tmp9_;
			AsComponent* _tmp10_;
			AsComponent* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
#line 377 "../src/Core/PackageKitBackend.vala"
			_tmp6_ = _package_it;
#line 377 "../src/Core/PackageKitBackend.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 377 "../src/Core/PackageKitBackend.vala"
				break;
#line 3821 "PackageKitBackend.c"
			}
#line 377 "../src/Core/PackageKitBackend.vala"
			_tmp7_ = _package_it;
#line 377 "../src/Core/PackageKitBackend.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 377 "../src/Core/PackageKitBackend.vala"
			package = (AppCenterCorePackage*) _tmp8_;
#line 378 "../src/Core/PackageKitBackend.vala"
			_tmp9_ = package;
#line 378 "../src/Core/PackageKitBackend.vala"
			_tmp10_ = app_center_core_package_get_component (_tmp9_);
#line 378 "../src/Core/PackageKitBackend.vala"
			_tmp11_ = _tmp10_;
#line 378 "../src/Core/PackageKitBackend.vala"
			_tmp12_ = as_component_get_id (_tmp11_);
#line 378 "../src/Core/PackageKitBackend.vala"
			_tmp13_ = _tmp12_;
#line 378 "../src/Core/PackageKitBackend.vala"
			if (g_strcmp0 (_tmp13_, id) == 0) {
#line 379 "../src/Core/PackageKitBackend.vala"
				result = package;
#line 379 "../src/Core/PackageKitBackend.vala"
				_g_object_unref0 (_package_it);
#line 379 "../src/Core/PackageKitBackend.vala"
				return result;
#line 3847 "PackageKitBackend.c"
			} else {
				AppCenterCorePackage* _tmp14_;
				AsComponent* _tmp15_;
				AsComponent* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gboolean _tmp21_;
#line 380 "../src/Core/PackageKitBackend.vala"
				_tmp14_ = package;
#line 380 "../src/Core/PackageKitBackend.vala"
				_tmp15_ = app_center_core_package_get_component (_tmp14_);
#line 380 "../src/Core/PackageKitBackend.vala"
				_tmp16_ = _tmp15_;
#line 380 "../src/Core/PackageKitBackend.vala"
				_tmp17_ = as_component_get_id (_tmp16_);
#line 380 "../src/Core/PackageKitBackend.vala"
				_tmp18_ = _tmp17_;
#line 380 "../src/Core/PackageKitBackend.vala"
				_tmp19_ = g_strconcat (id, ".desktop", NULL);
#line 380 "../src/Core/PackageKitBackend.vala"
				_tmp20_ = _tmp19_;
#line 380 "../src/Core/PackageKitBackend.vala"
				_tmp21_ = g_strcmp0 (_tmp18_, _tmp20_) == 0;
#line 380 "../src/Core/PackageKitBackend.vala"
				_g_free0 (_tmp20_);
#line 380 "../src/Core/PackageKitBackend.vala"
				if (_tmp21_) {
#line 381 "../src/Core/PackageKitBackend.vala"
					result = package;
#line 381 "../src/Core/PackageKitBackend.vala"
					_g_object_unref0 (_package_it);
#line 381 "../src/Core/PackageKitBackend.vala"
					return result;
#line 3883 "PackageKitBackend.c"
				}
			}
#line 377 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (package);
#line 3888 "PackageKitBackend.c"
		}
#line 377 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_package_it);
#line 3892 "PackageKitBackend.c"
	}
#line 385 "../src/Core/PackageKitBackend.vala"
	result = NULL;
#line 385 "../src/Core/PackageKitBackend.vala"
	return result;
#line 3898 "PackageKitBackend.c"
}

GeeHashMap*
app_center_core_package_kit_backend_get_packages_for_component_ids (AppCenterCorePackageKitBackend* self,
                                                                    gchar** ids,
                                                                    gint ids_length1)
{
	GeeHashMap* packages = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* result;
#line 388 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 389 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, APP_CENTER_CORE_TYPE_PACKAGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 389 "../src/Core/PackageKitBackend.vala"
	packages = _tmp0_;
#line 3915 "PackageKitBackend.c"
	{
		gchar** id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 390 "../src/Core/PackageKitBackend.vala"
		id_collection = ids;
#line 390 "../src/Core/PackageKitBackend.vala"
		id_collection_length1 = ids_length1;
#line 390 "../src/Core/PackageKitBackend.vala"
		for (id_it = 0; id_it < id_collection_length1; id_it = id_it + 1) {
#line 3927 "PackageKitBackend.c"
			const gchar* id = NULL;
#line 390 "../src/Core/PackageKitBackend.vala"
			id = id_collection[id_it];
#line 3931 "PackageKitBackend.c"
			{
				AppCenterCorePackage* package = NULL;
				const gchar* _tmp1_;
				AppCenterCorePackage* _tmp2_;
				AppCenterCorePackage* _tmp3_;
#line 391 "../src/Core/PackageKitBackend.vala"
				_tmp1_ = id;
#line 391 "../src/Core/PackageKitBackend.vala"
				_tmp2_ = app_center_core_backend_get_package_for_component_id ((AppCenterCoreBackend*) self, _tmp1_);
#line 391 "../src/Core/PackageKitBackend.vala"
				package = _tmp2_;
#line 392 "../src/Core/PackageKitBackend.vala"
				_tmp3_ = package;
#line 392 "../src/Core/PackageKitBackend.vala"
				if (_tmp3_ != NULL) {
#line 3947 "PackageKitBackend.c"
					GeeHashMap* _tmp4_;
					const gchar* _tmp5_;
					AppCenterCorePackage* _tmp6_;
#line 393 "../src/Core/PackageKitBackend.vala"
					_tmp4_ = packages;
#line 393 "../src/Core/PackageKitBackend.vala"
					_tmp5_ = id;
#line 393 "../src/Core/PackageKitBackend.vala"
					_tmp6_ = package;
#line 393 "../src/Core/PackageKitBackend.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, _tmp5_, _tmp6_);
#line 3959 "PackageKitBackend.c"
				}
#line 390 "../src/Core/PackageKitBackend.vala"
				_g_object_unref0 (package);
#line 3963 "PackageKitBackend.c"
			}
		}
	}
#line 397 "../src/Core/PackageKitBackend.vala"
	result = packages;
#line 397 "../src/Core/PackageKitBackend.vala"
	return result;
#line 3971 "PackageKitBackend.c"
}

static GeeCollection*
app_center_core_package_kit_backend_real_get_packages_for_component_id (AppCenterCoreBackend* base,
                                                                        const gchar* id)
{
	AppCenterCorePackageKitBackend * self;
	GeeArrayList* packages = NULL;
	GeeArrayList* _tmp0_;
	gchar* suffixed_id = NULL;
	gchar* _tmp1_;
	GeeCollection* result;
#line 400 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 400 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 401 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = gee_array_list_new (APP_CENTER_CORE_TYPE_PACKAGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 401 "../src/Core/PackageKitBackend.vala"
	packages = _tmp0_;
#line 402 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = g_strconcat (id, ".desktop", NULL);
#line 402 "../src/Core/PackageKitBackend.vala"
	suffixed_id = _tmp1_;
#line 3996 "PackageKitBackend.c"
	{
		GeeIterator* _package_it = NULL;
		GeeHashMap* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
#line 403 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = self->priv->package_list;
#line 403 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
#line 403 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = _tmp3_;
#line 403 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = _tmp4_;
#line 403 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 403 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = _tmp6_;
#line 403 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp5_);
#line 403 "../src/Core/PackageKitBackend.vala"
		_package_it = _tmp7_;
#line 403 "../src/Core/PackageKitBackend.vala"
		while (TRUE) {
#line 4023 "PackageKitBackend.c"
			GeeIterator* _tmp8_;
			AppCenterCorePackage* package = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			AppCenterCorePackage* _tmp11_;
			AsComponent* _tmp12_;
			AsComponent* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
#line 403 "../src/Core/PackageKitBackend.vala"
			_tmp8_ = _package_it;
#line 403 "../src/Core/PackageKitBackend.vala"
			if (!gee_iterator_next (_tmp8_)) {
#line 403 "../src/Core/PackageKitBackend.vala"
				break;
#line 4039 "PackageKitBackend.c"
			}
#line 403 "../src/Core/PackageKitBackend.vala"
			_tmp9_ = _package_it;
#line 403 "../src/Core/PackageKitBackend.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 403 "../src/Core/PackageKitBackend.vala"
			package = (AppCenterCorePackage*) _tmp10_;
#line 404 "../src/Core/PackageKitBackend.vala"
			_tmp11_ = package;
#line 404 "../src/Core/PackageKitBackend.vala"
			_tmp12_ = app_center_core_package_get_component (_tmp11_);
#line 404 "../src/Core/PackageKitBackend.vala"
			_tmp13_ = _tmp12_;
#line 404 "../src/Core/PackageKitBackend.vala"
			_tmp14_ = as_component_get_id (_tmp13_);
#line 404 "../src/Core/PackageKitBackend.vala"
			_tmp15_ = _tmp14_;
#line 404 "../src/Core/PackageKitBackend.vala"
			if (g_strcmp0 (_tmp15_, id) == 0) {
#line 4059 "PackageKitBackend.c"
				GeeArrayList* _tmp16_;
				AppCenterCorePackage* _tmp17_;
#line 405 "../src/Core/PackageKitBackend.vala"
				_tmp16_ = packages;
#line 405 "../src/Core/PackageKitBackend.vala"
				_tmp17_ = package;
#line 405 "../src/Core/PackageKitBackend.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 4068 "PackageKitBackend.c"
			} else {
				AppCenterCorePackage* _tmp18_;
				AsComponent* _tmp19_;
				AsComponent* _tmp20_;
				const gchar* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
#line 406 "../src/Core/PackageKitBackend.vala"
				_tmp18_ = package;
#line 406 "../src/Core/PackageKitBackend.vala"
				_tmp19_ = app_center_core_package_get_component (_tmp18_);
#line 406 "../src/Core/PackageKitBackend.vala"
				_tmp20_ = _tmp19_;
#line 406 "../src/Core/PackageKitBackend.vala"
				_tmp21_ = as_component_get_id (_tmp20_);
#line 406 "../src/Core/PackageKitBackend.vala"
				_tmp22_ = _tmp21_;
#line 406 "../src/Core/PackageKitBackend.vala"
				_tmp23_ = suffixed_id;
#line 406 "../src/Core/PackageKitBackend.vala"
				if (g_strcmp0 (_tmp22_, _tmp23_) == 0) {
#line 4090 "PackageKitBackend.c"
					GeeArrayList* _tmp24_;
					AppCenterCorePackage* _tmp25_;
#line 407 "../src/Core/PackageKitBackend.vala"
					_tmp24_ = packages;
#line 407 "../src/Core/PackageKitBackend.vala"
					_tmp25_ = package;
#line 407 "../src/Core/PackageKitBackend.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp25_);
#line 4099 "PackageKitBackend.c"
				}
			}
#line 403 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (package);
#line 4104 "PackageKitBackend.c"
		}
#line 403 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_package_it);
#line 4108 "PackageKitBackend.c"
	}
#line 411 "../src/Core/PackageKitBackend.vala"
	result = (GeeCollection*) packages;
#line 411 "../src/Core/PackageKitBackend.vala"
	_g_free0 (suffixed_id);
#line 411 "../src/Core/PackageKitBackend.vala"
	return result;
#line 4116 "PackageKitBackend.c"
}

static AppCenterCorePackage*
app_center_core_package_kit_backend_real_get_package_for_desktop_id (AppCenterCoreBackend* base,
                                                                     const gchar* desktop_id)
{
	AppCenterCorePackageKitBackend * self;
	AppCenterCorePackage* result;
#line 414 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 414 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (desktop_id != NULL, NULL);
#line 4129 "PackageKitBackend.c"
	{
		GeeIterator* _package_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 415 "../src/Core/PackageKitBackend.vala"
		_tmp0_ = self->priv->package_list;
#line 415 "../src/Core/PackageKitBackend.vala"
		_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 415 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = _tmp1_;
#line 415 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = _tmp2_;
#line 415 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 415 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = _tmp4_;
#line 415 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp3_);
#line 415 "../src/Core/PackageKitBackend.vala"
		_package_it = _tmp5_;
#line 415 "../src/Core/PackageKitBackend.vala"
		while (TRUE) {
#line 4156 "PackageKitBackend.c"
			GeeIterator* _tmp6_;
			AppCenterCorePackage* package = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			gboolean _tmp9_ = FALSE;
			AppCenterCorePackage* _tmp10_;
			AsComponent* _tmp11_;
			AsComponent* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
#line 415 "../src/Core/PackageKitBackend.vala"
			_tmp6_ = _package_it;
#line 415 "../src/Core/PackageKitBackend.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 415 "../src/Core/PackageKitBackend.vala"
				break;
#line 4173 "PackageKitBackend.c"
			}
#line 415 "../src/Core/PackageKitBackend.vala"
			_tmp7_ = _package_it;
#line 415 "../src/Core/PackageKitBackend.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 415 "../src/Core/PackageKitBackend.vala"
			package = (AppCenterCorePackage*) _tmp8_;
#line 416 "../src/Core/PackageKitBackend.vala"
			_tmp10_ = package;
#line 416 "../src/Core/PackageKitBackend.vala"
			_tmp11_ = app_center_core_package_get_component (_tmp10_);
#line 416 "../src/Core/PackageKitBackend.vala"
			_tmp12_ = _tmp11_;
#line 416 "../src/Core/PackageKitBackend.vala"
			_tmp13_ = as_component_get_id (_tmp12_);
#line 416 "../src/Core/PackageKitBackend.vala"
			_tmp14_ = _tmp13_;
#line 416 "../src/Core/PackageKitBackend.vala"
			if (g_strcmp0 (_tmp14_, desktop_id) == 0) {
#line 416 "../src/Core/PackageKitBackend.vala"
				_tmp9_ = TRUE;
#line 4195 "PackageKitBackend.c"
			} else {
				AppCenterCorePackage* _tmp15_;
				AsComponent* _tmp16_;
				AsComponent* _tmp17_;
				const gchar* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
#line 417 "../src/Core/PackageKitBackend.vala"
				_tmp15_ = package;
#line 417 "../src/Core/PackageKitBackend.vala"
				_tmp16_ = app_center_core_package_get_component (_tmp15_);
#line 417 "../src/Core/PackageKitBackend.vala"
				_tmp17_ = _tmp16_;
#line 417 "../src/Core/PackageKitBackend.vala"
				_tmp18_ = as_component_get_id (_tmp17_);
#line 417 "../src/Core/PackageKitBackend.vala"
				_tmp19_ = _tmp18_;
#line 417 "../src/Core/PackageKitBackend.vala"
				_tmp20_ = g_strconcat (_tmp19_, ".desktop", NULL);
#line 417 "../src/Core/PackageKitBackend.vala"
				_tmp21_ = _tmp20_;
#line 417 "../src/Core/PackageKitBackend.vala"
				_tmp9_ = g_strcmp0 (_tmp21_, desktop_id) == 0;
#line 417 "../src/Core/PackageKitBackend.vala"
				_g_free0 (_tmp21_);
#line 4222 "PackageKitBackend.c"
			}
#line 416 "../src/Core/PackageKitBackend.vala"
			if (_tmp9_) {
#line 419 "../src/Core/PackageKitBackend.vala"
				result = package;
#line 419 "../src/Core/PackageKitBackend.vala"
				_g_object_unref0 (_package_it);
#line 419 "../src/Core/PackageKitBackend.vala"
				return result;
#line 4232 "PackageKitBackend.c"
			}
#line 415 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (package);
#line 4236 "PackageKitBackend.c"
		}
#line 415 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_package_it);
#line 4240 "PackageKitBackend.c"
	}
#line 423 "../src/Core/PackageKitBackend.vala"
	result = NULL;
#line 423 "../src/Core/PackageKitBackend.vala"
	return result;
#line 4246 "PackageKitBackend.c"
}

static GeeCollection*
app_center_core_package_kit_backend_real_get_packages_by_author (AppCenterCoreBackend* base,
                                                                 const gchar* author,
                                                                 gint max)
{
	AppCenterCorePackageKitBackend * self;
	GeeArrayList* packages = NULL;
	GeeArrayList* _tmp0_;
	GeeCollection* result;
#line 426 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 426 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (author != NULL, NULL);
#line 427 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = gee_array_list_new (APP_CENTER_CORE_TYPE_PACKAGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 427 "../src/Core/PackageKitBackend.vala"
	packages = _tmp0_;
#line 4266 "PackageKitBackend.c"
	{
		GeeIterator* _package_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 428 "../src/Core/PackageKitBackend.vala"
		_tmp1_ = self->priv->package_list;
#line 428 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 428 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = _tmp2_;
#line 428 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = _tmp3_;
#line 428 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 428 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = _tmp5_;
#line 428 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp4_);
#line 428 "../src/Core/PackageKitBackend.vala"
		_package_it = _tmp6_;
#line 428 "../src/Core/PackageKitBackend.vala"
		while (TRUE) {
#line 4293 "PackageKitBackend.c"
			GeeIterator* _tmp7_;
			AppCenterCorePackage* package = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GeeArrayList* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			AppCenterCorePackage* _tmp13_;
			AsComponent* _tmp14_;
			AsComponent* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gboolean _tmp19_;
#line 428 "../src/Core/PackageKitBackend.vala"
			_tmp7_ = _package_it;
#line 428 "../src/Core/PackageKitBackend.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 428 "../src/Core/PackageKitBackend.vala"
				break;
#line 4314 "PackageKitBackend.c"
			}
#line 428 "../src/Core/PackageKitBackend.vala"
			_tmp8_ = _package_it;
#line 428 "../src/Core/PackageKitBackend.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 428 "../src/Core/PackageKitBackend.vala"
			package = (AppCenterCorePackage*) _tmp9_;
#line 429 "../src/Core/PackageKitBackend.vala"
			_tmp10_ = packages;
#line 429 "../src/Core/PackageKitBackend.vala"
			_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
#line 429 "../src/Core/PackageKitBackend.vala"
			_tmp12_ = _tmp11_;
#line 429 "../src/Core/PackageKitBackend.vala"
			if (_tmp12_ > max) {
#line 430 "../src/Core/PackageKitBackend.vala"
				_g_object_unref0 (package);
#line 430 "../src/Core/PackageKitBackend.vala"
				break;
#line 4334 "PackageKitBackend.c"
			}
#line 433 "../src/Core/PackageKitBackend.vala"
			_tmp13_ = package;
#line 433 "../src/Core/PackageKitBackend.vala"
			_tmp14_ = app_center_core_package_get_component (_tmp13_);
#line 433 "../src/Core/PackageKitBackend.vala"
			_tmp15_ = _tmp14_;
#line 433 "../src/Core/PackageKitBackend.vala"
			g_object_get (_tmp15_, "developer-name", &_tmp16_, NULL);
#line 433 "../src/Core/PackageKitBackend.vala"
			_tmp17_ = _tmp16_;
#line 433 "../src/Core/PackageKitBackend.vala"
			_tmp18_ = _tmp17_;
#line 433 "../src/Core/PackageKitBackend.vala"
			_tmp19_ = g_strcmp0 (_tmp18_, author) == 0;
#line 433 "../src/Core/PackageKitBackend.vala"
			_g_free0 (_tmp18_);
#line 433 "../src/Core/PackageKitBackend.vala"
			if (_tmp19_) {
#line 4354 "PackageKitBackend.c"
				GeeArrayList* _tmp20_;
				AppCenterCorePackage* _tmp21_;
#line 434 "../src/Core/PackageKitBackend.vala"
				_tmp20_ = packages;
#line 434 "../src/Core/PackageKitBackend.vala"
				_tmp21_ = package;
#line 434 "../src/Core/PackageKitBackend.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 4363 "PackageKitBackend.c"
			}
#line 428 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (package);
#line 4367 "PackageKitBackend.c"
		}
#line 428 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_package_it);
#line 4371 "PackageKitBackend.c"
	}
#line 438 "../src/Core/PackageKitBackend.vala"
	result = (GeeCollection*) packages;
#line 438 "../src/Core/PackageKitBackend.vala"
	return result;
#line 4377 "PackageKitBackend.c"
}

static Block54Data*
block54_data_ref (Block54Data* _data54_)
{
#line 441 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data54_->_ref_count_);
#line 441 "../src/Core/PackageKitBackend.vala"
	return _data54_;
#line 4387 "PackageKitBackend.c"
}

static void
block54_data_unref (void * _userdata_)
{
	Block54Data* _data54_;
	_data54_ = (Block54Data*) _userdata_;
#line 441 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data54_->_ref_count_)) {
#line 4397 "PackageKitBackend.c"
		AppCenterCorePackageKitBackend* self;
#line 441 "../src/Core/PackageKitBackend.vala"
		self = _data54_->self;
#line 441 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data54_->apps);
#line 441 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (self);
#line 441 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block54Data, _data54_);
#line 4407 "PackageKitBackend.c"
	}
}

static void
__lambda81_ (Block54Data* _data54_,
             AsComponent* comp)
{
	AppCenterCorePackageKitBackend* self;
	AppCenterCorePackage* package = NULL;
	const gchar* _tmp0_;
	AppCenterCorePackage* _tmp1_;
	AppCenterCorePackage* _tmp2_;
#line 454 "../src/Core/PackageKitBackend.vala"
	self = _data54_->self;
#line 454 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (comp != NULL);
#line 455 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = as_component_get_id (comp);
#line 455 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = app_center_core_backend_get_package_for_component_id ((AppCenterCoreBackend*) self, _tmp0_);
#line 455 "../src/Core/PackageKitBackend.vala"
	package = _tmp1_;
#line 456 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = package;
#line 456 "../src/Core/PackageKitBackend.vala"
	if (_tmp2_ != NULL) {
#line 4434 "PackageKitBackend.c"
		AppCenterCorePackage* _tmp3_;
#line 457 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = package;
#line 457 "../src/Core/PackageKitBackend.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _data54_->apps, _tmp3_);
#line 4440 "PackageKitBackend.c"
	}
#line 454 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (package);
#line 4444 "PackageKitBackend.c"
}

static void
___lambda81__gfunc (gconstpointer data,
                    gpointer self)
{
#line 454 "../src/Core/PackageKitBackend.vala"
	__lambda81_ (self, (AsComponent*) data);
#line 4453 "PackageKitBackend.c"
}

static GeeCollection*
app_center_core_package_kit_backend_real_get_applications_for_category (AppCenterCoreBackend* base,
                                                                        AsCategory* category)
{
	AppCenterCorePackageKitBackend * self;
	Block54Data* _data54_;
	GPtrArray* components = NULL;
	GPtrArray* _tmp0_;
	GPtrArray* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GPtrArray* category_array = NULL;
	GPtrArray* _tmp8_;
	AsCategory* _tmp9_;
	AsPool* _tmp10_;
	GPtrArray* _tmp11_;
	GPtrArray* _tmp12_;
	GPtrArray* _tmp13_;
	GeeTreeSet* _tmp14_;
	GPtrArray* _tmp15_;
	GeeCollection* _tmp16_;
	GeeCollection* result;
#line 441 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 441 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (category != NULL, NULL);
#line 441 "../src/Core/PackageKitBackend.vala"
	_data54_ = g_slice_new0 (Block54Data);
#line 441 "../src/Core/PackageKitBackend.vala"
	_data54_->_ref_count_ = 1;
#line 441 "../src/Core/PackageKitBackend.vala"
	_data54_->self = g_object_ref (self);
#line 442 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = as_category_get_components (category);
#line 442 "../src/Core/PackageKitBackend.vala"
	components = _tmp0_;
#line 444 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = components;
#line 444 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = vala_g_ptr_array_get_length (_tmp1_);
#line 444 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _tmp2_;
#line 444 "../src/Core/PackageKitBackend.vala"
	if (_tmp3_ != 0) {
#line 4500 "PackageKitBackend.c"
		GPtrArray* _tmp4_;
		GPtrArray* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 445 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = components;
#line 445 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = components;
#line 445 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = vala_g_ptr_array_get_length (_tmp5_);
#line 445 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = _tmp6_;
#line 445 "../src/Core/PackageKitBackend.vala"
		g_ptr_array_remove_range (_tmp4_, (guint) 0, (guint) _tmp7_);
#line 4515 "PackageKitBackend.c"
	}
#line 448 "../src/Core/PackageKitBackend.vala"
	_tmp8_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 448 "../src/Core/PackageKitBackend.vala"
	category_array = _tmp8_;
#line 449 "../src/Core/PackageKitBackend.vala"
	_tmp9_ = _g_object_ref0 (category);
#line 449 "../src/Core/PackageKitBackend.vala"
	g_ptr_array_add (category_array, _tmp9_);
#line 450 "../src/Core/PackageKitBackend.vala"
	_tmp10_ = self->priv->appstream_pool;
#line 450 "../src/Core/PackageKitBackend.vala"
	_tmp11_ = as_pool_get_components_gir (_tmp10_);
#line 450 "../src/Core/PackageKitBackend.vala"
	_tmp12_ = _tmp11_;
#line 450 "../src/Core/PackageKitBackend.vala"
	as_utils_sort_components_into_categories (_tmp12_, category_array, TRUE);
#line 450 "../src/Core/PackageKitBackend.vala"
	_g_ptr_array_unref0 (_tmp12_);
#line 451 "../src/Core/PackageKitBackend.vala"
	_tmp13_ = as_category_get_components (category);
#line 451 "../src/Core/PackageKitBackend.vala"
	components = _tmp13_;
#line 453 "../src/Core/PackageKitBackend.vala"
	_tmp14_ = gee_tree_set_new (APP_CENTER_CORE_TYPE_PACKAGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 453 "../src/Core/PackageKitBackend.vala"
	_data54_->apps = _tmp14_;
#line 454 "../src/Core/PackageKitBackend.vala"
	_tmp15_ = components;
#line 454 "../src/Core/PackageKitBackend.vala"
	g_ptr_array_foreach (_tmp15_, ___lambda81__gfunc, _data54_);
#line 461 "../src/Core/PackageKitBackend.vala"
	_tmp16_ = _g_object_ref0 ((GeeCollection*) _data54_->apps);
#line 461 "../src/Core/PackageKitBackend.vala"
	result = _tmp16_;
#line 461 "../src/Core/PackageKitBackend.vala"
	_g_ptr_array_unref0 (category_array);
#line 461 "../src/Core/PackageKitBackend.vala"
	block54_data_unref (_data54_);
#line 461 "../src/Core/PackageKitBackend.vala"
	_data54_ = NULL;
#line 461 "../src/Core/PackageKitBackend.vala"
	return result;
#line 4559 "PackageKitBackend.c"
}

static Block55Data*
block55_data_ref (Block55Data* _data55_)
{
#line 464 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data55_->_ref_count_);
#line 464 "../src/Core/PackageKitBackend.vala"
	return _data55_;
#line 4569 "PackageKitBackend.c"
}

static void
block55_data_unref (void * _userdata_)
{
	Block55Data* _data55_;
	_data55_ = (Block55Data*) _userdata_;
#line 464 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data55_->_ref_count_)) {
#line 4579 "PackageKitBackend.c"
		AppCenterCorePackageKitBackend* self;
#line 464 "../src/Core/PackageKitBackend.vala"
		self = _data55_->self;
#line 464 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data55_->apps);
#line 464 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (self);
#line 464 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block55Data, _data55_);
#line 4589 "PackageKitBackend.c"
	}
}

static void
___lambda82_ (Block55Data* _data55_,
              AsComponent* comp)
{
	AppCenterCorePackageKitBackend* self;
	AppCenterCorePackage* package = NULL;
	const gchar* _tmp0_;
	AppCenterCorePackage* _tmp1_;
	AppCenterCorePackage* _tmp2_;
#line 468 "../src/Core/PackageKitBackend.vala"
	self = _data55_->self;
#line 468 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (comp != NULL);
#line 469 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = as_component_get_id (comp);
#line 469 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = app_center_core_backend_get_package_for_component_id ((AppCenterCoreBackend*) self, _tmp0_);
#line 469 "../src/Core/PackageKitBackend.vala"
	package = _tmp1_;
#line 470 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = package;
#line 470 "../src/Core/PackageKitBackend.vala"
	if (_tmp2_ != NULL) {
#line 4616 "PackageKitBackend.c"
		GeeTreeSet* _tmp3_;
		AppCenterCorePackage* _tmp4_;
#line 471 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = _data55_->apps;
#line 471 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = package;
#line 471 "../src/Core/PackageKitBackend.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, _tmp4_);
#line 4625 "PackageKitBackend.c"
	}
#line 468 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (package);
#line 4629 "PackageKitBackend.c"
}

static void
____lambda82__gfunc (gconstpointer data,
                     gpointer self)
{
#line 468 "../src/Core/PackageKitBackend.vala"
	___lambda82_ (self, (AsComponent*) data);
#line 4638 "PackageKitBackend.c"
}

static Block56Data*
block56_data_ref (Block56Data* _data56_)
{
#line 467 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data56_->_ref_count_);
#line 467 "../src/Core/PackageKitBackend.vala"
	return _data56_;
#line 4648 "PackageKitBackend.c"
}

static void
block56_data_unref (void * _userdata_)
{
	Block56Data* _data56_;
	_data56_ = (Block56Data*) _userdata_;
#line 467 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data56_->_ref_count_)) {
#line 4658 "PackageKitBackend.c"
		AppCenterCorePackageKitBackend* self;
#line 467 "../src/Core/PackageKitBackend.vala"
		self = _data56_->_data55_->self;
#line 467 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data56_->cat_packages);
#line 467 "../src/Core/PackageKitBackend.vala"
		block55_data_unref (_data56_->_data55_);
#line 467 "../src/Core/PackageKitBackend.vala"
		_data56_->_data55_ = NULL;
#line 467 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block56Data, _data56_);
#line 4670 "PackageKitBackend.c"
	}
}

static void
___lambda83_ (Block56Data* _data56_,
              AsComponent* comp)
{
	Block55Data* _data55_;
	AppCenterCorePackageKitBackend* self;
	AppCenterCorePackage* package = NULL;
	const gchar* _tmp0_;
	AppCenterCorePackage* _tmp1_;
	gboolean _tmp2_ = FALSE;
	AppCenterCorePackage* _tmp3_;
#line 476 "../src/Core/PackageKitBackend.vala"
	_data55_ = _data56_->_data55_;
#line 476 "../src/Core/PackageKitBackend.vala"
	self = _data55_->self;
#line 476 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (comp != NULL);
#line 477 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = as_component_get_id (comp);
#line 477 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = app_center_core_backend_get_package_for_component_id ((AppCenterCoreBackend*) self, _tmp0_);
#line 477 "../src/Core/PackageKitBackend.vala"
	package = _tmp1_;
#line 478 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = package;
#line 478 "../src/Core/PackageKitBackend.vala"
	if (_tmp3_ != NULL) {
#line 4701 "PackageKitBackend.c"
		GeeCollection* _tmp4_;
		AppCenterCorePackage* _tmp5_;
#line 478 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = _data56_->cat_packages;
#line 478 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = package;
#line 478 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = gee_collection_contains (_tmp4_, _tmp5_);
#line 4710 "PackageKitBackend.c"
	} else {
#line 478 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = FALSE;
#line 4714 "PackageKitBackend.c"
	}
#line 478 "../src/Core/PackageKitBackend.vala"
	if (_tmp2_) {
#line 4718 "PackageKitBackend.c"
		GeeTreeSet* _tmp6_;
		AppCenterCorePackage* _tmp7_;
#line 479 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = _data55_->apps;
#line 479 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = package;
#line 479 "../src/Core/PackageKitBackend.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp7_);
#line 4727 "PackageKitBackend.c"
	}
#line 476 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (package);
#line 4731 "PackageKitBackend.c"
}

static void
____lambda83__gfunc (gconstpointer data,
                     gpointer self)
{
#line 476 "../src/Core/PackageKitBackend.vala"
	___lambda83_ (self, (AsComponent*) data);
#line 4740 "PackageKitBackend.c"
}

static GeeCollection*
app_center_core_package_kit_backend_real_search_applications (AppCenterCoreBackend* base,
                                                              const gchar* query,
                                                              AsCategory* category)
{
	AppCenterCorePackageKitBackend * self;
	Block55Data* _data55_;
	GeeTreeSet* _tmp0_;
	GPtrArray* comps = NULL;
	AsPool* _tmp1_;
	GPtrArray* _tmp2_;
	GeeTreeSet* _tmp6_;
	GeeCollection* _tmp7_;
	GeeCollection* result;
#line 464 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 464 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (query != NULL, NULL);
#line 464 "../src/Core/PackageKitBackend.vala"
	_data55_ = g_slice_new0 (Block55Data);
#line 464 "../src/Core/PackageKitBackend.vala"
	_data55_->_ref_count_ = 1;
#line 464 "../src/Core/PackageKitBackend.vala"
	_data55_->self = g_object_ref (self);
#line 465 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = gee_tree_set_new (APP_CENTER_CORE_TYPE_PACKAGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 465 "../src/Core/PackageKitBackend.vala"
	_data55_->apps = _tmp0_;
#line 466 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = self->priv->appstream_pool;
#line 466 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = as_pool_search_gir (_tmp1_, query);
#line 466 "../src/Core/PackageKitBackend.vala"
	comps = _tmp2_;
#line 467 "../src/Core/PackageKitBackend.vala"
	if (category == NULL) {
#line 4779 "PackageKitBackend.c"
		GPtrArray* _tmp3_;
#line 468 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = comps;
#line 468 "../src/Core/PackageKitBackend.vala"
		g_ptr_array_foreach (_tmp3_, ____lambda82__gfunc, _data55_);
#line 4785 "PackageKitBackend.c"
	} else {
		Block56Data* _data56_;
		GeeCollection* _tmp4_;
		GPtrArray* _tmp5_;
#line 467 "../src/Core/PackageKitBackend.vala"
		_data56_ = g_slice_new0 (Block56Data);
#line 467 "../src/Core/PackageKitBackend.vala"
		_data56_->_ref_count_ = 1;
#line 467 "../src/Core/PackageKitBackend.vala"
		_data56_->_data55_ = block55_data_ref (_data55_);
#line 475 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = app_center_core_backend_get_applications_for_category ((AppCenterCoreBackend*) self, category);
#line 475 "../src/Core/PackageKitBackend.vala"
		_data56_->cat_packages = _tmp4_;
#line 476 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = comps;
#line 476 "../src/Core/PackageKitBackend.vala"
		g_ptr_array_foreach (_tmp5_, ____lambda83__gfunc, _data56_);
#line 467 "../src/Core/PackageKitBackend.vala"
		block56_data_unref (_data56_);
#line 467 "../src/Core/PackageKitBackend.vala"
		_data56_ = NULL;
#line 4808 "PackageKitBackend.c"
	}
#line 484 "../src/Core/PackageKitBackend.vala"
	_tmp6_ = _data55_->apps;
#line 484 "../src/Core/PackageKitBackend.vala"
	_tmp7_ = _g_object_ref0 ((GeeCollection*) _tmp6_);
#line 484 "../src/Core/PackageKitBackend.vala"
	result = _tmp7_;
#line 484 "../src/Core/PackageKitBackend.vala"
	_g_ptr_array_unref0 (comps);
#line 484 "../src/Core/PackageKitBackend.vala"
	block55_data_unref (_data55_);
#line 484 "../src/Core/PackageKitBackend.vala"
	_data55_ = NULL;
#line 484 "../src/Core/PackageKitBackend.vala"
	return result;
#line 4824 "PackageKitBackend.c"
}

static GeeCollection*
app_center_core_package_kit_backend_real_search_applications_mime (AppCenterCoreBackend* base,
                                                                   const gchar* query)
{
	AppCenterCorePackageKitBackend * self;
	GeeTreeSet* apps = NULL;
	GeeTreeSet* _tmp0_;
	GeeCollection* result;
#line 487 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 487 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (query != NULL, NULL);
#line 488 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = gee_tree_set_new (APP_CENTER_CORE_TYPE_PACKAGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 488 "../src/Core/PackageKitBackend.vala"
	apps = _tmp0_;
#line 4843 "PackageKitBackend.c"
	{
		GeeIterator* _package_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 489 "../src/Core/PackageKitBackend.vala"
		_tmp1_ = self->priv->package_list;
#line 489 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 489 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = _tmp2_;
#line 489 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = _tmp3_;
#line 489 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 489 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = _tmp5_;
#line 489 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp4_);
#line 489 "../src/Core/PackageKitBackend.vala"
		_package_it = _tmp6_;
#line 489 "../src/Core/PackageKitBackend.vala"
		while (TRUE) {
#line 4870 "PackageKitBackend.c"
			GeeIterator* _tmp7_;
			AppCenterCorePackage* package = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			AsProvided* provided = NULL;
			AppCenterCorePackage* _tmp10_;
			AsComponent* _tmp11_;
			AsComponent* _tmp12_;
			AsProvided* _tmp13_;
			gboolean _tmp14_ = FALSE;
			AsProvided* _tmp15_;
#line 489 "../src/Core/PackageKitBackend.vala"
			_tmp7_ = _package_it;
#line 489 "../src/Core/PackageKitBackend.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 489 "../src/Core/PackageKitBackend.vala"
				break;
#line 4888 "PackageKitBackend.c"
			}
#line 489 "../src/Core/PackageKitBackend.vala"
			_tmp8_ = _package_it;
#line 489 "../src/Core/PackageKitBackend.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 489 "../src/Core/PackageKitBackend.vala"
			package = (AppCenterCorePackage*) _tmp9_;
#line 490 "../src/Core/PackageKitBackend.vala"
			_tmp10_ = package;
#line 490 "../src/Core/PackageKitBackend.vala"
			_tmp11_ = app_center_core_package_get_component (_tmp10_);
#line 490 "../src/Core/PackageKitBackend.vala"
			_tmp12_ = _tmp11_;
#line 490 "../src/Core/PackageKitBackend.vala"
			_tmp13_ = as_component_get_provided_for_kind (_tmp12_, AS_PROVIDED_KIND_MEDIATYPE);
#line 490 "../src/Core/PackageKitBackend.vala"
			provided = _tmp13_;
#line 491 "../src/Core/PackageKitBackend.vala"
			_tmp15_ = provided;
#line 491 "../src/Core/PackageKitBackend.vala"
			if (_tmp15_ != NULL) {
#line 4910 "PackageKitBackend.c"
				AsProvided* _tmp16_;
#line 491 "../src/Core/PackageKitBackend.vala"
				_tmp16_ = provided;
#line 491 "../src/Core/PackageKitBackend.vala"
				_tmp14_ = as_provided_has_item (_tmp16_, query);
#line 4916 "PackageKitBackend.c"
			} else {
#line 491 "../src/Core/PackageKitBackend.vala"
				_tmp14_ = FALSE;
#line 4920 "PackageKitBackend.c"
			}
#line 491 "../src/Core/PackageKitBackend.vala"
			if (_tmp14_) {
#line 4924 "PackageKitBackend.c"
				GeeTreeSet* _tmp17_;
				AppCenterCorePackage* _tmp18_;
#line 492 "../src/Core/PackageKitBackend.vala"
				_tmp17_ = apps;
#line 492 "../src/Core/PackageKitBackend.vala"
				_tmp18_ = package;
#line 492 "../src/Core/PackageKitBackend.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
#line 4933 "PackageKitBackend.c"
			}
#line 489 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (package);
#line 4937 "PackageKitBackend.c"
		}
#line 489 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_package_it);
#line 4941 "PackageKitBackend.c"
	}
#line 496 "../src/Core/PackageKitBackend.vala"
	result = (GeeCollection*) apps;
#line 496 "../src/Core/PackageKitBackend.vala"
	return result;
#line 4947 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_launch_job_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendLaunchJobData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (_data_->args);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendLaunchJobData, _data_);
#line 4963 "PackageKitBackend.c"
}

static gpointer
_app_center_core_job_args_ref0 (gpointer self)
{
#line 24 "../src/Core/PackageKitBackend.vala"
	return self ? app_center_core_job_args_ref (self) : NULL;
#line 4971 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_launch_job (AppCenterCorePackageKitBackend* self,
                                                AppCenterCoreJobType type,
                                                AppCenterCoreJobArgs* args,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	AppCenterCorePackageKitBackendLaunchJobData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	AppCenterCoreJobArgs* _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendLaunchJobData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_launch_job_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->type = type;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _app_center_core_job_args_ref0 (args);
#line 24 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (_data_->args);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->args = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_launch_job_co (_data_);
#line 5006 "PackageKitBackend.c"
}

static AppCenterCoreJob*
app_center_core_package_kit_backend_launch_job_finish (AppCenterCorePackageKitBackend* self,
                                                       GAsyncResult* _res_)
{
	AppCenterCoreJob* result;
	AppCenterCorePackageKitBackendLaunchJobData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->result = NULL;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 5023 "PackageKitBackend.c"
}

static Block57Data*
block57_data_ref (Block57Data* _data57_)
{
#line 499 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data57_->_ref_count_);
#line 499 "../src/Core/PackageKitBackend.vala"
	return _data57_;
#line 5033 "PackageKitBackend.c"
}

static void
block57_data_unref (void * _userdata_)
{
	Block57Data* _data57_;
	_data57_ = (Block57Data*) _userdata_;
#line 499 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data57_->_ref_count_)) {
#line 5043 "PackageKitBackend.c"
		AppCenterCorePackageKitBackend* self;
#line 499 "../src/Core/PackageKitBackend.vala"
		self = _data57_->self;
#line 499 "../src/Core/PackageKitBackend.vala"
		(_data57_->callback_target_destroy_notify == NULL) ? NULL : (_data57_->callback_target_destroy_notify (_data57_->callback_target), NULL);
#line 499 "../src/Core/PackageKitBackend.vala"
		_data57_->callback = NULL;
#line 499 "../src/Core/PackageKitBackend.vala"
		_data57_->callback_target = NULL;
#line 499 "../src/Core/PackageKitBackend.vala"
		_data57_->callback_target_destroy_notify = NULL;
#line 499 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (self);
#line 499 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block57Data, _data57_);
#line 5059 "PackageKitBackend.c"
	}
}

static gboolean
_app_center_core_package_kit_backend_launch_job_co_gsource_func (gpointer self)
{
	gboolean result;
	result = app_center_core_package_kit_backend_launch_job_co (self);
#line 503 "../src/Core/PackageKitBackend.vala"
	return result;
#line 5070 "PackageKitBackend.c"
}

static void
__lambda45_ (Block57Data* _data57_)
{
	AppCenterCorePackageKitBackend* self;
	GSourceFunc _tmp0_;
	gpointer _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
#line 504 "../src/Core/PackageKitBackend.vala"
	self = _data57_->self;
#line 505 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _data57_->callback;
#line 505 "../src/Core/PackageKitBackend.vala"
	_tmp0__target = _data57_->callback_target;
#line 505 "../src/Core/PackageKitBackend.vala"
	_tmp0__target_destroy_notify = _data57_->callback_target_destroy_notify;
#line 505 "../src/Core/PackageKitBackend.vala"
	_data57_->callback = NULL;
#line 505 "../src/Core/PackageKitBackend.vala"
	_data57_->callback_target = NULL;
#line 505 "../src/Core/PackageKitBackend.vala"
	_data57_->callback_target_destroy_notify = NULL;
#line 505 "../src/Core/PackageKitBackend.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify);
#line 5096 "PackageKitBackend.c"
}

static void
___lambda45__app_center_core_job_results_ready (AppCenterCoreJob* _sender,
                                                gpointer self)
{
#line 504 "../src/Core/PackageKitBackend.vala"
	__lambda45_ (self);
#line 5105 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_launch_job_co (AppCenterCorePackageKitBackendLaunchJobData* _data_)
{
#line 499 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 499 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 5115 "PackageKitBackend.c"
		goto _state_0;
#line 499 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 5119 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 499 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 5124 "PackageKitBackend.c"
	}
	_state_0:
#line 499 "../src/Core/PackageKitBackend.vala"
	_data_->_data57_ = g_slice_new0 (Block57Data);
#line 499 "../src/Core/PackageKitBackend.vala"
	_data_->_data57_->_ref_count_ = 1;
#line 499 "../src/Core/PackageKitBackend.vala"
	_data_->_data57_->self = g_object_ref (_data_->self);
#line 499 "../src/Core/PackageKitBackend.vala"
	_data_->_data57_->_async_data_ = _data_;
#line 500 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = app_center_core_job_new (_data_->type);
#line 500 "../src/Core/PackageKitBackend.vala"
	_data_->job = _data_->_tmp0_;
#line 501 "../src/Core/PackageKitBackend.vala"
	app_center_core_job_set_args (_data_->job, _data_->args);
#line 503 "../src/Core/PackageKitBackend.vala"
	_data_->_data57_->callback = _app_center_core_package_kit_backend_launch_job_co_gsource_func;
#line 503 "../src/Core/PackageKitBackend.vala"
	_data_->_data57_->callback_target = _data_;
#line 503 "../src/Core/PackageKitBackend.vala"
	_data_->_data57_->callback_target_destroy_notify = NULL;
#line 504 "../src/Core/PackageKitBackend.vala"
	g_signal_connect_data (_data_->job, "results-ready", (GCallback) ___lambda45__app_center_core_job_results_ready, block57_data_ref (_data_->_data57_), (GClosureNotify) block57_data_unref, 0);
#line 508 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = _data_->self->priv->jobs;
#line 508 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->job);
#line 508 "../src/Core/PackageKitBackend.vala"
	g_async_queue_push (_data_->_tmp1_, _data_->_tmp2_);
#line 509 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 1;
#line 509 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 5159 "PackageKitBackend.c"
	_state_1:
	;
#line 510 "../src/Core/PackageKitBackend.vala"
	_data_->result = _data_->job;
#line 510 "../src/Core/PackageKitBackend.vala"
	block57_data_unref (_data_->_data57_);
#line 510 "../src/Core/PackageKitBackend.vala"
	_data_->_data57_ = NULL;
#line 510 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 510 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 510 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 510 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5176 "PackageKitBackend.c"
		}
	}
#line 510 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 510 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 5183 "PackageKitBackend.c"
}

static Block58Data*
block58_data_ref (Block58Data* _data58_)
{
#line 513 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data58_->_ref_count_);
#line 513 "../src/Core/PackageKitBackend.vala"
	return _data58_;
#line 5193 "PackageKitBackend.c"
}

static void
block58_data_unref (void * _userdata_)
{
	Block58Data* _data58_;
	_data58_ = (Block58Data*) _userdata_;
#line 513 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data58_->_ref_count_)) {
#line 5203 "PackageKitBackend.c"
		AppCenterCorePackageKitBackend* self;
#line 513 "../src/Core/PackageKitBackend.vala"
		self = _data58_->self;
#line 513 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data58_->downloaded_updates);
#line 513 "../src/Core/PackageKitBackend.vala"
		_data58_->package_ids = (_vala_array_free (_data58_->package_ids, _data58_->package_ids_length1, (GDestroyNotify) g_free), NULL);
#line 513 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data58_->results);
#line 513 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (self);
#line 513 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block58Data, _data58_);
#line 5217 "PackageKitBackend.c"
	}
}

static void
___lambda4_ (AppCenterCorePackageKitBackend* self,
             PkProgress* t,
             PkProgressType p)
{
#line 519 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (t != NULL);
#line 5228 "PackageKitBackend.c"
}

static void
____lambda4__pk_progress_callback (PkProgress* progress,
                                   PkProgressType type,
                                   gpointer self)
{
#line 519 "../src/Core/PackageKitBackend.vala"
	___lambda4_ ((AppCenterCorePackageKitBackend*) self, progress, type);
#line 5238 "PackageKitBackend.c"
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 530 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 530 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 530 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 5253 "PackageKitBackend.c"
	}
#line 530 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 530 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 5259 "PackageKitBackend.c"
}

static void
__lambda5_ (Block58Data* _data58_,
            PkPackage* pk_package)
{
	AppCenterCorePackageKitBackend* self;
	GeeArrayList* _tmp0_;
	const gchar* _tmp1_;
#line 528 "../src/Core/PackageKitBackend.vala"
	self = _data58_->self;
#line 528 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (pk_package != NULL);
#line 529 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _data58_->downloaded_updates;
#line 529 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = pk_package_get_id (pk_package);
#line 529 "../src/Core/PackageKitBackend.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, _tmp1_)) {
#line 5279 "PackageKitBackend.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 530 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = pk_package_get_id (pk_package);
#line 530 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 530 "../src/Core/PackageKitBackend.vala"
		_vala_array_add6 (&_data58_->package_ids, &_data58_->package_ids_length1, &_data58_->_package_ids_size_, _tmp3_);
#line 5288 "PackageKitBackend.c"
	}
}

static void
___lambda5__gfunc (gconstpointer data,
                   gpointer self)
{
#line 528 "../src/Core/PackageKitBackend.vala"
	__lambda5_ (self, (PkPackage*) data);
#line 5298 "PackageKitBackend.c"
}

static void
_vala_array_add7 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 541 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 541 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 541 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 5313 "PackageKitBackend.c"
	}
#line 541 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 541 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 5319 "PackageKitBackend.c"
}

static void
___lambda6_ (AppCenterCorePackageKitBackend* self,
             PkProgress* p,
             PkProgressType t)
{
#line 545 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (p != NULL);
#line 5329 "PackageKitBackend.c"
}

static void
____lambda6__pk_progress_callback (PkProgress* progress,
                                   PkProgressType type,
                                   gpointer self)
{
#line 545 "../src/Core/PackageKitBackend.vala"
	___lambda6_ ((AppCenterCorePackageKitBackend*) self, progress, type);
#line 5339 "PackageKitBackend.c"
}

static void
__lambda7_ (Block58Data* _data58_,
            PkDetails* details)
{
	AppCenterCorePackageKitBackend* self;
	PkResults* _tmp0_;
#line 552 "../src/Core/PackageKitBackend.vala"
	self = _data58_->self;
#line 552 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (details != NULL);
#line 553 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _data58_->results;
#line 553 "../src/Core/PackageKitBackend.vala"
	pk_results_add_details (_tmp0_, details);
#line 5356 "PackageKitBackend.c"
}

static void
___lambda7__gfunc (gconstpointer data,
                   gpointer self)
{
#line 552 "../src/Core/PackageKitBackend.vala"
	__lambda7_ (self, (PkDetails*) data);
#line 5365 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_prepared_packages_internal (AppCenterCorePackageKitBackend* self,
                                                                    AppCenterCoreJob* job)
{
	Block58Data* _data58_;
	AppCenterCoreGetPreparedPackagesArgs* args = NULL;
	AppCenterCoreJobArgs* _tmp0_;
	AppCenterCoreJobArgs* _tmp1_;
	AppCenterCoreGetPreparedPackagesArgs* _tmp2_;
	GCancellable* cancellable = NULL;
	AppCenterCoreGetPreparedPackagesArgs* _tmp3_;
	GCancellable* _tmp4_;
	GCancellable* _tmp5_;
	gchar** _tmp12_;
	GeeArrayList* _tmp13_;
	PkResults* _tmp14_;
	GPtrArray* _tmp15_;
	GPtrArray* _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	PkResults* details = NULL;
	PkResults* _tmp27_;
	GPtrArray* _tmp28_;
	GPtrArray* _tmp29_;
	GValue _tmp30_ = {0};
	PkResults* _tmp31_;
	GError* _inner_error0_ = NULL;
#line 513 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 513 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (job != NULL);
#line 513 "../src/Core/PackageKitBackend.vala"
	_data58_ = g_slice_new0 (Block58Data);
#line 513 "../src/Core/PackageKitBackend.vala"
	_data58_->_ref_count_ = 1;
#line 513 "../src/Core/PackageKitBackend.vala"
	_data58_->self = g_object_ref (self);
#line 514 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_job_get_args (job);
#line 514 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 514 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = _app_center_core_job_args_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, APP_CENTER_CORE_TYPE_GET_PREPARED_PACKAGES_ARGS, AppCenterCoreGetPreparedPackagesArgs));
#line 514 "../src/Core/PackageKitBackend.vala"
	args = _tmp2_;
#line 515 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = args;
#line 515 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = _tmp3_->cancellable;
#line 515 "../src/Core/PackageKitBackend.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 515 "../src/Core/PackageKitBackend.vala"
	cancellable = _tmp5_;
#line 517 "../src/Core/PackageKitBackend.vala"
	_data58_->results = NULL;
#line 5423 "PackageKitBackend.c"
	{
		PkResults* _tmp6_ = NULL;
		AppCenterCoreTask* _tmp7_;
		GCancellable* _tmp8_;
		PkResults* _tmp9_;
		PkResults* _tmp10_;
#line 519 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = app_center_core_package_kit_backend_client;
#line 519 "../src/Core/PackageKitBackend.vala"
		_tmp8_ = cancellable;
#line 519 "../src/Core/PackageKitBackend.vala"
		_tmp9_ = pk_client_get_updates ((PkClient*) _tmp7_, (PkBitfield) 0, _tmp8_, ____lambda4__pk_progress_callback, self, &_inner_error0_);
#line 519 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = _tmp9_;
#line 519 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5440 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 519 "../src/Core/PackageKitBackend.vala"
		_tmp10_ = _tmp6_;
#line 519 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = NULL;
#line 519 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data58_->results);
#line 519 "../src/Core/PackageKitBackend.vala"
		_data58_->results = _tmp10_;
#line 518 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp6_);
#line 5453 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
#line 518 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 518 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 521 "../src/Core/PackageKitBackend.vala"
		_tmp11_ = e;
#line 521 "../src/Core/PackageKitBackend.vala"
		app_center_core_job_set_error (job, _tmp11_);
#line 522 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 523 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 523 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (cancellable);
#line 523 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (args);
#line 523 "../src/Core/PackageKitBackend.vala"
		block58_data_unref (_data58_);
#line 523 "../src/Core/PackageKitBackend.vala"
		_data58_ = NULL;
#line 523 "../src/Core/PackageKitBackend.vala"
		return;
#line 5482 "PackageKitBackend.c"
	}
	__finally0:
#line 518 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 518 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (cancellable);
#line 518 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (args);
#line 518 "../src/Core/PackageKitBackend.vala"
		block58_data_unref (_data58_);
#line 518 "../src/Core/PackageKitBackend.vala"
		_data58_ = NULL;
#line 518 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 518 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 518 "../src/Core/PackageKitBackend.vala"
		return;
#line 5501 "PackageKitBackend.c"
	}
#line 526 "../src/Core/PackageKitBackend.vala"
	_tmp12_ = g_new0 (gchar*, 0 + 1);
#line 526 "../src/Core/PackageKitBackend.vala"
	_data58_->package_ids = _tmp12_;
#line 526 "../src/Core/PackageKitBackend.vala"
	_data58_->package_ids_length1 = 0;
#line 526 "../src/Core/PackageKitBackend.vala"
	_data58_->_package_ids_size_ = _data58_->package_ids_length1;
#line 527 "../src/Core/PackageKitBackend.vala"
	_tmp13_ = app_center_core_package_kit_backend_get_downloaded_updates (self);
#line 527 "../src/Core/PackageKitBackend.vala"
	_data58_->downloaded_updates = _tmp13_;
#line 528 "../src/Core/PackageKitBackend.vala"
	_tmp14_ = _data58_->results;
#line 528 "../src/Core/PackageKitBackend.vala"
	_tmp15_ = pk_results_get_package_array (_tmp14_);
#line 528 "../src/Core/PackageKitBackend.vala"
	_tmp16_ = _tmp15_;
#line 528 "../src/Core/PackageKitBackend.vala"
	g_ptr_array_foreach (_tmp16_, ___lambda5__gfunc, _data58_);
#line 528 "../src/Core/PackageKitBackend.vala"
	_g_ptr_array_unref0 (_tmp16_);
#line 534 "../src/Core/PackageKitBackend.vala"
	_tmp17_ = _data58_->package_ids;
#line 534 "../src/Core/PackageKitBackend.vala"
	_tmp17__length1 = _data58_->package_ids_length1;
#line 534 "../src/Core/PackageKitBackend.vala"
	if (_tmp17__length1 == 0) {
#line 5531 "PackageKitBackend.c"
		GValue _tmp18_ = {0};
		PkResults* _tmp19_;
#line 535 "../src/Core/PackageKitBackend.vala"
		g_value_init (&_tmp18_, G_TYPE_OBJECT);
#line 535 "../src/Core/PackageKitBackend.vala"
		G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 535 "../src/Core/PackageKitBackend.vala"
		job->result = _tmp18_;
#line 536 "../src/Core/PackageKitBackend.vala"
		_tmp19_ = pk_results_new ();
#line 536 "../src/Core/PackageKitBackend.vala"
		g_value_take_object (&job->result, (GObject*) _tmp19_);
#line 537 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 538 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (cancellable);
#line 538 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (args);
#line 538 "../src/Core/PackageKitBackend.vala"
		block58_data_unref (_data58_);
#line 538 "../src/Core/PackageKitBackend.vala"
		_data58_ = NULL;
#line 538 "../src/Core/PackageKitBackend.vala"
		return;
#line 5556 "PackageKitBackend.c"
	}
#line 541 "../src/Core/PackageKitBackend.vala"
	_vala_array_add7 (&_data58_->package_ids, &_data58_->package_ids_length1, &_data58_->_package_ids_size_, NULL);
#line 5560 "PackageKitBackend.c"
	{
		PkResults* _tmp20_ = NULL;
		AppCenterCoreTask* _tmp21_;
		gchar** _tmp22_;
		gint _tmp22__length1;
		GCancellable* _tmp23_;
		PkResults* _tmp24_;
		PkResults* _tmp25_;
#line 545 "../src/Core/PackageKitBackend.vala"
		_tmp21_ = app_center_core_package_kit_backend_client;
#line 545 "../src/Core/PackageKitBackend.vala"
		_tmp22_ = _data58_->package_ids;
#line 545 "../src/Core/PackageKitBackend.vala"
		_tmp22__length1 = _data58_->package_ids_length1;
#line 545 "../src/Core/PackageKitBackend.vala"
		_tmp23_ = cancellable;
#line 545 "../src/Core/PackageKitBackend.vala"
		_tmp24_ = pk_client_get_details ((PkClient*) _tmp21_, _tmp22_, _tmp23_, ____lambda6__pk_progress_callback, self, &_inner_error0_);
#line 545 "../src/Core/PackageKitBackend.vala"
		_tmp20_ = _tmp24_;
#line 545 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5583 "PackageKitBackend.c"
			goto __catch1_g_error;
		}
#line 545 "../src/Core/PackageKitBackend.vala"
		_tmp25_ = _tmp20_;
#line 545 "../src/Core/PackageKitBackend.vala"
		_tmp20_ = NULL;
#line 545 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (details);
#line 545 "../src/Core/PackageKitBackend.vala"
		details = _tmp25_;
#line 544 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp20_);
#line 5596 "PackageKitBackend.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp26_;
#line 544 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 544 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 547 "../src/Core/PackageKitBackend.vala"
		_tmp26_ = e;
#line 547 "../src/Core/PackageKitBackend.vala"
		app_center_core_job_set_error (job, _tmp26_);
#line 548 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 549 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 549 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (details);
#line 549 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (cancellable);
#line 549 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (args);
#line 549 "../src/Core/PackageKitBackend.vala"
		block58_data_unref (_data58_);
#line 549 "../src/Core/PackageKitBackend.vala"
		_data58_ = NULL;
#line 549 "../src/Core/PackageKitBackend.vala"
		return;
#line 5627 "PackageKitBackend.c"
	}
	__finally1:
#line 544 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 544 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (details);
#line 544 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (cancellable);
#line 544 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (args);
#line 544 "../src/Core/PackageKitBackend.vala"
		block58_data_unref (_data58_);
#line 544 "../src/Core/PackageKitBackend.vala"
		_data58_ = NULL;
#line 544 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 544 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 544 "../src/Core/PackageKitBackend.vala"
		return;
#line 5648 "PackageKitBackend.c"
	}
#line 552 "../src/Core/PackageKitBackend.vala"
	_tmp27_ = details;
#line 552 "../src/Core/PackageKitBackend.vala"
	_tmp28_ = pk_results_get_details_array (_tmp27_);
#line 552 "../src/Core/PackageKitBackend.vala"
	_tmp29_ = _tmp28_;
#line 552 "../src/Core/PackageKitBackend.vala"
	g_ptr_array_foreach (_tmp29_, ___lambda7__gfunc, _data58_);
#line 552 "../src/Core/PackageKitBackend.vala"
	_g_ptr_array_unref0 (_tmp29_);
#line 556 "../src/Core/PackageKitBackend.vala"
	g_value_init (&_tmp30_, G_TYPE_OBJECT);
#line 556 "../src/Core/PackageKitBackend.vala"
	G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 556 "../src/Core/PackageKitBackend.vala"
	job->result = _tmp30_;
#line 557 "../src/Core/PackageKitBackend.vala"
	_tmp31_ = _data58_->results;
#line 557 "../src/Core/PackageKitBackend.vala"
	_data58_->results = NULL;
#line 557 "../src/Core/PackageKitBackend.vala"
	g_value_take_object (&job->result, (GObject*) _tmp31_);
#line 558 "../src/Core/PackageKitBackend.vala"
	g_signal_emit_by_name (job, "results-ready");
#line 513 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (details);
#line 513 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (cancellable);
#line 513 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (args);
#line 513 "../src/Core/PackageKitBackend.vala"
	block58_data_unref (_data58_);
#line 513 "../src/Core/PackageKitBackend.vala"
	_data58_ = NULL;
#line 5684 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_prepared_packages_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendGetPreparedPackagesData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendGetPreparedPackagesData, _data_);
#line 5700 "PackageKitBackend.c"
}

void
app_center_core_package_kit_backend_get_prepared_packages (AppCenterCorePackageKitBackend* self,
                                                           GCancellable* cancellable,
                                                           GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_)
{
	AppCenterCorePackageKitBackendGetPreparedPackagesData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendGetPreparedPackagesData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_get_prepared_packages_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_get_prepared_packages_co (_data_);
#line 5732 "PackageKitBackend.c"
}

PkResults*
app_center_core_package_kit_backend_get_prepared_packages_finish (AppCenterCorePackageKitBackend* self,
                                                                  GAsyncResult* _res_)
{
	PkResults* result;
	AppCenterCorePackageKitBackendGetPreparedPackagesData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 24 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 5747 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->result = NULL;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 5755 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_prepared_packages_ready (GObject* source_object,
                                                                 GAsyncResult* _res_,
                                                                 gpointer _user_data_)
{
	AppCenterCorePackageKitBackendGetPreparedPackagesData* _data_;
#line 565 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 565 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 565 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 565 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_get_prepared_packages_co (_data_);
#line 5772 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_get_prepared_packages_co (AppCenterCorePackageKitBackendGetPreparedPackagesData* _data_)
{
#line 561 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 561 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 5782 "PackageKitBackend.c"
		goto _state_0;
#line 561 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 5786 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 561 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 5791 "PackageKitBackend.c"
	}
	_state_0:
#line 562 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = app_center_core_get_prepared_packages_args_new ();
#line 562 "../src/Core/PackageKitBackend.vala"
	_data_->job_args = _data_->_tmp0_;
#line 563 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = _g_object_ref0 (_data_->cancellable);
#line 563 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->job_args->cancellable);
#line 563 "../src/Core/PackageKitBackend.vala"
	_data_->job_args->cancellable = _data_->_tmp1_;
#line 565 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 1;
#line 565 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_launch_job (_data_->self, APP_CENTER_CORE_JOB_TYPE_GET_PREPARED_PACKAGES, (AppCenterCoreJobArgs*) _data_->job_args, app_center_core_package_kit_backend_get_prepared_packages_ready, _data_);
#line 565 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 5810 "PackageKitBackend.c"
	_state_1:
#line 565 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = app_center_core_package_kit_backend_launch_job_finish (_data_->self, _data_->_res_);
#line 565 "../src/Core/PackageKitBackend.vala"
	_data_->job = _data_->_tmp2_;
#line 566 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_ = g_value_get_object (&_data_->job->result);
#line 566 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, pk_results_get_type (), PkResults));
#line 566 "../src/Core/PackageKitBackend.vala"
	_data_->result = _data_->_tmp4_;
#line 566 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->job);
#line 566 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (_data_->job_args);
#line 566 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 566 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 566 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 566 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5834 "PackageKitBackend.c"
		}
	}
#line 566 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 566 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 5841 "PackageKitBackend.c"
}

static void
___lambda8_ (AppCenterCorePackageKitBackend* self,
             PkProgress* prog,
             PkProgressType type)
{
#line 577 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (prog != NULL);
#line 5851 "PackageKitBackend.c"
}

static void
____lambda8__pk_progress_callback (PkProgress* progress,
                                   PkProgressType type,
                                   gpointer self)
{
#line 577 "../src/Core/PackageKitBackend.vala"
	___lambda8_ ((AppCenterCorePackageKitBackend*) self, progress, type);
#line 5861 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_installed_packages_internal (AppCenterCorePackageKitBackend* self,
                                                                     AppCenterCoreJob* job)
{
	AppCenterCoreGetInstalledPackagesArgs* args = NULL;
	AppCenterCoreJobArgs* _tmp0_;
	AppCenterCoreJobArgs* _tmp1_;
	GCancellable* cancellable = NULL;
	AppCenterCoreGetInstalledPackagesArgs* _tmp2_;
	GCancellable* _tmp3_;
	PkBitfield filter = 0ULL;
	GeeTreeSet* installed = NULL;
	GeeTreeSet* _tmp4_;
	GValue _tmp27_ = {0};
	GeeTreeSet* _tmp28_;
	GError* _inner_error0_ = NULL;
#line 569 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 569 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (job != NULL);
#line 570 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_job_get_args (job);
#line 570 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 570 "../src/Core/PackageKitBackend.vala"
	args = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, APP_CENTER_CORE_TYPE_GET_INSTALLED_PACKAGES_ARGS, AppCenterCoreGetInstalledPackagesArgs);
#line 571 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = args;
#line 571 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _tmp2_->cancellable;
#line 571 "../src/Core/PackageKitBackend.vala"
	cancellable = _tmp3_;
#line 573 "../src/Core/PackageKitBackend.vala"
	filter = pk_bitfield_from_enums ((gint) PK_FILTER_ENUM_INSTALLED, PK_FILTER_ENUM_NEWEST, -1);
#line 574 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = gee_tree_set_new (pk_package_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 574 "../src/Core/PackageKitBackend.vala"
	installed = _tmp4_;
#line 5902 "PackageKitBackend.c"
	{
		PkResults* results = NULL;
		AppCenterCoreTask* _tmp5_;
		GCancellable* _tmp6_;
		PkResults* _tmp7_;
		GPtrArray* packages = NULL;
		PkResults* _tmp8_;
		GPtrArray* _tmp9_;
#line 577 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = app_center_core_package_kit_backend_client;
#line 577 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = cancellable;
#line 577 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = pk_client_get_packages ((PkClient*) _tmp5_, filter, _tmp6_, ____lambda8__pk_progress_callback, self, &_inner_error0_);
#line 577 "../src/Core/PackageKitBackend.vala"
		results = _tmp7_;
#line 577 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5921 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 578 "../src/Core/PackageKitBackend.vala"
		_tmp8_ = results;
#line 578 "../src/Core/PackageKitBackend.vala"
		_tmp9_ = pk_results_get_package_array (_tmp8_);
#line 578 "../src/Core/PackageKitBackend.vala"
		packages = _tmp9_;
#line 5930 "PackageKitBackend.c"
		{
			gint i = 0;
#line 580 "../src/Core/PackageKitBackend.vala"
			i = 0;
#line 5935 "PackageKitBackend.c"
			{
				gboolean _tmp10_ = FALSE;
#line 580 "../src/Core/PackageKitBackend.vala"
				_tmp10_ = TRUE;
#line 580 "../src/Core/PackageKitBackend.vala"
				while (TRUE) {
#line 5942 "PackageKitBackend.c"
					GPtrArray* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					gboolean _tmp15_ = FALSE;
					GCancellable* _tmp16_;
					PkPackage* pk_package = NULL;
					GPtrArray* _tmp21_;
					gconstpointer _tmp22_;
					GeeTreeSet* _tmp23_;
					PkPackage* _tmp24_;
#line 580 "../src/Core/PackageKitBackend.vala"
					if (!_tmp10_) {
#line 5955 "PackageKitBackend.c"
						gint _tmp11_;
#line 580 "../src/Core/PackageKitBackend.vala"
						_tmp11_ = i;
#line 580 "../src/Core/PackageKitBackend.vala"
						i = _tmp11_ + 1;
#line 5961 "PackageKitBackend.c"
					}
#line 580 "../src/Core/PackageKitBackend.vala"
					_tmp10_ = FALSE;
#line 580 "../src/Core/PackageKitBackend.vala"
					_tmp12_ = packages;
#line 580 "../src/Core/PackageKitBackend.vala"
					_tmp13_ = vala_g_ptr_array_get_length (_tmp12_);
#line 580 "../src/Core/PackageKitBackend.vala"
					_tmp14_ = _tmp13_;
#line 580 "../src/Core/PackageKitBackend.vala"
					if (!(i < _tmp14_)) {
#line 580 "../src/Core/PackageKitBackend.vala"
						break;
#line 5975 "PackageKitBackend.c"
					}
#line 581 "../src/Core/PackageKitBackend.vala"
					_tmp16_ = cancellable;
#line 581 "../src/Core/PackageKitBackend.vala"
					if (_tmp16_ != NULL) {
#line 5981 "PackageKitBackend.c"
						GCancellable* _tmp17_;
#line 581 "../src/Core/PackageKitBackend.vala"
						_tmp17_ = cancellable;
#line 581 "../src/Core/PackageKitBackend.vala"
						_tmp15_ = g_cancellable_is_cancelled (_tmp17_);
#line 5987 "PackageKitBackend.c"
					} else {
#line 581 "../src/Core/PackageKitBackend.vala"
						_tmp15_ = FALSE;
#line 5991 "PackageKitBackend.c"
					}
#line 581 "../src/Core/PackageKitBackend.vala"
					if (_tmp15_) {
#line 5995 "PackageKitBackend.c"
						GValue _tmp18_ = {0};
						GeeTreeSet* _tmp19_;
						GObject* _tmp20_;
#line 582 "../src/Core/PackageKitBackend.vala"
						g_value_init (&_tmp18_, G_TYPE_OBJECT);
#line 582 "../src/Core/PackageKitBackend.vala"
						G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 582 "../src/Core/PackageKitBackend.vala"
						job->result = _tmp18_;
#line 583 "../src/Core/PackageKitBackend.vala"
						_tmp19_ = installed;
#line 583 "../src/Core/PackageKitBackend.vala"
						_tmp20_ = _g_object_ref0 ((GObject*) _tmp19_);
#line 583 "../src/Core/PackageKitBackend.vala"
						g_value_take_object (&job->result, _tmp20_);
#line 584 "../src/Core/PackageKitBackend.vala"
						g_signal_emit_by_name (job, "results-ready");
#line 585 "../src/Core/PackageKitBackend.vala"
						_g_ptr_array_unref0 (packages);
#line 585 "../src/Core/PackageKitBackend.vala"
						_g_object_unref0 (results);
#line 585 "../src/Core/PackageKitBackend.vala"
						_g_object_unref0 (installed);
#line 585 "../src/Core/PackageKitBackend.vala"
						return;
#line 6021 "PackageKitBackend.c"
					}
#line 588 "../src/Core/PackageKitBackend.vala"
					_tmp21_ = packages;
#line 588 "../src/Core/PackageKitBackend.vala"
					_tmp22_ = g_ptr_array_index (_tmp21_, (guint) i);
#line 588 "../src/Core/PackageKitBackend.vala"
					pk_package = (PkPackage*) _tmp22_;
#line 589 "../src/Core/PackageKitBackend.vala"
					_tmp23_ = installed;
#line 589 "../src/Core/PackageKitBackend.vala"
					_tmp24_ = pk_package;
#line 589 "../src/Core/PackageKitBackend.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 6035 "PackageKitBackend.c"
				}
			}
		}
#line 576 "../src/Core/PackageKitBackend.vala"
		_g_ptr_array_unref0 (packages);
#line 576 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (results);
#line 6043 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp25_;
		const gchar* _tmp26_;
#line 576 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 576 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 593 "../src/Core/PackageKitBackend.vala"
		_tmp25_ = e;
#line 593 "../src/Core/PackageKitBackend.vala"
		_tmp26_ = _tmp25_->message;
#line 593 "../src/Core/PackageKitBackend.vala"
		g_critical ("PackageKitBackend.vala:593: %s", _tmp26_);
#line 576 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 6063 "PackageKitBackend.c"
	}
	__finally0:
#line 576 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 576 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (installed);
#line 576 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 576 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 576 "../src/Core/PackageKitBackend.vala"
		return;
#line 6076 "PackageKitBackend.c"
	}
#line 596 "../src/Core/PackageKitBackend.vala"
	g_value_init (&_tmp27_, G_TYPE_OBJECT);
#line 596 "../src/Core/PackageKitBackend.vala"
	G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 596 "../src/Core/PackageKitBackend.vala"
	job->result = _tmp27_;
#line 597 "../src/Core/PackageKitBackend.vala"
	_tmp28_ = installed;
#line 597 "../src/Core/PackageKitBackend.vala"
	installed = NULL;
#line 597 "../src/Core/PackageKitBackend.vala"
	g_value_take_object (&job->result, (GObject*) _tmp28_);
#line 598 "../src/Core/PackageKitBackend.vala"
	g_signal_emit_by_name (job, "results-ready");
#line 569 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (installed);
#line 6094 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_installed_packages_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendGetInstalledPackagesData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendGetInstalledPackagesData, _data_);
#line 6110 "PackageKitBackend.c"
}

void
app_center_core_package_kit_backend_get_installed_packages (AppCenterCorePackageKitBackend* self,
                                                            GCancellable* cancellable,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_)
{
	AppCenterCorePackageKitBackendGetInstalledPackagesData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendGetInstalledPackagesData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_get_installed_packages_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_get_installed_packages_co (_data_);
#line 6142 "PackageKitBackend.c"
}

GeeTreeSet*
app_center_core_package_kit_backend_get_installed_packages_finish (AppCenterCorePackageKitBackend* self,
                                                                   GAsyncResult* _res_)
{
	GeeTreeSet* result;
	AppCenterCorePackageKitBackendGetInstalledPackagesData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 24 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 6157 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->result = NULL;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 6165 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_installed_packages_ready (GObject* source_object,
                                                                  GAsyncResult* _res_,
                                                                  gpointer _user_data_)
{
	AppCenterCorePackageKitBackendGetInstalledPackagesData* _data_;
#line 605 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 605 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 605 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 605 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_get_installed_packages_co (_data_);
#line 6182 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_get_installed_packages_co (AppCenterCorePackageKitBackendGetInstalledPackagesData* _data_)
{
#line 601 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 601 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 6192 "PackageKitBackend.c"
		goto _state_0;
#line 601 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 6196 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 601 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 6201 "PackageKitBackend.c"
	}
	_state_0:
#line 602 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = app_center_core_get_installed_packages_args_new ();
#line 602 "../src/Core/PackageKitBackend.vala"
	_data_->job_args = _data_->_tmp0_;
#line 603 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = _g_object_ref0 (_data_->cancellable);
#line 603 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->job_args->cancellable);
#line 603 "../src/Core/PackageKitBackend.vala"
	_data_->job_args->cancellable = _data_->_tmp1_;
#line 605 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 1;
#line 605 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_launch_job (_data_->self, APP_CENTER_CORE_JOB_TYPE_GET_INSTALLED_PACKAGES, (AppCenterCoreJobArgs*) _data_->job_args, app_center_core_package_kit_backend_get_installed_packages_ready, _data_);
#line 605 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 6220 "PackageKitBackend.c"
	_state_1:
#line 605 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = app_center_core_package_kit_backend_launch_job_finish (_data_->self, _data_->_res_);
#line 605 "../src/Core/PackageKitBackend.vala"
	_data_->job = _data_->_tmp2_;
#line 606 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_ = g_value_get_object (&_data_->job->result);
#line 606 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEE_TYPE_TREE_SET, GeeTreeSet));
#line 606 "../src/Core/PackageKitBackend.vala"
	_data_->result = _data_->_tmp4_;
#line 606 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->job);
#line 606 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (_data_->job_args);
#line 606 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 606 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 606 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 606 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6244 "PackageKitBackend.c"
		}
	}
#line 606 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 606 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 6251 "PackageKitBackend.c"
}

static Block59Data*
block59_data_ref (Block59Data* _data59_)
{
#line 609 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data59_->_ref_count_);
#line 609 "../src/Core/PackageKitBackend.vala"
	return _data59_;
#line 6261 "PackageKitBackend.c"
}

static void
block59_data_unref (void * _userdata_)
{
	Block59Data* _data59_;
	_data59_ = (Block59Data*) _userdata_;
#line 609 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data59_->_ref_count_)) {
#line 6271 "PackageKitBackend.c"
		AppCenterCorePackageKitBackend* self;
#line 609 "../src/Core/PackageKitBackend.vala"
		self = _data59_->self;
#line 609 "../src/Core/PackageKitBackend.vala"
		_data59_->package_array = (_vala_array_free (_data59_->package_array, _data59_->package_array_length1, (GDestroyNotify) g_free), NULL);
#line 609 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (self);
#line 609 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block59Data, _data59_);
#line 6281 "PackageKitBackend.c"
	}
}

static void
___lambda12_ (AppCenterCorePackageKitBackend* self,
              PkProgress* p,
              PkProgressType t)
{
#line 628 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (p != NULL);
#line 6292 "PackageKitBackend.c"
}

static void
____lambda12__pk_progress_callback (PkProgress* progress,
                                    PkProgressType type,
                                    gpointer self)
{
#line 628 "../src/Core/PackageKitBackend.vala"
	___lambda12_ ((AppCenterCorePackageKitBackend*) self, progress, type);
#line 6302 "PackageKitBackend.c"
}

static void
_vala_array_add8 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 631 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 631 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 631 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6317 "PackageKitBackend.c"
	}
#line 631 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 631 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 6323 "PackageKitBackend.c"
}

static void
___lambda13_ (Block59Data* _data59_,
              PkPackage* dep_package)
{
	AppCenterCorePackageKitBackend* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 630 "../src/Core/PackageKitBackend.vala"
	self = _data59_->self;
#line 630 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (dep_package != NULL);
#line 631 "../src/Core/PackageKitBackend.vala"
	g_object_get (dep_package, "package-id", &_tmp0_, NULL);
#line 631 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 631 "../src/Core/PackageKitBackend.vala"
	_vala_array_add8 (&_data59_->package_array, &_data59_->package_array_length1, &_data59_->_package_array_size_, _tmp1_);
#line 6343 "PackageKitBackend.c"
}

static void
____lambda13__gfunc (gconstpointer data,
                     gpointer self)
{
#line 630 "../src/Core/PackageKitBackend.vala"
	___lambda13_ (self, (PkPackage*) data);
#line 6352 "PackageKitBackend.c"
}

static void
_vala_array_add9 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 634 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 634 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 634 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6367 "PackageKitBackend.c"
	}
#line 634 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 634 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 6373 "PackageKitBackend.c"
}

static void
____lambda14_ (AppCenterCorePackageKitBackend* self,
               PkProgress* p,
               PkProgressType t)
{
#line 638 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (p != NULL);
#line 6383 "PackageKitBackend.c"
}

static void
_____lambda14__pk_progress_callback (PkProgress* progress,
                                     PkProgressType type,
                                     gpointer self)
{
#line 638 "../src/Core/PackageKitBackend.vala"
	____lambda14_ ((AppCenterCorePackageKitBackend*) self, progress, type);
#line 6393 "PackageKitBackend.c"
}

static void
___lambda15_ (Block59Data* _data59_,
              PkDetails* detail)
{
	AppCenterCorePackageKitBackend* self;
	guint64 _tmp0_;
	guint64 _tmp1_;
#line 645 "../src/Core/PackageKitBackend.vala"
	self = _data59_->self;
#line 645 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (detail != NULL);
#line 646 "../src/Core/PackageKitBackend.vala"
	g_object_get (detail, "size", &_tmp0_, NULL);
#line 646 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 646 "../src/Core/PackageKitBackend.vala"
	_data59_->size += _tmp1_;
#line 6413 "PackageKitBackend.c"
}

static void
____lambda15__gfunc (gconstpointer data,
                     gpointer self)
{
#line 645 "../src/Core/PackageKitBackend.vala"
	___lambda15_ (self, (PkDetails*) data);
#line 6422 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_download_size_internal (AppCenterCorePackageKitBackend* self,
                                                                AppCenterCoreJob* job)
{
	Block59Data* _data59_;
	AppCenterCoreGetDownloadSizeArgs* args = NULL;
	AppCenterCoreJobArgs* _tmp0_;
	AppCenterCoreJobArgs* _tmp1_;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreGetDownloadSizeArgs* _tmp2_;
	AppCenterCorePackage* _tmp3_;
	GCancellable* cancellable = NULL;
	AppCenterCoreGetDownloadSizeArgs* _tmp4_;
	GCancellable* _tmp5_;
	PkPackage* pk_package = NULL;
	PkPackage* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	PkBitfield filters = 0ULL;
	GValue _tmp42_ = {0};
	GError* _inner_error0_ = NULL;
#line 609 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 609 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (job != NULL);
#line 609 "../src/Core/PackageKitBackend.vala"
	_data59_ = g_slice_new0 (Block59Data);
#line 609 "../src/Core/PackageKitBackend.vala"
	_data59_->_ref_count_ = 1;
#line 609 "../src/Core/PackageKitBackend.vala"
	_data59_->self = g_object_ref (self);
#line 610 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_job_get_args (job);
#line 610 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 610 "../src/Core/PackageKitBackend.vala"
	args = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, APP_CENTER_CORE_TYPE_GET_DOWNLOAD_SIZE_ARGS, AppCenterCoreGetDownloadSizeArgs);
#line 611 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = args;
#line 611 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _tmp2_->package;
#line 611 "../src/Core/PackageKitBackend.vala"
	package = _tmp3_;
#line 612 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = args;
#line 612 "../src/Core/PackageKitBackend.vala"
	_tmp5_ = _tmp4_->cancellable;
#line 612 "../src/Core/PackageKitBackend.vala"
	cancellable = _tmp5_;
#line 6475 "PackageKitBackend.c"
	{
		PkPackage* _tmp6_ = NULL;
		AppCenterCorePackage* _tmp7_;
		PkPackage* _tmp8_;
		PkPackage* _tmp9_;
#line 616 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = package;
#line 616 "../src/Core/PackageKitBackend.vala"
		_tmp8_ = app_center_core_package_kit_backend_get_package_internal (self, _tmp7_, &_inner_error0_);
#line 616 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = _tmp8_;
#line 616 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6489 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 616 "../src/Core/PackageKitBackend.vala"
		_tmp9_ = _tmp6_;
#line 616 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = NULL;
#line 616 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 616 "../src/Core/PackageKitBackend.vala"
		pk_package = _tmp9_;
#line 615 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp6_);
#line 6502 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
#line 615 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 615 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 618 "../src/Core/PackageKitBackend.vala"
		_tmp10_ = e;
#line 618 "../src/Core/PackageKitBackend.vala"
		app_center_core_job_set_error (job, _tmp10_);
#line 619 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 620 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 620 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 620 "../src/Core/PackageKitBackend.vala"
		block59_data_unref (_data59_);
#line 620 "../src/Core/PackageKitBackend.vala"
		_data59_ = NULL;
#line 620 "../src/Core/PackageKitBackend.vala"
		return;
#line 6529 "PackageKitBackend.c"
	}
	__finally0:
#line 615 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 615 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 615 "../src/Core/PackageKitBackend.vala"
		block59_data_unref (_data59_);
#line 615 "../src/Core/PackageKitBackend.vala"
		_data59_ = NULL;
#line 615 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 615 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 615 "../src/Core/PackageKitBackend.vala"
		return;
#line 6546 "PackageKitBackend.c"
	}
#line 623 "../src/Core/PackageKitBackend.vala"
	_data59_->size = (guint64) 0;
#line 625 "../src/Core/PackageKitBackend.vala"
	_tmp11_ = pk_package;
#line 625 "../src/Core/PackageKitBackend.vala"
	g_object_get (_tmp11_, "package-id", &_tmp12_, NULL);
#line 625 "../src/Core/PackageKitBackend.vala"
	_tmp13_ = _tmp12_;
#line 625 "../src/Core/PackageKitBackend.vala"
	_tmp14_ = g_new0 (gchar*, 2 + 1);
#line 625 "../src/Core/PackageKitBackend.vala"
	_tmp14_[0] = _tmp13_;
#line 625 "../src/Core/PackageKitBackend.vala"
	_tmp14_[1] = NULL;
#line 625 "../src/Core/PackageKitBackend.vala"
	_data59_->package_array = _tmp14_;
#line 625 "../src/Core/PackageKitBackend.vala"
	_data59_->package_array_length1 = 2;
#line 625 "../src/Core/PackageKitBackend.vala"
	_data59_->_package_array_size_ = _data59_->package_array_length1;
#line 626 "../src/Core/PackageKitBackend.vala"
	filters = pk_bitfield_from_enums ((gint) PK_FILTER_ENUM_NOT_INSTALLED, PK_FILTER_ENUM_ARCH, PK_FILTER_ENUM_NEWEST, -1);
#line 6570 "PackageKitBackend.c"
	{
		PkResults* deps_result = NULL;
		AppCenterCoreTask* _tmp15_;
		gchar** _tmp16_;
		gint _tmp16__length1;
		GCancellable* _tmp17_;
		PkResults* _tmp18_;
		PkPackage* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar** _tmp22_;
		PkResults* _tmp23_;
		GPtrArray* _tmp24_;
		GPtrArray* _tmp25_;
		PkResults* details = NULL;
		PkResults* _tmp33_;
		GPtrArray* _tmp34_;
		GPtrArray* _tmp35_;
#line 628 "../src/Core/PackageKitBackend.vala"
		_tmp15_ = app_center_core_package_kit_backend_client;
#line 628 "../src/Core/PackageKitBackend.vala"
		_tmp16_ = _data59_->package_array;
#line 628 "../src/Core/PackageKitBackend.vala"
		_tmp16__length1 = _data59_->package_array_length1;
#line 628 "../src/Core/PackageKitBackend.vala"
		_tmp17_ = cancellable;
#line 628 "../src/Core/PackageKitBackend.vala"
		_tmp18_ = pk_client_depends_on ((PkClient*) _tmp15_, filters, _tmp16_, TRUE, _tmp17_, ____lambda12__pk_progress_callback, self, &_inner_error0_);
#line 628 "../src/Core/PackageKitBackend.vala"
		deps_result = _tmp18_;
#line 628 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6603 "PackageKitBackend.c"
			goto __catch1_g_error;
		}
#line 629 "../src/Core/PackageKitBackend.vala"
		_tmp19_ = pk_package;
#line 629 "../src/Core/PackageKitBackend.vala"
		g_object_get (_tmp19_, "package-id", &_tmp20_, NULL);
#line 629 "../src/Core/PackageKitBackend.vala"
		_tmp21_ = _tmp20_;
#line 629 "../src/Core/PackageKitBackend.vala"
		_tmp22_ = g_new0 (gchar*, 1 + 1);
#line 629 "../src/Core/PackageKitBackend.vala"
		_tmp22_[0] = _tmp21_;
#line 629 "../src/Core/PackageKitBackend.vala"
		_data59_->package_array = (_vala_array_free (_data59_->package_array, _data59_->package_array_length1, (GDestroyNotify) g_free), NULL);
#line 629 "../src/Core/PackageKitBackend.vala"
		_data59_->package_array = _tmp22_;
#line 629 "../src/Core/PackageKitBackend.vala"
		_data59_->package_array_length1 = 1;
#line 629 "../src/Core/PackageKitBackend.vala"
		_data59_->_package_array_size_ = _data59_->package_array_length1;
#line 630 "../src/Core/PackageKitBackend.vala"
		_tmp23_ = deps_result;
#line 630 "../src/Core/PackageKitBackend.vala"
		_tmp24_ = pk_results_get_package_array (_tmp23_);
#line 630 "../src/Core/PackageKitBackend.vala"
		_tmp25_ = _tmp24_;
#line 630 "../src/Core/PackageKitBackend.vala"
		g_ptr_array_foreach (_tmp25_, ____lambda13__gfunc, _data59_);
#line 630 "../src/Core/PackageKitBackend.vala"
		_g_ptr_array_unref0 (_tmp25_);
#line 634 "../src/Core/PackageKitBackend.vala"
		_vala_array_add9 (&_data59_->package_array, &_data59_->package_array_length1, &_data59_->_package_array_size_, NULL);
#line 6636 "PackageKitBackend.c"
		{
			PkResults* _tmp26_ = NULL;
			AppCenterCoreTask* _tmp27_;
			gchar** _tmp28_;
			gint _tmp28__length1;
			GCancellable* _tmp29_;
			PkResults* _tmp30_;
			PkResults* _tmp31_;
#line 638 "../src/Core/PackageKitBackend.vala"
			_tmp27_ = app_center_core_package_kit_backend_client;
#line 638 "../src/Core/PackageKitBackend.vala"
			_tmp28_ = _data59_->package_array;
#line 638 "../src/Core/PackageKitBackend.vala"
			_tmp28__length1 = _data59_->package_array_length1;
#line 638 "../src/Core/PackageKitBackend.vala"
			_tmp29_ = cancellable;
#line 638 "../src/Core/PackageKitBackend.vala"
			_tmp30_ = pk_client_get_details ((PkClient*) _tmp27_, _tmp28_, _tmp29_, _____lambda14__pk_progress_callback, self, &_inner_error0_);
#line 638 "../src/Core/PackageKitBackend.vala"
			_tmp26_ = _tmp30_;
#line 638 "../src/Core/PackageKitBackend.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6659 "PackageKitBackend.c"
				goto __catch2_g_error;
			}
#line 638 "../src/Core/PackageKitBackend.vala"
			_tmp31_ = _tmp26_;
#line 638 "../src/Core/PackageKitBackend.vala"
			_tmp26_ = NULL;
#line 638 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (details);
#line 638 "../src/Core/PackageKitBackend.vala"
			details = _tmp31_;
#line 637 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (_tmp26_);
#line 6672 "PackageKitBackend.c"
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			GError* _tmp32_;
#line 637 "../src/Core/PackageKitBackend.vala"
			e = _inner_error0_;
#line 637 "../src/Core/PackageKitBackend.vala"
			_inner_error0_ = NULL;
#line 640 "../src/Core/PackageKitBackend.vala"
			_tmp32_ = e;
#line 640 "../src/Core/PackageKitBackend.vala"
			app_center_core_job_set_error (job, _tmp32_);
#line 641 "../src/Core/PackageKitBackend.vala"
			g_signal_emit_by_name (job, "results-ready");
#line 642 "../src/Core/PackageKitBackend.vala"
			_g_error_free0 (e);
#line 642 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (details);
#line 642 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (deps_result);
#line 642 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (pk_package);
#line 642 "../src/Core/PackageKitBackend.vala"
			block59_data_unref (_data59_);
#line 642 "../src/Core/PackageKitBackend.vala"
			_data59_ = NULL;
#line 642 "../src/Core/PackageKitBackend.vala"
			return;
#line 6703 "PackageKitBackend.c"
		}
		__finally2:
#line 637 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 637 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (details);
#line 637 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (deps_result);
#line 6712 "PackageKitBackend.c"
			goto __catch1_g_error;
		}
#line 645 "../src/Core/PackageKitBackend.vala"
		_tmp33_ = details;
#line 645 "../src/Core/PackageKitBackend.vala"
		_tmp34_ = pk_results_get_details_array (_tmp33_);
#line 645 "../src/Core/PackageKitBackend.vala"
		_tmp35_ = _tmp34_;
#line 645 "../src/Core/PackageKitBackend.vala"
		g_ptr_array_foreach (_tmp35_, ____lambda15__gfunc, _data59_);
#line 645 "../src/Core/PackageKitBackend.vala"
		_g_ptr_array_unref0 (_tmp35_);
#line 627 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (details);
#line 627 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (deps_result);
#line 6729 "PackageKitBackend.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		PkPackage* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		GError* _tmp40_;
		const gchar* _tmp41_;
#line 627 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 627 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 649 "../src/Core/PackageKitBackend.vala"
		_tmp36_ = pk_package;
#line 649 "../src/Core/PackageKitBackend.vala"
		g_object_get (_tmp36_, "package-id", &_tmp37_, NULL);
#line 649 "../src/Core/PackageKitBackend.vala"
		_tmp38_ = _tmp37_;
#line 649 "../src/Core/PackageKitBackend.vala"
		_tmp39_ = _tmp38_;
#line 649 "../src/Core/PackageKitBackend.vala"
		_tmp40_ = e;
#line 649 "../src/Core/PackageKitBackend.vala"
		_tmp41_ = _tmp40_->message;
#line 649 "../src/Core/PackageKitBackend.vala"
		g_warning ("PackageKitBackend.vala:649: Error fetching dependencies for %s: %s", _tmp39_, _tmp41_);
#line 649 "../src/Core/PackageKitBackend.vala"
		_g_free0 (_tmp39_);
#line 627 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 6763 "PackageKitBackend.c"
	}
	__finally1:
#line 627 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 627 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 627 "../src/Core/PackageKitBackend.vala"
		block59_data_unref (_data59_);
#line 627 "../src/Core/PackageKitBackend.vala"
		_data59_ = NULL;
#line 627 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 627 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 627 "../src/Core/PackageKitBackend.vala"
		return;
#line 6780 "PackageKitBackend.c"
	}
#line 652 "../src/Core/PackageKitBackend.vala"
	g_value_init (&_tmp42_, G_TYPE_UINT64);
#line 652 "../src/Core/PackageKitBackend.vala"
	G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 652 "../src/Core/PackageKitBackend.vala"
	job->result = _tmp42_;
#line 653 "../src/Core/PackageKitBackend.vala"
	g_value_set_uint64 (&job->result, _data59_->size);
#line 654 "../src/Core/PackageKitBackend.vala"
	g_signal_emit_by_name (job, "results-ready");
#line 609 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (pk_package);
#line 609 "../src/Core/PackageKitBackend.vala"
	block59_data_unref (_data59_);
#line 609 "../src/Core/PackageKitBackend.vala"
	_data59_ = NULL;
#line 6798 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_get_download_size_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendGetDownloadSizeData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendGetDownloadSizeData, _data_);
#line 6814 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_get_download_size (AppCenterCoreBackend* base,
                                                            AppCenterCorePackage* package,
                                                            GCancellable* cancellable,
                                                            gboolean is_update,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_)
{
	AppCenterCorePackageKitBackend * self;
	AppCenterCorePackageKitBackendGetDownloadSizeData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	AppCenterCorePackage* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (package != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendGetDownloadSizeData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_real_get_download_size_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->package = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->is_update = is_update;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_get_download_size_co (_data_);
#line 6860 "PackageKitBackend.c"
}

static guint64
app_center_core_package_kit_backend_get_download_size_finish (AppCenterCoreBackend* base,
                                                              GAsyncResult* _res_,
                                                              GError** error)
{
	guint64 result;
	AppCenterCorePackageKitBackendGetDownloadSizeData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 6874 "PackageKitBackend.c"
		guint64 _tmp0_ = 0ULL;
#line 24 "../src/Core/PackageKitBackend.vala"
		return _tmp0_;
#line 6878 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 6884 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_download_size_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_)
{
	AppCenterCorePackageKitBackendGetDownloadSizeData* _data_;
#line 662 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 662 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 662 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 662 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_get_download_size_co (_data_);
#line 6901 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_real_get_download_size_co (AppCenterCorePackageKitBackendGetDownloadSizeData* _data_)
{
#line 657 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 657 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 6911 "PackageKitBackend.c"
		goto _state_0;
#line 657 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 6915 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 657 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 6920 "PackageKitBackend.c"
	}
	_state_0:
#line 658 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = app_center_core_get_download_size_args_new ();
#line 658 "../src/Core/PackageKitBackend.vala"
	_data_->job_args = _data_->_tmp0_;
#line 659 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = _data_->job_args;
#line 659 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->package);
#line 659 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp1_->package);
#line 659 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_->package = _data_->_tmp2_;
#line 660 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_ = _data_->job_args;
#line 660 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp4_ = _g_object_ref0 (_data_->cancellable);
#line 660 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp3_->cancellable);
#line 660 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_->cancellable = _data_->_tmp4_;
#line 662 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp5_ = _data_->job_args;
#line 662 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 1;
#line 662 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_launch_job (_data_->self, APP_CENTER_CORE_JOB_TYPE_GET_DOWNLOAD_SIZE, (AppCenterCoreJobArgs*) _data_->_tmp5_, app_center_core_package_kit_backend_get_download_size_ready, _data_);
#line 662 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 6951 "PackageKitBackend.c"
	_state_1:
#line 662 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp6_ = app_center_core_package_kit_backend_launch_job_finish (_data_->self, _data_->_res_);
#line 662 "../src/Core/PackageKitBackend.vala"
	_data_->job = _data_->_tmp6_;
#line 663 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp7_ = _data_->job;
#line 663 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp8_ = app_center_core_job_get_error (_data_->_tmp7_);
#line 663 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 663 "../src/Core/PackageKitBackend.vala"
	if (_data_->_tmp9_ != NULL) {
#line 664 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp10_ = _data_->job;
#line 664 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp11_ = app_center_core_job_get_error (_data_->_tmp10_);
#line 664 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 664 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp13_ = _g_error_copy0 (_data_->_tmp12_);
#line 664 "../src/Core/PackageKitBackend.vala"
		_data_->_inner_error0_ = _data_->_tmp13_;
#line 664 "../src/Core/PackageKitBackend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 664 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data_->job);
#line 664 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (_data_->job_args);
#line 664 "../src/Core/PackageKitBackend.vala"
		g_object_unref (_data_->_async_result);
#line 664 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 6985 "PackageKitBackend.c"
	}
#line 667 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp14_ = _data_->job;
#line 667 "../src/Core/PackageKitBackend.vala"
	_data_->result = g_value_get_uint64 (&_data_->_tmp14_->result);
#line 667 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->job);
#line 667 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (_data_->job_args);
#line 667 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 667 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 667 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 667 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7003 "PackageKitBackend.c"
		}
	}
#line 667 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 667 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 7010 "PackageKitBackend.c"
}

static Block60Data*
block60_data_ref (Block60Data* _data60_)
{
#line 670 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data60_->_ref_count_);
#line 670 "../src/Core/PackageKitBackend.vala"
	return _data60_;
#line 7020 "PackageKitBackend.c"
}

static void
block60_data_unref (void * _userdata_)
{
	Block60Data* _data60_;
	_data60_ = (Block60Data*) _userdata_;
#line 670 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data60_->_ref_count_)) {
#line 7030 "PackageKitBackend.c"
		AppCenterCorePackageKitBackend* self;
#line 670 "../src/Core/PackageKitBackend.vala"
		self = _data60_->self;
#line 670 "../src/Core/PackageKitBackend.vala"
		_data60_->packages_ids = (_vala_array_free (_data60_->packages_ids, _data60_->packages_ids_length1, (GDestroyNotify) g_free), NULL);
#line 670 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (self);
#line 670 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block60Data, _data60_);
#line 7040 "PackageKitBackend.c"
	}
}

static gchar**
_vala_array_dup6 (gchar** self,
                  gssize length)
{
#line 679 "../src/Core/PackageKitBackend.vala"
	if (length >= 0) {
#line 7050 "PackageKitBackend.c"
		gchar** result;
		gssize i;
#line 679 "../src/Core/PackageKitBackend.vala"
		result = g_new0 (gchar*, length + 1);
#line 679 "../src/Core/PackageKitBackend.vala"
		for (i = 0; i < length; i++) {
#line 7057 "PackageKitBackend.c"
			gchar* _tmp0_;
#line 679 "../src/Core/PackageKitBackend.vala"
			_tmp0_ = g_strdup (self[i]);
#line 679 "../src/Core/PackageKitBackend.vala"
			result[i] = _tmp0_;
#line 7063 "PackageKitBackend.c"
		}
#line 679 "../src/Core/PackageKitBackend.vala"
		return result;
#line 7067 "PackageKitBackend.c"
	}
#line 679 "../src/Core/PackageKitBackend.vala"
	return NULL;
#line 7071 "PackageKitBackend.c"
}

static void
_vala_array_add10 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 680 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 680 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 680 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7086 "PackageKitBackend.c"
	}
#line 680 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 680 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 7092 "PackageKitBackend.c"
}

static void
___lambda71_ (AppCenterCorePackageKitBackend* self)
{
}

static void
____lambda71__pk_progress_callback (PkProgress* progress,
                                    PkProgressType type,
                                    gpointer self)
{
#line 683 "../src/Core/PackageKitBackend.vala"
	___lambda71_ ((AppCenterCorePackageKitBackend*) self);
#line 7107 "PackageKitBackend.c"
}

static void
____lambda72_ (AppCenterCorePackageKitBackend* self)
{
}

static void
_____lambda72__pk_progress_callback (PkProgress* progress,
                                     PkProgressType type,
                                     gpointer self)
{
#line 692 "../src/Core/PackageKitBackend.vala"
	____lambda72_ ((AppCenterCorePackageKitBackend*) self);
#line 7122 "PackageKitBackend.c"
}

static void
_vala_array_add11 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 698 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 698 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 698 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7137 "PackageKitBackend.c"
	}
#line 698 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 698 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 7143 "PackageKitBackend.c"
}

static void
___lambda73_ (Block60Data* _data60_,
              PkPackage* package)
{
	AppCenterCorePackageKitBackend* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 697 "../src/Core/PackageKitBackend.vala"
	self = _data60_->self;
#line 697 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (package != NULL);
#line 698 "../src/Core/PackageKitBackend.vala"
	g_object_get (package, "package-id", &_tmp0_, NULL);
#line 698 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 698 "../src/Core/PackageKitBackend.vala"
	_vala_array_add11 (&_data60_->packages_ids, &_data60_->packages_ids_length1, &_data60_->_packages_ids_size_, _tmp1_);
#line 7163 "PackageKitBackend.c"
}

static void
____lambda73__gfunc (gconstpointer data,
                     gpointer self)
{
#line 697 "../src/Core/PackageKitBackend.vala"
	___lambda73_ (self, (PkPackage*) data);
#line 7172 "PackageKitBackend.c"
}

static void
_vala_array_add12 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 701 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 701 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 701 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7187 "PackageKitBackend.c"
	}
#line 701 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 701 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 7193 "PackageKitBackend.c"
}

static void
___lambda74_ (Block60Data* _data60_,
              PkProgress* progress,
              PkProgressType status)
{
	AppCenterCorePackageKitBackend* self;
	AppCenterCoreChangeInformation* _tmp0_;
	const gchar* _tmp1_;
#line 703 "../src/Core/PackageKitBackend.vala"
	self = _data60_->self;
#line 703 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (progress != NULL);
#line 704 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_update_progress_status (self, progress, status);
#line 705 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _data60_->change_info;
#line 705 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = utils_pk_status_to_string (self->priv->status);
#line 705 "../src/Core/PackageKitBackend.vala"
	app_center_core_change_information_callback (_tmp0_, self->priv->can_cancel, _tmp1_, self->priv->progress, app_center_core_package_kit_backend_pk_status_to_appcenter_status (self->priv->status));
#line 7216 "PackageKitBackend.c"
}

static void
____lambda74__pk_progress_callback (PkProgress* progress,
                                    PkProgressType type,
                                    gpointer self)
{
#line 703 "../src/Core/PackageKitBackend.vala"
	___lambda74_ (self, progress, type);
#line 7226 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_install_package_internal (AppCenterCorePackageKitBackend* self,
                                                              AppCenterCoreJob* job)
{
	Block60Data* _data60_;
	AppCenterCoreInstallPackageArgs* args = NULL;
	AppCenterCoreJobArgs* _tmp0_;
	AppCenterCoreJobArgs* _tmp1_;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreInstallPackageArgs* _tmp2_;
	AppCenterCorePackage* _tmp3_;
	AppCenterCoreInstallPackageArgs* _tmp4_;
	AppCenterCoreChangeInformation* _tmp5_;
	GCancellable* cancellable = NULL;
	AppCenterCoreInstallPackageArgs* _tmp6_;
	GCancellable* _tmp7_;
	PkExitEnum exit_status = 0;
	AppCenterCorePackage* _tmp8_;
	AsComponent* _tmp9_;
	AsComponent* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	GValue _tmp41_ = {0};
	GError* _inner_error0_ = NULL;
#line 670 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 670 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (job != NULL);
#line 670 "../src/Core/PackageKitBackend.vala"
	_data60_ = g_slice_new0 (Block60Data);
#line 670 "../src/Core/PackageKitBackend.vala"
	_data60_->_ref_count_ = 1;
#line 670 "../src/Core/PackageKitBackend.vala"
	_data60_->self = g_object_ref (self);
#line 671 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_job_get_args (job);
#line 671 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 671 "../src/Core/PackageKitBackend.vala"
	args = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, APP_CENTER_CORE_TYPE_INSTALL_PACKAGE_ARGS, AppCenterCoreInstallPackageArgs);
#line 672 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = args;
#line 672 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _tmp2_->package;
#line 672 "../src/Core/PackageKitBackend.vala"
	package = _tmp3_;
#line 673 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = args;
#line 673 "../src/Core/PackageKitBackend.vala"
	_tmp5_ = _tmp4_->change_info;
#line 673 "../src/Core/PackageKitBackend.vala"
	_data60_->change_info = _tmp5_;
#line 674 "../src/Core/PackageKitBackend.vala"
	_tmp6_ = args;
#line 674 "../src/Core/PackageKitBackend.vala"
	_tmp7_ = _tmp6_->cancellable;
#line 674 "../src/Core/PackageKitBackend.vala"
	cancellable = _tmp7_;
#line 676 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_reset_progress (self);
#line 678 "../src/Core/PackageKitBackend.vala"
	exit_status = PK_EXIT_ENUM_UNKNOWN;
#line 679 "../src/Core/PackageKitBackend.vala"
	_tmp8_ = package;
#line 679 "../src/Core/PackageKitBackend.vala"
	_tmp9_ = app_center_core_package_get_component (_tmp8_);
#line 679 "../src/Core/PackageKitBackend.vala"
	_tmp10_ = _tmp9_;
#line 679 "../src/Core/PackageKitBackend.vala"
	_tmp12_ = _tmp11_ = as_component_get_pkgnames (_tmp10_);
#line 679 "../src/Core/PackageKitBackend.vala"
	_tmp13_ = (_tmp12_ != NULL) ? _vala_array_dup6 (_tmp12_, _vala_array_length (_tmp11_)) : _tmp12_;
#line 679 "../src/Core/PackageKitBackend.vala"
	_tmp13__length1 = _vala_array_length (_tmp11_);
#line 679 "../src/Core/PackageKitBackend.vala"
	_data60_->packages_ids = _tmp13_;
#line 679 "../src/Core/PackageKitBackend.vala"
	_data60_->packages_ids_length1 = _tmp13__length1;
#line 679 "../src/Core/PackageKitBackend.vala"
	_data60_->_packages_ids_size_ = _data60_->packages_ids_length1;
#line 680 "../src/Core/PackageKitBackend.vala"
	_vala_array_add10 (&_data60_->packages_ids, &_data60_->packages_ids_length1, &_data60_->_packages_ids_size_, NULL);
#line 7313 "PackageKitBackend.c"
	{
		PkResults* results = NULL;
		AppCenterCoreTask* _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
		GCancellable* _tmp16_;
		PkResults* _tmp17_;
		GPtrArray* package_array = NULL;
		PkResults* _tmp18_;
		GPtrArray* _tmp19_;
		GPtrArray* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		gchar** _tmp31_;
		GPtrArray* _tmp32_;
		PkResults* _tmp33_ = NULL;
		AppCenterCoreTask* _tmp34_;
		gchar** _tmp35_;
		gint _tmp35__length1;
		GCancellable* _tmp36_;
		PkResults* _tmp37_;
		PkResults* _tmp38_;
		PkResults* _tmp39_;
#line 683 "../src/Core/PackageKitBackend.vala"
		_tmp14_ = app_center_core_package_kit_backend_client;
#line 683 "../src/Core/PackageKitBackend.vala"
		_tmp15_ = _data60_->packages_ids;
#line 683 "../src/Core/PackageKitBackend.vala"
		_tmp15__length1 = _data60_->packages_ids_length1;
#line 683 "../src/Core/PackageKitBackend.vala"
		_tmp16_ = cancellable;
#line 683 "../src/Core/PackageKitBackend.vala"
		_tmp17_ = pk_client_resolve ((PkClient*) _tmp14_, pk_bitfield_from_enums ((gint) PK_FILTER_ENUM_NEWEST, PK_FILTER_ENUM_ARCH, -1), _tmp15_, _tmp16_, ____lambda71__pk_progress_callback, self, &_inner_error0_);
#line 683 "../src/Core/PackageKitBackend.vala"
		results = _tmp17_;
#line 683 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7351 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 690 "../src/Core/PackageKitBackend.vala"
		_tmp18_ = results;
#line 690 "../src/Core/PackageKitBackend.vala"
		_tmp19_ = pk_results_get_package_array (_tmp18_);
#line 690 "../src/Core/PackageKitBackend.vala"
		package_array = _tmp19_;
#line 691 "../src/Core/PackageKitBackend.vala"
		_tmp20_ = package_array;
#line 691 "../src/Core/PackageKitBackend.vala"
		_tmp21_ = vala_g_ptr_array_get_length (_tmp20_);
#line 691 "../src/Core/PackageKitBackend.vala"
		_tmp22_ = _tmp21_;
#line 691 "../src/Core/PackageKitBackend.vala"
		if (_tmp22_ == 0) {
#line 7368 "PackageKitBackend.c"
			PkResults* _tmp23_ = NULL;
			AppCenterCoreTask* _tmp24_;
			gchar** _tmp25_;
			gint _tmp25__length1;
			GCancellable* _tmp26_;
			PkResults* _tmp27_;
			PkResults* _tmp28_;
			PkResults* _tmp29_;
			GPtrArray* _tmp30_;
#line 692 "../src/Core/PackageKitBackend.vala"
			_tmp24_ = app_center_core_package_kit_backend_client;
#line 692 "../src/Core/PackageKitBackend.vala"
			_tmp25_ = _data60_->packages_ids;
#line 692 "../src/Core/PackageKitBackend.vala"
			_tmp25__length1 = _data60_->packages_ids_length1;
#line 692 "../src/Core/PackageKitBackend.vala"
			_tmp26_ = cancellable;
#line 692 "../src/Core/PackageKitBackend.vala"
			_tmp27_ = pk_client_resolve ((PkClient*) _tmp24_, pk_bitfield_from_enums ((gint) PK_FILTER_ENUM_NEWEST, PK_FILTER_ENUM_NOT_ARCH, -1), _tmp25_, _tmp26_, _____lambda72__pk_progress_callback, self, &_inner_error0_);
#line 692 "../src/Core/PackageKitBackend.vala"
			_tmp23_ = _tmp27_;
#line 692 "../src/Core/PackageKitBackend.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 692 "../src/Core/PackageKitBackend.vala"
				_g_ptr_array_unref0 (package_array);
#line 692 "../src/Core/PackageKitBackend.vala"
				_g_object_unref0 (results);
#line 7396 "PackageKitBackend.c"
				goto __catch0_g_error;
			}
#line 692 "../src/Core/PackageKitBackend.vala"
			_tmp28_ = _tmp23_;
#line 692 "../src/Core/PackageKitBackend.vala"
			_tmp23_ = NULL;
#line 692 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (results);
#line 692 "../src/Core/PackageKitBackend.vala"
			results = _tmp28_;
#line 693 "../src/Core/PackageKitBackend.vala"
			_tmp29_ = results;
#line 693 "../src/Core/PackageKitBackend.vala"
			_tmp30_ = pk_results_get_package_array (_tmp29_);
#line 693 "../src/Core/PackageKitBackend.vala"
			_g_ptr_array_unref0 (package_array);
#line 693 "../src/Core/PackageKitBackend.vala"
			package_array = _tmp30_;
#line 691 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (_tmp23_);
#line 7417 "PackageKitBackend.c"
		}
#line 696 "../src/Core/PackageKitBackend.vala"
		_tmp31_ = g_new0 (gchar*, 0 + 1);
#line 696 "../src/Core/PackageKitBackend.vala"
		_data60_->packages_ids = (_vala_array_free (_data60_->packages_ids, _data60_->packages_ids_length1, (GDestroyNotify) g_free), NULL);
#line 696 "../src/Core/PackageKitBackend.vala"
		_data60_->packages_ids = _tmp31_;
#line 696 "../src/Core/PackageKitBackend.vala"
		_data60_->packages_ids_length1 = 0;
#line 696 "../src/Core/PackageKitBackend.vala"
		_data60_->_packages_ids_size_ = _data60_->packages_ids_length1;
#line 697 "../src/Core/PackageKitBackend.vala"
		_tmp32_ = package_array;
#line 697 "../src/Core/PackageKitBackend.vala"
		g_ptr_array_foreach (_tmp32_, ____lambda73__gfunc, _data60_);
#line 701 "../src/Core/PackageKitBackend.vala"
		_vala_array_add12 (&_data60_->packages_ids, &_data60_->packages_ids_length1, &_data60_->_packages_ids_size_, NULL);
#line 703 "../src/Core/PackageKitBackend.vala"
		_tmp34_ = app_center_core_package_kit_backend_client;
#line 703 "../src/Core/PackageKitBackend.vala"
		_tmp35_ = _data60_->packages_ids;
#line 703 "../src/Core/PackageKitBackend.vala"
		_tmp35__length1 = _data60_->packages_ids_length1;
#line 703 "../src/Core/PackageKitBackend.vala"
		_tmp36_ = cancellable;
#line 703 "../src/Core/PackageKitBackend.vala"
		_tmp37_ = pk_task_install_packages_sync ((PkTask*) _tmp34_, _tmp35_, _tmp36_, ____lambda74__pk_progress_callback, _data60_, &_inner_error0_);
#line 703 "../src/Core/PackageKitBackend.vala"
		_tmp33_ = _tmp37_;
#line 703 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 703 "../src/Core/PackageKitBackend.vala"
			_g_ptr_array_unref0 (package_array);
#line 703 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (results);
#line 7453 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 703 "../src/Core/PackageKitBackend.vala"
		_tmp38_ = _tmp33_;
#line 703 "../src/Core/PackageKitBackend.vala"
		_tmp33_ = NULL;
#line 703 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (results);
#line 703 "../src/Core/PackageKitBackend.vala"
		results = _tmp38_;
#line 708 "../src/Core/PackageKitBackend.vala"
		_tmp39_ = results;
#line 708 "../src/Core/PackageKitBackend.vala"
		exit_status = pk_results_get_exit_code (_tmp39_);
#line 682 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp33_);
#line 682 "../src/Core/PackageKitBackend.vala"
		_g_ptr_array_unref0 (package_array);
#line 682 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (results);
#line 7474 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp40_;
#line 682 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 682 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 710 "../src/Core/PackageKitBackend.vala"
		_tmp40_ = e;
#line 710 "../src/Core/PackageKitBackend.vala"
		app_center_core_job_set_error (job, _tmp40_);
#line 711 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 712 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 712 "../src/Core/PackageKitBackend.vala"
		block60_data_unref (_data60_);
#line 712 "../src/Core/PackageKitBackend.vala"
		_data60_ = NULL;
#line 712 "../src/Core/PackageKitBackend.vala"
		return;
#line 7499 "PackageKitBackend.c"
	}
	__finally0:
#line 682 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 682 "../src/Core/PackageKitBackend.vala"
		block60_data_unref (_data60_);
#line 682 "../src/Core/PackageKitBackend.vala"
		_data60_ = NULL;
#line 682 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 682 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 682 "../src/Core/PackageKitBackend.vala"
		return;
#line 7514 "PackageKitBackend.c"
	}
#line 715 "../src/Core/PackageKitBackend.vala"
	g_value_init (&_tmp41_, G_TYPE_BOOLEAN);
#line 715 "../src/Core/PackageKitBackend.vala"
	G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 715 "../src/Core/PackageKitBackend.vala"
	job->result = _tmp41_;
#line 716 "../src/Core/PackageKitBackend.vala"
	g_value_set_boolean (&job->result, exit_status == PK_EXIT_ENUM_SUCCESS);
#line 717 "../src/Core/PackageKitBackend.vala"
	g_signal_emit_by_name (job, "results-ready");
#line 670 "../src/Core/PackageKitBackend.vala"
	block60_data_unref (_data60_);
#line 670 "../src/Core/PackageKitBackend.vala"
	_data60_ = NULL;
#line 7530 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_install_package_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendInstallPackageData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->change_info);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendInstallPackageData, _data_);
#line 7548 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_install_package (AppCenterCoreBackend* base,
                                                          AppCenterCorePackage* package,
                                                          AppCenterCoreChangeInformation* change_info,
                                                          GCancellable* cancellable,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_)
{
	AppCenterCorePackageKitBackend * self;
	AppCenterCorePackageKitBackendInstallPackageData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	AppCenterCorePackage* _tmp1_;
	AppCenterCoreChangeInformation* _tmp2_;
	GCancellable* _tmp3_;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (package != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendInstallPackageData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_real_install_package_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->package = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = _g_object_ref0 (change_info);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->change_info);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->change_info = _tmp2_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->cancellable = _tmp3_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_install_package_co (_data_);
#line 7599 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_install_package_finish (AppCenterCoreBackend* base,
                                                            GAsyncResult* _res_,
                                                            GError** error)
{
	gboolean result;
	AppCenterCorePackageKitBackendInstallPackageData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 7613 "PackageKitBackend.c"
		gboolean _tmp0_ = FALSE;
#line 24 "../src/Core/PackageKitBackend.vala"
		return _tmp0_;
#line 7617 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 7623 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_install_package_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	AppCenterCorePackageKitBackendInstallPackageData* _data_;
#line 726 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 726 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 726 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 726 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_install_package_co (_data_);
#line 7640 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_real_install_package_co (AppCenterCorePackageKitBackendInstallPackageData* _data_)
{
#line 720 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 720 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 7650 "PackageKitBackend.c"
		goto _state_0;
#line 720 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 7654 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 720 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 7659 "PackageKitBackend.c"
	}
	_state_0:
#line 721 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = app_center_core_install_package_args_new ();
#line 721 "../src/Core/PackageKitBackend.vala"
	_data_->job_args = _data_->_tmp0_;
#line 722 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = _data_->job_args;
#line 722 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->package);
#line 722 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp1_->package);
#line 722 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_->package = _data_->_tmp2_;
#line 723 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_ = _data_->job_args;
#line 723 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp4_ = _g_object_ref0 (_data_->change_info);
#line 723 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp3_->change_info);
#line 723 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_->change_info = _data_->_tmp4_;
#line 724 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp5_ = _data_->job_args;
#line 724 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp6_ = _g_object_ref0 (_data_->cancellable);
#line 724 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp5_->cancellable);
#line 724 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp5_->cancellable = _data_->_tmp6_;
#line 726 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp7_ = _data_->job_args;
#line 726 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 1;
#line 726 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_launch_job (_data_->self, APP_CENTER_CORE_JOB_TYPE_INSTALL_PACKAGE, (AppCenterCoreJobArgs*) _data_->_tmp7_, app_center_core_package_kit_backend_install_package_ready, _data_);
#line 726 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 7698 "PackageKitBackend.c"
	_state_1:
#line 726 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp8_ = app_center_core_package_kit_backend_launch_job_finish (_data_->self, _data_->_res_);
#line 726 "../src/Core/PackageKitBackend.vala"
	_data_->job = _data_->_tmp8_;
#line 727 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp9_ = _data_->job;
#line 727 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp10_ = app_center_core_job_get_error (_data_->_tmp9_);
#line 727 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp11_ = _data_->_tmp10_;
#line 727 "../src/Core/PackageKitBackend.vala"
	if (_data_->_tmp11_ != NULL) {
#line 728 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp12_ = _data_->job;
#line 728 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp13_ = app_center_core_job_get_error (_data_->_tmp12_);
#line 728 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 728 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp15_ = _g_error_copy0 (_data_->_tmp14_);
#line 728 "../src/Core/PackageKitBackend.vala"
		_data_->_inner_error0_ = _data_->_tmp15_;
#line 728 "../src/Core/PackageKitBackend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 728 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data_->job);
#line 728 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (_data_->job_args);
#line 728 "../src/Core/PackageKitBackend.vala"
		g_object_unref (_data_->_async_result);
#line 728 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 7732 "PackageKitBackend.c"
	}
#line 731 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp16_ = _data_->job;
#line 731 "../src/Core/PackageKitBackend.vala"
	_data_->result = g_value_get_boolean (&_data_->_tmp16_->result);
#line 731 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->job);
#line 731 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (_data_->job_args);
#line 731 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 731 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 731 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 731 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7750 "PackageKitBackend.c"
		}
	}
#line 731 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 731 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 7757 "PackageKitBackend.c"
}

static Block61Data*
block61_data_ref (Block61Data* _data61_)
{
#line 734 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data61_->_ref_count_);
#line 734 "../src/Core/PackageKitBackend.vala"
	return _data61_;
#line 7767 "PackageKitBackend.c"
}

static void
block61_data_unref (void * _userdata_)
{
	Block61Data* _data61_;
	_data61_ = (Block61Data*) _userdata_;
#line 734 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data61_->_ref_count_)) {
#line 7777 "PackageKitBackend.c"
		AppCenterCorePackageKitBackend* self;
#line 734 "../src/Core/PackageKitBackend.vala"
		self = _data61_->self;
#line 734 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (self);
#line 734 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block61Data, _data61_);
#line 7785 "PackageKitBackend.c"
	}
}

static void
_vala_array_add13 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 751 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 751 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 751 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7801 "PackageKitBackend.c"
	}
#line 751 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 751 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 7807 "PackageKitBackend.c"
}

static void
___lambda75_ (Block61Data* _data61_,
              PkProgress* progress,
              PkProgressType status)
{
	AppCenterCorePackageKitBackend* self;
	AppCenterCoreChangeInformation* _tmp0_;
	const gchar* _tmp1_;
#line 754 "../src/Core/PackageKitBackend.vala"
	self = _data61_->self;
#line 754 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (progress != NULL);
#line 755 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_update_progress_status (self, progress, status);
#line 756 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _data61_->change_info;
#line 756 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = utils_pk_status_to_string (self->priv->status);
#line 756 "../src/Core/PackageKitBackend.vala"
	app_center_core_change_information_callback (_tmp0_, self->priv->can_cancel, _tmp1_, self->priv->progress, app_center_core_package_kit_backend_pk_status_to_appcenter_status (self->priv->status));
#line 7830 "PackageKitBackend.c"
}

static void
____lambda75__pk_progress_callback (PkProgress* progress,
                                    PkProgressType type,
                                    gpointer self)
{
#line 754 "../src/Core/PackageKitBackend.vala"
	___lambda75_ (self, progress, type);
#line 7840 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_update_package_internal (AppCenterCorePackageKitBackend* self,
                                                             AppCenterCoreJob* job)
{
	Block61Data* _data61_;
	AppCenterCoreUpdatePackageArgs* args = NULL;
	AppCenterCoreJobArgs* _tmp0_;
	AppCenterCoreJobArgs* _tmp1_;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreUpdatePackageArgs* _tmp2_;
	AppCenterCorePackage* _tmp3_;
	GCancellable* cancellable = NULL;
	AppCenterCoreUpdatePackageArgs* _tmp4_;
	GCancellable* _tmp5_;
	AppCenterCoreUpdatePackageArgs* _tmp6_;
	AppCenterCoreChangeInformation* _tmp7_;
	PkExitEnum exit_status = 0;
	gchar** packages_ids = NULL;
	AppCenterCorePackage* _tmp8_;
	AppCenterCoreChangeInformation* _tmp9_;
	AppCenterCoreChangeInformation* _tmp10_;
	GeeMultiMap* _tmp11_;
	GeeMultiMap* _tmp12_;
	GeeCollection* _tmp13_;
	GeeCollection* _tmp14_;
	gint _tmp15_ = 0;
	gpointer* _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gint packages_ids_length1;
	gint _packages_ids_size_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	GValue _tmp27_ = {0};
	GError* _inner_error0_ = NULL;
#line 734 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 734 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (job != NULL);
#line 734 "../src/Core/PackageKitBackend.vala"
	_data61_ = g_slice_new0 (Block61Data);
#line 734 "../src/Core/PackageKitBackend.vala"
	_data61_->_ref_count_ = 1;
#line 734 "../src/Core/PackageKitBackend.vala"
	_data61_->self = g_object_ref (self);
#line 735 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_job_get_args (job);
#line 735 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 735 "../src/Core/PackageKitBackend.vala"
	args = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, APP_CENTER_CORE_TYPE_UPDATE_PACKAGE_ARGS, AppCenterCoreUpdatePackageArgs);
#line 736 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = args;
#line 736 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _tmp2_->package;
#line 736 "../src/Core/PackageKitBackend.vala"
	package = _tmp3_;
#line 737 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = args;
#line 737 "../src/Core/PackageKitBackend.vala"
	_tmp5_ = _tmp4_->cancellable;
#line 737 "../src/Core/PackageKitBackend.vala"
	cancellable = _tmp5_;
#line 738 "../src/Core/PackageKitBackend.vala"
	_tmp6_ = args;
#line 738 "../src/Core/PackageKitBackend.vala"
	_tmp7_ = _tmp6_->change_info;
#line 738 "../src/Core/PackageKitBackend.vala"
	_data61_->change_info = _tmp7_;
#line 740 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_reset_progress (self);
#line 742 "../src/Core/PackageKitBackend.vala"
	exit_status = PK_EXIT_ENUM_UNKNOWN;
#line 743 "../src/Core/PackageKitBackend.vala"
	_tmp8_ = package;
#line 743 "../src/Core/PackageKitBackend.vala"
	_tmp9_ = app_center_core_package_get_change_information (_tmp8_);
#line 743 "../src/Core/PackageKitBackend.vala"
	_tmp10_ = _tmp9_;
#line 743 "../src/Core/PackageKitBackend.vala"
	_tmp11_ = app_center_core_change_information_get_updatable_packages (_tmp10_);
#line 743 "../src/Core/PackageKitBackend.vala"
	_tmp12_ = _tmp11_;
#line 743 "../src/Core/PackageKitBackend.vala"
	_tmp13_ = gee_multi_map_get (_tmp12_, (AppCenterCoreBackend*) self);
#line 743 "../src/Core/PackageKitBackend.vala"
	_tmp14_ = _tmp13_;
#line 743 "../src/Core/PackageKitBackend.vala"
	_tmp16_ = gee_collection_to_array (_tmp14_, &_tmp15_);
#line 743 "../src/Core/PackageKitBackend.vala"
	_tmp17_ = _tmp16_;
#line 743 "../src/Core/PackageKitBackend.vala"
	_tmp17__length1 = _tmp15_;
#line 743 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_tmp14_);
#line 743 "../src/Core/PackageKitBackend.vala"
	packages_ids = _tmp17_;
#line 743 "../src/Core/PackageKitBackend.vala"
	packages_ids_length1 = _tmp17__length1;
#line 743 "../src/Core/PackageKitBackend.vala"
	_packages_ids_size_ = packages_ids_length1;
#line 745 "../src/Core/PackageKitBackend.vala"
	_tmp18_ = packages_ids;
#line 745 "../src/Core/PackageKitBackend.vala"
	_tmp18__length1 = packages_ids_length1;
#line 745 "../src/Core/PackageKitBackend.vala"
	if (_tmp18__length1 == 0) {
#line 7950 "PackageKitBackend.c"
		GValue _tmp19_ = {0};
#line 746 "../src/Core/PackageKitBackend.vala"
		g_value_init (&_tmp19_, G_TYPE_BOOLEAN);
#line 746 "../src/Core/PackageKitBackend.vala"
		g_value_set_boolean (&_tmp19_, TRUE);
#line 746 "../src/Core/PackageKitBackend.vala"
		G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 746 "../src/Core/PackageKitBackend.vala"
		job->result = _tmp19_;
#line 747 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 748 "../src/Core/PackageKitBackend.vala"
		packages_ids = (_vala_array_free (packages_ids, packages_ids_length1, (GDestroyNotify) g_free), NULL);
#line 748 "../src/Core/PackageKitBackend.vala"
		block61_data_unref (_data61_);
#line 748 "../src/Core/PackageKitBackend.vala"
		_data61_ = NULL;
#line 748 "../src/Core/PackageKitBackend.vala"
		return;
#line 7970 "PackageKitBackend.c"
	}
#line 751 "../src/Core/PackageKitBackend.vala"
	_vala_array_add13 (&packages_ids, &packages_ids_length1, &_packages_ids_size_, NULL);
#line 7974 "PackageKitBackend.c"
	{
		PkResults* results = NULL;
		AppCenterCoreTask* _tmp20_;
		gchar** _tmp21_;
		gint _tmp21__length1;
		GCancellable* _tmp22_;
		PkResults* _tmp23_;
		PkResults* _tmp24_;
#line 754 "../src/Core/PackageKitBackend.vala"
		_tmp20_ = app_center_core_package_kit_backend_client;
#line 754 "../src/Core/PackageKitBackend.vala"
		_tmp21_ = packages_ids;
#line 754 "../src/Core/PackageKitBackend.vala"
		_tmp21__length1 = packages_ids_length1;
#line 754 "../src/Core/PackageKitBackend.vala"
		_tmp22_ = cancellable;
#line 754 "../src/Core/PackageKitBackend.vala"
		_tmp23_ = pk_task_update_packages_sync ((PkTask*) _tmp20_, _tmp21_, _tmp22_, ____lambda75__pk_progress_callback, _data61_, &_inner_error0_);
#line 754 "../src/Core/PackageKitBackend.vala"
		results = _tmp23_;
#line 754 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7997 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 759 "../src/Core/PackageKitBackend.vala"
		_tmp24_ = results;
#line 759 "../src/Core/PackageKitBackend.vala"
		exit_status = pk_results_get_exit_code (_tmp24_);
#line 760 "../src/Core/PackageKitBackend.vala"
		if (exit_status == PK_EXIT_ENUM_SUCCESS) {
#line 8006 "PackageKitBackend.c"
			GCancellable* _tmp25_;
#line 761 "../src/Core/PackageKitBackend.vala"
			_tmp25_ = cancellable;
#line 761 "../src/Core/PackageKitBackend.vala"
			pk_offline_trigger (PK_OFFLINE_ACTION_REBOOT, _tmp25_, &_inner_error0_);
#line 761 "../src/Core/PackageKitBackend.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 761 "../src/Core/PackageKitBackend.vala"
				_g_object_unref0 (results);
#line 8016 "PackageKitBackend.c"
				goto __catch0_g_error;
			}
		}
#line 753 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (results);
#line 8022 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp26_;
#line 753 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 753 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 764 "../src/Core/PackageKitBackend.vala"
		_tmp26_ = e;
#line 764 "../src/Core/PackageKitBackend.vala"
		app_center_core_job_set_error (job, _tmp26_);
#line 765 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 766 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 766 "../src/Core/PackageKitBackend.vala"
		packages_ids = (_vala_array_free (packages_ids, packages_ids_length1, (GDestroyNotify) g_free), NULL);
#line 766 "../src/Core/PackageKitBackend.vala"
		block61_data_unref (_data61_);
#line 766 "../src/Core/PackageKitBackend.vala"
		_data61_ = NULL;
#line 766 "../src/Core/PackageKitBackend.vala"
		return;
#line 8049 "PackageKitBackend.c"
	}
	__finally0:
#line 753 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 753 "../src/Core/PackageKitBackend.vala"
		packages_ids = (_vala_array_free (packages_ids, packages_ids_length1, (GDestroyNotify) g_free), NULL);
#line 753 "../src/Core/PackageKitBackend.vala"
		block61_data_unref (_data61_);
#line 753 "../src/Core/PackageKitBackend.vala"
		_data61_ = NULL;
#line 753 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 753 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 753 "../src/Core/PackageKitBackend.vala"
		return;
#line 8066 "PackageKitBackend.c"
	}
#line 769 "../src/Core/PackageKitBackend.vala"
	g_value_init (&_tmp27_, G_TYPE_BOOLEAN);
#line 769 "../src/Core/PackageKitBackend.vala"
	G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 769 "../src/Core/PackageKitBackend.vala"
	job->result = _tmp27_;
#line 770 "../src/Core/PackageKitBackend.vala"
	g_value_set_boolean (&job->result, exit_status == PK_EXIT_ENUM_SUCCESS);
#line 771 "../src/Core/PackageKitBackend.vala"
	g_signal_emit_by_name (job, "results-ready");
#line 734 "../src/Core/PackageKitBackend.vala"
	packages_ids = (_vala_array_free (packages_ids, packages_ids_length1, (GDestroyNotify) g_free), NULL);
#line 734 "../src/Core/PackageKitBackend.vala"
	block61_data_unref (_data61_);
#line 734 "../src/Core/PackageKitBackend.vala"
	_data61_ = NULL;
#line 8084 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_update_package_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendUpdatePackageData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->change_info);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendUpdatePackageData, _data_);
#line 8102 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_update_package (AppCenterCoreBackend* base,
                                                         AppCenterCorePackage* package,
                                                         AppCenterCoreChangeInformation* change_info,
                                                         GCancellable* cancellable,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	AppCenterCorePackageKitBackend * self;
	AppCenterCorePackageKitBackendUpdatePackageData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	AppCenterCorePackage* _tmp1_;
	AppCenterCoreChangeInformation* _tmp2_;
	GCancellable* _tmp3_;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (package != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendUpdatePackageData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_real_update_package_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->package = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = _g_object_ref0 (change_info);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->change_info);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->change_info = _tmp2_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->cancellable = _tmp3_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_update_package_co (_data_);
#line 8153 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_update_package_finish (AppCenterCoreBackend* base,
                                                           GAsyncResult* _res_,
                                                           GError** error)
{
	gboolean result;
	AppCenterCorePackageKitBackendUpdatePackageData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 8167 "PackageKitBackend.c"
		gboolean _tmp0_ = FALSE;
#line 24 "../src/Core/PackageKitBackend.vala"
		return _tmp0_;
#line 8171 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 8177 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_update_package_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_)
{
	AppCenterCorePackageKitBackendUpdatePackageData* _data_;
#line 782 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 782 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 782 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 782 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_update_package_co (_data_);
#line 8194 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_real_update_package_co (AppCenterCorePackageKitBackendUpdatePackageData* _data_)
{
#line 774 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 774 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 8204 "PackageKitBackend.c"
		goto _state_0;
#line 774 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 8208 "PackageKitBackend.c"
		goto _state_1;
#line 774 "../src/Core/PackageKitBackend.vala"
		case 2:
#line 8212 "PackageKitBackend.c"
		goto _state_2;
		default:
#line 774 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 8217 "PackageKitBackend.c"
	}
	_state_0:
#line 775 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = app_center_core_update_package_args_new ();
#line 775 "../src/Core/PackageKitBackend.vala"
	_data_->job_args = _data_->_tmp0_;
#line 776 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = _data_->job_args;
#line 776 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->package);
#line 776 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp1_->package);
#line 776 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_->package = _data_->_tmp2_;
#line 777 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_ = _data_->job_args;
#line 777 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp4_ = _g_object_ref0 (_data_->change_info);
#line 777 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp3_->change_info);
#line 777 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_->change_info = _data_->_tmp4_;
#line 778 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp5_ = _data_->job_args;
#line 778 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp6_ = _g_object_ref0 (_data_->cancellable);
#line 778 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp5_->cancellable);
#line 778 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp5_->cancellable = _data_->_tmp6_;
#line 780 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp7_ = app_center_core_package_kit_backend_update_permission;
#line 780 "../src/Core/PackageKitBackend.vala"
	if (_data_->_tmp7_ == NULL) {
#line 8252 "PackageKitBackend.c"
		{
#line 782 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp9_ = (PolkitUnixProcess*) polkit_unix_process_new ((gint) getpid ());
#line 782 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 782 "../src/Core/PackageKitBackend.vala"
			_data_->_state_ = 1;
#line 782 "../src/Core/PackageKitBackend.vala"
			polkit_permission_new ("io.elementary.appcenter.update", (PolkitSubject*) _data_->_tmp10_, NULL, app_center_core_package_kit_backend_update_package_ready, _data_);
#line 782 "../src/Core/PackageKitBackend.vala"
			return FALSE;
#line 8264 "PackageKitBackend.c"
			_state_1:
#line 782 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp11_ = polkit_permission_new_finish (_data_->_res_, &_data_->_inner_error0_);
#line 782 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 782 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (_data_->_tmp10_);
#line 782 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp8_ = _data_->_tmp12_;
#line 782 "../src/Core/PackageKitBackend.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 8276 "PackageKitBackend.c"
				goto __catch0_g_error;
			}
#line 782 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp13_ = _data_->_tmp8_;
#line 782 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp8_ = NULL;
#line 782 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (app_center_core_package_kit_backend_update_permission);
#line 782 "../src/Core/PackageKitBackend.vala"
			app_center_core_package_kit_backend_update_permission = _data_->_tmp13_;
#line 781 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (_data_->_tmp8_);
#line 8289 "PackageKitBackend.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 781 "../src/Core/PackageKitBackend.vala"
			_data_->e = _data_->_inner_error0_;
#line 781 "../src/Core/PackageKitBackend.vala"
			_data_->_inner_error0_ = NULL;
#line 787 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp14_ = _data_->e;
#line 787 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp15_ = _data_->_tmp14_->message;
#line 787 "../src/Core/PackageKitBackend.vala"
			g_warning ("PackageKitBackend.vala:787: Can't get permission to update without pro" \
"mpting for admin: %s", _data_->_tmp15_);
#line 781 "../src/Core/PackageKitBackend.vala"
			_g_error_free0 (_data_->e);
#line 8306 "PackageKitBackend.c"
		}
		__finally0:
#line 781 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 781 "../src/Core/PackageKitBackend.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 781 "../src/Core/PackageKitBackend.vala"
			_app_center_core_job_args_unref0 (_data_->job_args);
#line 781 "../src/Core/PackageKitBackend.vala"
			g_object_unref (_data_->_async_result);
#line 781 "../src/Core/PackageKitBackend.vala"
			return FALSE;
#line 8319 "PackageKitBackend.c"
		}
	}
#line 791 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp16_ = _data_->job_args;
#line 791 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 2;
#line 791 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_launch_job (_data_->self, APP_CENTER_CORE_JOB_TYPE_UPDATE_PACKAGE, (AppCenterCoreJobArgs*) _data_->_tmp16_, app_center_core_package_kit_backend_update_package_ready, _data_);
#line 791 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 8330 "PackageKitBackend.c"
	_state_2:
#line 791 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp17_ = app_center_core_package_kit_backend_launch_job_finish (_data_->self, _data_->_res_);
#line 791 "../src/Core/PackageKitBackend.vala"
	_data_->job = _data_->_tmp17_;
#line 792 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp18_ = _data_->job;
#line 792 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp19_ = app_center_core_job_get_error (_data_->_tmp18_);
#line 792 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 792 "../src/Core/PackageKitBackend.vala"
	if (_data_->_tmp20_ != NULL) {
#line 793 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp21_ = _data_->job;
#line 793 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp22_ = app_center_core_job_get_error (_data_->_tmp21_);
#line 793 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp23_ = _data_->_tmp22_;
#line 793 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp24_ = _g_error_copy0 (_data_->_tmp23_);
#line 793 "../src/Core/PackageKitBackend.vala"
		_data_->_inner_error0_ = _data_->_tmp24_;
#line 793 "../src/Core/PackageKitBackend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 793 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data_->job);
#line 793 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (_data_->job_args);
#line 793 "../src/Core/PackageKitBackend.vala"
		g_object_unref (_data_->_async_result);
#line 793 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 8364 "PackageKitBackend.c"
	}
#line 796 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp25_ = _data_->job;
#line 796 "../src/Core/PackageKitBackend.vala"
	_data_->result = g_value_get_boolean (&_data_->_tmp25_->result);
#line 796 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->job);
#line 796 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (_data_->job_args);
#line 796 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 796 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 796 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 796 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8382 "PackageKitBackend.c"
		}
	}
#line 796 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 796 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 8389 "PackageKitBackend.c"
}

static Block62Data*
block62_data_ref (Block62Data* _data62_)
{
#line 799 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data62_->_ref_count_);
#line 799 "../src/Core/PackageKitBackend.vala"
	return _data62_;
#line 8399 "PackageKitBackend.c"
}

static void
block62_data_unref (void * _userdata_)
{
	Block62Data* _data62_;
	_data62_ = (Block62Data*) _userdata_;
#line 799 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data62_->_ref_count_)) {
#line 8409 "PackageKitBackend.c"
		AppCenterCorePackageKitBackend* self;
#line 799 "../src/Core/PackageKitBackend.vala"
		self = _data62_->self;
#line 799 "../src/Core/PackageKitBackend.vala"
		_data62_->packages_ids = (_vala_array_free (_data62_->packages_ids, _data62_->packages_ids_length1, (GDestroyNotify) g_free), NULL);
#line 799 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (self);
#line 799 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block62Data, _data62_);
#line 8419 "PackageKitBackend.c"
	}
}

static gchar**
_vala_array_dup7 (gchar** self,
                  gssize length)
{
#line 808 "../src/Core/PackageKitBackend.vala"
	if (length >= 0) {
#line 8429 "PackageKitBackend.c"
		gchar** result;
		gssize i;
#line 808 "../src/Core/PackageKitBackend.vala"
		result = g_new0 (gchar*, length + 1);
#line 808 "../src/Core/PackageKitBackend.vala"
		for (i = 0; i < length; i++) {
#line 8436 "PackageKitBackend.c"
			gchar* _tmp0_;
#line 808 "../src/Core/PackageKitBackend.vala"
			_tmp0_ = g_strdup (self[i]);
#line 808 "../src/Core/PackageKitBackend.vala"
			result[i] = _tmp0_;
#line 8442 "PackageKitBackend.c"
		}
#line 808 "../src/Core/PackageKitBackend.vala"
		return result;
#line 8446 "PackageKitBackend.c"
	}
#line 808 "../src/Core/PackageKitBackend.vala"
	return NULL;
#line 8450 "PackageKitBackend.c"
}

static void
_vala_array_add14 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 809 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 809 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 809 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 8465 "PackageKitBackend.c"
	}
#line 809 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 809 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 8471 "PackageKitBackend.c"
}

static void
___lambda76_ (AppCenterCorePackageKitBackend* self)
{
}

static void
____lambda76__pk_progress_callback (PkProgress* progress,
                                    PkProgressType type,
                                    gpointer self)
{
#line 812 "../src/Core/PackageKitBackend.vala"
	___lambda76_ ((AppCenterCorePackageKitBackend*) self);
#line 8486 "PackageKitBackend.c"
}

static void
_vala_array_add15 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 815 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 815 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 815 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 8501 "PackageKitBackend.c"
	}
#line 815 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 815 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 8507 "PackageKitBackend.c"
}

static void
___lambda77_ (Block62Data* _data62_,
              PkPackage* package)
{
	AppCenterCorePackageKitBackend* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 814 "../src/Core/PackageKitBackend.vala"
	self = _data62_->self;
#line 814 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (package != NULL);
#line 815 "../src/Core/PackageKitBackend.vala"
	g_object_get (package, "package-id", &_tmp0_, NULL);
#line 815 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 815 "../src/Core/PackageKitBackend.vala"
	_vala_array_add15 (&_data62_->packages_ids, &_data62_->packages_ids_length1, &_data62_->_packages_ids_size_, _tmp1_);
#line 8527 "PackageKitBackend.c"
}

static void
____lambda77__gfunc (gconstpointer data,
                     gpointer self)
{
#line 814 "../src/Core/PackageKitBackend.vala"
	___lambda77_ (self, (PkPackage*) data);
#line 8536 "PackageKitBackend.c"
}

static void
___lambda78_ (Block62Data* _data62_,
              PkProgress* progress,
              PkProgressType status)
{
	AppCenterCorePackageKitBackend* self;
	AppCenterCoreChangeInformation* _tmp0_;
	const gchar* _tmp1_;
#line 818 "../src/Core/PackageKitBackend.vala"
	self = _data62_->self;
#line 818 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (progress != NULL);
#line 819 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_update_progress_status (self, progress, status);
#line 820 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _data62_->change_info;
#line 820 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = utils_pk_status_to_string (self->priv->status);
#line 820 "../src/Core/PackageKitBackend.vala"
	app_center_core_change_information_callback (_tmp0_, self->priv->can_cancel, _tmp1_, self->priv->progress, app_center_core_package_kit_backend_pk_status_to_appcenter_status (self->priv->status));
#line 8559 "PackageKitBackend.c"
}

static void
____lambda78__pk_progress_callback (PkProgress* progress,
                                    PkProgressType type,
                                    gpointer self)
{
#line 818 "../src/Core/PackageKitBackend.vala"
	___lambda78_ (self, progress, type);
#line 8569 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_remove_package_internal (AppCenterCorePackageKitBackend* self,
                                                             AppCenterCoreJob* job)
{
	Block62Data* _data62_;
	AppCenterCoreRemovePackageArgs* args = NULL;
	AppCenterCoreJobArgs* _tmp0_;
	AppCenterCoreJobArgs* _tmp1_;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreRemovePackageArgs* _tmp2_;
	AppCenterCorePackage* _tmp3_;
	GCancellable* cancellable = NULL;
	AppCenterCoreRemovePackageArgs* _tmp4_;
	GCancellable* _tmp5_;
	AppCenterCoreRemovePackageArgs* _tmp6_;
	AppCenterCoreChangeInformation* _tmp7_;
	PkExitEnum exit_status = 0;
	AppCenterCorePackage* _tmp8_;
	AsComponent* _tmp9_;
	AsComponent* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	GValue _tmp30_ = {0};
	GError* _inner_error0_ = NULL;
#line 799 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 799 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (job != NULL);
#line 799 "../src/Core/PackageKitBackend.vala"
	_data62_ = g_slice_new0 (Block62Data);
#line 799 "../src/Core/PackageKitBackend.vala"
	_data62_->_ref_count_ = 1;
#line 799 "../src/Core/PackageKitBackend.vala"
	_data62_->self = g_object_ref (self);
#line 800 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_job_get_args (job);
#line 800 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 800 "../src/Core/PackageKitBackend.vala"
	args = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, APP_CENTER_CORE_TYPE_REMOVE_PACKAGE_ARGS, AppCenterCoreRemovePackageArgs);
#line 801 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = args;
#line 801 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _tmp2_->package;
#line 801 "../src/Core/PackageKitBackend.vala"
	package = _tmp3_;
#line 802 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = args;
#line 802 "../src/Core/PackageKitBackend.vala"
	_tmp5_ = _tmp4_->cancellable;
#line 802 "../src/Core/PackageKitBackend.vala"
	cancellable = _tmp5_;
#line 803 "../src/Core/PackageKitBackend.vala"
	_tmp6_ = args;
#line 803 "../src/Core/PackageKitBackend.vala"
	_tmp7_ = _tmp6_->change_info;
#line 803 "../src/Core/PackageKitBackend.vala"
	_data62_->change_info = _tmp7_;
#line 805 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_reset_progress (self);
#line 807 "../src/Core/PackageKitBackend.vala"
	exit_status = PK_EXIT_ENUM_UNKNOWN;
#line 808 "../src/Core/PackageKitBackend.vala"
	_tmp8_ = package;
#line 808 "../src/Core/PackageKitBackend.vala"
	_tmp9_ = app_center_core_package_get_component (_tmp8_);
#line 808 "../src/Core/PackageKitBackend.vala"
	_tmp10_ = _tmp9_;
#line 808 "../src/Core/PackageKitBackend.vala"
	_tmp12_ = _tmp11_ = as_component_get_pkgnames (_tmp10_);
#line 808 "../src/Core/PackageKitBackend.vala"
	_tmp13_ = (_tmp12_ != NULL) ? _vala_array_dup7 (_tmp12_, _vala_array_length (_tmp11_)) : _tmp12_;
#line 808 "../src/Core/PackageKitBackend.vala"
	_tmp13__length1 = _vala_array_length (_tmp11_);
#line 808 "../src/Core/PackageKitBackend.vala"
	_data62_->packages_ids = _tmp13_;
#line 808 "../src/Core/PackageKitBackend.vala"
	_data62_->packages_ids_length1 = _tmp13__length1;
#line 808 "../src/Core/PackageKitBackend.vala"
	_data62_->_packages_ids_size_ = _data62_->packages_ids_length1;
#line 809 "../src/Core/PackageKitBackend.vala"
	_vala_array_add14 (&_data62_->packages_ids, &_data62_->packages_ids_length1, &_data62_->_packages_ids_size_, NULL);
#line 8656 "PackageKitBackend.c"
	{
		PkResults* results = NULL;
		AppCenterCoreTask* _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
		GCancellable* _tmp16_;
		PkResults* _tmp17_;
		gchar** _tmp18_;
		PkResults* _tmp19_;
		GPtrArray* _tmp20_;
		GPtrArray* _tmp21_;
		PkResults* _tmp22_ = NULL;
		AppCenterCoreTask* _tmp23_;
		gchar** _tmp24_;
		gint _tmp24__length1;
		GCancellable* _tmp25_;
		PkResults* _tmp26_;
		PkResults* _tmp27_;
		PkResults* _tmp28_;
#line 812 "../src/Core/PackageKitBackend.vala"
		_tmp14_ = app_center_core_package_kit_backend_client;
#line 812 "../src/Core/PackageKitBackend.vala"
		_tmp15_ = _data62_->packages_ids;
#line 812 "../src/Core/PackageKitBackend.vala"
		_tmp15__length1 = _data62_->packages_ids_length1;
#line 812 "../src/Core/PackageKitBackend.vala"
		_tmp16_ = cancellable;
#line 812 "../src/Core/PackageKitBackend.vala"
		_tmp17_ = pk_client_resolve ((PkClient*) _tmp14_, pk_bitfield_from_enums ((gint) PK_FILTER_ENUM_INSTALLED, PK_FILTER_ENUM_NEWEST, -1), _tmp15_, _tmp16_, ____lambda76__pk_progress_callback, self, &_inner_error0_);
#line 812 "../src/Core/PackageKitBackend.vala"
		results = _tmp17_;
#line 812 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8690 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 813 "../src/Core/PackageKitBackend.vala"
		_tmp18_ = g_new0 (gchar*, 0 + 1);
#line 813 "../src/Core/PackageKitBackend.vala"
		_data62_->packages_ids = (_vala_array_free (_data62_->packages_ids, _data62_->packages_ids_length1, (GDestroyNotify) g_free), NULL);
#line 813 "../src/Core/PackageKitBackend.vala"
		_data62_->packages_ids = _tmp18_;
#line 813 "../src/Core/PackageKitBackend.vala"
		_data62_->packages_ids_length1 = 0;
#line 813 "../src/Core/PackageKitBackend.vala"
		_data62_->_packages_ids_size_ = _data62_->packages_ids_length1;
#line 814 "../src/Core/PackageKitBackend.vala"
		_tmp19_ = results;
#line 814 "../src/Core/PackageKitBackend.vala"
		_tmp20_ = pk_results_get_package_array (_tmp19_);
#line 814 "../src/Core/PackageKitBackend.vala"
		_tmp21_ = _tmp20_;
#line 814 "../src/Core/PackageKitBackend.vala"
		g_ptr_array_foreach (_tmp21_, ____lambda77__gfunc, _data62_);
#line 814 "../src/Core/PackageKitBackend.vala"
		_g_ptr_array_unref0 (_tmp21_);
#line 818 "../src/Core/PackageKitBackend.vala"
		_tmp23_ = app_center_core_package_kit_backend_client;
#line 818 "../src/Core/PackageKitBackend.vala"
		_tmp24_ = _data62_->packages_ids;
#line 818 "../src/Core/PackageKitBackend.vala"
		_tmp24__length1 = _data62_->packages_ids_length1;
#line 818 "../src/Core/PackageKitBackend.vala"
		_tmp25_ = cancellable;
#line 818 "../src/Core/PackageKitBackend.vala"
		_tmp26_ = pk_task_remove_packages_sync ((PkTask*) _tmp23_, _tmp24_, TRUE, TRUE, _tmp25_, ____lambda78__pk_progress_callback, _data62_, &_inner_error0_);
#line 818 "../src/Core/PackageKitBackend.vala"
		_tmp22_ = _tmp26_;
#line 818 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 818 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (results);
#line 8729 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 818 "../src/Core/PackageKitBackend.vala"
		_tmp27_ = _tmp22_;
#line 818 "../src/Core/PackageKitBackend.vala"
		_tmp22_ = NULL;
#line 818 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (results);
#line 818 "../src/Core/PackageKitBackend.vala"
		results = _tmp27_;
#line 823 "../src/Core/PackageKitBackend.vala"
		_tmp28_ = results;
#line 823 "../src/Core/PackageKitBackend.vala"
		exit_status = pk_results_get_exit_code (_tmp28_);
#line 811 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp22_);
#line 811 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (results);
#line 8748 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp29_;
#line 811 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 811 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 825 "../src/Core/PackageKitBackend.vala"
		_tmp29_ = e;
#line 825 "../src/Core/PackageKitBackend.vala"
		app_center_core_job_set_error (job, _tmp29_);
#line 826 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 827 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 827 "../src/Core/PackageKitBackend.vala"
		block62_data_unref (_data62_);
#line 827 "../src/Core/PackageKitBackend.vala"
		_data62_ = NULL;
#line 827 "../src/Core/PackageKitBackend.vala"
		return;
#line 8773 "PackageKitBackend.c"
	}
	__finally0:
#line 811 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 811 "../src/Core/PackageKitBackend.vala"
		block62_data_unref (_data62_);
#line 811 "../src/Core/PackageKitBackend.vala"
		_data62_ = NULL;
#line 811 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 811 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 811 "../src/Core/PackageKitBackend.vala"
		return;
#line 8788 "PackageKitBackend.c"
	}
#line 830 "../src/Core/PackageKitBackend.vala"
	g_value_init (&_tmp30_, G_TYPE_BOOLEAN);
#line 830 "../src/Core/PackageKitBackend.vala"
	G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 830 "../src/Core/PackageKitBackend.vala"
	job->result = _tmp30_;
#line 831 "../src/Core/PackageKitBackend.vala"
	g_value_set_boolean (&job->result, exit_status == PK_EXIT_ENUM_SUCCESS);
#line 832 "../src/Core/PackageKitBackend.vala"
	g_signal_emit_by_name (job, "results-ready");
#line 799 "../src/Core/PackageKitBackend.vala"
	block62_data_unref (_data62_);
#line 799 "../src/Core/PackageKitBackend.vala"
	_data62_ = NULL;
#line 8804 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_remove_package_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendRemovePackageData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->change_info);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendRemovePackageData, _data_);
#line 8822 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_remove_package (AppCenterCoreBackend* base,
                                                         AppCenterCorePackage* package,
                                                         AppCenterCoreChangeInformation* change_info,
                                                         GCancellable* cancellable,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	AppCenterCorePackageKitBackend * self;
	AppCenterCorePackageKitBackendRemovePackageData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	AppCenterCorePackage* _tmp1_;
	AppCenterCoreChangeInformation* _tmp2_;
	GCancellable* _tmp3_;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (package != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendRemovePackageData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_real_remove_package_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->package = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = _g_object_ref0 (change_info);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->change_info);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->change_info = _tmp2_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->cancellable = _tmp3_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_remove_package_co (_data_);
#line 8873 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_remove_package_finish (AppCenterCoreBackend* base,
                                                           GAsyncResult* _res_,
                                                           GError** error)
{
	gboolean result;
	AppCenterCorePackageKitBackendRemovePackageData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 8887 "PackageKitBackend.c"
		gboolean _tmp0_ = FALSE;
#line 24 "../src/Core/PackageKitBackend.vala"
		return _tmp0_;
#line 8891 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 8897 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_remove_package_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_)
{
	AppCenterCorePackageKitBackendRemovePackageData* _data_;
#line 841 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 841 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 841 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 841 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_remove_package_co (_data_);
#line 8914 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_real_remove_package_co (AppCenterCorePackageKitBackendRemovePackageData* _data_)
{
#line 835 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 835 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 8924 "PackageKitBackend.c"
		goto _state_0;
#line 835 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 8928 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 835 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 8933 "PackageKitBackend.c"
	}
	_state_0:
#line 836 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = app_center_core_remove_package_args_new ();
#line 836 "../src/Core/PackageKitBackend.vala"
	_data_->job_args = _data_->_tmp0_;
#line 837 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = _data_->job_args;
#line 837 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->package);
#line 837 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp1_->package);
#line 837 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_->package = _data_->_tmp2_;
#line 838 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_ = _data_->job_args;
#line 838 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp4_ = _g_object_ref0 (_data_->change_info);
#line 838 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp3_->change_info);
#line 838 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_->change_info = _data_->_tmp4_;
#line 839 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp5_ = _data_->job_args;
#line 839 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp6_ = _g_object_ref0 (_data_->cancellable);
#line 839 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp5_->cancellable);
#line 839 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp5_->cancellable = _data_->_tmp6_;
#line 841 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp7_ = _data_->job_args;
#line 841 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 1;
#line 841 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_launch_job (_data_->self, APP_CENTER_CORE_JOB_TYPE_REMOVE_PACKAGE, (AppCenterCoreJobArgs*) _data_->_tmp7_, app_center_core_package_kit_backend_remove_package_ready, _data_);
#line 841 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 8972 "PackageKitBackend.c"
	_state_1:
#line 841 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp8_ = app_center_core_package_kit_backend_launch_job_finish (_data_->self, _data_->_res_);
#line 841 "../src/Core/PackageKitBackend.vala"
	_data_->job = _data_->_tmp8_;
#line 842 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp9_ = _data_->job;
#line 842 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp10_ = app_center_core_job_get_error (_data_->_tmp9_);
#line 842 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp11_ = _data_->_tmp10_;
#line 842 "../src/Core/PackageKitBackend.vala"
	if (_data_->_tmp11_ != NULL) {
#line 843 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp12_ = _data_->job;
#line 843 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp13_ = app_center_core_job_get_error (_data_->_tmp12_);
#line 843 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 843 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp15_ = _g_error_copy0 (_data_->_tmp14_);
#line 843 "../src/Core/PackageKitBackend.vala"
		_data_->_inner_error0_ = _data_->_tmp15_;
#line 843 "../src/Core/PackageKitBackend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 843 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data_->job);
#line 843 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (_data_->job_args);
#line 843 "../src/Core/PackageKitBackend.vala"
		g_object_unref (_data_->_async_result);
#line 843 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 9006 "PackageKitBackend.c"
	}
#line 846 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp16_ = _data_->job;
#line 846 "../src/Core/PackageKitBackend.vala"
	_data_->result = g_value_get_boolean (&_data_->_tmp16_->result);
#line 846 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->job);
#line 846 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (_data_->job_args);
#line 846 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 846 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 846 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 846 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9024 "PackageKitBackend.c"
		}
	}
#line 846 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 846 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 9031 "PackageKitBackend.c"
}

static gchar**
_vala_array_dup8 (gchar** self,
                  gssize length)
{
#line 866 "../src/Core/PackageKitBackend.vala"
	if (length >= 0) {
#line 9040 "PackageKitBackend.c"
		gchar** result;
		gssize i;
#line 866 "../src/Core/PackageKitBackend.vala"
		result = g_new0 (gchar*, length + 1);
#line 866 "../src/Core/PackageKitBackend.vala"
		for (i = 0; i < length; i++) {
#line 9047 "PackageKitBackend.c"
			gchar* _tmp0_;
#line 866 "../src/Core/PackageKitBackend.vala"
			_tmp0_ = g_strdup (self[i]);
#line 866 "../src/Core/PackageKitBackend.vala"
			result[i] = _tmp0_;
#line 9053 "PackageKitBackend.c"
		}
#line 866 "../src/Core/PackageKitBackend.vala"
		return result;
#line 9057 "PackageKitBackend.c"
	}
#line 866 "../src/Core/PackageKitBackend.vala"
	return NULL;
#line 9061 "PackageKitBackend.c"
}

static GeeArrayList*
app_center_core_package_kit_backend_get_downloaded_updates (AppCenterCorePackageKitBackend* self)
{
	GeeArrayList* downloaded_updates = NULL;
	GeeArrayList* _tmp0_;
#line 856 "../src/Core/PackageKitBackend.vala"
	static const char PK_PREPARED_IDS_PATH[] = "/var/lib/PackageKit/prepared-update";
#line 9071 "PackageKitBackend.c"
	GKeyFile* key_file = NULL;
	GKeyFile* _tmp1_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 849 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 850 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 850 "../src/Core/PackageKitBackend.vala"
	downloaded_updates = _tmp0_;
#line 858 "../src/Core/PackageKitBackend.vala"
	if (!g_file_test (PK_PREPARED_IDS_PATH, G_FILE_TEST_IS_REGULAR)) {
#line 859 "../src/Core/PackageKitBackend.vala"
		result = downloaded_updates;
#line 859 "../src/Core/PackageKitBackend.vala"
		return result;
#line 9088 "PackageKitBackend.c"
	}
#line 862 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = g_key_file_new ();
#line 862 "../src/Core/PackageKitBackend.vala"
	key_file = _tmp1_;
#line 9094 "PackageKitBackend.c"
	{
		GKeyFile* _tmp2_;
		gchar* _tmp3_ = NULL;
		GKeyFile* _tmp4_;
		gchar* _tmp5_;
		gchar** prepared_ids = NULL;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint prepared_ids_length1;
		gint _prepared_ids_size_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		gchar** _tmp9_;
		gint _tmp9__length1;
		GeeArrayList* _tmp10_;
#line 864 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = key_file;
#line 864 "../src/Core/PackageKitBackend.vala"
		g_key_file_load_from_file (_tmp2_, PK_PREPARED_IDS_PATH, G_KEY_FILE_NONE, &_inner_error0_);
#line 864 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9116 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 865 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = key_file;
#line 865 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = g_key_file_get_string (_tmp4_, "update", "prepared_ids", &_inner_error0_);
#line 865 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = _tmp5_;
#line 865 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9127 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 865 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = _tmp6_ = g_strsplit (_tmp3_, ",", 0);
#line 865 "../src/Core/PackageKitBackend.vala"
		prepared_ids = _tmp7_;
#line 865 "../src/Core/PackageKitBackend.vala"
		prepared_ids_length1 = _vala_array_length (_tmp6_);
#line 865 "../src/Core/PackageKitBackend.vala"
		_prepared_ids_size_ = prepared_ids_length1;
#line 866 "../src/Core/PackageKitBackend.vala"
		_tmp8_ = prepared_ids;
#line 866 "../src/Core/PackageKitBackend.vala"
		_tmp8__length1 = prepared_ids_length1;
#line 866 "../src/Core/PackageKitBackend.vala"
		_tmp9_ = (_tmp8_ != NULL) ? _vala_array_dup8 (_tmp8_, _tmp8__length1) : _tmp8_;
#line 866 "../src/Core/PackageKitBackend.vala"
		_tmp9__length1 = _tmp8__length1;
#line 866 "../src/Core/PackageKitBackend.vala"
		_tmp10_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp9_, _tmp9__length1, NULL, NULL, NULL);
#line 866 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (downloaded_updates);
#line 866 "../src/Core/PackageKitBackend.vala"
		downloaded_updates = _tmp10_;
#line 863 "../src/Core/PackageKitBackend.vala"
		prepared_ids = (_vala_array_free (prepared_ids, prepared_ids_length1, (GDestroyNotify) g_free), NULL);
#line 863 "../src/Core/PackageKitBackend.vala"
		_g_free0 (_tmp3_);
#line 9156 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 863 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 863 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 868 "../src/Core/PackageKitBackend.vala"
		_tmp11_ = e;
#line 868 "../src/Core/PackageKitBackend.vala"
		_tmp12_ = _tmp11_->message;
#line 868 "../src/Core/PackageKitBackend.vala"
		g_warning ("PackageKitBackend.vala:868: Unable to read PackageKit prepared ids: %s", _tmp12_);
#line 863 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 9176 "PackageKitBackend.c"
	}
	__finally0:
#line 863 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 863 "../src/Core/PackageKitBackend.vala"
		_g_key_file_unref0 (key_file);
#line 863 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (downloaded_updates);
#line 863 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 863 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 863 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 9191 "PackageKitBackend.c"
	}
#line 871 "../src/Core/PackageKitBackend.vala"
	result = downloaded_updates;
#line 871 "../src/Core/PackageKitBackend.vala"
	_g_key_file_unref0 (key_file);
#line 871 "../src/Core/PackageKitBackend.vala"
	return result;
#line 9199 "PackageKitBackend.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 9218 "PackageKitBackend.c"
}

gboolean
app_center_core_package_kit_backend_is_restart_required (AppCenterCorePackageKitBackend* self)
{
#line 875 "../src/Core/PackageKitBackend.vala"
	static const char PK_OFFLINE_UPDATE_ACTION_PATH[] = "/var/lib/PackageKit/offline-update-action";
#line 9226 "PackageKitBackend.c"
	GFile* pk_offline_update_action = NULL;
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 874 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 877 "../src/Core/PackageKitBackend.vala"
	if (!g_file_test (PK_OFFLINE_UPDATE_ACTION_PATH, G_FILE_TEST_IS_REGULAR)) {
#line 878 "../src/Core/PackageKitBackend.vala"
		result = FALSE;
#line 878 "../src/Core/PackageKitBackend.vala"
		return result;
#line 9239 "PackageKitBackend.c"
	}
#line 881 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = g_file_new_for_path (PK_OFFLINE_UPDATE_ACTION_PATH);
#line 881 "../src/Core/PackageKitBackend.vala"
	pk_offline_update_action = _tmp0_;
#line 9245 "PackageKitBackend.c"
	{
		GFileInputStream* is = NULL;
		GFile* _tmp1_;
		GFileInputStream* _tmp2_;
		GDataInputStream* dis = NULL;
		GFileInputStream* _tmp3_;
		GDataInputStream* _tmp4_;
		gchar* _tmp5_ = NULL;
		GDataInputStream* _tmp6_;
		gchar* _tmp7_;
#line 883 "../src/Core/PackageKitBackend.vala"
		_tmp1_ = pk_offline_update_action;
#line 883 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = g_file_read (_tmp1_, NULL, &_inner_error0_);
#line 883 "../src/Core/PackageKitBackend.vala"
		is = _tmp2_;
#line 883 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9264 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 884 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = is;
#line 884 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = g_data_input_stream_new ((GInputStream*) _tmp3_);
#line 884 "../src/Core/PackageKitBackend.vala"
		dis = _tmp4_;
#line 886 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = dis;
#line 886 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = g_data_input_stream_read_line (_tmp6_, NULL, NULL, &_inner_error0_);
#line 886 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = _tmp7_;
#line 886 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 886 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (dis);
#line 886 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (is);
#line 9285 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 886 "../src/Core/PackageKitBackend.vala"
		if (string_contains (_tmp5_, "reboot")) {
#line 887 "../src/Core/PackageKitBackend.vala"
			result = TRUE;
#line 887 "../src/Core/PackageKitBackend.vala"
			_g_free0 (_tmp5_);
#line 887 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (dis);
#line 887 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (is);
#line 887 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (pk_offline_update_action);
#line 887 "../src/Core/PackageKitBackend.vala"
			return result;
#line 9302 "PackageKitBackend.c"
		}
#line 882 "../src/Core/PackageKitBackend.vala"
		_g_free0 (_tmp5_);
#line 882 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (dis);
#line 882 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (is);
#line 9310 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 882 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 882 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 890 "../src/Core/PackageKitBackend.vala"
		_tmp8_ = e;
#line 890 "../src/Core/PackageKitBackend.vala"
		_tmp9_ = _tmp8_->message;
#line 890 "../src/Core/PackageKitBackend.vala"
		g_critical ("PackageKitBackend.vala:890: Couldn't read PackageKit offline update ac" \
"tion: %s", _tmp9_);
#line 882 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 9330 "PackageKitBackend.c"
	}
	__finally0:
#line 882 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9335 "PackageKitBackend.c"
		gboolean _tmp10_ = FALSE;
#line 882 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_offline_update_action);
#line 882 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 882 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 882 "../src/Core/PackageKitBackend.vala"
		return _tmp10_;
#line 9345 "PackageKitBackend.c"
	}
#line 893 "../src/Core/PackageKitBackend.vala"
	result = FALSE;
#line 893 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (pk_offline_update_action);
#line 893 "../src/Core/PackageKitBackend.vala"
	return result;
#line 9353 "PackageKitBackend.c"
}

static Block63Data*
block63_data_ref (Block63Data* _data63_)
{
#line 896 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data63_->_ref_count_);
#line 896 "../src/Core/PackageKitBackend.vala"
	return _data63_;
#line 9363 "PackageKitBackend.c"
}

static void
block63_data_unref (void * _userdata_)
{
	Block63Data* _data63_;
	_data63_ = (Block63Data*) _userdata_;
#line 896 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data63_->_ref_count_)) {
#line 9373 "PackageKitBackend.c"
		AppCenterCorePackageKitBackend* self;
#line 896 "../src/Core/PackageKitBackend.vala"
		self = _data63_->self;
#line 896 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data63_->downloaded_updates);
#line 896 "../src/Core/PackageKitBackend.vala"
		_data63_->package_ids = (_vala_array_free (_data63_->package_ids, _data63_->package_ids_length1, (GDestroyNotify) g_free), NULL);
#line 896 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data63_->results);
#line 896 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (self);
#line 896 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block63Data, _data63_);
#line 9387 "PackageKitBackend.c"
	}
}

static void
___lambda67_ (AppCenterCorePackageKitBackend* self,
              PkProgress* t,
              PkProgressType p)
{
#line 902 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (t != NULL);
#line 9398 "PackageKitBackend.c"
}

static void
____lambda67__pk_progress_callback (PkProgress* progress,
                                    PkProgressType type,
                                    gpointer self)
{
#line 902 "../src/Core/PackageKitBackend.vala"
	___lambda67_ ((AppCenterCorePackageKitBackend*) self, progress, type);
#line 9408 "PackageKitBackend.c"
}

static void
_vala_array_add16 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 926 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 926 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 926 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9423 "PackageKitBackend.c"
	}
#line 926 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 926 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 9429 "PackageKitBackend.c"
}

static void
__lambda68_ (Block63Data* _data63_,
             PkPackage* pk_package)
{
	AppCenterCorePackageKitBackend* self;
	GeeArrayList* _tmp0_;
	const gchar* _tmp1_;
#line 924 "../src/Core/PackageKitBackend.vala"
	self = _data63_->self;
#line 924 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (pk_package != NULL);
#line 925 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _data63_->downloaded_updates;
#line 925 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = pk_package_get_id (pk_package);
#line 925 "../src/Core/PackageKitBackend.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, _tmp1_)) {
#line 9449 "PackageKitBackend.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 926 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = pk_package_get_id (pk_package);
#line 926 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 926 "../src/Core/PackageKitBackend.vala"
		_vala_array_add16 (&_data63_->package_ids, &_data63_->package_ids_length1, &_data63_->_package_ids_size_, _tmp3_);
#line 9458 "PackageKitBackend.c"
	}
}

static void
___lambda68__gfunc (gconstpointer data,
                    gpointer self)
{
#line 924 "../src/Core/PackageKitBackend.vala"
	__lambda68_ (self, (PkPackage*) data);
#line 9468 "PackageKitBackend.c"
}

static void
_vala_array_add17 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 937 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 937 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 937 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9483 "PackageKitBackend.c"
	}
#line 937 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 937 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 9489 "PackageKitBackend.c"
}

static void
___lambda69_ (AppCenterCorePackageKitBackend* self,
              PkProgress* p,
              PkProgressType t)
{
#line 941 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (p != NULL);
#line 9499 "PackageKitBackend.c"
}

static void
____lambda69__pk_progress_callback (PkProgress* progress,
                                    PkProgressType type,
                                    gpointer self)
{
#line 941 "../src/Core/PackageKitBackend.vala"
	___lambda69_ ((AppCenterCorePackageKitBackend*) self, progress, type);
#line 9509 "PackageKitBackend.c"
}

static void
__lambda70_ (Block63Data* _data63_,
             PkDetails* details)
{
	AppCenterCorePackageKitBackend* self;
	PkResults* _tmp0_;
#line 948 "../src/Core/PackageKitBackend.vala"
	self = _data63_->self;
#line 948 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (details != NULL);
#line 949 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _data63_->results;
#line 949 "../src/Core/PackageKitBackend.vala"
	pk_results_add_details (_tmp0_, details);
#line 9526 "PackageKitBackend.c"
}

static void
___lambda70__gfunc (gconstpointer data,
                    gpointer self)
{
#line 948 "../src/Core/PackageKitBackend.vala"
	__lambda70_ (self, (PkDetails*) data);
#line 9535 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_updates_internal (AppCenterCorePackageKitBackend* self,
                                                          AppCenterCoreJob* job)
{
	Block63Data* _data63_;
	AppCenterCoreGetUpdatesArgs* args = NULL;
	AppCenterCoreJobArgs* _tmp0_;
	AppCenterCoreJobArgs* _tmp1_;
	AppCenterCoreGetUpdatesArgs* _tmp2_;
	GCancellable* cancellable = NULL;
	AppCenterCoreGetUpdatesArgs* _tmp3_;
	GCancellable* _tmp4_;
	GCancellable* _tmp5_;
	gchar** _tmp32_;
	GeeArrayList* _tmp33_;
	PkResults* _tmp34_;
	GPtrArray* _tmp35_;
	GPtrArray* _tmp36_;
	gchar** _tmp37_;
	gint _tmp37__length1;
	PkResults* details = NULL;
	PkResults* _tmp47_;
	GPtrArray* _tmp48_;
	GPtrArray* _tmp49_;
	GValue _tmp50_ = {0};
	PkResults* _tmp51_;
	GError* _inner_error0_ = NULL;
#line 896 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 896 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (job != NULL);
#line 896 "../src/Core/PackageKitBackend.vala"
	_data63_ = g_slice_new0 (Block63Data);
#line 896 "../src/Core/PackageKitBackend.vala"
	_data63_->_ref_count_ = 1;
#line 896 "../src/Core/PackageKitBackend.vala"
	_data63_->self = g_object_ref (self);
#line 897 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_job_get_args (job);
#line 897 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 897 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = _app_center_core_job_args_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, APP_CENTER_CORE_TYPE_GET_UPDATES_ARGS, AppCenterCoreGetUpdatesArgs));
#line 897 "../src/Core/PackageKitBackend.vala"
	args = _tmp2_;
#line 898 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = args;
#line 898 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = _tmp3_->cancellable;
#line 898 "../src/Core/PackageKitBackend.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 898 "../src/Core/PackageKitBackend.vala"
	cancellable = _tmp5_;
#line 900 "../src/Core/PackageKitBackend.vala"
	_data63_->results = NULL;
#line 9593 "PackageKitBackend.c"
	{
		PkResults* _tmp6_ = NULL;
		AppCenterCoreTask* _tmp7_;
		GCancellable* _tmp8_;
		PkResults* _tmp9_;
		PkResults* _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gint _tmp12_ = 0;
		gchar** _tmp13_;
		gint _tmp13__length1;
#line 902 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = app_center_core_package_kit_backend_client;
#line 902 "../src/Core/PackageKitBackend.vala"
		_tmp8_ = cancellable;
#line 902 "../src/Core/PackageKitBackend.vala"
		_tmp9_ = pk_client_get_updates ((PkClient*) _tmp7_, (PkBitfield) 0, _tmp8_, ____lambda67__pk_progress_callback, self, &_inner_error0_);
#line 902 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = _tmp9_;
#line 902 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9615 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 902 "../src/Core/PackageKitBackend.vala"
		_tmp10_ = _tmp6_;
#line 902 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = NULL;
#line 902 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data63_->results);
#line 902 "../src/Core/PackageKitBackend.vala"
		_data63_->results = _tmp10_;
#line 904 "../src/Core/PackageKitBackend.vala"
		_tmp11_ = app_center_core_package_kit_backend_get_fake_packages (self, &_tmp12_);
#line 904 "../src/Core/PackageKitBackend.vala"
		_tmp11__length1 = _tmp12_;
#line 904 "../src/Core/PackageKitBackend.vala"
		_tmp13_ = _tmp11_;
#line 904 "../src/Core/PackageKitBackend.vala"
		_tmp13__length1 = _tmp11__length1;
#line 904 "../src/Core/PackageKitBackend.vala"
		if (_tmp13__length1 > 0) {
#line 9636 "PackageKitBackend.c"
			gchar** _tmp14_;
			gint _tmp14__length1;
			gint _tmp15_ = 0;
			gchar** _tmp16_;
			gint _tmp16__length1;
			gchar** _tmp29_;
			gchar** _tmp30_;
			gint _tmp30__length1;
#line 905 "../src/Core/PackageKitBackend.vala"
			_tmp14_ = app_center_core_package_kit_backend_get_fake_packages (self, &_tmp15_);
#line 905 "../src/Core/PackageKitBackend.vala"
			_tmp14__length1 = _tmp15_;
#line 905 "../src/Core/PackageKitBackend.vala"
			_tmp16_ = _tmp14_;
#line 905 "../src/Core/PackageKitBackend.vala"
			_tmp16__length1 = _tmp14__length1;
#line 9653 "PackageKitBackend.c"
			{
				gchar** name_collection = NULL;
				gint name_collection_length1 = 0;
				gint _name_collection_size_ = 0;
				gint name_it = 0;
#line 905 "../src/Core/PackageKitBackend.vala"
				name_collection = _tmp16_;
#line 905 "../src/Core/PackageKitBackend.vala"
				name_collection_length1 = _tmp16__length1;
#line 905 "../src/Core/PackageKitBackend.vala"
				for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 9665 "PackageKitBackend.c"
					const gchar* name = NULL;
#line 905 "../src/Core/PackageKitBackend.vala"
					name = name_collection[name_it];
#line 9669 "PackageKitBackend.c"
					{
						PkPackage* package = NULL;
						PkPackage* _tmp17_;
						gboolean _tmp18_ = FALSE;
						PkPackage* _tmp19_;
						const gchar* _tmp20_;
						gchar* _tmp21_;
						gchar* _tmp22_;
						gboolean _tmp23_;
#line 906 "../src/Core/PackageKitBackend.vala"
						_tmp17_ = pk_package_new ();
#line 906 "../src/Core/PackageKitBackend.vala"
						package = _tmp17_;
#line 907 "../src/Core/PackageKitBackend.vala"
						_tmp19_ = package;
#line 907 "../src/Core/PackageKitBackend.vala"
						_tmp20_ = name;
#line 907 "../src/Core/PackageKitBackend.vala"
						_tmp21_ = g_strdup_printf (APP_CENTER_CORE_PACKAGE_KIT_BACKEND_FAKE_PACKAGE_ID, _tmp20_);
#line 907 "../src/Core/PackageKitBackend.vala"
						_tmp22_ = _tmp21_;
#line 907 "../src/Core/PackageKitBackend.vala"
						_tmp23_ = pk_package_set_id (_tmp19_, _tmp22_, &_inner_error0_);
#line 907 "../src/Core/PackageKitBackend.vala"
						_g_free0 (_tmp22_);
#line 907 "../src/Core/PackageKitBackend.vala"
						_tmp18_ = _tmp23_;
#line 907 "../src/Core/PackageKitBackend.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 907 "../src/Core/PackageKitBackend.vala"
							_g_object_unref0 (package);
#line 907 "../src/Core/PackageKitBackend.vala"
							_g_object_unref0 (_tmp6_);
#line 9703 "PackageKitBackend.c"
							goto __catch0_g_error;
						}
#line 907 "../src/Core/PackageKitBackend.vala"
						if (_tmp18_) {
#line 9708 "PackageKitBackend.c"
							PkResults* _tmp24_;
							PkPackage* _tmp25_;
#line 908 "../src/Core/PackageKitBackend.vala"
							_tmp24_ = _data63_->results;
#line 908 "../src/Core/PackageKitBackend.vala"
							_tmp25_ = package;
#line 908 "../src/Core/PackageKitBackend.vala"
							pk_results_add_package (_tmp24_, _tmp25_);
#line 9717 "PackageKitBackend.c"
						} else {
							const gchar* _tmp26_;
							gchar* _tmp27_;
							gchar* _tmp28_;
#line 910 "../src/Core/PackageKitBackend.vala"
							_tmp26_ = name;
#line 910 "../src/Core/PackageKitBackend.vala"
							_tmp27_ = g_strdup_printf ("Could not add a fake package '%s' to the update list", _tmp26_);
#line 910 "../src/Core/PackageKitBackend.vala"
							_tmp28_ = _tmp27_;
#line 910 "../src/Core/PackageKitBackend.vala"
							g_warning ("PackageKitBackend.vala:910: %s", _tmp28_);
#line 910 "../src/Core/PackageKitBackend.vala"
							_g_free0 (_tmp28_);
#line 9732 "PackageKitBackend.c"
						}
#line 905 "../src/Core/PackageKitBackend.vala"
						_g_object_unref0 (package);
#line 9736 "PackageKitBackend.c"
					}
				}
			}
#line 914 "../src/Core/PackageKitBackend.vala"
			_tmp29_ = g_new0 (gchar*, 0 + 1);
#line 914 "../src/Core/PackageKitBackend.vala"
			_tmp30_ = _tmp29_;
#line 914 "../src/Core/PackageKitBackend.vala"
			_tmp30__length1 = 0;
#line 914 "../src/Core/PackageKitBackend.vala"
			app_center_core_package_kit_backend_set_fake_packages (self, _tmp30_, 0);
#line 914 "../src/Core/PackageKitBackend.vala"
			_tmp30_ = (_vala_array_free (_tmp30_, _tmp30__length1, (GDestroyNotify) g_free), NULL);
#line 9750 "PackageKitBackend.c"
		}
#line 901 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp6_);
#line 9754 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp31_;
#line 901 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 901 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 917 "../src/Core/PackageKitBackend.vala"
		_tmp31_ = e;
#line 917 "../src/Core/PackageKitBackend.vala"
		app_center_core_job_set_error (job, _tmp31_);
#line 918 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 919 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 919 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (cancellable);
#line 919 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (args);
#line 919 "../src/Core/PackageKitBackend.vala"
		block63_data_unref (_data63_);
#line 919 "../src/Core/PackageKitBackend.vala"
		_data63_ = NULL;
#line 919 "../src/Core/PackageKitBackend.vala"
		return;
#line 9783 "PackageKitBackend.c"
	}
	__finally0:
#line 901 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 901 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (cancellable);
#line 901 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (args);
#line 901 "../src/Core/PackageKitBackend.vala"
		block63_data_unref (_data63_);
#line 901 "../src/Core/PackageKitBackend.vala"
		_data63_ = NULL;
#line 901 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 901 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 901 "../src/Core/PackageKitBackend.vala"
		return;
#line 9802 "PackageKitBackend.c"
	}
#line 922 "../src/Core/PackageKitBackend.vala"
	_tmp32_ = g_new0 (gchar*, 0 + 1);
#line 922 "../src/Core/PackageKitBackend.vala"
	_data63_->package_ids = _tmp32_;
#line 922 "../src/Core/PackageKitBackend.vala"
	_data63_->package_ids_length1 = 0;
#line 922 "../src/Core/PackageKitBackend.vala"
	_data63_->_package_ids_size_ = _data63_->package_ids_length1;
#line 923 "../src/Core/PackageKitBackend.vala"
	_tmp33_ = app_center_core_package_kit_backend_get_downloaded_updates (self);
#line 923 "../src/Core/PackageKitBackend.vala"
	_data63_->downloaded_updates = _tmp33_;
#line 924 "../src/Core/PackageKitBackend.vala"
	_tmp34_ = _data63_->results;
#line 924 "../src/Core/PackageKitBackend.vala"
	_tmp35_ = pk_results_get_package_array (_tmp34_);
#line 924 "../src/Core/PackageKitBackend.vala"
	_tmp36_ = _tmp35_;
#line 924 "../src/Core/PackageKitBackend.vala"
	g_ptr_array_foreach (_tmp36_, ___lambda68__gfunc, _data63_);
#line 924 "../src/Core/PackageKitBackend.vala"
	_g_ptr_array_unref0 (_tmp36_);
#line 930 "../src/Core/PackageKitBackend.vala"
	_tmp37_ = _data63_->package_ids;
#line 930 "../src/Core/PackageKitBackend.vala"
	_tmp37__length1 = _data63_->package_ids_length1;
#line 930 "../src/Core/PackageKitBackend.vala"
	if (_tmp37__length1 == 0) {
#line 9832 "PackageKitBackend.c"
		GValue _tmp38_ = {0};
		PkResults* _tmp39_;
#line 931 "../src/Core/PackageKitBackend.vala"
		g_value_init (&_tmp38_, G_TYPE_OBJECT);
#line 931 "../src/Core/PackageKitBackend.vala"
		G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 931 "../src/Core/PackageKitBackend.vala"
		job->result = _tmp38_;
#line 932 "../src/Core/PackageKitBackend.vala"
		_tmp39_ = pk_results_new ();
#line 932 "../src/Core/PackageKitBackend.vala"
		g_value_take_object (&job->result, (GObject*) _tmp39_);
#line 933 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 934 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (cancellable);
#line 934 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (args);
#line 934 "../src/Core/PackageKitBackend.vala"
		block63_data_unref (_data63_);
#line 934 "../src/Core/PackageKitBackend.vala"
		_data63_ = NULL;
#line 934 "../src/Core/PackageKitBackend.vala"
		return;
#line 9857 "PackageKitBackend.c"
	}
#line 937 "../src/Core/PackageKitBackend.vala"
	_vala_array_add17 (&_data63_->package_ids, &_data63_->package_ids_length1, &_data63_->_package_ids_size_, NULL);
#line 9861 "PackageKitBackend.c"
	{
		PkResults* _tmp40_ = NULL;
		AppCenterCoreTask* _tmp41_;
		gchar** _tmp42_;
		gint _tmp42__length1;
		GCancellable* _tmp43_;
		PkResults* _tmp44_;
		PkResults* _tmp45_;
#line 941 "../src/Core/PackageKitBackend.vala"
		_tmp41_ = app_center_core_package_kit_backend_client;
#line 941 "../src/Core/PackageKitBackend.vala"
		_tmp42_ = _data63_->package_ids;
#line 941 "../src/Core/PackageKitBackend.vala"
		_tmp42__length1 = _data63_->package_ids_length1;
#line 941 "../src/Core/PackageKitBackend.vala"
		_tmp43_ = cancellable;
#line 941 "../src/Core/PackageKitBackend.vala"
		_tmp44_ = pk_client_get_details ((PkClient*) _tmp41_, _tmp42_, _tmp43_, ____lambda69__pk_progress_callback, self, &_inner_error0_);
#line 941 "../src/Core/PackageKitBackend.vala"
		_tmp40_ = _tmp44_;
#line 941 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9884 "PackageKitBackend.c"
			goto __catch1_g_error;
		}
#line 941 "../src/Core/PackageKitBackend.vala"
		_tmp45_ = _tmp40_;
#line 941 "../src/Core/PackageKitBackend.vala"
		_tmp40_ = NULL;
#line 941 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (details);
#line 941 "../src/Core/PackageKitBackend.vala"
		details = _tmp45_;
#line 940 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp40_);
#line 9897 "PackageKitBackend.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp46_;
#line 940 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 940 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 943 "../src/Core/PackageKitBackend.vala"
		_tmp46_ = e;
#line 943 "../src/Core/PackageKitBackend.vala"
		app_center_core_job_set_error (job, _tmp46_);
#line 944 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 945 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 945 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (details);
#line 945 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (cancellable);
#line 945 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (args);
#line 945 "../src/Core/PackageKitBackend.vala"
		block63_data_unref (_data63_);
#line 945 "../src/Core/PackageKitBackend.vala"
		_data63_ = NULL;
#line 945 "../src/Core/PackageKitBackend.vala"
		return;
#line 9928 "PackageKitBackend.c"
	}
	__finally1:
#line 940 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 940 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (details);
#line 940 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (cancellable);
#line 940 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (args);
#line 940 "../src/Core/PackageKitBackend.vala"
		block63_data_unref (_data63_);
#line 940 "../src/Core/PackageKitBackend.vala"
		_data63_ = NULL;
#line 940 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 940 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 940 "../src/Core/PackageKitBackend.vala"
		return;
#line 9949 "PackageKitBackend.c"
	}
#line 948 "../src/Core/PackageKitBackend.vala"
	_tmp47_ = details;
#line 948 "../src/Core/PackageKitBackend.vala"
	_tmp48_ = pk_results_get_details_array (_tmp47_);
#line 948 "../src/Core/PackageKitBackend.vala"
	_tmp49_ = _tmp48_;
#line 948 "../src/Core/PackageKitBackend.vala"
	g_ptr_array_foreach (_tmp49_, ___lambda70__gfunc, _data63_);
#line 948 "../src/Core/PackageKitBackend.vala"
	_g_ptr_array_unref0 (_tmp49_);
#line 952 "../src/Core/PackageKitBackend.vala"
	g_value_init (&_tmp50_, G_TYPE_OBJECT);
#line 952 "../src/Core/PackageKitBackend.vala"
	G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 952 "../src/Core/PackageKitBackend.vala"
	job->result = _tmp50_;
#line 953 "../src/Core/PackageKitBackend.vala"
	_tmp51_ = _data63_->results;
#line 953 "../src/Core/PackageKitBackend.vala"
	_data63_->results = NULL;
#line 953 "../src/Core/PackageKitBackend.vala"
	g_value_take_object (&job->result, (GObject*) _tmp51_);
#line 954 "../src/Core/PackageKitBackend.vala"
	g_signal_emit_by_name (job, "results-ready");
#line 896 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (details);
#line 896 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (cancellable);
#line 896 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (args);
#line 896 "../src/Core/PackageKitBackend.vala"
	block63_data_unref (_data63_);
#line 896 "../src/Core/PackageKitBackend.vala"
	_data63_ = NULL;
#line 9985 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_updates_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendGetUpdatesData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendGetUpdatesData, _data_);
#line 10001 "PackageKitBackend.c"
}

void
app_center_core_package_kit_backend_get_updates (AppCenterCorePackageKitBackend* self,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	AppCenterCorePackageKitBackendGetUpdatesData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendGetUpdatesData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_get_updates_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_get_updates_co (_data_);
#line 10033 "PackageKitBackend.c"
}

PkResults*
app_center_core_package_kit_backend_get_updates_finish (AppCenterCorePackageKitBackend* self,
                                                        GAsyncResult* _res_,
                                                        GError** error)
{
	PkResults* result;
	AppCenterCorePackageKitBackendGetUpdatesData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 24 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 10049 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->result = NULL;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 10057 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_updates_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_)
{
	AppCenterCorePackageKitBackendGetUpdatesData* _data_;
#line 961 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 961 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 961 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 961 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_get_updates_co (_data_);
#line 10074 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_get_updates_co (AppCenterCorePackageKitBackendGetUpdatesData* _data_)
{
#line 957 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 957 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 10084 "PackageKitBackend.c"
		goto _state_0;
#line 957 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 10088 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 957 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 10093 "PackageKitBackend.c"
	}
	_state_0:
#line 958 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = app_center_core_get_updates_args_new ();
#line 958 "../src/Core/PackageKitBackend.vala"
	_data_->job_args = _data_->_tmp0_;
#line 959 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = _data_->job_args;
#line 959 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->cancellable);
#line 959 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp1_->cancellable);
#line 959 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_->cancellable = _data_->_tmp2_;
#line 961 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_ = _data_->job_args;
#line 961 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 1;
#line 961 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_launch_job (_data_->self, APP_CENTER_CORE_JOB_TYPE_GET_UPDATES, (AppCenterCoreJobArgs*) _data_->_tmp3_, app_center_core_package_kit_backend_get_updates_ready, _data_);
#line 961 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 10116 "PackageKitBackend.c"
	_state_1:
#line 961 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp4_ = app_center_core_package_kit_backend_launch_job_finish (_data_->self, _data_->_res_);
#line 961 "../src/Core/PackageKitBackend.vala"
	_data_->job = _data_->_tmp4_;
#line 962 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp5_ = _data_->job;
#line 962 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp6_ = app_center_core_job_get_error (_data_->_tmp5_);
#line 962 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 962 "../src/Core/PackageKitBackend.vala"
	if (_data_->_tmp7_ != NULL) {
#line 963 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp8_ = _data_->job;
#line 963 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp9_ = app_center_core_job_get_error (_data_->_tmp8_);
#line 963 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 963 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp11_ = _g_error_copy0 (_data_->_tmp10_);
#line 963 "../src/Core/PackageKitBackend.vala"
		_data_->_inner_error0_ = _data_->_tmp11_;
#line 963 "../src/Core/PackageKitBackend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 963 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data_->job);
#line 963 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (_data_->job_args);
#line 963 "../src/Core/PackageKitBackend.vala"
		g_object_unref (_data_->_async_result);
#line 963 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 10150 "PackageKitBackend.c"
	}
#line 966 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp12_ = _data_->job;
#line 966 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp13_ = g_value_get_object (&_data_->_tmp12_->result);
#line 966 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, pk_results_get_type (), PkResults));
#line 966 "../src/Core/PackageKitBackend.vala"
	_data_->result = _data_->_tmp14_;
#line 966 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->job);
#line 966 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (_data_->job_args);
#line 966 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 966 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 966 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 966 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10172 "PackageKitBackend.c"
		}
	}
#line 966 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 966 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 10179 "PackageKitBackend.c"
}

static void
___lambda16_ (AppCenterCorePackageKitBackend* self,
              PkProgress* t,
              PkProgressType p)
{
#line 984 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (t != NULL);
#line 10189 "PackageKitBackend.c"
}

static void
____lambda16__pk_progress_callback (PkProgress* progress,
                                    PkProgressType type,
                                    gpointer self)
{
#line 984 "../src/Core/PackageKitBackend.vala"
	___lambda16_ ((AppCenterCorePackageKitBackend*) self, progress, type);
#line 10199 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_refresh_cache_internal (AppCenterCorePackageKitBackend* self,
                                                            AppCenterCoreJob* job)
{
	AppCenterCoreRefreshCacheArgs* args = NULL;
	AppCenterCoreJobArgs* _tmp0_;
	AppCenterCoreJobArgs* _tmp1_;
	GCancellable* cancellable = NULL;
	AppCenterCoreRefreshCacheArgs* _tmp2_;
	GCancellable* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean _tmp8_;
	PkResults* results = NULL;
	PkExitEnum exit_status = 0;
	PkResults* _tmp16_;
	GValue _tmp18_ = {0};
	GError* _inner_error0_ = NULL;
#line 969 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 969 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (job != NULL);
#line 970 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_job_get_args (job);
#line 970 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 970 "../src/Core/PackageKitBackend.vala"
	args = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, APP_CENTER_CORE_TYPE_REFRESH_CACHE_ARGS, AppCenterCoreRefreshCacheArgs);
#line 971 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = args;
#line 971 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _tmp2_->cancellable;
#line 971 "../src/Core/PackageKitBackend.vala"
	cancellable = _tmp3_;
#line 975 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = app_center_core_package_kit_backend_get_downloaded_updates (self);
#line 975 "../src/Core/PackageKitBackend.vala"
	_tmp5_ = _tmp4_;
#line 975 "../src/Core/PackageKitBackend.vala"
	_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 975 "../src/Core/PackageKitBackend.vala"
	_tmp7_ = _tmp6_;
#line 975 "../src/Core/PackageKitBackend.vala"
	_tmp8_ = _tmp7_ > 0;
#line 975 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_tmp5_);
#line 975 "../src/Core/PackageKitBackend.vala"
	if (_tmp8_) {
#line 10252 "PackageKitBackend.c"
		GValue _tmp9_ = {0};
#line 976 "../src/Core/PackageKitBackend.vala"
		g_value_init (&_tmp9_, G_TYPE_BOOLEAN);
#line 976 "../src/Core/PackageKitBackend.vala"
		G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 976 "../src/Core/PackageKitBackend.vala"
		job->result = _tmp9_;
#line 977 "../src/Core/PackageKitBackend.vala"
		g_value_set_boolean (&job->result, TRUE);
#line 978 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 979 "../src/Core/PackageKitBackend.vala"
		return;
#line 10266 "PackageKitBackend.c"
	}
#line 982 "../src/Core/PackageKitBackend.vala"
	results = NULL;
#line 10270 "PackageKitBackend.c"
	{
		PkResults* _tmp10_ = NULL;
		AppCenterCoreTask* _tmp11_;
		GCancellable* _tmp12_;
		PkResults* _tmp13_;
		PkResults* _tmp14_;
#line 984 "../src/Core/PackageKitBackend.vala"
		_tmp11_ = app_center_core_package_kit_backend_client;
#line 984 "../src/Core/PackageKitBackend.vala"
		_tmp12_ = cancellable;
#line 984 "../src/Core/PackageKitBackend.vala"
		_tmp13_ = pk_client_refresh_cache ((PkClient*) _tmp11_, FALSE, _tmp12_, ____lambda16__pk_progress_callback, self, &_inner_error0_);
#line 984 "../src/Core/PackageKitBackend.vala"
		_tmp10_ = _tmp13_;
#line 984 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10287 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 984 "../src/Core/PackageKitBackend.vala"
		_tmp14_ = _tmp10_;
#line 984 "../src/Core/PackageKitBackend.vala"
		_tmp10_ = NULL;
#line 984 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (results);
#line 984 "../src/Core/PackageKitBackend.vala"
		results = _tmp14_;
#line 983 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp10_);
#line 10300 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
#line 983 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 983 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 986 "../src/Core/PackageKitBackend.vala"
		_tmp15_ = e;
#line 986 "../src/Core/PackageKitBackend.vala"
		app_center_core_job_set_error (job, _tmp15_);
#line 987 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 988 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 988 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (results);
#line 988 "../src/Core/PackageKitBackend.vala"
		return;
#line 10323 "PackageKitBackend.c"
	}
	__finally0:
#line 983 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 983 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (results);
#line 983 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 983 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 983 "../src/Core/PackageKitBackend.vala"
		return;
#line 10336 "PackageKitBackend.c"
	}
#line 991 "../src/Core/PackageKitBackend.vala"
	_tmp16_ = results;
#line 991 "../src/Core/PackageKitBackend.vala"
	exit_status = pk_results_get_exit_code (_tmp16_);
#line 992 "../src/Core/PackageKitBackend.vala"
	if (exit_status == PK_EXIT_ENUM_SUCCESS) {
#line 10344 "PackageKitBackend.c"
		AppCenterCoreBackendAggregator* _tmp17_;
#line 993 "../src/Core/PackageKitBackend.vala"
		app_center_core_package_kit_backend_reload_appstream_pool (self);
#line 994 "../src/Core/PackageKitBackend.vala"
		_tmp17_ = app_center_core_backend_aggregator_get_default ();
#line 994 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (_tmp17_, "cache-flush-needed");
#line 10352 "PackageKitBackend.c"
	}
#line 997 "../src/Core/PackageKitBackend.vala"
	g_value_init (&_tmp18_, G_TYPE_BOOLEAN);
#line 997 "../src/Core/PackageKitBackend.vala"
	G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 997 "../src/Core/PackageKitBackend.vala"
	job->result = _tmp18_;
#line 998 "../src/Core/PackageKitBackend.vala"
	g_value_set_boolean (&job->result, exit_status == PK_EXIT_ENUM_SUCCESS);
#line 999 "../src/Core/PackageKitBackend.vala"
	g_signal_emit_by_name (job, "results-ready");
#line 969 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (results);
#line 10366 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_refresh_cache_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendRefreshCacheData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendRefreshCacheData, _data_);
#line 10380 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_refresh_cache (AppCenterCoreBackend* base,
                                                        GCancellable* cancellable,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_)
{
	AppCenterCorePackageKitBackend * self;
	AppCenterCorePackageKitBackendRefreshCacheData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendRefreshCacheData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_real_refresh_cache_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_refresh_cache_co (_data_);
#line 10413 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_refresh_cache_finish (AppCenterCoreBackend* base,
                                                          GAsyncResult* _res_,
                                                          GError** error)
{
	gboolean result;
	AppCenterCorePackageKitBackendRefreshCacheData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 10427 "PackageKitBackend.c"
		gboolean _tmp0_ = FALSE;
#line 24 "../src/Core/PackageKitBackend.vala"
		return _tmp0_;
#line 10431 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 10437 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_refresh_cache_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_)
{
	AppCenterCorePackageKitBackendRefreshCacheData* _data_;
#line 1006 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 1006 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 1006 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 1006 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_refresh_cache_co (_data_);
#line 10454 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_real_refresh_cache_co (AppCenterCorePackageKitBackendRefreshCacheData* _data_)
{
#line 1002 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 1002 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 10464 "PackageKitBackend.c"
		goto _state_0;
#line 1002 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 10468 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 1002 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 10473 "PackageKitBackend.c"
	}
	_state_0:
#line 1003 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = app_center_core_refresh_cache_args_new ();
#line 1003 "../src/Core/PackageKitBackend.vala"
	_data_->job_args = _data_->_tmp0_;
#line 1004 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = _data_->job_args;
#line 1004 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->cancellable);
#line 1004 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp1_->cancellable);
#line 1004 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_->cancellable = _data_->_tmp2_;
#line 1006 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_ = _data_->job_args;
#line 1006 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 1;
#line 1006 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_launch_job (_data_->self, APP_CENTER_CORE_JOB_TYPE_REFRESH_CACHE, (AppCenterCoreJobArgs*) _data_->_tmp3_, app_center_core_package_kit_backend_refresh_cache_ready, _data_);
#line 1006 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 10496 "PackageKitBackend.c"
	_state_1:
#line 1006 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp4_ = app_center_core_package_kit_backend_launch_job_finish (_data_->self, _data_->_res_);
#line 1006 "../src/Core/PackageKitBackend.vala"
	_data_->job = _data_->_tmp4_;
#line 1007 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp5_ = _data_->job;
#line 1007 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp6_ = app_center_core_job_get_error (_data_->_tmp5_);
#line 1007 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 1007 "../src/Core/PackageKitBackend.vala"
	if (_data_->_tmp7_ != NULL) {
#line 1008 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp8_ = _data_->job;
#line 1008 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp9_ = app_center_core_job_get_error (_data_->_tmp8_);
#line 1008 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 1008 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp11_ = _g_error_copy0 (_data_->_tmp10_);
#line 1008 "../src/Core/PackageKitBackend.vala"
		_data_->_inner_error0_ = _data_->_tmp11_;
#line 1008 "../src/Core/PackageKitBackend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1008 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data_->job);
#line 1008 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (_data_->job_args);
#line 1008 "../src/Core/PackageKitBackend.vala"
		g_object_unref (_data_->_async_result);
#line 1008 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 10530 "PackageKitBackend.c"
	}
#line 1011 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp12_ = _data_->job;
#line 1011 "../src/Core/PackageKitBackend.vala"
	_data_->result = g_value_get_boolean (&_data_->_tmp12_->result);
#line 1011 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->job);
#line 1011 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (_data_->job_args);
#line 1011 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1011 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 1011 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1011 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10548 "PackageKitBackend.c"
		}
	}
#line 1011 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 1011 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 10555 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_is_package_installed_internal (AppCenterCorePackageKitBackend* self,
                                                                   AppCenterCoreJob* job)
{
	AppCenterCoreIsPackageInstalledArgs* args = NULL;
	AppCenterCoreJobArgs* _tmp0_;
	AppCenterCoreJobArgs* _tmp1_;
	AppCenterCoreIsPackageInstalledArgs* _tmp2_;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreIsPackageInstalledArgs* _tmp3_;
	AppCenterCorePackage* _tmp4_;
	PkPackage* pk_package = NULL;
	GValue _tmp10_ = {0};
	PkPackage* _tmp11_;
	PkInfoEnum _tmp12_;
	PkInfoEnum _tmp13_;
	GValue _tmp14_ = {0};
	GError* _inner_error0_ = NULL;
#line 1014 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 1014 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (job != NULL);
#line 1015 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_job_get_args (job);
#line 1015 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 1015 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = _app_center_core_job_args_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, APP_CENTER_CORE_TYPE_ISPACKAGE_INSTALLED_ARGS, AppCenterCoreIsPackageInstalledArgs));
#line 1015 "../src/Core/PackageKitBackend.vala"
	args = _tmp2_;
#line 1016 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = args;
#line 1016 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = _tmp3_->package;
#line 1016 "../src/Core/PackageKitBackend.vala"
	package = _tmp4_;
#line 10594 "PackageKitBackend.c"
	{
		PkPackage* _tmp5_ = NULL;
		AppCenterCorePackage* _tmp6_;
		PkPackage* _tmp7_;
		PkPackage* _tmp8_;
#line 1020 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = package;
#line 1020 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = app_center_core_package_kit_backend_get_package_internal (self, _tmp6_, &_inner_error0_);
#line 1020 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = _tmp7_;
#line 1020 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10608 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 1020 "../src/Core/PackageKitBackend.vala"
		_tmp8_ = _tmp5_;
#line 1020 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = NULL;
#line 1020 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 1020 "../src/Core/PackageKitBackend.vala"
		pk_package = _tmp8_;
#line 1019 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp5_);
#line 10621 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
#line 1019 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 1019 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 1022 "../src/Core/PackageKitBackend.vala"
		_tmp9_ = e;
#line 1022 "../src/Core/PackageKitBackend.vala"
		app_center_core_job_set_error (job, _tmp9_);
#line 1023 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 1024 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 1024 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 1024 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (args);
#line 1024 "../src/Core/PackageKitBackend.vala"
		return;
#line 10646 "PackageKitBackend.c"
	}
	__finally0:
#line 1019 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1019 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 1019 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (args);
#line 1019 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1019 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 1019 "../src/Core/PackageKitBackend.vala"
		return;
#line 10661 "PackageKitBackend.c"
	}
#line 1027 "../src/Core/PackageKitBackend.vala"
	g_value_init (&_tmp10_, G_TYPE_BOOLEAN);
#line 1027 "../src/Core/PackageKitBackend.vala"
	G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 1027 "../src/Core/PackageKitBackend.vala"
	job->result = _tmp10_;
#line 1028 "../src/Core/PackageKitBackend.vala"
	_tmp11_ = pk_package;
#line 1028 "../src/Core/PackageKitBackend.vala"
	_tmp12_ = pk_package_get_info (_tmp11_);
#line 1028 "../src/Core/PackageKitBackend.vala"
	_tmp13_ = _tmp12_;
#line 1028 "../src/Core/PackageKitBackend.vala"
	g_value_init (&_tmp14_, G_TYPE_BOOLEAN);
#line 1028 "../src/Core/PackageKitBackend.vala"
	g_value_set_boolean (&_tmp14_, _tmp13_ == PK_INFO_ENUM_INSTALLED);
#line 1028 "../src/Core/PackageKitBackend.vala"
	G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 1028 "../src/Core/PackageKitBackend.vala"
	job->result = _tmp14_;
#line 1029 "../src/Core/PackageKitBackend.vala"
	g_signal_emit_by_name (job, "results-ready");
#line 1014 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (pk_package);
#line 1014 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (args);
#line 10689 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_is_package_installed_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendIsPackageInstalledData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendIsPackageInstalledData, _data_);
#line 10703 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_is_package_installed (AppCenterCoreBackend* base,
                                                               AppCenterCorePackage* package,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_)
{
	AppCenterCorePackageKitBackend * self;
	AppCenterCorePackageKitBackendIsPackageInstalledData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	AppCenterCorePackage* _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (package != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendIsPackageInstalledData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_real_is_package_installed_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->package = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_is_package_installed_co (_data_);
#line 10738 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_is_package_installed_finish (AppCenterCoreBackend* base,
                                                                 GAsyncResult* _res_,
                                                                 GError** error)
{
	gboolean result;
	AppCenterCorePackageKitBackendIsPackageInstalledData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 10752 "PackageKitBackend.c"
		gboolean _tmp0_ = FALSE;
#line 24 "../src/Core/PackageKitBackend.vala"
		return _tmp0_;
#line 10756 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 10762 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_is_package_installed_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_)
{
	AppCenterCorePackageKitBackendIsPackageInstalledData* _data_;
#line 1036 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 1036 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 1036 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 1036 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_is_package_installed_co (_data_);
#line 10779 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_real_is_package_installed_co (AppCenterCorePackageKitBackendIsPackageInstalledData* _data_)
{
#line 1032 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 1032 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 10789 "PackageKitBackend.c"
		goto _state_0;
#line 1032 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 10793 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 1032 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 10798 "PackageKitBackend.c"
	}
	_state_0:
#line 1033 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = app_center_core_ispackage_installed_args_new ();
#line 1033 "../src/Core/PackageKitBackend.vala"
	_data_->job_args = _data_->_tmp0_;
#line 1034 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = _data_->job_args;
#line 1034 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->package);
#line 1034 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp1_->package);
#line 1034 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_->package = _data_->_tmp2_;
#line 1036 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_ = _data_->job_args;
#line 1036 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 1;
#line 1036 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_launch_job (_data_->self, APP_CENTER_CORE_JOB_TYPE_IS_PACKAGE_INSTALLED, (AppCenterCoreJobArgs*) _data_->_tmp3_, app_center_core_package_kit_backend_is_package_installed_ready, _data_);
#line 1036 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 10821 "PackageKitBackend.c"
	_state_1:
#line 1036 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp4_ = app_center_core_package_kit_backend_launch_job_finish (_data_->self, _data_->_res_);
#line 1036 "../src/Core/PackageKitBackend.vala"
	_data_->job = _data_->_tmp4_;
#line 1037 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp5_ = _data_->job;
#line 1037 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp6_ = app_center_core_job_get_error (_data_->_tmp5_);
#line 1037 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 1037 "../src/Core/PackageKitBackend.vala"
	if (_data_->_tmp7_ != NULL) {
#line 1038 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp8_ = _data_->job;
#line 1038 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp9_ = app_center_core_job_get_error (_data_->_tmp8_);
#line 1038 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 1038 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp11_ = _g_error_copy0 (_data_->_tmp10_);
#line 1038 "../src/Core/PackageKitBackend.vala"
		_data_->_inner_error0_ = _data_->_tmp11_;
#line 1038 "../src/Core/PackageKitBackend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1038 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data_->job);
#line 1038 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (_data_->job_args);
#line 1038 "../src/Core/PackageKitBackend.vala"
		g_object_unref (_data_->_async_result);
#line 1038 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 10855 "PackageKitBackend.c"
	}
#line 1041 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp12_ = _data_->job;
#line 1041 "../src/Core/PackageKitBackend.vala"
	_data_->result = g_value_get_boolean (&_data_->_tmp12_->result);
#line 1041 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->job);
#line 1041 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (_data_->job_args);
#line 1041 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1041 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 1041 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1041 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10873 "PackageKitBackend.c"
		}
	}
#line 1041 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 1041 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 10880 "PackageKitBackend.c"
}

static Block64Data*
block64_data_ref (Block64Data* _data64_)
{
#line 1044 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data64_->_ref_count_);
#line 1044 "../src/Core/PackageKitBackend.vala"
	return _data64_;
#line 10890 "PackageKitBackend.c"
}

static void
block64_data_unref (void * _userdata_)
{
	Block64Data* _data64_;
	_data64_ = (Block64Data*) _userdata_;
#line 1044 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data64_->_ref_count_)) {
#line 10900 "PackageKitBackend.c"
		AppCenterCorePackageKitBackend* self;
#line 1044 "../src/Core/PackageKitBackend.vala"
		self = _data64_->self;
#line 1044 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data64_->pk_package);
#line 1044 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (self);
#line 1044 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block64Data, _data64_);
#line 10910 "PackageKitBackend.c"
	}
}

static void
___lambda9_ (AppCenterCorePackageKitBackend* self)
{
}

static void
____lambda9__pk_progress_callback (PkProgress* progress,
                                   PkProgressType type,
                                   gpointer self)
{
#line 1054 "../src/Core/PackageKitBackend.vala"
	___lambda9_ ((AppCenterCorePackageKitBackend*) self);
#line 10926 "PackageKitBackend.c"
}

static void
____lambda10_ (AppCenterCorePackageKitBackend* self,
               PkProgress* t,
               PkProgressType p)
{
#line 1065 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (t != NULL);
#line 10936 "PackageKitBackend.c"
}

static void
_____lambda10__pk_progress_callback (PkProgress* progress,
                                     PkProgressType type,
                                     gpointer self)
{
#line 1065 "../src/Core/PackageKitBackend.vala"
	____lambda10_ ((AppCenterCorePackageKitBackend*) self, progress, type);
#line 10946 "PackageKitBackend.c"
}

static void
____lambda11_ (Block64Data* _data64_,
               PkDetails* details)
{
	AppCenterCorePackageKitBackend* self;
	PkPackage* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	PkPackage* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	PkPackage* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	PkPackage* _tmp12_;
	PkGroupEnum _tmp13_;
	PkGroupEnum _tmp14_;
	PkPackage* _tmp15_;
	guint64 _tmp16_;
	guint64 _tmp17_;
	PkPackage* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
#line 1066 "../src/Core/PackageKitBackend.vala"
	self = _data64_->self;
#line 1066 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (details != NULL);
#line 1067 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _data64_->pk_package;
#line 1067 "../src/Core/PackageKitBackend.vala"
	g_object_get (details, "license", &_tmp1_, NULL);
#line 1067 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = _tmp1_;
#line 1067 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _tmp2_;
#line 1067 "../src/Core/PackageKitBackend.vala"
	g_object_set (_tmp0_, "license", _tmp3_, NULL);
#line 1067 "../src/Core/PackageKitBackend.vala"
	_g_free0 (_tmp3_);
#line 1068 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = _data64_->pk_package;
#line 1068 "../src/Core/PackageKitBackend.vala"
	g_object_get (details, "description", &_tmp5_, NULL);
#line 1068 "../src/Core/PackageKitBackend.vala"
	_tmp6_ = _tmp5_;
#line 1068 "../src/Core/PackageKitBackend.vala"
	_tmp7_ = _tmp6_;
#line 1068 "../src/Core/PackageKitBackend.vala"
	g_object_set (_tmp4_, "description", _tmp7_, NULL);
#line 1068 "../src/Core/PackageKitBackend.vala"
	_g_free0 (_tmp7_);
#line 1069 "../src/Core/PackageKitBackend.vala"
	_tmp8_ = _data64_->pk_package;
#line 1069 "../src/Core/PackageKitBackend.vala"
	g_object_get (details, "summary", &_tmp9_, NULL);
#line 1069 "../src/Core/PackageKitBackend.vala"
	_tmp10_ = _tmp9_;
#line 1069 "../src/Core/PackageKitBackend.vala"
	_tmp11_ = _tmp10_;
#line 1069 "../src/Core/PackageKitBackend.vala"
	pk_package_set_summary (_tmp8_, _tmp11_);
#line 1069 "../src/Core/PackageKitBackend.vala"
	_g_free0 (_tmp11_);
#line 1070 "../src/Core/PackageKitBackend.vala"
	_tmp12_ = _data64_->pk_package;
#line 1070 "../src/Core/PackageKitBackend.vala"
	g_object_get (details, "group", &_tmp13_, NULL);
#line 1070 "../src/Core/PackageKitBackend.vala"
	_tmp14_ = _tmp13_;
#line 1070 "../src/Core/PackageKitBackend.vala"
	g_object_set (_tmp12_, "group", _tmp14_, NULL);
#line 1071 "../src/Core/PackageKitBackend.vala"
	_tmp15_ = _data64_->pk_package;
#line 1071 "../src/Core/PackageKitBackend.vala"
	g_object_get (details, "size", &_tmp16_, NULL);
#line 1071 "../src/Core/PackageKitBackend.vala"
	_tmp17_ = _tmp16_;
#line 1071 "../src/Core/PackageKitBackend.vala"
	g_object_set (_tmp15_, "size", _tmp17_, NULL);
#line 1072 "../src/Core/PackageKitBackend.vala"
	_tmp18_ = _data64_->pk_package;
#line 1072 "../src/Core/PackageKitBackend.vala"
	g_object_get (details, "url", &_tmp19_, NULL);
#line 1072 "../src/Core/PackageKitBackend.vala"
	_tmp20_ = _tmp19_;
#line 1072 "../src/Core/PackageKitBackend.vala"
	_tmp21_ = _tmp20_;
#line 1072 "../src/Core/PackageKitBackend.vala"
	g_object_set (_tmp18_, "url", _tmp21_, NULL);
#line 1072 "../src/Core/PackageKitBackend.vala"
	_g_free0 (_tmp21_);
#line 11044 "PackageKitBackend.c"
}

static void
_____lambda11__gfunc (gconstpointer data,
                      gpointer self)
{
#line 1066 "../src/Core/PackageKitBackend.vala"
	____lambda11_ (self, (PkDetails*) data);
#line 11053 "PackageKitBackend.c"
}

static PkPackage*
app_center_core_package_kit_backend_get_package_internal (AppCenterCorePackageKitBackend* self,
                                                          AppCenterCorePackage* package,
                                                          GError** error)
{
	Block64Data* _data64_;
	gboolean _tmp0_ = FALSE;
	AsComponent* _tmp1_;
	AsComponent* _tmp2_;
	gchar* name = NULL;
	AsComponent* _tmp8_;
	AsComponent* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	PkBitfield filter = 0ULL;
	PkPackage* _tmp31_;
	PkPackage* _tmp49_;
	PkPackage* _tmp51_;
	PkPackage* _tmp52_;
	GError* _inner_error0_ = NULL;
	PkPackage* result;
#line 1044 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1044 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (package != NULL, NULL);
#line 1044 "../src/Core/PackageKitBackend.vala"
	_data64_ = g_slice_new0 (Block64Data);
#line 1044 "../src/Core/PackageKitBackend.vala"
	_data64_->_ref_count_ = 1;
#line 1044 "../src/Core/PackageKitBackend.vala"
	_data64_->self = g_object_ref (self);
#line 1045 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = app_center_core_package_get_component (package);
#line 1045 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = _tmp1_;
#line 1045 "../src/Core/PackageKitBackend.vala"
	if (_tmp2_ == NULL) {
#line 1045 "../src/Core/PackageKitBackend.vala"
		_tmp0_ = TRUE;
#line 11097 "PackageKitBackend.c"
	} else {
		AsComponent* _tmp3_;
		AsComponent* _tmp4_;
		gchar** _tmp5_;
		gchar** _tmp6_;
#line 1045 "../src/Core/PackageKitBackend.vala"
		_tmp3_ = app_center_core_package_get_component (package);
#line 1045 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = _tmp3_;
#line 1045 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = _tmp5_ = as_component_get_pkgnames (_tmp4_);
#line 1045 "../src/Core/PackageKitBackend.vala"
		_tmp0_ = _vala_array_length (_tmp5_) < 1;
#line 11111 "PackageKitBackend.c"
	}
#line 1045 "../src/Core/PackageKitBackend.vala"
	if (_tmp0_) {
#line 11115 "PackageKitBackend.c"
		GError* _tmp7_;
#line 1046 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = g_error_new_literal (PACKAGE_KIT_BACKEND_ERROR, PACKAGE_KIT_BACKEND_ERROR_PACKAGE_NOT_FOUND, "Package not found");
#line 1046 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = _tmp7_;
#line 1046 "../src/Core/PackageKitBackend.vala"
		g_propagate_error (error, _inner_error0_);
#line 1046 "../src/Core/PackageKitBackend.vala"
		block64_data_unref (_data64_);
#line 1046 "../src/Core/PackageKitBackend.vala"
		_data64_ = NULL;
#line 1046 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 11129 "PackageKitBackend.c"
	}
#line 1049 "../src/Core/PackageKitBackend.vala"
	_tmp8_ = app_center_core_package_get_component (package);
#line 1049 "../src/Core/PackageKitBackend.vala"
	_tmp9_ = _tmp8_;
#line 1049 "../src/Core/PackageKitBackend.vala"
	_tmp11_ = _tmp10_ = as_component_get_pkgnames (_tmp9_);
#line 1049 "../src/Core/PackageKitBackend.vala"
	_tmp12_ = _tmp11_[0];
#line 1049 "../src/Core/PackageKitBackend.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 1049 "../src/Core/PackageKitBackend.vala"
	name = _tmp13_;
#line 1051 "../src/Core/PackageKitBackend.vala"
	_data64_->pk_package = NULL;
#line 1052 "../src/Core/PackageKitBackend.vala"
	filter = pk_bitfield_from_enums ((gint) PK_FILTER_ENUM_NEWEST, -1);
#line 11147 "PackageKitBackend.c"
	{
		PkResults* results = NULL;
		AppCenterCoreTask* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar** _tmp17_;
		gchar** _tmp18_;
		gint _tmp18__length1;
		PkResults* _tmp19_;
		PkResults* _tmp20_;
		GPtrArray* array = NULL;
		PkResults* _tmp21_;
		GPtrArray* _tmp22_;
		GPtrArray* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
#line 1054 "../src/Core/PackageKitBackend.vala"
		_tmp14_ = app_center_core_package_kit_backend_client;
#line 1054 "../src/Core/PackageKitBackend.vala"
		_tmp15_ = name;
#line 1054 "../src/Core/PackageKitBackend.vala"
		_tmp16_ = g_strdup (_tmp15_);
#line 1054 "../src/Core/PackageKitBackend.vala"
		_tmp17_ = g_new0 (gchar*, 2 + 1);
#line 1054 "../src/Core/PackageKitBackend.vala"
		_tmp17_[0] = _tmp16_;
#line 1054 "../src/Core/PackageKitBackend.vala"
		_tmp17_[1] = NULL;
#line 1054 "../src/Core/PackageKitBackend.vala"
		_tmp18_ = _tmp17_;
#line 1054 "../src/Core/PackageKitBackend.vala"
		_tmp18__length1 = 2;
#line 1054 "../src/Core/PackageKitBackend.vala"
		_tmp19_ = pk_task_resolve_sync ((PkTask*) _tmp14_, filter, _tmp18_, NULL, ____lambda9__pk_progress_callback, self, &_inner_error0_);
#line 1054 "../src/Core/PackageKitBackend.vala"
		_tmp20_ = _tmp19_;
#line 1054 "../src/Core/PackageKitBackend.vala"
		_tmp18_ = (_vala_array_free (_tmp18_, _tmp18__length1, (GDestroyNotify) g_free), NULL);
#line 1054 "../src/Core/PackageKitBackend.vala"
		results = _tmp20_;
#line 1054 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11190 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 1055 "../src/Core/PackageKitBackend.vala"
		_tmp21_ = results;
#line 1055 "../src/Core/PackageKitBackend.vala"
		_tmp22_ = pk_results_get_package_array (_tmp21_);
#line 1055 "../src/Core/PackageKitBackend.vala"
		array = _tmp22_;
#line 1056 "../src/Core/PackageKitBackend.vala"
		_tmp23_ = array;
#line 1056 "../src/Core/PackageKitBackend.vala"
		_tmp24_ = vala_g_ptr_array_get_length (_tmp23_);
#line 1056 "../src/Core/PackageKitBackend.vala"
		_tmp25_ = _tmp24_;
#line 1056 "../src/Core/PackageKitBackend.vala"
		if (_tmp25_ > 0) {
#line 11207 "PackageKitBackend.c"
			GPtrArray* _tmp26_;
			gconstpointer _tmp27_;
			PkPackage* _tmp28_;
#line 1057 "../src/Core/PackageKitBackend.vala"
			_tmp26_ = array;
#line 1057 "../src/Core/PackageKitBackend.vala"
			_tmp27_ = g_ptr_array_index (_tmp26_, (guint) 0);
#line 1057 "../src/Core/PackageKitBackend.vala"
			_tmp28_ = _g_object_ref0 ((PkPackage*) _tmp27_);
#line 1057 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (_data64_->pk_package);
#line 1057 "../src/Core/PackageKitBackend.vala"
			_data64_->pk_package = _tmp28_;
#line 11221 "PackageKitBackend.c"
		}
#line 1053 "../src/Core/PackageKitBackend.vala"
		_g_ptr_array_unref0 (array);
#line 1053 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (results);
#line 11227 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp29_;
		GError* _tmp30_;
#line 1053 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 1053 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 1060 "../src/Core/PackageKitBackend.vala"
		_tmp29_ = e;
#line 1060 "../src/Core/PackageKitBackend.vala"
		_tmp30_ = _g_error_copy0 (_tmp29_);
#line 1060 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = _tmp30_;
#line 1060 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 11247 "PackageKitBackend.c"
		goto __finally0;
	}
	__finally0:
#line 1053 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1053 "../src/Core/PackageKitBackend.vala"
		g_propagate_error (error, _inner_error0_);
#line 1053 "../src/Core/PackageKitBackend.vala"
		_g_free0 (name);
#line 1053 "../src/Core/PackageKitBackend.vala"
		block64_data_unref (_data64_);
#line 1053 "../src/Core/PackageKitBackend.vala"
		_data64_ = NULL;
#line 1053 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 11263 "PackageKitBackend.c"
	}
#line 1063 "../src/Core/PackageKitBackend.vala"
	_tmp31_ = _data64_->pk_package;
#line 1063 "../src/Core/PackageKitBackend.vala"
	if (_tmp31_ != NULL) {
#line 11269 "PackageKitBackend.c"
		{
			PkResults* details = NULL;
			AppCenterCoreTask* _tmp32_;
			PkPackage* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar** _tmp36_;
			gchar** _tmp37_;
			gint _tmp37__length1;
			PkResults* _tmp38_;
			PkResults* _tmp39_;
			PkResults* _tmp40_;
			GPtrArray* _tmp41_;
			GPtrArray* _tmp42_;
#line 1065 "../src/Core/PackageKitBackend.vala"
			_tmp32_ = app_center_core_package_kit_backend_client;
#line 1065 "../src/Core/PackageKitBackend.vala"
			_tmp33_ = _data64_->pk_package;
#line 1065 "../src/Core/PackageKitBackend.vala"
			g_object_get (_tmp33_, "package-id", &_tmp34_, NULL);
#line 1065 "../src/Core/PackageKitBackend.vala"
			_tmp35_ = _tmp34_;
#line 1065 "../src/Core/PackageKitBackend.vala"
			_tmp36_ = g_new0 (gchar*, 2 + 1);
#line 1065 "../src/Core/PackageKitBackend.vala"
			_tmp36_[0] = _tmp35_;
#line 1065 "../src/Core/PackageKitBackend.vala"
			_tmp36_[1] = NULL;
#line 1065 "../src/Core/PackageKitBackend.vala"
			_tmp37_ = _tmp36_;
#line 1065 "../src/Core/PackageKitBackend.vala"
			_tmp37__length1 = 2;
#line 1065 "../src/Core/PackageKitBackend.vala"
			_tmp38_ = pk_task_get_details_sync ((PkTask*) _tmp32_, _tmp37_, NULL, _____lambda10__pk_progress_callback, self, &_inner_error0_);
#line 1065 "../src/Core/PackageKitBackend.vala"
			_tmp39_ = _tmp38_;
#line 1065 "../src/Core/PackageKitBackend.vala"
			_tmp37_ = (_vala_array_free (_tmp37_, _tmp37__length1, (GDestroyNotify) g_free), NULL);
#line 1065 "../src/Core/PackageKitBackend.vala"
			details = _tmp39_;
#line 1065 "../src/Core/PackageKitBackend.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11312 "PackageKitBackend.c"
				goto __catch1_g_error;
			}
#line 1066 "../src/Core/PackageKitBackend.vala"
			_tmp40_ = details;
#line 1066 "../src/Core/PackageKitBackend.vala"
			_tmp41_ = pk_results_get_details_array (_tmp40_);
#line 1066 "../src/Core/PackageKitBackend.vala"
			_tmp42_ = _tmp41_;
#line 1066 "../src/Core/PackageKitBackend.vala"
			g_ptr_array_foreach (_tmp42_, _____lambda11__gfunc, _data64_);
#line 1066 "../src/Core/PackageKitBackend.vala"
			_g_ptr_array_unref0 (_tmp42_);
#line 1064 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (details);
#line 11327 "PackageKitBackend.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			PkPackage* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			GError* _tmp47_;
			const gchar* _tmp48_;
#line 1064 "../src/Core/PackageKitBackend.vala"
			e = _inner_error0_;
#line 1064 "../src/Core/PackageKitBackend.vala"
			_inner_error0_ = NULL;
#line 1075 "../src/Core/PackageKitBackend.vala"
			_tmp43_ = _data64_->pk_package;
#line 1075 "../src/Core/PackageKitBackend.vala"
			g_object_get (_tmp43_, "package-id", &_tmp44_, NULL);
#line 1075 "../src/Core/PackageKitBackend.vala"
			_tmp45_ = _tmp44_;
#line 1075 "../src/Core/PackageKitBackend.vala"
			_tmp46_ = _tmp45_;
#line 1075 "../src/Core/PackageKitBackend.vala"
			_tmp47_ = e;
#line 1075 "../src/Core/PackageKitBackend.vala"
			_tmp48_ = _tmp47_->message;
#line 1075 "../src/Core/PackageKitBackend.vala"
			g_warning ("PackageKitBackend.vala:1075: Unable to get details for package %s: %s", _tmp46_, _tmp48_);
#line 1075 "../src/Core/PackageKitBackend.vala"
			_g_free0 (_tmp46_);
#line 1064 "../src/Core/PackageKitBackend.vala"
			_g_error_free0 (e);
#line 11361 "PackageKitBackend.c"
		}
		__finally1:
#line 1064 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1064 "../src/Core/PackageKitBackend.vala"
			g_propagate_error (error, _inner_error0_);
#line 1064 "../src/Core/PackageKitBackend.vala"
			_g_free0 (name);
#line 1064 "../src/Core/PackageKitBackend.vala"
			block64_data_unref (_data64_);
#line 1064 "../src/Core/PackageKitBackend.vala"
			_data64_ = NULL;
#line 1064 "../src/Core/PackageKitBackend.vala"
			return NULL;
#line 11376 "PackageKitBackend.c"
		}
	}
#line 1079 "../src/Core/PackageKitBackend.vala"
	_tmp49_ = _data64_->pk_package;
#line 1079 "../src/Core/PackageKitBackend.vala"
	if (_tmp49_ == NULL) {
#line 11383 "PackageKitBackend.c"
		GError* _tmp50_;
#line 1080 "../src/Core/PackageKitBackend.vala"
		_tmp50_ = g_error_new_literal (PACKAGE_KIT_BACKEND_ERROR, PACKAGE_KIT_BACKEND_ERROR_PACKAGE_NOT_FOUND, "Package not found");
#line 1080 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = _tmp50_;
#line 1080 "../src/Core/PackageKitBackend.vala"
		g_propagate_error (error, _inner_error0_);
#line 1080 "../src/Core/PackageKitBackend.vala"
		_g_free0 (name);
#line 1080 "../src/Core/PackageKitBackend.vala"
		block64_data_unref (_data64_);
#line 1080 "../src/Core/PackageKitBackend.vala"
		_data64_ = NULL;
#line 1080 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 11399 "PackageKitBackend.c"
	}
#line 1083 "../src/Core/PackageKitBackend.vala"
	_tmp51_ = _data64_->pk_package;
#line 1083 "../src/Core/PackageKitBackend.vala"
	_tmp52_ = _g_object_ref0 (_tmp51_);
#line 1083 "../src/Core/PackageKitBackend.vala"
	result = _tmp52_;
#line 1083 "../src/Core/PackageKitBackend.vala"
	_g_free0 (name);
#line 1083 "../src/Core/PackageKitBackend.vala"
	block64_data_unref (_data64_);
#line 1083 "../src/Core/PackageKitBackend.vala"
	_data64_ = NULL;
#line 1083 "../src/Core/PackageKitBackend.vala"
	return result;
#line 11415 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_update_multiple_package_state_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendUpdateMultiplePackageStateData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->packages);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendUpdateMultiplePackageStateData, _data_);
#line 11429 "PackageKitBackend.c"
}

void
app_center_core_package_kit_backend_update_multiple_package_state (AppCenterCorePackageKitBackend* self,
                                                                   GeeCollection* packages,
                                                                   GAsyncReadyCallback _callback_,
                                                                   gpointer _user_data_)
{
	AppCenterCorePackageKitBackendUpdateMultiplePackageStateData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	GeeCollection* _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (packages != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendUpdateMultiplePackageStateData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_update_multiple_package_state_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (packages);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->packages);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->packages = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_update_multiple_package_state_co (_data_);
#line 11463 "PackageKitBackend.c"
}

void
app_center_core_package_kit_backend_update_multiple_package_state_finish (AppCenterCorePackageKitBackend* self,
                                                                          GAsyncResult* _res_,
                                                                          GError** error)
{
	AppCenterCorePackageKitBackendUpdateMultiplePackageStateData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 24 "../src/Core/PackageKitBackend.vala"
		return;
#line 11478 "PackageKitBackend.c"
	}
}

static void
_vala_array_add18 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1090 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 1090 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1090 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11494 "PackageKitBackend.c"
	}
#line 1090 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 1090 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 11500 "PackageKitBackend.c"
}

static void
_vala_array_add19 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1098 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 1098 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1098 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11515 "PackageKitBackend.c"
	}
#line 1098 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 1098 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 11521 "PackageKitBackend.c"
}

static void
___lambda84_ (AppCenterCorePackageKitBackend* self)
{
}

static void
____lambda84__pk_progress_callback (PkProgress* progress,
                                    PkProgressType type,
                                    gpointer self)
{
#line 1103 "../src/Core/PackageKitBackend.vala"
	___lambda84_ ((AppCenterCorePackageKitBackend*) self);
#line 11536 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_update_multiple_package_state_ready (GObject* source_object,
                                                                         GAsyncResult* _res_,
                                                                         gpointer _user_data_)
{
	AppCenterCorePackageKitBackendUpdateMultiplePackageStateData* _data_;
#line 1103 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 1103 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 1103 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 1103 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_update_multiple_package_state_co (_data_);
#line 11553 "PackageKitBackend.c"
}

static void
___lambda85_ (AppCenterCorePackageKitBackend* self,
              PkPackage* pk_package)
{
	AppCenterCorePackage* _tmp0_;
	AppCenterCorePackage* _tmp1_;
#line 1105 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (pk_package != NULL);
#line 1106 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_package_kit_backend_populate_basic_package_details (self, pk_package);
#line 1106 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 1106 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_tmp1_);
#line 11570 "PackageKitBackend.c"
}

static void
____lambda85__gfunc (gconstpointer data,
                     gpointer self)
{
#line 1105 "../src/Core/PackageKitBackend.vala"
	___lambda85_ ((AppCenterCorePackageKitBackend*) self, (PkPackage*) data);
#line 11579 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_update_multiple_package_state_co (AppCenterCorePackageKitBackendUpdateMultiplePackageStateData* _data_)
{
#line 1086 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 1086 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 11589 "PackageKitBackend.c"
		goto _state_0;
#line 1086 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 11593 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 1086 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 11598 "PackageKitBackend.c"
	}
	_state_0:
#line 1087 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 1087 "../src/Core/PackageKitBackend.vala"
	_data_->query = _data_->_tmp0_;
#line 1087 "../src/Core/PackageKitBackend.vala"
	_data_->query_length1 = 0;
#line 1087 "../src/Core/PackageKitBackend.vala"
	_data_->_query_size_ = _data_->query_length1;
#line 11609 "PackageKitBackend.c"
	{
#line 1088 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp1_ = gee_iterable_iterator ((GeeIterable*) _data_->packages);
#line 1088 "../src/Core/PackageKitBackend.vala"
		_data_->_app_it = _data_->_tmp1_;
#line 1088 "../src/Core/PackageKitBackend.vala"
		while (TRUE) {
#line 1088 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp2_ = _data_->_app_it;
#line 1088 "../src/Core/PackageKitBackend.vala"
			if (!gee_iterator_next (_data_->_tmp2_)) {
#line 1088 "../src/Core/PackageKitBackend.vala"
				break;
#line 11623 "PackageKitBackend.c"
			}
#line 1088 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp3_ = _data_->_app_it;
#line 1088 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp4_ = gee_iterator_get (_data_->_tmp3_);
#line 1088 "../src/Core/PackageKitBackend.vala"
			_data_->app = (AppCenterCorePackage*) _data_->_tmp4_;
#line 1089 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp5_ = _data_->app;
#line 1089 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp6_ = app_center_core_package_get_backend (_data_->_tmp5_);
#line 1089 "../src/Core/PackageKitBackend.vala"
			_data_->_tmp7_ = _data_->_tmp6_;
#line 1089 "../src/Core/PackageKitBackend.vala"
			if (_data_->_tmp7_ == G_TYPE_CHECK_INSTANCE_CAST (_data_->self, APP_CENTER_CORE_TYPE_BACKEND, AppCenterCoreBackend)) {
#line 1090 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp8_ = _data_->app;
#line 1090 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp9_ = app_center_core_package_get_component (_data_->_tmp8_);
#line 1090 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp10_ = _data_->_tmp9_;
#line 1090 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp12_ = _data_->_tmp11_ = as_component_get_pkgnames (_data_->_tmp10_);
#line 1090 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp13_ = _data_->_tmp12_[0];
#line 1090 "../src/Core/PackageKitBackend.vala"
				_data_->_tmp14_ = g_strdup (_data_->_tmp13_);
#line 1090 "../src/Core/PackageKitBackend.vala"
				_vala_array_add18 (&_data_->query, &_data_->query_length1, &_data_->_query_size_, _data_->_tmp14_);
#line 11653 "PackageKitBackend.c"
			}
#line 1088 "../src/Core/PackageKitBackend.vala"
			_g_object_unref0 (_data_->app);
#line 11657 "PackageKitBackend.c"
		}
#line 1088 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data_->_app_it);
#line 11661 "PackageKitBackend.c"
	}
#line 1094 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp15_ = _data_->query;
#line 1094 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp15__length1 = _data_->query_length1;
#line 1094 "../src/Core/PackageKitBackend.vala"
	if (_data_->_tmp15__length1 < 1) {
#line 1095 "../src/Core/PackageKitBackend.vala"
		_data_->query = (_vala_array_free (_data_->query, _data_->query_length1, (GDestroyNotify) g_free), NULL);
#line 1095 "../src/Core/PackageKitBackend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1095 "../src/Core/PackageKitBackend.vala"
		if (_data_->_state_ != 0) {
#line 1095 "../src/Core/PackageKitBackend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 1095 "../src/Core/PackageKitBackend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 11679 "PackageKitBackend.c"
			}
		}
#line 1095 "../src/Core/PackageKitBackend.vala"
		g_object_unref (_data_->_async_result);
#line 1095 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 11686 "PackageKitBackend.c"
	}
#line 1098 "../src/Core/PackageKitBackend.vala"
	_vala_array_add19 (&_data_->query, &_data_->query_length1, &_data_->_query_size_, NULL);
#line 1100 "../src/Core/PackageKitBackend.vala"
	_data_->filter = pk_bitfield_from_enums ((gint) PK_FILTER_ENUM_NONE, -1);
#line 11692 "PackageKitBackend.c"
	{
#line 1103 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp16_ = app_center_core_package_kit_backend_client;
#line 1103 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp17_ = _data_->query;
#line 1103 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp17__length1 = _data_->query_length1;
#line 1103 "../src/Core/PackageKitBackend.vala"
		_data_->_state_ = 1;
#line 1103 "../src/Core/PackageKitBackend.vala"
		pk_task_search_names_async ((PkTask*) _data_->_tmp16_, _data_->filter, _data_->_tmp17_, NULL, ____lambda84__pk_progress_callback, _data_->self, app_center_core_package_kit_backend_update_multiple_package_state_ready, _data_);
#line 1103 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 11706 "PackageKitBackend.c"
		_state_1:
#line 1103 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp18_ = pk_task_generic_finish ((PkTask*) _data_->_tmp16_, _data_->_res_, &_data_->_inner_error0_);
#line 1103 "../src/Core/PackageKitBackend.vala"
		_data_->results = _data_->_tmp18_;
#line 1103 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 11714 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 1104 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp19_ = _data_->results;
#line 1104 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp20_ = pk_results_get_package_array (_data_->_tmp19_);
#line 1104 "../src/Core/PackageKitBackend.vala"
		_data_->array = _data_->_tmp20_;
#line 1105 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp21_ = _data_->array;
#line 1105 "../src/Core/PackageKitBackend.vala"
		g_ptr_array_foreach (_data_->_tmp21_, ____lambda85__gfunc, _data_->self);
#line 1102 "../src/Core/PackageKitBackend.vala"
		_g_ptr_array_unref0 (_data_->array);
#line 1102 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data_->results);
#line 11731 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1102 "../src/Core/PackageKitBackend.vala"
		_data_->e = _data_->_inner_error0_;
#line 1102 "../src/Core/PackageKitBackend.vala"
		_data_->_inner_error0_ = NULL;
#line 1109 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp22_ = _data_->e;
#line 1109 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp23_ = _g_error_copy0 (_data_->_tmp22_);
#line 1109 "../src/Core/PackageKitBackend.vala"
		_data_->_inner_error0_ = _data_->_tmp23_;
#line 1109 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (_data_->e);
#line 11748 "PackageKitBackend.c"
		goto __finally0;
	}
	__finally0:
#line 1102 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1102 "../src/Core/PackageKitBackend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1102 "../src/Core/PackageKitBackend.vala"
		_data_->query = (_vala_array_free (_data_->query, _data_->query_length1, (GDestroyNotify) g_free), NULL);
#line 1102 "../src/Core/PackageKitBackend.vala"
		g_object_unref (_data_->_async_result);
#line 1102 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 11762 "PackageKitBackend.c"
	}
#line 1086 "../src/Core/PackageKitBackend.vala"
	_data_->query = (_vala_array_free (_data_->query, _data_->query_length1, (GDestroyNotify) g_free), NULL);
#line 1086 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1086 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 1086 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1086 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 11774 "PackageKitBackend.c"
		}
	}
#line 1086 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 1086 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 11781 "PackageKitBackend.c"
}

static AppCenterCorePackage*
app_center_core_package_kit_backend_populate_basic_package_details (AppCenterCorePackageKitBackend* self,
                                                                    PkPackage* pk_package)
{
	AppCenterCorePackage* package = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	AppCenterCorePackage* _tmp3_;
	AppCenterCorePackage* _tmp4_;
	const gchar* _tmp5_;
	AppCenterCorePackage* _tmp6_;
	AsComponent* _tmp7_;
	AsComponent* _tmp8_;
	const gchar* _tmp9_;
	AppCenterCorePackage* _tmp12_;
	AsComponent* _tmp13_;
	AsComponent* _tmp14_;
	const gchar* _tmp15_;
	PkInfoEnum _tmp18_;
	PkInfoEnum _tmp19_;
	AppCenterCorePackage* result;
#line 1113 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1113 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (pk_package != NULL, NULL);
#line 1114 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = self->priv->package_list;
#line 1114 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = pk_package_get_name (pk_package);
#line 1114 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 1114 "../src/Core/PackageKitBackend.vala"
	package = (AppCenterCorePackage*) _tmp2_;
#line 1115 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = package;
#line 1115 "../src/Core/PackageKitBackend.vala"
	if (_tmp3_ == NULL) {
#line 1116 "../src/Core/PackageKitBackend.vala"
		result = NULL;
#line 1116 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (package);
#line 1116 "../src/Core/PackageKitBackend.vala"
		return result;
#line 11828 "PackageKitBackend.c"
	}
#line 1121 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = package;
#line 1121 "../src/Core/PackageKitBackend.vala"
	_tmp5_ = pk_package_get_version (pk_package);
#line 1121 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_set_latest_version (_tmp4_, _tmp5_);
#line 1124 "../src/Core/PackageKitBackend.vala"
	_tmp6_ = package;
#line 1124 "../src/Core/PackageKitBackend.vala"
	_tmp7_ = app_center_core_package_get_component (_tmp6_);
#line 1124 "../src/Core/PackageKitBackend.vala"
	_tmp8_ = _tmp7_;
#line 1124 "../src/Core/PackageKitBackend.vala"
	_tmp9_ = as_component_get_name (_tmp8_);
#line 1124 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_tmp9_ == NULL)) {
#line 11846 "PackageKitBackend.c"
		AppCenterCorePackage* _tmp10_;
		const gchar* _tmp11_;
#line 1125 "../src/Core/PackageKitBackend.vala"
		_tmp10_ = package;
#line 1125 "../src/Core/PackageKitBackend.vala"
		_tmp11_ = pk_package_get_name (pk_package);
#line 1125 "../src/Core/PackageKitBackend.vala"
		app_center_core_package_set_name (_tmp10_, _tmp11_);
#line 11855 "PackageKitBackend.c"
	}
#line 1128 "../src/Core/PackageKitBackend.vala"
	_tmp12_ = package;
#line 1128 "../src/Core/PackageKitBackend.vala"
	_tmp13_ = app_center_core_package_get_component (_tmp12_);
#line 1128 "../src/Core/PackageKitBackend.vala"
	_tmp14_ = _tmp13_;
#line 1128 "../src/Core/PackageKitBackend.vala"
	_tmp15_ = as_component_get_summary (_tmp14_);
#line 1128 "../src/Core/PackageKitBackend.vala"
	if (_tmp15_ == NULL) {
#line 11867 "PackageKitBackend.c"
		AppCenterCorePackage* _tmp16_;
		const gchar* _tmp17_;
#line 1129 "../src/Core/PackageKitBackend.vala"
		_tmp16_ = package;
#line 1129 "../src/Core/PackageKitBackend.vala"
		_tmp17_ = pk_package_get_summary (pk_package);
#line 1129 "../src/Core/PackageKitBackend.vala"
		app_center_core_package_set_summary (_tmp16_, _tmp17_);
#line 11876 "PackageKitBackend.c"
	}
#line 1132 "../src/Core/PackageKitBackend.vala"
	_tmp18_ = pk_package_get_info (pk_package);
#line 1132 "../src/Core/PackageKitBackend.vala"
	_tmp19_ = _tmp18_;
#line 1132 "../src/Core/PackageKitBackend.vala"
	if (_tmp19_ == PK_INFO_ENUM_INSTALLED) {
#line 11884 "PackageKitBackend.c"
		AppCenterCorePackage* _tmp20_;
#line 1133 "../src/Core/PackageKitBackend.vala"
		_tmp20_ = package;
#line 1133 "../src/Core/PackageKitBackend.vala"
		app_center_core_package_mark_installed (_tmp20_);
#line 11890 "PackageKitBackend.c"
	}
#line 1136 "../src/Core/PackageKitBackend.vala"
	result = package;
#line 1136 "../src/Core/PackageKitBackend.vala"
	return result;
#line 11896 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_package_details_internal (AppCenterCorePackageKitBackend* self,
                                                                  AppCenterCoreJob* job)
{
	AppCenterCoreGetPackageDetailsArgs* args = NULL;
	AppCenterCoreJobArgs* _tmp0_;
	AppCenterCoreJobArgs* _tmp1_;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreGetPackageDetailsArgs* _tmp2_;
	AppCenterCorePackage* _tmp3_;
	PkPackage* pk_package = NULL;
	AppCenterCorePackageDetails* _result_ = NULL;
	AppCenterCorePackageDetails* _tmp9_;
	AppCenterCorePackageDetails* _tmp10_;
	PkPackage* _tmp11_;
	const gchar* _tmp12_;
	AppCenterCorePackageDetails* _tmp13_;
	PkPackage* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	AppCenterCorePackageDetails* _tmp18_;
	PkPackage* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	AppCenterCorePackageDetails* _tmp22_;
	PkPackage* _tmp23_;
	const gchar* _tmp24_;
	GValue _tmp25_ = {0};
	AppCenterCorePackageDetails* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 1139 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 1139 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (job != NULL);
#line 1140 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_job_get_args (job);
#line 1140 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 1140 "../src/Core/PackageKitBackend.vala"
	args = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, APP_CENTER_CORE_TYPE_GET_PACKAGE_DETAILS_ARGS, AppCenterCoreGetPackageDetailsArgs);
#line 1141 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = args;
#line 1141 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _tmp2_->package;
#line 1141 "../src/Core/PackageKitBackend.vala"
	package = _tmp3_;
#line 11946 "PackageKitBackend.c"
	{
		PkPackage* _tmp4_ = NULL;
		AppCenterCorePackage* _tmp5_;
		PkPackage* _tmp6_;
		PkPackage* _tmp7_;
#line 1145 "../src/Core/PackageKitBackend.vala"
		_tmp5_ = package;
#line 1145 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = app_center_core_package_kit_backend_get_package_internal (self, _tmp5_, &_inner_error0_);
#line 1145 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = _tmp6_;
#line 1145 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11960 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 1145 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = _tmp4_;
#line 1145 "../src/Core/PackageKitBackend.vala"
		_tmp4_ = NULL;
#line 1145 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 1145 "../src/Core/PackageKitBackend.vala"
		pk_package = _tmp7_;
#line 1144 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp4_);
#line 11973 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
#line 1144 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 1144 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 1147 "../src/Core/PackageKitBackend.vala"
		_tmp8_ = e;
#line 1147 "../src/Core/PackageKitBackend.vala"
		app_center_core_job_set_error (job, _tmp8_);
#line 1148 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 1149 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 1149 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 1149 "../src/Core/PackageKitBackend.vala"
		return;
#line 11996 "PackageKitBackend.c"
	}
	__finally0:
#line 1144 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1144 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 1144 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1144 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 1144 "../src/Core/PackageKitBackend.vala"
		return;
#line 12009 "PackageKitBackend.c"
	}
#line 1152 "../src/Core/PackageKitBackend.vala"
	_tmp9_ = app_center_core_package_details_new ();
#line 1152 "../src/Core/PackageKitBackend.vala"
	_result_ = _tmp9_;
#line 1153 "../src/Core/PackageKitBackend.vala"
	_tmp10_ = _result_;
#line 1153 "../src/Core/PackageKitBackend.vala"
	_tmp11_ = pk_package;
#line 1153 "../src/Core/PackageKitBackend.vala"
	_tmp12_ = pk_package_get_name (_tmp11_);
#line 1153 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_details_set_name (_tmp10_, _tmp12_);
#line 1154 "../src/Core/PackageKitBackend.vala"
	_tmp13_ = _result_;
#line 1154 "../src/Core/PackageKitBackend.vala"
	_tmp14_ = pk_package;
#line 1154 "../src/Core/PackageKitBackend.vala"
	g_object_get (_tmp14_, "description", &_tmp15_, NULL);
#line 1154 "../src/Core/PackageKitBackend.vala"
	_tmp16_ = _tmp15_;
#line 1154 "../src/Core/PackageKitBackend.vala"
	_tmp17_ = _tmp16_;
#line 1154 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_details_set_description (_tmp13_, _tmp17_);
#line 1154 "../src/Core/PackageKitBackend.vala"
	_g_free0 (_tmp17_);
#line 1155 "../src/Core/PackageKitBackend.vala"
	_tmp18_ = _result_;
#line 1155 "../src/Core/PackageKitBackend.vala"
	_tmp19_ = pk_package;
#line 1155 "../src/Core/PackageKitBackend.vala"
	_tmp20_ = pk_package_get_summary (_tmp19_);
#line 1155 "../src/Core/PackageKitBackend.vala"
	_tmp21_ = _tmp20_;
#line 1155 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_details_set_summary (_tmp18_, _tmp21_);
#line 1156 "../src/Core/PackageKitBackend.vala"
	_tmp22_ = _result_;
#line 1156 "../src/Core/PackageKitBackend.vala"
	_tmp23_ = pk_package;
#line 1156 "../src/Core/PackageKitBackend.vala"
	_tmp24_ = pk_package_get_version (_tmp23_);
#line 1156 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_details_set_version (_tmp22_, _tmp24_);
#line 1158 "../src/Core/PackageKitBackend.vala"
	g_value_init (&_tmp25_, G_TYPE_OBJECT);
#line 1158 "../src/Core/PackageKitBackend.vala"
	G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 1158 "../src/Core/PackageKitBackend.vala"
	job->result = _tmp25_;
#line 1159 "../src/Core/PackageKitBackend.vala"
	_tmp26_ = _result_;
#line 1159 "../src/Core/PackageKitBackend.vala"
	_result_ = NULL;
#line 1159 "../src/Core/PackageKitBackend.vala"
	g_value_take_object (&job->result, (GObject*) _tmp26_);
#line 1160 "../src/Core/PackageKitBackend.vala"
	g_signal_emit_by_name (job, "results-ready");
#line 1139 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_result_);
#line 1139 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (pk_package);
#line 12073 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_get_package_details_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendGetPackageDetailsData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendGetPackageDetailsData, _data_);
#line 12089 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_get_package_details (AppCenterCoreBackend* base,
                                                              AppCenterCorePackage* package,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_)
{
	AppCenterCorePackageKitBackend * self;
	AppCenterCorePackageKitBackendGetPackageDetailsData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	AppCenterCorePackage* _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (package != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendGetPackageDetailsData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_real_get_package_details_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->package = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_get_package_details_co (_data_);
#line 12124 "PackageKitBackend.c"
}

static AppCenterCorePackageDetails*
app_center_core_package_kit_backend_get_package_details_finish (AppCenterCoreBackend* base,
                                                                GAsyncResult* _res_,
                                                                GError** error)
{
	AppCenterCorePackageDetails* result;
	AppCenterCorePackageKitBackendGetPackageDetailsData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 24 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 12140 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->result = NULL;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 12148 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_package_details_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_)
{
	AppCenterCorePackageKitBackendGetPackageDetailsData* _data_;
#line 1167 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 1167 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 1167 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 1167 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_get_package_details_co (_data_);
#line 12165 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_real_get_package_details_co (AppCenterCorePackageKitBackendGetPackageDetailsData* _data_)
{
#line 1163 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 1163 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 12175 "PackageKitBackend.c"
		goto _state_0;
#line 1163 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 12179 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 1163 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 12184 "PackageKitBackend.c"
	}
	_state_0:
#line 1164 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = app_center_core_get_package_details_args_new ();
#line 1164 "../src/Core/PackageKitBackend.vala"
	_data_->job_args = _data_->_tmp0_;
#line 1165 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = _data_->job_args;
#line 1165 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->package);
#line 1165 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp1_->package);
#line 1165 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_->package = _data_->_tmp2_;
#line 1167 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_ = _data_->job_args;
#line 1167 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 1;
#line 1167 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_launch_job (_data_->self, APP_CENTER_CORE_JOB_TYPE_GET_PACKAGE_DETAILS, (AppCenterCoreJobArgs*) _data_->_tmp3_, app_center_core_package_kit_backend_get_package_details_ready, _data_);
#line 1167 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 12207 "PackageKitBackend.c"
	_state_1:
#line 1167 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp4_ = app_center_core_package_kit_backend_launch_job_finish (_data_->self, _data_->_res_);
#line 1167 "../src/Core/PackageKitBackend.vala"
	_data_->job = _data_->_tmp4_;
#line 1168 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp5_ = _data_->job;
#line 1168 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp6_ = app_center_core_job_get_error (_data_->_tmp5_);
#line 1168 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 1168 "../src/Core/PackageKitBackend.vala"
	if (_data_->_tmp7_ != NULL) {
#line 1169 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp8_ = _data_->job;
#line 1169 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp9_ = app_center_core_job_get_error (_data_->_tmp8_);
#line 1169 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 1169 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp11_ = _g_error_copy0 (_data_->_tmp10_);
#line 1169 "../src/Core/PackageKitBackend.vala"
		_data_->_inner_error0_ = _data_->_tmp11_;
#line 1169 "../src/Core/PackageKitBackend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1169 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data_->job);
#line 1169 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (_data_->job_args);
#line 1169 "../src/Core/PackageKitBackend.vala"
		g_object_unref (_data_->_async_result);
#line 1169 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 12241 "PackageKitBackend.c"
	}
#line 1172 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp12_ = _data_->job;
#line 1172 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp13_ = g_value_get_object (&_data_->_tmp12_->result);
#line 1172 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, APP_CENTER_CORE_TYPE_PACKAGE_DETAILS, AppCenterCorePackageDetails));
#line 1172 "../src/Core/PackageKitBackend.vala"
	_data_->result = _data_->_tmp14_;
#line 1172 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->job);
#line 1172 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (_data_->job_args);
#line 1172 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1172 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 1172 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1172 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 12263 "PackageKitBackend.c"
		}
	}
#line 1172 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 1172 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 12270 "PackageKitBackend.c"
}

static Block65Data*
block65_data_ref (Block65Data* _data65_)
{
#line 1175 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data65_->_ref_count_);
#line 1175 "../src/Core/PackageKitBackend.vala"
	return _data65_;
#line 12280 "PackageKitBackend.c"
}

static void
block65_data_unref (void * _userdata_)
{
	Block65Data* _data65_;
	_data65_ = (Block65Data*) _userdata_;
#line 1175 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data65_->_ref_count_)) {
#line 12290 "PackageKitBackend.c"
		AppCenterCorePackageKitBackend* self;
#line 1175 "../src/Core/PackageKitBackend.vala"
		self = _data65_->self;
#line 1175 "../src/Core/PackageKitBackend.vala"
		_data65_->package_array = (_vala_array_free (_data65_->package_array, _data65_->package_array_length1, (GDestroyNotify) g_free), NULL);
#line 1175 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (self);
#line 1175 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block65Data, _data65_);
#line 12300 "PackageKitBackend.c"
	}
}

static void
___lambda79_ (AppCenterCorePackageKitBackend* self,
              PkProgress* p,
              PkProgressType t)
{
#line 1192 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (p != NULL);
#line 12311 "PackageKitBackend.c"
}

static void
____lambda79__pk_progress_callback (PkProgress* progress,
                                    PkProgressType type,
                                    gpointer self)
{
#line 1192 "../src/Core/PackageKitBackend.vala"
	___lambda79_ ((AppCenterCorePackageKitBackend*) self, progress, type);
#line 12321 "PackageKitBackend.c"
}

static void
_vala_array_add20 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 1195 "../src/Core/PackageKitBackend.vala"
	if ((*length) == (*size)) {
#line 1195 "../src/Core/PackageKitBackend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1195 "../src/Core/PackageKitBackend.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 12336 "PackageKitBackend.c"
	}
#line 1195 "../src/Core/PackageKitBackend.vala"
	(*array)[(*length)++] = value;
#line 1195 "../src/Core/PackageKitBackend.vala"
	(*array)[*length] = NULL;
#line 12342 "PackageKitBackend.c"
}

static void
___lambda80_ (Block65Data* _data65_,
              PkPackage* dep_package)
{
	AppCenterCorePackageKitBackend* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 1194 "../src/Core/PackageKitBackend.vala"
	self = _data65_->self;
#line 1194 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (dep_package != NULL);
#line 1195 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = pk_package_get_name (dep_package);
#line 1195 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1195 "../src/Core/PackageKitBackend.vala"
	_vala_array_add20 (&_data65_->package_array, &_data65_->package_array_length1, &_data65_->_package_array_size_, _tmp1_);
#line 12362 "PackageKitBackend.c"
}

static void
____lambda80__gfunc (gconstpointer data,
                     gpointer self)
{
#line 1194 "../src/Core/PackageKitBackend.vala"
	___lambda80_ (self, (PkPackage*) data);
#line 12371 "PackageKitBackend.c"
}

static gchar**
_vala_array_dup9 (gchar** self,
                  gssize length)
{
#line 1203 "../src/Core/PackageKitBackend.vala"
	if (length >= 0) {
#line 12380 "PackageKitBackend.c"
		gchar** result;
		gssize i;
#line 1203 "../src/Core/PackageKitBackend.vala"
		result = g_new0 (gchar*, length + 1);
#line 1203 "../src/Core/PackageKitBackend.vala"
		for (i = 0; i < length; i++) {
#line 12387 "PackageKitBackend.c"
			gchar* _tmp0_;
#line 1203 "../src/Core/PackageKitBackend.vala"
			_tmp0_ = g_strdup (self[i]);
#line 1203 "../src/Core/PackageKitBackend.vala"
			result[i] = _tmp0_;
#line 12393 "PackageKitBackend.c"
		}
#line 1203 "../src/Core/PackageKitBackend.vala"
		return result;
#line 12397 "PackageKitBackend.c"
	}
#line 1203 "../src/Core/PackageKitBackend.vala"
	return NULL;
#line 12401 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_package_dependencies_internal (AppCenterCorePackageKitBackend* self,
                                                                       AppCenterCoreJob* job)
{
	Block65Data* _data65_;
	AppCenterCoreGetPackageDependenciesArgs* args = NULL;
	AppCenterCoreJobArgs* _tmp0_;
	AppCenterCoreJobArgs* _tmp1_;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreGetPackageDependenciesArgs* _tmp2_;
	AppCenterCorePackage* _tmp3_;
	GCancellable* cancellable = NULL;
	AppCenterCoreGetPackageDependenciesArgs* _tmp4_;
	GCancellable* _tmp5_;
	PkPackage* pk_package = NULL;
	PkPackage* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	PkBitfield filters = 0ULL;
	GeeArrayList* _result_ = NULL;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar** _tmp25_;
	gint _tmp25__length1;
	GeeArrayList* _tmp26_;
	GValue _tmp27_ = {0};
	GeeArrayList* _tmp28_;
	GError* _inner_error0_ = NULL;
#line 1175 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 1175 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (job != NULL);
#line 1175 "../src/Core/PackageKitBackend.vala"
	_data65_ = g_slice_new0 (Block65Data);
#line 1175 "../src/Core/PackageKitBackend.vala"
	_data65_->_ref_count_ = 1;
#line 1175 "../src/Core/PackageKitBackend.vala"
	_data65_->self = g_object_ref (self);
#line 1176 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_job_get_args (job);
#line 1176 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 1176 "../src/Core/PackageKitBackend.vala"
	args = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, APP_CENTER_CORE_TYPE_GET_PACKAGE_DEPENDENCIES_ARGS, AppCenterCoreGetPackageDependenciesArgs);
#line 1177 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = args;
#line 1177 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _tmp2_->package;
#line 1177 "../src/Core/PackageKitBackend.vala"
	package = _tmp3_;
#line 1178 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = args;
#line 1178 "../src/Core/PackageKitBackend.vala"
	_tmp5_ = _tmp4_->cancellable;
#line 1178 "../src/Core/PackageKitBackend.vala"
	cancellable = _tmp5_;
#line 12461 "PackageKitBackend.c"
	{
		PkPackage* _tmp6_ = NULL;
		AppCenterCorePackage* _tmp7_;
		PkPackage* _tmp8_;
		PkPackage* _tmp9_;
#line 1182 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = package;
#line 1182 "../src/Core/PackageKitBackend.vala"
		_tmp8_ = app_center_core_package_kit_backend_get_package_internal (self, _tmp7_, &_inner_error0_);
#line 1182 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = _tmp8_;
#line 1182 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12475 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
#line 1182 "../src/Core/PackageKitBackend.vala"
		_tmp9_ = _tmp6_;
#line 1182 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = NULL;
#line 1182 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 1182 "../src/Core/PackageKitBackend.vala"
		pk_package = _tmp9_;
#line 1181 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_tmp6_);
#line 12488 "PackageKitBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
#line 1181 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 1181 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 1184 "../src/Core/PackageKitBackend.vala"
		_tmp10_ = e;
#line 1184 "../src/Core/PackageKitBackend.vala"
		app_center_core_job_set_error (job, _tmp10_);
#line 1185 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 1186 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 1186 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 1186 "../src/Core/PackageKitBackend.vala"
		block65_data_unref (_data65_);
#line 1186 "../src/Core/PackageKitBackend.vala"
		_data65_ = NULL;
#line 1186 "../src/Core/PackageKitBackend.vala"
		return;
#line 12515 "PackageKitBackend.c"
	}
	__finally0:
#line 1181 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1181 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 1181 "../src/Core/PackageKitBackend.vala"
		block65_data_unref (_data65_);
#line 1181 "../src/Core/PackageKitBackend.vala"
		_data65_ = NULL;
#line 1181 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1181 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 1181 "../src/Core/PackageKitBackend.vala"
		return;
#line 12532 "PackageKitBackend.c"
	}
#line 1189 "../src/Core/PackageKitBackend.vala"
	_tmp11_ = pk_package;
#line 1189 "../src/Core/PackageKitBackend.vala"
	g_object_get (_tmp11_, "package-id", &_tmp12_, NULL);
#line 1189 "../src/Core/PackageKitBackend.vala"
	_tmp13_ = _tmp12_;
#line 1189 "../src/Core/PackageKitBackend.vala"
	_tmp14_ = g_new0 (gchar*, 2 + 1);
#line 1189 "../src/Core/PackageKitBackend.vala"
	_tmp14_[0] = _tmp13_;
#line 1189 "../src/Core/PackageKitBackend.vala"
	_tmp14_[1] = NULL;
#line 1189 "../src/Core/PackageKitBackend.vala"
	_data65_->package_array = _tmp14_;
#line 1189 "../src/Core/PackageKitBackend.vala"
	_data65_->package_array_length1 = 2;
#line 1189 "../src/Core/PackageKitBackend.vala"
	_data65_->_package_array_size_ = _data65_->package_array_length1;
#line 1190 "../src/Core/PackageKitBackend.vala"
	filters = pk_bitfield_from_enums ((gint) PK_FILTER_ENUM_ARCH, PK_FILTER_ENUM_NEWEST, -1);
#line 12554 "PackageKitBackend.c"
	{
		PkResults* deps_result = NULL;
		AppCenterCoreTask* _tmp15_;
		gchar** _tmp16_;
		gint _tmp16__length1;
		GCancellable* _tmp17_;
		PkResults* _tmp18_;
		gchar** _tmp19_;
		PkResults* _tmp20_;
		GPtrArray* _tmp21_;
		GPtrArray* _tmp22_;
#line 1192 "../src/Core/PackageKitBackend.vala"
		_tmp15_ = app_center_core_package_kit_backend_client;
#line 1192 "../src/Core/PackageKitBackend.vala"
		_tmp16_ = _data65_->package_array;
#line 1192 "../src/Core/PackageKitBackend.vala"
		_tmp16__length1 = _data65_->package_array_length1;
#line 1192 "../src/Core/PackageKitBackend.vala"
		_tmp17_ = cancellable;
#line 1192 "../src/Core/PackageKitBackend.vala"
		_tmp18_ = pk_client_depends_on ((PkClient*) _tmp15_, filters, _tmp16_, TRUE, _tmp17_, ____lambda79__pk_progress_callback, self, &_inner_error0_);
#line 1192 "../src/Core/PackageKitBackend.vala"
		deps_result = _tmp18_;
#line 1192 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12580 "PackageKitBackend.c"
			goto __catch1_g_error;
		}
#line 1193 "../src/Core/PackageKitBackend.vala"
		_tmp19_ = g_new0 (gchar*, 0 + 1);
#line 1193 "../src/Core/PackageKitBackend.vala"
		_data65_->package_array = (_vala_array_free (_data65_->package_array, _data65_->package_array_length1, (GDestroyNotify) g_free), NULL);
#line 1193 "../src/Core/PackageKitBackend.vala"
		_data65_->package_array = _tmp19_;
#line 1193 "../src/Core/PackageKitBackend.vala"
		_data65_->package_array_length1 = 0;
#line 1193 "../src/Core/PackageKitBackend.vala"
		_data65_->_package_array_size_ = _data65_->package_array_length1;
#line 1194 "../src/Core/PackageKitBackend.vala"
		_tmp20_ = deps_result;
#line 1194 "../src/Core/PackageKitBackend.vala"
		_tmp21_ = pk_results_get_package_array (_tmp20_);
#line 1194 "../src/Core/PackageKitBackend.vala"
		_tmp22_ = _tmp21_;
#line 1194 "../src/Core/PackageKitBackend.vala"
		g_ptr_array_foreach (_tmp22_, ____lambda80__gfunc, _data65_);
#line 1194 "../src/Core/PackageKitBackend.vala"
		_g_ptr_array_unref0 (_tmp22_);
#line 1191 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (deps_result);
#line 12605 "PackageKitBackend.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
#line 1191 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 1191 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 1198 "../src/Core/PackageKitBackend.vala"
		_tmp23_ = e;
#line 1198 "../src/Core/PackageKitBackend.vala"
		app_center_core_job_set_error (job, _tmp23_);
#line 1199 "../src/Core/PackageKitBackend.vala"
		g_signal_emit_by_name (job, "results-ready");
#line 1200 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 1200 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 1200 "../src/Core/PackageKitBackend.vala"
		block65_data_unref (_data65_);
#line 1200 "../src/Core/PackageKitBackend.vala"
		_data65_ = NULL;
#line 1200 "../src/Core/PackageKitBackend.vala"
		return;
#line 12632 "PackageKitBackend.c"
	}
	__finally1:
#line 1191 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1191 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (pk_package);
#line 1191 "../src/Core/PackageKitBackend.vala"
		block65_data_unref (_data65_);
#line 1191 "../src/Core/PackageKitBackend.vala"
		_data65_ = NULL;
#line 1191 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1191 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 1191 "../src/Core/PackageKitBackend.vala"
		return;
#line 12649 "PackageKitBackend.c"
	}
#line 1203 "../src/Core/PackageKitBackend.vala"
	_tmp24_ = _data65_->package_array;
#line 1203 "../src/Core/PackageKitBackend.vala"
	_tmp24__length1 = _data65_->package_array_length1;
#line 1203 "../src/Core/PackageKitBackend.vala"
	_tmp25_ = (_tmp24_ != NULL) ? _vala_array_dup9 (_tmp24_, _tmp24__length1) : _tmp24_;
#line 1203 "../src/Core/PackageKitBackend.vala"
	_tmp25__length1 = _tmp24__length1;
#line 1203 "../src/Core/PackageKitBackend.vala"
	_tmp26_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp25_, _tmp25__length1, NULL, NULL, NULL);
#line 1203 "../src/Core/PackageKitBackend.vala"
	_result_ = _tmp26_;
#line 1205 "../src/Core/PackageKitBackend.vala"
	g_value_init (&_tmp27_, G_TYPE_OBJECT);
#line 1205 "../src/Core/PackageKitBackend.vala"
	G_IS_VALUE (&job->result) ? (g_value_unset (&job->result), NULL) : NULL;
#line 1205 "../src/Core/PackageKitBackend.vala"
	job->result = _tmp27_;
#line 1206 "../src/Core/PackageKitBackend.vala"
	_tmp28_ = _result_;
#line 1206 "../src/Core/PackageKitBackend.vala"
	_result_ = NULL;
#line 1206 "../src/Core/PackageKitBackend.vala"
	g_value_take_object (&job->result, (GObject*) _tmp28_);
#line 1207 "../src/Core/PackageKitBackend.vala"
	g_signal_emit_by_name (job, "results-ready");
#line 1175 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_result_);
#line 1175 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (pk_package);
#line 1175 "../src/Core/PackageKitBackend.vala"
	block65_data_unref (_data65_);
#line 1175 "../src/Core/PackageKitBackend.vala"
	_data65_ = NULL;
#line 12685 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_package_dependencies_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendGetPackageDependenciesData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendGetPackageDependenciesData, _data_);
#line 12703 "PackageKitBackend.c"
}

void
app_center_core_package_kit_backend_get_package_dependencies (AppCenterCorePackageKitBackend* self,
                                                              AppCenterCorePackage* package,
                                                              GCancellable* cancellable,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_)
{
	AppCenterCorePackageKitBackendGetPackageDependenciesData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	AppCenterCorePackage* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (package != NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendGetPackageDependenciesData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_get_package_dependencies_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->package);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->package = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_get_package_dependencies_co (_data_);
#line 12745 "PackageKitBackend.c"
}

GeeArrayList*
app_center_core_package_kit_backend_get_package_dependencies_finish (AppCenterCorePackageKitBackend* self,
                                                                     GAsyncResult* _res_,
                                                                     GError** error)
{
	GeeArrayList* result;
	AppCenterCorePackageKitBackendGetPackageDependenciesData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 24 "../src/Core/PackageKitBackend.vala"
		return NULL;
#line 12761 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->result = NULL;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 12769 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_get_package_dependencies_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_)
{
	AppCenterCorePackageKitBackendGetPackageDependenciesData* _data_;
#line 1216 "../src/Core/PackageKitBackend.vala"
	_data_ = _user_data_;
#line 1216 "../src/Core/PackageKitBackend.vala"
	_data_->_source_object_ = source_object;
#line 1216 "../src/Core/PackageKitBackend.vala"
	_data_->_res_ = _res_;
#line 1216 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_get_package_dependencies_co (_data_);
#line 12786 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_get_package_dependencies_co (AppCenterCorePackageKitBackendGetPackageDependenciesData* _data_)
{
#line 1210 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 1210 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 12796 "PackageKitBackend.c"
		goto _state_0;
#line 1210 "../src/Core/PackageKitBackend.vala"
		case 1:
#line 12800 "PackageKitBackend.c"
		goto _state_1;
		default:
#line 1210 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 12805 "PackageKitBackend.c"
	}
	_state_0:
#line 1211 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp0_ = _g_object_ref0 (_data_->package);
#line 1211 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp1_ = _g_object_ref0 (_data_->cancellable);
#line 1211 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = NULL;
#line 1211 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_ = app_center_core_get_package_dependencies_args_new ();
#line 1211 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp2_->package);
#line 1211 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_->package = _data_->_tmp0_;
#line 1211 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->_tmp2_->cancellable);
#line 1211 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp2_->cancellable = _data_->_tmp1_;
#line 1211 "../src/Core/PackageKitBackend.vala"
	_data_->job_args = _data_->_tmp2_;
#line 1216 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp3_ = _data_->job_args;
#line 1216 "../src/Core/PackageKitBackend.vala"
	_data_->_state_ = 1;
#line 1216 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_launch_job (_data_->self, APP_CENTER_CORE_JOB_TYPE_GET_PACKAGE_DEPENDENCIES, (AppCenterCoreJobArgs*) _data_->_tmp3_, app_center_core_package_kit_backend_get_package_dependencies_ready, _data_);
#line 1216 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 12834 "PackageKitBackend.c"
	_state_1:
#line 1216 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp4_ = app_center_core_package_kit_backend_launch_job_finish (_data_->self, _data_->_res_);
#line 1216 "../src/Core/PackageKitBackend.vala"
	_data_->job = _data_->_tmp4_;
#line 1217 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp5_ = _data_->job;
#line 1217 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp6_ = app_center_core_job_get_error (_data_->_tmp5_);
#line 1217 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 1217 "../src/Core/PackageKitBackend.vala"
	if (_data_->_tmp7_ != NULL) {
#line 1218 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp8_ = _data_->job;
#line 1218 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp9_ = app_center_core_job_get_error (_data_->_tmp8_);
#line 1218 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 1218 "../src/Core/PackageKitBackend.vala"
		_data_->_tmp11_ = _g_error_copy0 (_data_->_tmp10_);
#line 1218 "../src/Core/PackageKitBackend.vala"
		_data_->_inner_error0_ = _data_->_tmp11_;
#line 1218 "../src/Core/PackageKitBackend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1218 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (_data_->job);
#line 1218 "../src/Core/PackageKitBackend.vala"
		_app_center_core_job_args_unref0 (_data_->job_args);
#line 1218 "../src/Core/PackageKitBackend.vala"
		g_object_unref (_data_->_async_result);
#line 1218 "../src/Core/PackageKitBackend.vala"
		return FALSE;
#line 12868 "PackageKitBackend.c"
	}
#line 1221 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp12_ = _data_->job;
#line 1221 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp13_ = g_value_get_object (&_data_->_tmp12_->result);
#line 1221 "../src/Core/PackageKitBackend.vala"
	_data_->_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, GEE_TYPE_ARRAY_LIST, GeeArrayList));
#line 1221 "../src/Core/PackageKitBackend.vala"
	_data_->result = _data_->_tmp14_;
#line 1221 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->job);
#line 1221 "../src/Core/PackageKitBackend.vala"
	_app_center_core_job_args_unref0 (_data_->job_args);
#line 1221 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1221 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 1221 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1221 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 12890 "PackageKitBackend.c"
		}
	}
#line 1221 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 1221 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 12897 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_update_progress_status (AppCenterCorePackageKitBackend* self,
                                                            PkProgress* progress,
                                                            PkProgressType type)
{
#line 1224 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 1224 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (progress != NULL);
#line 1225 "../src/Core/PackageKitBackend.vala"
	switch (type) {
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_ALLOW_CANCEL:
#line 12913 "PackageKitBackend.c"
		{
			gboolean _tmp0_;
			gboolean _tmp1_;
#line 1227 "../src/Core/PackageKitBackend.vala"
			_tmp0_ = pk_progress_get_allow_cancel (progress);
#line 1227 "../src/Core/PackageKitBackend.vala"
			_tmp1_ = _tmp0_;
#line 1227 "../src/Core/PackageKitBackend.vala"
			self->priv->can_cancel = _tmp1_;
#line 1228 "../src/Core/PackageKitBackend.vala"
			break;
#line 12925 "PackageKitBackend.c"
		}
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_ITEM_PROGRESS:
#line 12929 "PackageKitBackend.c"
		{
			gint _tmp8_;
			gint _tmp9_;
			gdouble progress_sum = 0.0;
#line 1230 "../src/Core/PackageKitBackend.vala"
			if (self->priv->current_status == PK_STATUS_ENUM_SETUP) {
#line 12936 "PackageKitBackend.c"
				guint _tmp2_;
				guint _tmp3_;
#line 1231 "../src/Core/PackageKitBackend.vala"
				_tmp2_ = pk_progress_get_status (progress);
#line 1231 "../src/Core/PackageKitBackend.vala"
				_tmp3_ = _tmp2_;
#line 1231 "../src/Core/PackageKitBackend.vala"
				self->priv->current_status = (PkStatusEnum) _tmp3_;
#line 1233 "../src/Core/PackageKitBackend.vala"
				if (self->priv->current_status != PK_STATUS_ENUM_DOWNLOAD) {
#line 1234 "../src/Core/PackageKitBackend.vala"
					self->priv->progress_denom = (gdouble) 100.0f;
#line 12949 "PackageKitBackend.c"
				}
			} else {
				guint _tmp4_;
				guint _tmp5_;
#line 1238 "../src/Core/PackageKitBackend.vala"
				_tmp4_ = pk_progress_get_status (progress);
#line 1238 "../src/Core/PackageKitBackend.vala"
				_tmp5_ = _tmp4_;
#line 1238 "../src/Core/PackageKitBackend.vala"
				if (((PkStatusEnum) _tmp5_) != self->priv->current_status) {
#line 12960 "PackageKitBackend.c"
					guint _tmp6_;
					guint _tmp7_;
#line 1239 "../src/Core/PackageKitBackend.vala"
					_tmp6_ = pk_progress_get_status (progress);
#line 1239 "../src/Core/PackageKitBackend.vala"
					_tmp7_ = _tmp6_;
#line 1239 "../src/Core/PackageKitBackend.vala"
					self->priv->current_status = (PkStatusEnum) _tmp7_;
#line 1240 "../src/Core/PackageKitBackend.vala"
					self->priv->current_progress = self->priv->last_progress;
#line 12971 "PackageKitBackend.c"
				}
			}
#line 1243 "../src/Core/PackageKitBackend.vala"
			_tmp8_ = pk_progress_get_percentage (progress);
#line 1243 "../src/Core/PackageKitBackend.vala"
			_tmp9_ = _tmp8_;
#line 1243 "../src/Core/PackageKitBackend.vala"
			self->priv->last_progress = _tmp9_;
#line 1244 "../src/Core/PackageKitBackend.vala"
			progress_sum = (gdouble) (self->priv->current_progress + self->priv->last_progress);
#line 1245 "../src/Core/PackageKitBackend.vala"
			self->priv->progress = progress_sum / self->priv->progress_denom;
#line 1246 "../src/Core/PackageKitBackend.vala"
			break;
#line 12986 "PackageKitBackend.c"
		}
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_STATUS:
#line 12990 "PackageKitBackend.c"
		{
			guint _tmp10_;
			guint _tmp11_;
#line 1248 "../src/Core/PackageKitBackend.vala"
			_tmp10_ = pk_progress_get_status (progress);
#line 1248 "../src/Core/PackageKitBackend.vala"
			_tmp11_ = _tmp10_;
#line 1248 "../src/Core/PackageKitBackend.vala"
			self->priv->status = (PkStatusEnum) _tmp11_;
#line 1249 "../src/Core/PackageKitBackend.vala"
			break;
#line 13002 "PackageKitBackend.c"
		}
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_CALLER_ACTIVE:
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_DOWNLOAD_SIZE_REMAINING:
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_ELAPSED_TIME:
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_INVALID:
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_PACKAGE:
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_PACKAGE_ID:
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_PERCENTAGE:
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_REMAINING_TIME:
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_ROLE:
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_SPEED:
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_TRANSACTION_FLAGS:
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_TRANSACTION_ID:
#line 1225 "../src/Core/PackageKitBackend.vala"
		case PK_PROGRESS_TYPE_UID:
#line 13030 "PackageKitBackend.c"
		{
#line 1265 "../src/Core/PackageKitBackend.vala"
			break;
#line 13034 "PackageKitBackend.c"
		}
		default:
#line 1225 "../src/Core/PackageKitBackend.vala"
		break;
#line 13039 "PackageKitBackend.c"
	}
}

static AppCenterCoreChangeInformationStatus
app_center_core_package_kit_backend_pk_status_to_appcenter_status (PkStatusEnum status)
{
	AppCenterCoreChangeInformationStatus result;
#line 1270 "../src/Core/PackageKitBackend.vala"
	switch (status) {
#line 1270 "../src/Core/PackageKitBackend.vala"
		case PK_STATUS_ENUM_WAIT:
#line 1270 "../src/Core/PackageKitBackend.vala"
		case PK_STATUS_ENUM_WAITING_FOR_AUTH:
#line 13053 "PackageKitBackend.c"
		{
#line 1273 "../src/Core/PackageKitBackend.vala"
			result = APP_CENTER_CORE_CHANGE_INFORMATION_STATUS_WAITING;
#line 1273 "../src/Core/PackageKitBackend.vala"
			return result;
#line 13059 "PackageKitBackend.c"
		}
#line 1270 "../src/Core/PackageKitBackend.vala"
		case PK_STATUS_ENUM_CANCEL:
#line 13063 "PackageKitBackend.c"
		{
#line 1275 "../src/Core/PackageKitBackend.vala"
			result = APP_CENTER_CORE_CHANGE_INFORMATION_STATUS_CANCELLED;
#line 1275 "../src/Core/PackageKitBackend.vala"
			return result;
#line 13069 "PackageKitBackend.c"
		}
#line 1270 "../src/Core/PackageKitBackend.vala"
		case PK_STATUS_ENUM_FINISHED:
#line 13073 "PackageKitBackend.c"
		{
#line 1277 "../src/Core/PackageKitBackend.vala"
			result = APP_CENTER_CORE_CHANGE_INFORMATION_STATUS_FINISHED;
#line 1277 "../src/Core/PackageKitBackend.vala"
			return result;
#line 13079 "PackageKitBackend.c"
		}
		default:
		{
#line 1279 "../src/Core/PackageKitBackend.vala"
			result = APP_CENTER_CORE_CHANGE_INFORMATION_STATUS_RUNNING;
#line 1279 "../src/Core/PackageKitBackend.vala"
			return result;
#line 13087 "PackageKitBackend.c"
		}
	}
}

static void
app_center_core_package_kit_backend_reset_progress (AppCenterCorePackageKitBackend* self)
{
#line 1283 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 1284 "../src/Core/PackageKitBackend.vala"
	self->priv->can_cancel = TRUE;
#line 1285 "../src/Core/PackageKitBackend.vala"
	self->priv->current_progress = 0;
#line 1286 "../src/Core/PackageKitBackend.vala"
	self->priv->last_progress = 0;
#line 1287 "../src/Core/PackageKitBackend.vala"
	self->priv->current_status = PK_STATUS_ENUM_SETUP;
#line 1288 "../src/Core/PackageKitBackend.vala"
	self->priv->status = PK_STATUS_ENUM_SETUP;
#line 1289 "../src/Core/PackageKitBackend.vala"
	self->priv->progress_denom = (gdouble) 200.0f;
#line 1290 "../src/Core/PackageKitBackend.vala"
	self->priv->progress = (gdouble) 0.0f;
#line 13111 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_repair_data_free (gpointer _data)
{
	AppCenterCorePackageKitBackendRepairData* _data_;
	_data_ = _data;
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_slice_free (AppCenterCorePackageKitBackendRepairData, _data_);
#line 13125 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_repair (AppCenterCoreBackend* base,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	AppCenterCorePackageKitBackend * self;
	AppCenterCorePackageKitBackendRepairData* _data_;
	AppCenterCorePackageKitBackend* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_slice_new0 (AppCenterCorePackageKitBackendRepairData);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, app_center_core_package_kit_backend_real_repair_data_free);
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->self = _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_real_repair_co (_data_);
#line 13158 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_repair_finish (AppCenterCoreBackend* base,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	gboolean result;
	AppCenterCorePackageKitBackendRepairData* _data_;
#line 24 "../src/Core/PackageKitBackend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	if (NULL == _data_) {
#line 13172 "PackageKitBackend.c"
		gboolean _tmp0_ = FALSE;
#line 24 "../src/Core/PackageKitBackend.vala"
		return _tmp0_;
#line 13176 "PackageKitBackend.c"
	}
#line 24 "../src/Core/PackageKitBackend.vala"
	result = _data_->result;
#line 24 "../src/Core/PackageKitBackend.vala"
	return result;
#line 13182 "PackageKitBackend.c"
}

static gboolean
app_center_core_package_kit_backend_real_repair_co (AppCenterCorePackageKitBackendRepairData* _data_)
{
#line 1293 "../src/Core/PackageKitBackend.vala"
	switch (_data_->_state_) {
#line 1293 "../src/Core/PackageKitBackend.vala"
		case 0:
#line 13192 "PackageKitBackend.c"
		goto _state_0;
		default:
#line 1293 "../src/Core/PackageKitBackend.vala"
		g_assert_not_reached ();
#line 13197 "PackageKitBackend.c"
	}
	_state_0:
#line 1294 "../src/Core/PackageKitBackend.vala"
	_data_->result = TRUE;
#line 1294 "../src/Core/PackageKitBackend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1294 "../src/Core/PackageKitBackend.vala"
	if (_data_->_state_ != 0) {
#line 1294 "../src/Core/PackageKitBackend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1294 "../src/Core/PackageKitBackend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 13210 "PackageKitBackend.c"
		}
	}
#line 1294 "../src/Core/PackageKitBackend.vala"
	g_object_unref (_data_->_async_result);
#line 1294 "../src/Core/PackageKitBackend.vala"
	return FALSE;
#line 13217 "PackageKitBackend.c"
}

static AppCenterCorePackageKitBackend*
__lambda44_ (void)
{
	AppCenterCorePackageKitBackend* _tmp0_;
	AppCenterCorePackageKitBackend* result;
#line 1299 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_package_kit_backend_new ();
#line 1299 "../src/Core/PackageKitBackend.vala"
	result = _tmp0_;
#line 1299 "../src/Core/PackageKitBackend.vala"
	return result;
#line 13231 "PackageKitBackend.c"
}

static gpointer
___lambda44__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda44_ ();
#line 1299 "../src/Core/PackageKitBackend.vala"
	return result;
#line 13241 "PackageKitBackend.c"
}

AppCenterCorePackageKitBackend*
app_center_core_package_kit_backend_get_default (void)
{
	gconstpointer _tmp0_;
	AppCenterCorePackageKitBackend* result;
#line 1299 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = g_once (&app_center_core_package_kit_backend_instance, ___lambda44__gthread_func, NULL);
#line 1299 "../src/Core/PackageKitBackend.vala"
	result = (AppCenterCorePackageKitBackend*) _tmp0_;
#line 1299 "../src/Core/PackageKitBackend.vala"
	return result;
#line 13255 "PackageKitBackend.c"
}

gchar**
app_center_core_package_kit_backend_get_fake_packages (AppCenterCorePackageKitBackend* self,
                                                       gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 33 "../src/Core/PackageKitBackend.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = self->priv->_fake_packages;
#line 33 "../src/Core/PackageKitBackend.vala"
	_tmp0__length1 = self->priv->_fake_packages_length1;
#line 33 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 33 "../src/Core/PackageKitBackend.vala"
	_tmp1__length1 = _tmp0__length1;
#line 33 "../src/Core/PackageKitBackend.vala"
	if (result_length1) {
#line 33 "../src/Core/PackageKitBackend.vala"
		*result_length1 = _tmp1__length1;
#line 13281 "PackageKitBackend.c"
	}
#line 33 "../src/Core/PackageKitBackend.vala"
	result = _tmp1_;
#line 33 "../src/Core/PackageKitBackend.vala"
	return result;
#line 13287 "PackageKitBackend.c"
}

static gchar**
_vala_array_dup10 (gchar** self,
                   gssize length)
{
#line 33 "../src/Core/PackageKitBackend.vala"
	if (length >= 0) {
#line 13296 "PackageKitBackend.c"
		gchar** result;
		gssize i;
#line 33 "../src/Core/PackageKitBackend.vala"
		result = g_new0 (gchar*, length + 1);
#line 33 "../src/Core/PackageKitBackend.vala"
		for (i = 0; i < length; i++) {
#line 13303 "PackageKitBackend.c"
			gchar* _tmp0_;
#line 33 "../src/Core/PackageKitBackend.vala"
			_tmp0_ = g_strdup (self[i]);
#line 33 "../src/Core/PackageKitBackend.vala"
			result[i] = _tmp0_;
#line 13309 "PackageKitBackend.c"
		}
#line 33 "../src/Core/PackageKitBackend.vala"
		return result;
#line 13313 "PackageKitBackend.c"
	}
#line 33 "../src/Core/PackageKitBackend.vala"
	return NULL;
#line 13317 "PackageKitBackend.c"
}

void
app_center_core_package_kit_backend_set_fake_packages (AppCenterCorePackageKitBackend* self,
                                                       gchar** value,
                                                       gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
#line 33 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Core/PackageKitBackend.vala"
	old_value = app_center_core_package_kit_backend_get_fake_packages (self, &old_value_length);
#line 33 "../src/Core/PackageKitBackend.vala"
	if (old_value != value) {
#line 13333 "PackageKitBackend.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 33 "../src/Core/PackageKitBackend.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup10 (value, value_length1) : value;
#line 33 "../src/Core/PackageKitBackend.vala"
		_tmp0__length1 = value_length1;
#line 33 "../src/Core/PackageKitBackend.vala"
		self->priv->_fake_packages = (_vala_array_free (self->priv->_fake_packages, self->priv->_fake_packages_length1, (GDestroyNotify) g_free), NULL);
#line 33 "../src/Core/PackageKitBackend.vala"
		self->priv->_fake_packages = _tmp0_;
#line 33 "../src/Core/PackageKitBackend.vala"
		self->priv->_fake_packages_length1 = _tmp0__length1;
#line 33 "../src/Core/PackageKitBackend.vala"
		self->priv->__fake_packages_size_ = self->priv->_fake_packages_length1;
#line 33 "../src/Core/PackageKitBackend.vala"
		g_object_notify_by_pspec ((GObject *) self, app_center_core_package_kit_backend_properties[APP_CENTER_CORE_PACKAGE_KIT_BACKEND_FAKE_PACKAGES_PROPERTY]);
#line 13350 "PackageKitBackend.c"
	}
}

static AppCenterCoreJobType
app_center_core_package_kit_backend_real_get_job_type (AppCenterCoreBackend* base)
{
	AppCenterCoreJobType result;
	AppCenterCorePackageKitBackend* self;
#line 43 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 43 "../src/Core/PackageKitBackend.vala"
	result = self->priv->_job_type;
#line 43 "../src/Core/PackageKitBackend.vala"
	return result;
#line 13365 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_set_job_type (AppCenterCoreBackend* base,
                                                       AppCenterCoreJobType value)
{
	AppCenterCorePackageKitBackend* self;
	AppCenterCoreJobType old_value;
#line 43 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 43 "../src/Core/PackageKitBackend.vala"
	old_value = app_center_core_package_kit_backend_real_get_job_type (base);
#line 43 "../src/Core/PackageKitBackend.vala"
	if (old_value != value) {
#line 43 "../src/Core/PackageKitBackend.vala"
		self->priv->_job_type = value;
#line 43 "../src/Core/PackageKitBackend.vala"
		g_object_notify_by_pspec ((GObject *) self, app_center_core_package_kit_backend_properties[APP_CENTER_CORE_PACKAGE_KIT_BACKEND_JOB_TYPE_PROPERTY]);
#line 13384 "PackageKitBackend.c"
	}
}

static gboolean
app_center_core_package_kit_backend_real_get_working (AppCenterCoreBackend* base)
{
	gboolean result;
	AppCenterCorePackageKitBackend* self;
#line 44 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 44 "../src/Core/PackageKitBackend.vala"
	result = self->priv->_working;
#line 44 "../src/Core/PackageKitBackend.vala"
	return result;
#line 13399 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_real_set_working (AppCenterCoreBackend* base,
                                                      gboolean value)
{
	AppCenterCorePackageKitBackend* self;
	gboolean old_value;
#line 44 "../src/Core/PackageKitBackend.vala"
	self = (AppCenterCorePackageKitBackend*) base;
#line 44 "../src/Core/PackageKitBackend.vala"
	old_value = app_center_core_package_kit_backend_real_get_working (base);
#line 44 "../src/Core/PackageKitBackend.vala"
	if (old_value != value) {
#line 44 "../src/Core/PackageKitBackend.vala"
		self->priv->_working = value;
#line 44 "../src/Core/PackageKitBackend.vala"
		g_object_notify_by_pspec ((GObject *) self, app_center_core_package_kit_backend_properties[APP_CENTER_CORE_PACKAGE_KIT_BACKEND_WORKING_PROPERTY]);
#line 13418 "PackageKitBackend.c"
	}
}

gboolean
app_center_core_package_kit_backend_get_supports_parallel_package_queries (void)
{
	gboolean result;
	PkControl* _tmp0_;
	PkControl* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	PkControl* _tmp8_;
	PkControl* _tmp9_;
	guint _tmp10_;
	guint _tmp11_;
#line 53 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_package_kit_backend_get_control ();
#line 53 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = _tmp0_;
#line 53 "../src/Core/PackageKitBackend.vala"
	g_object_get (_tmp1_, "backend-name", &_tmp2_, NULL);
#line 53 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _tmp2_;
#line 53 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = _tmp3_;
#line 53 "../src/Core/PackageKitBackend.vala"
	_tmp5_ = g_strcmp0 (_tmp4_, "aptcc") != 0;
#line 53 "../src/Core/PackageKitBackend.vala"
	_g_free0 (_tmp4_);
#line 53 "../src/Core/PackageKitBackend.vala"
	if (_tmp5_) {
#line 54 "../src/Core/PackageKitBackend.vala"
		result = TRUE;
#line 54 "../src/Core/PackageKitBackend.vala"
		return result;
#line 13458 "PackageKitBackend.c"
	}
#line 57 "../src/Core/PackageKitBackend.vala"
	_tmp8_ = app_center_core_package_kit_backend_get_control ();
#line 57 "../src/Core/PackageKitBackend.vala"
	_tmp9_ = _tmp8_;
#line 57 "../src/Core/PackageKitBackend.vala"
	g_object_get (_tmp9_, "version-major", &_tmp10_, NULL);
#line 57 "../src/Core/PackageKitBackend.vala"
	_tmp11_ = _tmp10_;
#line 57 "../src/Core/PackageKitBackend.vala"
	if (_tmp11_ >= ((guint) 1)) {
#line 13470 "PackageKitBackend.c"
		PkControl* _tmp12_;
		PkControl* _tmp13_;
		guint _tmp14_;
		guint _tmp15_;
#line 58 "../src/Core/PackageKitBackend.vala"
		_tmp12_ = app_center_core_package_kit_backend_get_control ();
#line 58 "../src/Core/PackageKitBackend.vala"
		_tmp13_ = _tmp12_;
#line 58 "../src/Core/PackageKitBackend.vala"
		g_object_get (_tmp13_, "version-minor", &_tmp14_, NULL);
#line 58 "../src/Core/PackageKitBackend.vala"
		_tmp15_ = _tmp14_;
#line 58 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = _tmp15_ >= ((guint) 1);
#line 13485 "PackageKitBackend.c"
	} else {
#line 57 "../src/Core/PackageKitBackend.vala"
		_tmp7_ = FALSE;
#line 13489 "PackageKitBackend.c"
	}
#line 57 "../src/Core/PackageKitBackend.vala"
	if (_tmp7_) {
#line 13493 "PackageKitBackend.c"
		PkControl* _tmp16_;
		PkControl* _tmp17_;
		guint _tmp18_;
		guint _tmp19_;
#line 59 "../src/Core/PackageKitBackend.vala"
		_tmp16_ = app_center_core_package_kit_backend_get_control ();
#line 59 "../src/Core/PackageKitBackend.vala"
		_tmp17_ = _tmp16_;
#line 59 "../src/Core/PackageKitBackend.vala"
		g_object_get (_tmp17_, "version-micro", &_tmp18_, NULL);
#line 59 "../src/Core/PackageKitBackend.vala"
		_tmp19_ = _tmp18_;
#line 59 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = _tmp19_ >= ((guint) 10);
#line 13508 "PackageKitBackend.c"
	} else {
#line 57 "../src/Core/PackageKitBackend.vala"
		_tmp6_ = FALSE;
#line 13512 "PackageKitBackend.c"
	}
#line 57 "../src/Core/PackageKitBackend.vala"
	if (_tmp6_) {
#line 60 "../src/Core/PackageKitBackend.vala"
		result = TRUE;
#line 60 "../src/Core/PackageKitBackend.vala"
		return result;
#line 13520 "PackageKitBackend.c"
	}
#line 63 "../src/Core/PackageKitBackend.vala"
	result = FALSE;
#line 63 "../src/Core/PackageKitBackend.vala"
	return result;
#line 13526 "PackageKitBackend.c"
}

static PkControl*
app_center_core_package_kit_backend_get_control (void)
{
	PkControl* result;
	PkControl* _tmp0_;
	PkControl* _tmp2_;
#line 70 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = app_center_core_package_kit_backend__control;
#line 70 "../src/Core/PackageKitBackend.vala"
	if (_tmp0_ == NULL) {
#line 13539 "PackageKitBackend.c"
		PkControl* _tmp1_;
#line 71 "../src/Core/PackageKitBackend.vala"
		_tmp1_ = pk_control_new ();
#line 71 "../src/Core/PackageKitBackend.vala"
		_g_object_unref0 (app_center_core_package_kit_backend__control);
#line 71 "../src/Core/PackageKitBackend.vala"
		app_center_core_package_kit_backend__control = _tmp1_;
#line 13547 "PackageKitBackend.c"
	}
#line 74 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = app_center_core_package_kit_backend__control;
#line 74 "../src/Core/PackageKitBackend.vala"
	result = _tmp2_;
#line 74 "../src/Core/PackageKitBackend.vala"
	return result;
#line 13555 "PackageKitBackend.c"
}

static Block66Data*
block66_data_ref (Block66Data* _data66_)
{
#line 135 "../src/Core/PackageKitBackend.vala"
	g_atomic_int_inc (&_data66_->_ref_count_);
#line 135 "../src/Core/PackageKitBackend.vala"
	return _data66_;
#line 13565 "PackageKitBackend.c"
}

static void
block66_data_unref (void * _userdata_)
{
	Block66Data* _data66_;
	_data66_ = (Block66Data*) _userdata_;
#line 135 "../src/Core/PackageKitBackend.vala"
	if (g_atomic_int_dec_and_test (&_data66_->_ref_count_)) {
#line 135 "../src/Core/PackageKitBackend.vala"
		_g_main_loop_unref0 (_data66_->loop);
#line 135 "../src/Core/PackageKitBackend.vala"
		g_slice_free (Block66Data, _data66_);
#line 13579 "PackageKitBackend.c"
	}
}

static void
_app_center_core_package_kit_backend___lambda86_ (Block66Data* _data66_,
                                                  GObject* obj,
                                                  GAsyncResult* res)
{
	GMainLoop* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 143 "../src/Core/PackageKitBackend.vala"
	g_return_if_fail (res != NULL);
#line 13592 "PackageKitBackend.c"
	{
		PkControl* _tmp0_;
#line 145 "../src/Core/PackageKitBackend.vala"
		_tmp0_ = app_center_core_package_kit_backend__control;
#line 145 "../src/Core/PackageKitBackend.vala"
		pk_control_get_properties_finish (_tmp0_, res, &_inner_error0_);
#line 145 "../src/Core/PackageKitBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13601 "PackageKitBackend.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 144 "../src/Core/PackageKitBackend.vala"
		e = _inner_error0_;
#line 144 "../src/Core/PackageKitBackend.vala"
		_inner_error0_ = NULL;
#line 147 "../src/Core/PackageKitBackend.vala"
		_tmp1_ = e;
#line 147 "../src/Core/PackageKitBackend.vala"
		_tmp2_ = _tmp1_->message;
#line 147 "../src/Core/PackageKitBackend.vala"
		g_warning ("PackageKitBackend.vala:147: %s", _tmp2_);
#line 144 "../src/Core/PackageKitBackend.vala"
		_g_error_free0 (e);
#line 13623 "PackageKitBackend.c"
	}
	__finally0:
#line 144 "../src/Core/PackageKitBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 144 "../src/Core/PackageKitBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 144 "../src/Core/PackageKitBackend.vala"
		g_clear_error (&_inner_error0_);
#line 144 "../src/Core/PackageKitBackend.vala"
		return;
#line 13634 "PackageKitBackend.c"
	}
#line 150 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _data66_->loop;
#line 150 "../src/Core/PackageKitBackend.vala"
	g_main_loop_quit (_tmp3_);
#line 13640 "PackageKitBackend.c"
}

static void
__app_center_core_package_kit_backend___lambda86__gasync_ready_callback (GObject* source_object,
                                                                         GAsyncResult* res,
                                                                         gpointer self)
{
#line 143 "../src/Core/PackageKitBackend.vala"
	_app_center_core_package_kit_backend___lambda86_ (self, source_object, res);
#line 143 "../src/Core/PackageKitBackend.vala"
	block66_data_unref (self);
#line 13652 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_class_init (AppCenterCorePackageKitBackendClass * klass,
                                                gpointer klass_data)
{
	Block66Data* _data66_;
	PkControl* _tmp0_;
	GMainLoop* _tmp1_;
	PkControl* _tmp2_;
	GMainLoop* _tmp3_;
	AppCenterCoreTask* _tmp4_ = NULL;
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Core/PackageKitBackend.vala"
	g_type_class_adjust_private_offset (klass, &AppCenterCorePackageKitBackend_private_offset);
#line 24 "../src/Core/PackageKitBackend.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_app_center_core_package_kit_backend_get_property;
#line 24 "../src/Core/PackageKitBackend.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_app_center_core_package_kit_backend_set_property;
#line 24 "../src/Core/PackageKitBackend.vala"
	G_OBJECT_CLASS (klass)->finalize = app_center_core_package_kit_backend_finalize;
#line 24 "../src/Core/PackageKitBackend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_CORE_PACKAGE_KIT_BACKEND_FAKE_PACKAGES_PROPERTY, app_center_core_package_kit_backend_properties[APP_CENTER_CORE_PACKAGE_KIT_BACKEND_FAKE_PACKAGES_PROPERTY] = g_param_spec_boxed ("fake-packages", "fake-packages", "fake-packages", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Core/PackageKitBackend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_CORE_PACKAGE_KIT_BACKEND_JOB_TYPE_PROPERTY, app_center_core_package_kit_backend_properties[APP_CENTER_CORE_PACKAGE_KIT_BACKEND_JOB_TYPE_PROPERTY] = g_param_spec_enum ("job-type", "job-type", "job-type", APP_CENTER_CORE_JOB_TYPE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Core/PackageKitBackend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_CORE_PACKAGE_KIT_BACKEND_WORKING_PROPERTY, app_center_core_package_kit_backend_properties[APP_CENTER_CORE_PACKAGE_KIT_BACKEND_WORKING_PROPERTY] = g_param_spec_boolean ("working", "working", "working", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 135 "../src/Core/PackageKitBackend.vala"
	_data66_ = g_slice_new0 (Block66Data);
#line 135 "../src/Core/PackageKitBackend.vala"
	_data66_->_ref_count_ = 1;
#line 136 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = pk_control_new ();
#line 136 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (app_center_core_package_kit_backend__control);
#line 136 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend__control = _tmp0_;
#line 142 "../src/Core/PackageKitBackend.vala"
	_tmp1_ = g_main_loop_new (NULL, FALSE);
#line 142 "../src/Core/PackageKitBackend.vala"
	_data66_->loop = _tmp1_;
#line 143 "../src/Core/PackageKitBackend.vala"
	_tmp2_ = app_center_core_package_kit_backend__control;
#line 143 "../src/Core/PackageKitBackend.vala"
	pk_control_get_properties_async (_tmp2_, NULL, __app_center_core_package_kit_backend___lambda86__gasync_ready_callback, block66_data_ref (_data66_));
#line 153 "../src/Core/PackageKitBackend.vala"
	_tmp3_ = _data66_->loop;
#line 153 "../src/Core/PackageKitBackend.vala"
	g_main_loop_run (_tmp3_);
#line 154 "../src/Core/PackageKitBackend.vala"
	_tmp4_ = app_center_core_task_new ();
#line 154 "../src/Core/PackageKitBackend.vala"
	pk_task_set_only_download ((PkTask*) _tmp4_, TRUE);
#line 154 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (app_center_core_package_kit_backend_client);
#line 154 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_client = _tmp4_;
#line 135 "../src/Core/PackageKitBackend.vala"
	block66_data_unref (_data66_);
#line 135 "../src/Core/PackageKitBackend.vala"
	_data66_ = NULL;
#line 13715 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_app_center_core_backend_interface_init (AppCenterCoreBackendIface * iface,
                                                                            gpointer iface_data)
{
#line 24 "../src/Core/PackageKitBackend.vala"
	app_center_core_package_kit_backend_app_center_core_backend_parent_iface = g_type_interface_peek_parent (iface);
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_prepared_applications = (void (*) (AppCenterCoreBackend*, GCancellable*, GAsyncReadyCallback, gpointer)) app_center_core_package_kit_backend_real_get_prepared_applications;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_prepared_applications_finish = (GeeCollection* (*) (AppCenterCoreBackend*, GAsyncResult*)) app_center_core_package_kit_backend_get_prepared_applications_finish;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_installed_applications = (void (*) (AppCenterCoreBackend*, GCancellable*, GAsyncReadyCallback, gpointer)) app_center_core_package_kit_backend_real_get_installed_applications;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_installed_applications_finish = (GeeCollection* (*) (AppCenterCoreBackend*, GAsyncResult*)) app_center_core_package_kit_backend_get_installed_applications_finish;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_package_for_component_id = (AppCenterCorePackage* (*) (AppCenterCoreBackend*, const gchar*)) app_center_core_package_kit_backend_real_get_package_for_component_id;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_packages_for_component_id = (GeeCollection* (*) (AppCenterCoreBackend*, const gchar*)) app_center_core_package_kit_backend_real_get_packages_for_component_id;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_package_for_desktop_id = (AppCenterCorePackage* (*) (AppCenterCoreBackend*, const gchar*)) app_center_core_package_kit_backend_real_get_package_for_desktop_id;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_packages_by_author = (GeeCollection* (*) (AppCenterCoreBackend*, const gchar*, gint)) app_center_core_package_kit_backend_real_get_packages_by_author;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_applications_for_category = (GeeCollection* (*) (AppCenterCoreBackend*, AsCategory*)) app_center_core_package_kit_backend_real_get_applications_for_category;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->search_applications = (GeeCollection* (*) (AppCenterCoreBackend*, const gchar*, AsCategory*)) app_center_core_package_kit_backend_real_search_applications;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->search_applications_mime = (GeeCollection* (*) (AppCenterCoreBackend*, const gchar*)) app_center_core_package_kit_backend_real_search_applications_mime;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_download_size = (void (*) (AppCenterCoreBackend*, AppCenterCorePackage*, GCancellable*, gboolean, GAsyncReadyCallback, gpointer)) app_center_core_package_kit_backend_real_get_download_size;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_download_size_finish = (guint64 (*) (AppCenterCoreBackend*, GAsyncResult*, GError**)) app_center_core_package_kit_backend_get_download_size_finish;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->install_package = (void (*) (AppCenterCoreBackend*, AppCenterCorePackage*, AppCenterCoreChangeInformation*, GCancellable*, GAsyncReadyCallback, gpointer)) app_center_core_package_kit_backend_real_install_package;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->install_package_finish = (gboolean (*) (AppCenterCoreBackend*, GAsyncResult*, GError**)) app_center_core_package_kit_backend_install_package_finish;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->update_package = (void (*) (AppCenterCoreBackend*, AppCenterCorePackage*, AppCenterCoreChangeInformation*, GCancellable*, GAsyncReadyCallback, gpointer)) app_center_core_package_kit_backend_real_update_package;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->update_package_finish = (gboolean (*) (AppCenterCoreBackend*, GAsyncResult*, GError**)) app_center_core_package_kit_backend_update_package_finish;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->remove_package = (void (*) (AppCenterCoreBackend*, AppCenterCorePackage*, AppCenterCoreChangeInformation*, GCancellable*, GAsyncReadyCallback, gpointer)) app_center_core_package_kit_backend_real_remove_package;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->remove_package_finish = (gboolean (*) (AppCenterCoreBackend*, GAsyncResult*, GError**)) app_center_core_package_kit_backend_remove_package_finish;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->refresh_cache = (void (*) (AppCenterCoreBackend*, GCancellable*, GAsyncReadyCallback, gpointer)) app_center_core_package_kit_backend_real_refresh_cache;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->refresh_cache_finish = (gboolean (*) (AppCenterCoreBackend*, GAsyncResult*, GError**)) app_center_core_package_kit_backend_refresh_cache_finish;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->is_package_installed = (void (*) (AppCenterCoreBackend*, AppCenterCorePackage*, GAsyncReadyCallback, gpointer)) app_center_core_package_kit_backend_real_is_package_installed;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->is_package_installed_finish = (gboolean (*) (AppCenterCoreBackend*, GAsyncResult*, GError**)) app_center_core_package_kit_backend_is_package_installed_finish;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_package_details = (void (*) (AppCenterCoreBackend*, AppCenterCorePackage*, GAsyncReadyCallback, gpointer)) app_center_core_package_kit_backend_real_get_package_details;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_package_details_finish = (AppCenterCorePackageDetails* (*) (AppCenterCoreBackend*, GAsyncResult*, GError**)) app_center_core_package_kit_backend_get_package_details_finish;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->repair = (void (*) (AppCenterCoreBackend*, GCancellable*, GAsyncReadyCallback, gpointer)) app_center_core_package_kit_backend_real_repair;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->repair_finish = (gboolean (*) (AppCenterCoreBackend*, GAsyncResult*, GError**)) app_center_core_package_kit_backend_repair_finish;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_job_type = app_center_core_package_kit_backend_real_get_job_type;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->set_job_type = app_center_core_package_kit_backend_real_set_job_type;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->get_working = app_center_core_package_kit_backend_real_get_working;
#line 24 "../src/Core/PackageKitBackend.vala"
	iface->set_working = app_center_core_package_kit_backend_real_set_working;
#line 13786 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_instance_init (AppCenterCorePackageKitBackend * self,
                                                   gpointer klass)
{
	GAsyncQueue* _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	self->priv = app_center_core_package_kit_backend_get_instance_private (self);
#line 26 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = g_async_queue_new_full (_g_object_unref0_);
#line 26 "../src/Core/PackageKitBackend.vala"
	self->priv->jobs = _tmp0_;
#line 29 "../src/Core/PackageKitBackend.vala"
	self->priv->last_action = NULL;
#line 41 "../src/Core/PackageKitBackend.vala"
	self->priv->thread_should_run = TRUE;
#line 78 "../src/Core/PackageKitBackend.vala"
	self->priv->can_cancel = TRUE;
#line 79 "../src/Core/PackageKitBackend.vala"
	self->priv->current_progress = 0;
#line 80 "../src/Core/PackageKitBackend.vala"
	self->priv->last_progress = 0;
#line 81 "../src/Core/PackageKitBackend.vala"
	self->priv->current_status = PK_STATUS_ENUM_SETUP;
#line 82 "../src/Core/PackageKitBackend.vala"
	self->priv->status = PK_STATUS_ENUM_SETUP;
#line 83 "../src/Core/PackageKitBackend.vala"
	self->priv->progress_denom = (gdouble) 200.0f;
#line 84 "../src/Core/PackageKitBackend.vala"
	self->priv->progress = (gdouble) 0.0f;
#line 13818 "PackageKitBackend.c"
}

static void
app_center_core_package_kit_backend_finalize (GObject * obj)
{
	AppCenterCorePackageKitBackend * self;
	GThread* _tmp0_;
#line 24 "../src/Core/PackageKitBackend.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_CENTER_CORE_TYPE_PACKAGE_KIT_BACKEND, AppCenterCorePackageKitBackend);
#line 266 "../src/Core/PackageKitBackend.vala"
	self->priv->thread_should_run = FALSE;
#line 267 "../src/Core/PackageKitBackend.vala"
	_tmp0_ = self->priv->worker_thread;
#line 267 "../src/Core/PackageKitBackend.vala"
	self->priv->worker_thread = NULL;
#line 267 "../src/Core/PackageKitBackend.vala"
	g_thread_join (_tmp0_);
#line 26 "../src/Core/PackageKitBackend.vala"
	_g_async_queue_unref0 (self->priv->jobs);
#line 27 "../src/Core/PackageKitBackend.vala"
	_g_thread_unref0 (self->priv->worker_thread);
#line 29 "../src/Core/PackageKitBackend.vala"
	_g_date_time_unref0 (self->priv->last_action);
#line 30 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (self->priv->package_list);
#line 31 "../src/Core/PackageKitBackend.vala"
	_g_object_unref0 (self->priv->appstream_pool);
#line 33 "../src/Core/PackageKitBackend.vala"
	self->priv->_fake_packages = (_vala_array_free (self->priv->_fake_packages, self->priv->_fake_packages_length1, (GDestroyNotify) g_free), NULL);
#line 24 "../src/Core/PackageKitBackend.vala"
	G_OBJECT_CLASS (app_center_core_package_kit_backend_parent_class)->finalize (obj);
#line 13850 "PackageKitBackend.c"
}

static GType
app_center_core_package_kit_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AppCenterCorePackageKitBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_center_core_package_kit_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppCenterCorePackageKitBackend), 0, (GInstanceInitFunc) app_center_core_package_kit_backend_instance_init, NULL };
	static const GInterfaceInfo app_center_core_backend_info = { (GInterfaceInitFunc) app_center_core_package_kit_backend_app_center_core_backend_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType app_center_core_package_kit_backend_type_id;
	app_center_core_package_kit_backend_type_id = g_type_register_static (G_TYPE_OBJECT, "AppCenterCorePackageKitBackend", &g_define_type_info, 0);
	g_type_add_interface_static (app_center_core_package_kit_backend_type_id, APP_CENTER_CORE_TYPE_BACKEND, &app_center_core_backend_info);
	AppCenterCorePackageKitBackend_private_offset = g_type_add_instance_private (app_center_core_package_kit_backend_type_id, sizeof (AppCenterCorePackageKitBackendPrivate));
	return app_center_core_package_kit_backend_type_id;
}

GType
app_center_core_package_kit_backend_get_type (void)
{
	static volatile gsize app_center_core_package_kit_backend_type_id__once = 0;
	if (g_once_init_enter (&app_center_core_package_kit_backend_type_id__once)) {
		GType app_center_core_package_kit_backend_type_id;
		app_center_core_package_kit_backend_type_id = app_center_core_package_kit_backend_get_type_once ();
		g_once_init_leave (&app_center_core_package_kit_backend_type_id__once, app_center_core_package_kit_backend_type_id);
	}
	return app_center_core_package_kit_backend_type_id__once;
}

static void
_vala_app_center_core_package_kit_backend_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec)
{
	AppCenterCorePackageKitBackend * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_CENTER_CORE_TYPE_PACKAGE_KIT_BACKEND, AppCenterCorePackageKitBackend);
#line 24 "../src/Core/PackageKitBackend.vala"
	switch (property_id) {
#line 24 "../src/Core/PackageKitBackend.vala"
		case APP_CENTER_CORE_PACKAGE_KIT_BACKEND_FAKE_PACKAGES_PROPERTY:
#line 13889 "PackageKitBackend.c"
		{
			int length;
#line 24 "../src/Core/PackageKitBackend.vala"
			g_value_set_boxed (value, app_center_core_package_kit_backend_get_fake_packages (self, &length));
#line 13894 "PackageKitBackend.c"
		}
#line 24 "../src/Core/PackageKitBackend.vala"
		break;
#line 24 "../src/Core/PackageKitBackend.vala"
		case APP_CENTER_CORE_PACKAGE_KIT_BACKEND_JOB_TYPE_PROPERTY:
#line 24 "../src/Core/PackageKitBackend.vala"
		g_value_set_enum (value, app_center_core_backend_get_job_type ((AppCenterCoreBackend*) self));
#line 24 "../src/Core/PackageKitBackend.vala"
		break;
#line 24 "../src/Core/PackageKitBackend.vala"
		case APP_CENTER_CORE_PACKAGE_KIT_BACKEND_WORKING_PROPERTY:
#line 24 "../src/Core/PackageKitBackend.vala"
		g_value_set_boolean (value, app_center_core_backend_get_working ((AppCenterCoreBackend*) self));
#line 24 "../src/Core/PackageKitBackend.vala"
		break;
#line 13910 "PackageKitBackend.c"
		default:
#line 24 "../src/Core/PackageKitBackend.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Core/PackageKitBackend.vala"
		break;
#line 13916 "PackageKitBackend.c"
	}
}

static void
_vala_app_center_core_package_kit_backend_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec)
{
	AppCenterCorePackageKitBackend * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_CENTER_CORE_TYPE_PACKAGE_KIT_BACKEND, AppCenterCorePackageKitBackend);
#line 24 "../src/Core/PackageKitBackend.vala"
	switch (property_id) {
#line 24 "../src/Core/PackageKitBackend.vala"
		case APP_CENTER_CORE_PACKAGE_KIT_BACKEND_FAKE_PACKAGES_PROPERTY:
#line 13932 "PackageKitBackend.c"
		{
			gpointer boxed;
#line 24 "../src/Core/PackageKitBackend.vala"
			boxed = g_value_get_boxed (value);
#line 24 "../src/Core/PackageKitBackend.vala"
			app_center_core_package_kit_backend_set_fake_packages (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 13939 "PackageKitBackend.c"
		}
#line 24 "../src/Core/PackageKitBackend.vala"
		break;
#line 24 "../src/Core/PackageKitBackend.vala"
		case APP_CENTER_CORE_PACKAGE_KIT_BACKEND_JOB_TYPE_PROPERTY:
#line 24 "../src/Core/PackageKitBackend.vala"
		app_center_core_backend_set_job_type ((AppCenterCoreBackend*) self, g_value_get_enum (value));
#line 24 "../src/Core/PackageKitBackend.vala"
		break;
#line 24 "../src/Core/PackageKitBackend.vala"
		case APP_CENTER_CORE_PACKAGE_KIT_BACKEND_WORKING_PROPERTY:
#line 24 "../src/Core/PackageKitBackend.vala"
		app_center_core_backend_set_working ((AppCenterCoreBackend*) self, g_value_get_boolean (value));
#line 24 "../src/Core/PackageKitBackend.vala"
		break;
#line 13955 "PackageKitBackend.c"
		default:
#line 24 "../src/Core/PackageKitBackend.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Core/PackageKitBackend.vala"
		break;
#line 13961 "PackageKitBackend.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

